<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 
	protected $obj_branch;		
	protected $obj_course;
	protected $obj_notify;
	private $obj_registrasi;
	private $obj_harga;
	// init variabel
	private $str_tgl;
	private $str_desc;
	private $str_idjadwal;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// business object loaded
		$this->obj_branch = $this->obj_ctrl->LoadBusiness('cabang', 'mysql', $this->arr_config['db']);
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		$this->obj_harga= $this->obj_ctrl->LoadBusiness('course_wilayah', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		// load javascript 
		$this->obj_ctrl->LoadJavascript('jquery-1.3.2', 'jquery.ui');
		$this->obj_ctrl->LoadJavascript('ui/ui.core', 'jquery.ui');
		$this->obj_ctrl->LoadJavascript('ui/ui.datepicker', 'jquery.ui');
		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
		$this->obj_ctrl->LoadJavascript('ajaxify', 'jquery');
		$this->obj_ctrl->LoadJavaScript('ajax');
		// load style
		$this->obj_ctrl->LoadStyle('base/ui.all', 'jquery.ui');
		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		//display variabel
		self::DisplayVariabel();
		// display form
		self::DisplayFormEdit();
		// display test cookies
		self::DisplayNotification();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	private function DisplayVariabel(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));
		
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->arr_routes['params'][0])));
		
		$this->obj_tmpl->addVar('content', 'PAGE', $this->arr_routes['params'][0]);
		//link image
		$this->obj_tmpl->addVar('content', 'JQUERY_STYLE', HTTPPATH.'doc/temp/');
		//link autocomplete
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'membership', 'member', 'kota'));
	}
	
	private function DisplayFormEdit(){
		$this->obj_tmpl->addVar('content', 'URL_PENYELENGGARA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'cost'));
		$params = array($this->arr_routes['params'][1]);
		$result = $this->obj_course->GetDataAsSingleArray("GetDetailCourseById", $params);
		if(!empty($result)){
			self::ListContentCombo($result['id_penyelenggara']);
			$this->obj_tmpl->addVar('content', 'ID_COURSE', $result['id_course']);
			$this->obj_tmpl->addVar('content', 'TEMPAT', $result['tempat']);
			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);
			$this->obj_tmpl->addVar('content', 'PJ', $result['penanggung_jawab']);
			$this->obj_tmpl->addVar('content', 'TEKNISI', $result['teknisi']);
			$this->obj_tmpl->addVar('content', 'NURSE', $result['perawat']);
			$this->obj_tmpl->addVar('content', 'SESI', $result['nomor_pelatihan']);
			$this->obj_tmpl->addVar('content', 'KAPASITAS', $result['kapasitas']);
			
			$rs_city = $this->obj_harga->GetDataAsSingleArray("GetCityPenyelenggara", array($result['id_penyelenggara']));
			
		  	if(!empty($rs_city))
								$cost = $this->obj_harga->GetDataAsSingleArray("GetCostPenyelenggaraByIdCity", array($rs_city['id_city']));
								if(!empty($cost)){
								  $this->obj_tmpl->addVar('content', 'HARGA', "Rp ". number_format($cost['biaya'],0,',','.'));
								}
			self::GetAllTanggalCourseById($result['id_course']);
			$this->obj_tmpl->addVar('content', 'KOTA', self::GetNameCityById($result['id_city']));
			
			
			//content verifikasi
				$isi=array ( 0  => array ( 'waiting',"Waiting")
					, 1 => array ('reject',"Reject")
					, 2 => array ('verified',"Verified"));
			$rec=0;		
			while($rec <=2 ){
				if($isi[$rec][0] == $result['status_verifikasi'])
					$this->obj_tmpl->addVar('list_verifikasi', 'SELECTED', 'selected="selected"');
				else
					$this->obj_tmpl->addVar('list_verifikasi', 'SELECTED', '');
					$this->obj_tmpl->addVar('list_verifikasi', 'ID_VERIFIKASI', $isi[$rec][0]);
					$this->obj_tmpl->addVar('list_verifikasi', 'VERIFIKASI', $isi[$rec][1]);
					$this->obj_tmpl->ParseTemplate('list_verifikasi', 'a');	
					$rec++;
			}
		
			//------------		
		}
	}
	
	private function GetNameCityById($idcity){
		$result = $this->obj_registrasi->GetDataAsSingleArray("GetCityById", array($idcity));
		return $result['city_name'];
	}
	
	private function GetAllTanggalCourseById($id_course){
		
		$params = array($id_course);
		$rs_id = $this->obj_course->GetResourceId("GetAllTanggalCourseById", $params);
		if($rs_id){
			while($rs = mysqli_fetch_assoc($rs_id)){
				// gabungkan string
				$this->str_tgl = $this->str_tgl." ".$rs['tanggal'];
				$this->str_desc = $this->str_desc."#".$rs['deskripsi_tempat'];
				$this->str_idjadwal = $this->str_idjadwal."#".$rs['id_course_jadwal'];
			}
			
			// pecah variabel ke dalam array
			$this->str_tgl = explode(" ", $this->str_tgl);
			$this->str_desc = explode("#", $this->str_desc);
			$this->str_idjadwal = explode("#", $this->str_idjadwal);
			// set link untuk menuju ke halaman tambah atau edit jam materi
			$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'materi', array($this->arr_routes['params'][0], $this->arr_routes['params'][1]));
			// cetak ke pattemplate
			if(!empty($this->str_idjadwal[1])){
				$this->obj_tmpl->addVar('content', 'ID_JADWAL_1', $this->str_idjadwal[1]);
				$this->obj_tmpl->addVar('content', 'TGL_1', $this->str_tgl[1]);
				$this->obj_tmpl->addVar('content', 'DESC_1', $this->str_desc[1]);
				$this->obj_tmpl->addVar('content', 'URL_JADWAL_MATERI_1', $url_edit.'/'.$this->str_idjadwal[1]);
			}
			if(!empty($this->str_idjadwal[2])){
				$this->obj_tmpl->addVar('content', 'ID_JADWAL_2', $this->str_idjadwal[2]);
				$this->obj_tmpl->addVar('content', 'TGL_2', $this->str_tgl[2]);
				$this->obj_tmpl->addVar('content', 'DESC_2', $this->str_desc[2]);
				$this->obj_tmpl->addVar('content', 'URL_JADWAL_MATERI_2', $url_edit.'/'.$this->str_idjadwal[2]);
			}
			if(!empty($this->str_idjadwal[3])){
				$this->obj_tmpl->addVar('content', 'ID_JADWAL_3', $this->str_idjadwal[3]);
				$this->obj_tmpl->addVar('content', 'TGL_3', $this->str_tgl[3]);
				$this->obj_tmpl->addVar('content', 'DESC_3', $this->str_desc[3]);
				$this->obj_tmpl->addVar('content', 'URL_JADWAL_MATERI_3', $url_edit.'/'.$this->str_idjadwal[3]);
			}
		}
	}
	
	private function ListContentCombo($position){
		//parse data
		$cabang = $this->obj_branch->GetListCabangAll(array());
		
		$count = $this->obj_branch->CountCabang(array());
		$isi=array ( 0  => array ( 'Left',"Left")
                , 1 => array ('Right',"Right")
				, 2 => array ('Bottom',"Bottom"));
		$rec=0;		
		foreach($cabang as $key => $value) {
			if($value['id_penyelenggara'] == $position)
				$this->obj_tmpl->addVar('list_penyelenggara', 'SELECTED', 'selected="selected"');
			else
				$this->obj_tmpl->addVar('list_penyelenggara', 'SELECTED', '');
				$this->obj_tmpl->addVar('list_penyelenggara', 'ID_PENYELENGGARA', $value['id_penyelenggara']);
				$this->obj_tmpl->addVar('list_penyelenggara', 'PENYELENGGARA', $value['nama']);
				$this->obj_tmpl->ParseTemplate('list_penyelenggara', 'a');	
				$rec++;
		}			
		
		
	}
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>
