<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	var $obj_notify;

	var $obj_system;

	var $arr_selected;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/		

		// load business object

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		/* 

		-- display view content

		*/

		parent::DisplayWebTitle('Features Allocation');

		// display page link navigation

		self::DisplayPageLink();	

		// display variable

		self::DisplayVariable();	

		// display table induk

		self::DisplayTableFeatures();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'fasilitas'));

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function DisplayVariable(){

		$this->obj_tmpl->addVar('content', 'ID_GROUP', $this->arr_routes['params'][0]);

		$result = $this->obj_system->GetDetailData('sys_group_m', array('id_group' => "int:" . $this->arr_routes['params'][0]));

		$this->obj_tmpl->addVar('content', 'GROUP_NAME', $result['name_group']);

		$this->obj_tmpl->addVar('content', 'ID_AUTH', $this->arr_routes['params'][1]);

		$result = $this->obj_system->GetDetailData('sys_authority_m', array('id_auth' => "int:" . $this->arr_routes['params'][1]));

		$this->obj_tmpl->addVar('content', 'AUTH_NAME', $result['auth_name']);

	}

	

	private function DisplayTableFeatures(){

		// get 	

		$this->arr_selected = $this->obj_system->GetSelectedFeatures($this->arr_routes['params'][1]);

		// parameter

		$table = array("tbl" => "sys_menu_m");

		$fields = array("id_nav" => "id_nav", "title" => "title", "naration" => "naration");

		$params = array("id_group:AND" => "int:" . $this->arr_routes['params'][0], "id_parent:AND" => "int:" . 0);

		$limits = array();

		$orders = array("sort" => "ASC");

		// ------------------------------------------------------------------

		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);

		$no = 0;

		while($rec = mysqli_fetch_assoc($rs_id)){

			// parse data

			if(in_array($rec['id_nav'], $this->arr_selected))

				$this->obj_tmpl->addVar('list_menu', 'SELECTED', 'checked="checked"');	

			else

				$this->obj_tmpl->addVar('list_menu', 'SELECTED', '');	

			$this->obj_tmpl->addVar('list_menu', 'ID', $rec['id_nav']);	

			$this->obj_tmpl->addVar('list_menu', 'TITLE', $rec['title']);

			$this->obj_tmpl->addVar('list_menu', 'DESKRIPSI', $rec['naration']);

			$this->obj_tmpl->addVar('list_menu', 'INDENT', $no);

			// get child data

			$str_child = self::DisplayChild($rec['id_nav'], 10);

			$this->obj_tmpl->addVar('list_menu', 'CHILD', $str_child);

			// repeat

			$this->obj_tmpl->ParseTemplate('list_menu', 'a');

			$no++;	

		}

		if($no < 1)

			$this->obj_tmpl->setAttribute('list_menu', 'visibility', 'hidden');

	}

	

	private function DisplayChild($parent, $indent){

		$table = array("tbl" => "sys_menu_m");

		$fields = array("id_nav" => "id_nav", "title" => "title", "naration" => "naration");

		$params = array("id_group:AND" => "int:" . $this->arr_routes['params'][0], "id_parent:AND" => "int:" . $parent);

		$limits = array();

		$orders = array("sort" => "ASC");

		// ------------------------------------------------------------------

		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);

		$no = $indent + 30;

		$str = "";

		while($rec = mysqli_fetch_assoc($rs_id)){

			// parse data

			if(in_array($rec['id_nav'], $this->arr_selected))

				$selected = 'checked="checked"';	

			else

				$selected = '';		

			$str .= "<tr>";

			$str .= "<td style=\"padding-left: ".$no."px !important;\"><label>";

         	$str .= "<input type=\"checkbox\" name=\"selected[]\" value=\"".$rec['id_nav']."\" $selected />";

         	$str .= $rec['title'];          

			$str .= "<br /><em>".$rec['naration']."</em></label></td>";

			$str .= "</tr>";

			$str .= self::DisplayChild($rec['id_nav'], $no);

		}

		return $str;

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>