<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_admin;

	protected $obj_account;

	protected $obj_notify;

	protected $obj_date;

	protected $obj_crypt;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();		

		/* Other object loaded below */

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);

		$this->obj_account = $this->obj_ctrl->LoadBusiness('account', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_account->SetUsesBusinessQuery($loaded_query);

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');	

	}

	

	public function PageView(){

		// check authority

		//self::CheckAuthority();

		// variable display

		self::DisplayVariable();		

		// display user account

		self::DisplayUserAccount();

		// display privacy settings

		self::DisplayPrivacySettings();

		// display notification

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function CheckAuthority(){

		$params = array($this->str_userid, $this->arr_routes['params'][2]);

		if(!$this->obj_admin->CheckAuthorityByCabangAdmin($params)){

			// redirect to view page

			$this->obj_ctrl->RedirectUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');

		}

	}

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota'));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));

		// sub navigasi

		$page = $this->arr_routes['params'][0];

		$id_person = $this->arr_routes['params'][1];

		$id_cabang = $this->arr_routes['params'][2];

		// --

		$this->obj_tmpl->addVar('content', 'PAGE', $page);

		$this->obj_tmpl->addVar('content', 'ID_PERSON', $id_person);

		$this->obj_tmpl->addVar('content', 'ID_CABANG', $id_cabang);

		// --

		$this->obj_tmpl->addVar('content', 'URL_PRIBADI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_EDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_WORK_MAIN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kantor', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_WORK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_PRIVACY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'privacy', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_account', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($page, $id_person, $id_cabang)));	

	}

	

	private function DisplayUserAccount(){

		$result = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->arr_routes['params'][1]));
		
        $result_dpw = $this->obj_account->GetDataAsSingleArray("GetCekAkunAdminDpw", array($this->arr_routes['params'][1],$this->arr_routes['params'][1]));
        $result_dpd = $this->obj_account->GetDataAsSingleArray("GetCekAkunAdminDpd", array($this->arr_routes['params'][1],$this->arr_routes['params'][1]));
        //print_r($result_dpw[id]);
		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'EMAIL', $result['email']);

			$this->obj_tmpl->addVar('content', 'EMAIL_NOTIFIKASI', $result['email']);

			$this->obj_tmpl->addVar('content', 'USERID', $result['userid']);
            if(!empty($result_dpw[id])){
                
                $this->obj_tmpl->addVar('content', 'PASS_OLD',"******" );
                
            }elseif(!empty($result_dpd[id])){
                 $this->obj_tmpl->addVar('content', 'PASS_OLD',"******");
                
            }else{   
			$this->obj_tmpl->addVar('content', 'PASS_OLD', $this->obj_crypt->StandardDecrypt($result['pass'], $result['hash_key']));
            }
		}

	}

	

	private function DisplayPrivacySettings(){

		$result = $this->obj_account->GetDataAsSingleArray("GetPrivacySettingByIdPerson",array($this->arr_routes['params'][1]));

		if(!empty($result)){

			// basic

			if($result['basic'] == 'member')

				$this->obj_tmpl->addVar('content', 'PERSONAL_MEMBER', 'selected="selected"');

			else

				$this->obj_tmpl->addVar('content', 'PERSONAL_ALL', 'selected="selected"');

			// education

			if($result['education'] == 'member')

				$this->obj_tmpl->addVar('content', 'EDUCATION_MEMBER', 'selected="selected"');

			else

				$this->obj_tmpl->addVar('content', 'EDUCATION_ALL', 'selected="selected"');

			// workplace

			if($result['workplace'] == 'member')

				$this->obj_tmpl->addVar('content', 'WORKPLACE_MEMBER', 'selected="selected"');

			else

				$this->obj_tmpl->addVar('content', 'WORKPLACE_ALL', 'selected="selected"');

			// alamat

			if($result['address'] == 'member')

				$this->obj_tmpl->addVar('content', 'ALAMAT_MEMBER', 'selected="selected"');

			else

				$this->obj_tmpl->addVar('content', 'ALAMAT_ALL', 'selected="selected"');

			// post date

			$this->obj_tmpl->addVar('content', 'MDD_PRIVACY', $this->obj_date->GetFullDate($result['mdd']));

		}

	}

}



?>