<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_notify;

	protected $obj_data;

	protected $obj_cv;
	protected $obj_iuran;
	protected $obj_date;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_data = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);

		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		$this->obj_iuran = $this->obj_ctrl->LoadBusiness('iuran', 'mysql', $this->arr_config['db']);
		$loaded_query = array('business');
		$this->obj_iuran->SetUsesBusinessQuery($loaded_query);	
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	

	}

	

	public function PageView(){

		// display notification

		self::DisplayNotification();

		/* display view content */

		self::DisplayData();

		// hak akses

		//self::DisplayHakAkses();

		// kelompok studi

		//self::DisplayKelompokStudi();

		// variable display

		self::DisplayVariable();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariable(){

		// variable
$page = $this->arr_routes['params'][0];
		$id_person = $this->arr_routes['params'][1];
		$id_cabang = $this->arr_routes['params'][2];
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// parse url
		$this->obj_tmpl->addVar('content', 'URL_PRIBADI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_EDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_WORK_MAIN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kantor', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_WORK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_PRIVACY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'privacy', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_account', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($page, $id_person, $id_cabang)));	

	}

	

	private function DisplayData(){

		// get data anggota

		$result = $this->obj_cv->GetDataKeanggotaanByIdPerson(array($this->arr_routes['params'][1]));

		if(isset($this->obj_notify->arr_message['field'])){

			$result = $this->obj_notify->arr_message['field'];

		}

		$this->obj_tmpl->addVar('content', 'NO_IDI', $result['no_idi']);

		$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);

		$this->obj_tmpl->addVar('content', 'STATUS_ANGGOTA', $result['status_anggota']);

		// cabang

		$rs_id = $this->obj_data->GetDataCabang();

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				if($rec['id_cabang'] == $result['id_cabang']){

					$this->obj_tmpl->addVar('content', 'ID_CABANG', $rec['id_cabang']);

					$this->obj_tmpl->addVar('list_cabang', 'SELECTED', $rec['nama']);

				}else{

					$this->obj_tmpl->addVar('list_cabang', 'SELECTED', '');

				}

				$this->obj_tmpl->ParseTemplate('list_cabang', 'a');

			}

		}

		// tim p2kb

		$params = array($this->arr_routes['params'][1]);

		$rs_id = $this->obj_cv->GetTimP2kbByIdPerson($params);

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_tim_p2kb', 'WILAYAH', $rec['nama']);

				$this->obj_tmpl->addVar('list_tim_p2kb', 'DESKRIPSI', $rec['deskripsi']);

				$this->obj_tmpl->ParseTemplate('list_tim_p2kb', 'a');

			}

		}
		$tahun_selected = '';
		$tahun_start = date('Y')+3;
		$tahun = 2012;
		if(isset($this->arr_routes['params'][2])){
			$tahun = $this->arr_routes['params'][2];
		}
		$this->obj_tmpl->addVar('content', 'TAHUN', $tahun);
		for($i=$tahun_start;$i>=$tahun;$i--){
			if($i == $tahun){
				$tahun_selected = $i;
				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');
			}else{
				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');
			}
			$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $i);
			$iuran = $this->GetStatusPembayaran($this->arr_routes['params'][1], $i);
			$this->obj_tmpl->addVar('list_tahun', 'BYR', $iuran);
			$result = $this->obj_iuran->GetDataAsSingleArray("GetDataAnggotaRincianByPersonTahun", array($this->arr_routes['params'][1], $i));
			if(!empty($result)){
			$this->obj_tmpl->addVar('list_tahun', 'TGL',$this->obj_date->GetFullDate($result['mdd']));
			}
			$this->obj_tmpl->parseTemplate('list_tahun', 'a');
		}

	}

	
	private function GetStatusPembayaran($id_pereson, $tahun){
		//$this->obj_iuran->DebugQuery("GetDataAnggotaIuranByPersonTahun", array($id_pereson, $tahun));
		$result = $this->obj_iuran->GetDataAsSingleArray("GetDataAnggotaIuranByPersonTahun", array($id_pereson, $tahun));
		if(!empty($result)){
			switch($result['status_pelunasan']){
				
				case 'yes':
					return HTTPPATH.'doc/temp/note_accept.png';
					break;
				default:
					return HTTPPATH.'doc/temp/note_process.png';
					break;
			}
		}else{
			return HTTPPATH.'doc/temp/note_process.png';
		}
		
	} 
	private function DisplayHakAkses(){

		// get data anggota

		$rs_id=$this->obj_cv->GetDetailHakAksesByIdPerson(array($this->arr_routes['params'][1], $this->arr_config['app_group']['private']));

		while($rec = mysqli_fetch_assoc($rs_id)){

			$this->obj_tmpl->addVar('list_access', 'NAMA', $rec['auth_name']);

			$this->obj_tmpl->addVar('list_access', 'DESKRIPSI', $rec['deskripsi']);

			$this->obj_tmpl->ParseTemplate('list_access', 'a');

		}

	}

	

	private function DisplayKelompokStudi(){

		$arr_ks = array();

		// get data anggota

		$rs_id = $this->obj_cv->GetKelompokStudiByIdPerson(array($this->arr_routes['params'][1]));

		while($rec = mysqli_fetch_assoc($rs_id)){

			$arr_ks[] = $rec['id_kelompok_studi'];

		}

		// list data

		$table = array("tbl" => "spt_kelompok_studi_m");

		$fields = array("id_kelompok_studi" => "id_kelompok_studi", "nama" => "nama");

		$params = array();

		$limits = array();

		$orders = array("nama" => "ASC");

		// ------------------------------------------------------------------

		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);

		while($rec = mysqli_fetch_assoc($rs_id)){

			if(in_array($rec['id_kelompok_studi'], $arr_ks))

				$this->obj_tmpl->addVar('list_ks', 'CHECKED', 'checked="checked"');

			else

				$this->obj_tmpl->addVar('list_ks', 'CHECKED', '');

			$this->obj_tmpl->addVar('list_ks', 'VALUE', $rec['id_kelompok_studi']);

			$this->obj_tmpl->addVar('list_ks', 'NAMA', $rec['nama']);

			$this->obj_tmpl->ParseTemplate('list_ks', 'a');

		}

	}

}



?>