<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_admin;

	protected $obj_cv;

	protected $obj_notify;

	protected $obj_date;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */		

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	

		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date= $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		// javascript loaded

		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');

		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

		// loaded style

		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');	

	}

	

	public function PageView(){	

		// check authority

		self::CheckAuthority();	

		// display notification

		self::DisplayNotification();

		// display variable

		self::DisplayVariable();

		// display add form

		self::DisplayEditForm();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function CheckAuthority(){

		$params = array($this->str_userid, $this->arr_routes['params'][2]);

		if(!$this->obj_admin->CheckAuthorityByCabangAdmin($params)){

			// redirect to view page

			$this->obj_ctrl->RedirectUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');

		}

	}

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));

		// sub navigasi

		$page = $this->arr_routes['params'][0];

		$id_person = $this->arr_routes['params'][1];

		$id_cabang = $this->arr_routes['params'][2];

		$this->obj_tmpl->addVar('content', 'PAGE', $page);

		$this->obj_tmpl->addVar('content', 'ID_PERSON', $id_person);

		$this->obj_tmpl->addVar('content', 'ID_CABANG', $id_cabang);

		// --

		$this->obj_tmpl->addVar('content', 'URL_PRIBADI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_EDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_WORK_MAIN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kantor', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_WORK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_PRIVACY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'privacy', array($page, $id_person, $id_cabang)));

		$this->obj_tmpl->addVar('content', 'URL_ACCOUNT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($page, $id_person, $id_cabang)));	

		// remote data

		$this->obj_tmpl->addVar('content', 'URL_REMOTEKOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota'));

		$this->obj_tmpl->addVar('content', 'URL_REMOTEPRAKTIK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tempat-praktik'));

	}

	

	private function DisplayEditForm(){

		$params = array($this->arr_routes['params'][1]);

		$result = $this->obj_cv->GetDetailTempatKerjaUtamaById($params);

		// parse

		if(!isset($this->obj_notify->arr_message['field'])){

			if(!empty($result)){

				$this->obj_tmpl->addVar('content', 'TEMPAT', $result['tempat']);

				$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);

				$this->obj_tmpl->addVar('content', 'NOMOR_SK', $result['nomor_sk']);

				$this->obj_tmpl->addVar('content', 'KETERANGAN_SK', $result['keterangan_sk']);	

				$this->obj_tmpl->addVar('content', 'JABATAN', $result['jabatan']);

				$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);	

				$this->obj_tmpl->addVar('content', 'TELEPON', $result['telepon']);

				$this->obj_tmpl->addVar('content', 'FAX', $result['fax']);

				$this->obj_tmpl->addVar('content', $result['status_pegawai'], 'selected="selected"');

			}

		}

	}

}



?>