<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_admin;
	protected $obj_cv;
	protected $obj_anggota;
	protected $obj_data;
	protected $obj_notify;
	protected $obj_system;
	private $int_propinsi;
	private $int_kota;
	//protected $obj_data;
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();		
		/* Other object loaded below */
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		$this->obj_anggota = $this->obj_ctrl->LoadBusiness('anggota', 'mysql', $this->arr_config['db']);	
		//$this->obj_data = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);
		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);
		$this->obj_data = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);
		$this->obj_data->UseQuery(array('propinsi', 'kota'));
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
		$this->obj_ctrl->LoadJavascript('jquery');
		$this->obj_ctrl->LoadJavascript('ajaxify', 'jquery');
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		// check authority
		//self::CheckAuthority();
		// variable display
		self::DisplayVariable();
		// display notification
		self::DisplayNotification();
		// keanggotaan
		self::DisplayKeanggotaan();
		// hak akses
		self::DisplayHakAkses();
		// kelompok studi
		self::DisplayKelompokStudi();
		// tim p2kb
		//self::DisplayTimP2Kb();
		// komisi pusat
		// self::DisplayKomisiPusat();
		// kolegium
		// self::DisplayKolegium();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function CheckAuthority(){
		$params = array($this->str_userid, $this->arr_routes['params'][2]);
		if(!$this->obj_admin->CheckAuthorityByCabangAdmin($params)){
			// redirect to view page
			$this->obj_ctrl->RedirectUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');
		}
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));
		$this->obj_tmpl->addVar('content', 'URL_KOTA_KOM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota-komisariat'));
		// sub navigasi
		$page = $this->arr_routes['params'][0];
		$id_person = $this->arr_routes['params'][1];
		$id_cabang = $this->arr_routes['params'][2];
		// --
		$this->obj_tmpl->addVar('content', 'PAGE', $page);
		$this->obj_tmpl->addVar('content', 'ID_PERSON', $id_person);
		$this->obj_tmpl->addVar('content', 'ID_CABANG', $id_cabang);
		// --
		$this->obj_tmpl->addVar('content', 'URL_PRIBADI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_EDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_WORK_MAIN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kantor', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_WORK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_PRIVACY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'privacy', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_account', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($page, $id_person, $id_cabang)));	
		
		$result = $this->obj_admin->GetDatasetAsArray('CekAuthorityadmin',(array($this->str_userid,'32')));
		//print_r($result[0]['total']);
		if(empty($result[0]['id_auth'])){
			 $this->obj_tmpl->setAttribute('conf_show', 'visibility', 'hidden');
			  $this->obj_tmpl->setAttribute('conf_show_wilayah', 'visibility', 'hidden');
			 
			}	
	}

	private function DisplayKeanggotaan(){
		// get data anggota
		$result = $this->obj_cv->GetDataKeanggotaanByIdPerson(array($this->arr_routes['params'][1]));
		if(isset($this->obj_notify->arr_message['field'])){
			$result = $this->obj_notify->arr_message['field'];
		}
		$this->obj_tmpl->addVar('conf_show_wilayah', $result['status_anggota'], 'selected="selected"');
		//$prov_selected = ((isset($this->obj_notify->arr_message['field']['prov_kom']))?$this->obj_notify->arr_message['field']['prov_kom']:0);
		
		$this->int_propinsi = (isset($result['id_province_kom'])?$result['id_province_kom']:0);
		//print_r($this->int_propinsi);
		$this->int_kota = (isset($result['id_city_komisariat'])?$result['id_city_komisariat']:0);
		$this->obj_tmpl->addVar('content', 'NO_IDI', $result['no_idi']);
		$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);
		
		
		// Propinsi
			
		$rs_id = $this->obj_admin->GetListProvinceByAdmin(array());	
			while($rs = mysqli_fetch_assoc($rs_id)){	
			
				
				if($rs['id_province'] == $result['id_province_kom'] ){
					$this->obj_tmpl->addVar('list_province', 'SELECTED', 'selected="selected"');
				
				}else{
					$this->obj_tmpl->addVar('list_province', 'SELECTED', '');
				}	
				$this->obj_tmpl->addVar('list_province', 'VALUE', $rs['id_province']);
				$this->obj_tmpl->addVar('list_province', 'NAME', $rs['province_name']);
				$this->obj_tmpl->parseTemplate('list_province', 'a');
			}
		//$this->obj_data->DebugQuery("GetListKotaByPropinsi", array($this->int_propinsi));	
		$rs_id = $this->obj_data->GetResourceId("GetListKotaByPropinsi", array($this->int_propinsi));
		if($rs_id){
			while($rec = mysqli_fetch_assoc($rs_id)){
			
				if($rec['id_city']==$result['id_city_komisariat']){
				$this->obj_tmpl->addVar('list_kota', 'SELECTED', 'selected="selected"');
				}else{
					$this->obj_tmpl->addVar('list_kota', 'SELECTED', '');
				}	
				$this->obj_tmpl->addVar('list_kota', 'VALUE', $rec['id_city']);
				$this->obj_tmpl->addVar('list_kota', 'NAMA', $rec['city_name']);
				$this->obj_tmpl->ParseTemplate('list_kota', 'a');
			}
		}
		// cabang
		//$rs_id = $this->obj_data->GetDataCabang();
		$rs_id = $this->obj_data->GetResourceId("GetListKomisariatByKota", array($this->int_kota));
		//while($rec = mysqli_fetch_assoc($rs_id)){
		if($rs_id){
			while($rec = mysqli_fetch_assoc($rs_id)){
			if($rec['id_cabang'] == $result['id_cabang']){
				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', 'selected="selected"');
			
			}else{
				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', '');
				
			}	
			$this->obj_tmpl->addVar('list_cabang', 'VALUE', $rec['id_cabang']);
			$this->obj_tmpl->addVar('list_cabang', 'LABEL', $rec['nama']);
			$this->obj_tmpl->ParseTemplate('list_cabang', 'a');
			}
		}
	}
	
	private function DisplayHakAkses(){
		// get data anggota
		$result = $this->obj_cv->GetHakAksesByIdPerson(array($this->arr_routes['params'][1], $this->arr_config['app_group']['private']));
		// list data
		$table = array("tbl" => "sys_authority_m");
		$fields = array("id_auth" => "id_auth", "id_group" => "id_group", "auth_name" => "auth_name", "deskripsi" => "deskripsi");
		$params = array("id_group:AND" => "int:" . $this->arr_config['app_group']['private']);
		$limits = array();
		$orders = array("auth_name" => "ASC");
		// ------------------------------------------------------------------
		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);
		while($rec = mysqli_fetch_assoc($rs_id)){
			if(in_array($rec['id_auth'], $result))
				$this->obj_tmpl->addVar('list_access', 'CHECKED', 'checked="checked"');
			else
				$this->obj_tmpl->addVar('list_access', 'CHECKED', '');
			$this->obj_tmpl->addVar('list_access', 'VALUE', $rec['id_auth']);
			$this->obj_tmpl->addVar('list_access', 'NAMA', $rec['auth_name']);
			$this->obj_tmpl->addVar('list_access', 'DESKRIPSI', $rec['deskripsi']);
			$this->obj_tmpl->ParseTemplate('list_access', 'a');
		}
	}
	
	private function DisplayTimP2Kb(){
		$arr_tim = array();
		// get data anggota
		$rs_id = $this->obj_cv->GetTimP2kbByIdPerson(array($this->arr_routes['params'][1]));
		while($rec = mysqli_fetch_assoc($rs_id)){
			$arr_tim[] = $rec['id_wilayah'];
		}
		// list data
		$table = array("tbl" => "cpd_wilayah_p2kb_m");
		$fields = array("id_wilayah" => "id_wilayah", "nama" => "nama", "deskripsi" => "deskripsi");
		$params = array();
		$limits = array();
		$orders = array("id_wilayah" => "ASC");
		// ------------------------------------------------------------------
		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);
		while($rec = mysqli_fetch_assoc($rs_id)){
			if(in_array($rec['id_wilayah'], $arr_tim))
				$this->obj_tmpl->addVar('list_tim', 'CHECKED', 'checked="checked"');
			else
				$this->obj_tmpl->addVar('list_tim', 'CHECKED', '');
			$this->obj_tmpl->addVar('list_tim', 'VALUE', $rec['id_wilayah']);
			$this->obj_tmpl->addVar('list_tim', 'NAMA', $rec['nama']);
			$this->obj_tmpl->addVar('list_tim', 'DESKRIPSI', $rec['deskripsi']);
			$this->obj_tmpl->ParseTemplate('list_tim', 'a');
		}
	}
	
	private function DisplayKelompokStudi(){
		$arr_ks = array();
		// get data anggota
		$rs_id = $this->obj_cv->GetKelompokStudiByIdPerson(array($this->arr_routes['params'][1]));
		while($rec = mysqli_fetch_assoc($rs_id)){
			$arr_ks[] = $rec['id_kelompok_studi'];
		}
		// list data
		$table = array("tbl" => "spt_kelompok_studi_m");
		$fields = array("id_kelompok_studi" => "id_kelompok_studi", "nama" => "nama");
		$params = array();
		$limits = array();
		$orders = array("nama" => "ASC");
		// ------------------------------------------------------------------
		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);
		while($rec = mysqli_fetch_assoc($rs_id)){
			if(in_array($rec['id_kelompok_studi'], $arr_ks))
				$this->obj_tmpl->addVar('list_ks', 'CHECKED', 'checked="checked"');
			else
				$this->obj_tmpl->addVar('list_ks', 'CHECKED', '');
			$this->obj_tmpl->addVar('list_ks', 'VALUE', $rec['id_kelompok_studi']);
			$this->obj_tmpl->addVar('list_ks', 'NAMA', $rec['nama']);
			$this->obj_tmpl->ParseTemplate('list_ks', 'a');
		}
	}
}

?>