<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_admin;
	protected $obj_cv;
	protected $obj_notify;
	protected $obj_date;
	private $obj_branch;
	
	private $obj_tcpdf;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
		//$this->obj_tmpl->readTemplatesFromFile('template.html');
         $this->obj_tmpl->readTemplatesFromFile('styles.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('content');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();		
		/* Other object loaded below */
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);	
		$this->obj_branch = $this->obj_ctrl->LoadBusiness('cabang', 'mysql', $this->arr_config['db']);
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');		
		// load plugins
		//$this->obj_ctrl->LoadFile('phpqrcode/qrlib.php', 'plugins');
		//$this->obj_tcpdf = $this->obj_ctrl->LoadClass('tcpdf');
	}
	
	public function PageView(){
		// check authority
		//self::CheckAuthority();
		// display notification
		//self::PrintPDF();
		self::DisplayNotification();
		/* display view content */
		self::DisplayIdentitasPribadi();
		
		// keanggotaan
		//self::DisplayKeanggotaan();
		// variable display
		self::DisplayVariable();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function CheckAuthority(){
		$params = array($this->str_userid, $this->arr_routes['params'][2]);
		if(!$this->obj_admin->CheckAuthorityByCabangAdmin($params)){
			// redirect to view page
			$this->obj_ctrl->RedirectUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');
		}
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));	
	}
	
	private function DisplayIdentitasPribadi(){
		//$params = array($this->arr_routes['params'][1]);
		$id=$_POST['selector'];
		$N = count($id);
		for($i=0; $i < $N; $i++)
		{
		
		$result = $this->obj_cv->GetListDataKeAnggotaByperson(array($id[$i]));	
		//while($rs = mysqli_fetch_assoc($rs_id)){	
		while($data_keanggotaan = mysqli_fetch_assoc($result)){
		
		$style = array(
						'position' => 'R',
						'align' => 'C',
						'stretch' => true,
						'fitwidth' => true,
						'border' => true,
						'padding' => 1,
						'fgcolor' => array(0,0,0),
						'bgcolor' => false, //array(255,255,255),
						'text' => true,
						'font' => 'helvetica',
						'fontsize' => 8,
						'stretchtext' => 4
					);
		
		
		
		
					// CODE 128 A
						//$this->obj_tcpdf->Cell(30, 0, 'CODE 128 A', 0, 1);
			//$barcode=$this->obj_tcpdf->write1DBarcode($data_keanggotaan['no_anggota'], 'C128', 0, 30, '', 15, 0.3, $style, 'N');
			//print_r($barcode);
			//echo"$barcode"."test";
		$this->obj_tmpl->addVar('list_kta', 'NO_ANGGOTA', $data_keanggotaan['no_anggota']);
		$this->obj_tmpl->addVar('list_kta', 'STATUS_ANGGOTA', $data_keanggotaan['status_anggota']);
		$this->obj_tmpl->addVar('list_kta', 'CABANG', $data_keanggotaan['cabang']);
		//$this->obj_tmpl->addVar('list_kta', 'BARCODE', $barcode);
		$tempdir = "doc/temp/"; //<-- Nama Folder file QR Code kita nantinya akan disimpan
if (!file_exists($tempdir))#kalau folder belum ada, maka buat.
    mkdir($tempdir);
	#parameter inputan


		$this->obj_tmpl->addVar('contet', 'BARCODE', $data_keanggotaan['no_anggota'] );
		
		
		}
		//print_r($id);
		//$this->obj_cv->Debugquery("GetListDataKeAnggotaByperson",array($id[$i]));
		$rs_id = $this->obj_cv->GetListDataAnggotaByperson(array($id[$i]));		
		//while($rs = mysqli_fetch_assoc($rs_id)){	
		while($data = mysqli_fetch_assoc($rs_id)){
		// photo
	    $file_photo = "https://ppni-inna.org/doc/person/".$id[$i]."/foto/".$data['photo'];
	    $this->obj_tmpl->addVar('list_kta', 'PHOTOPATH', $file_photo);
	   // print_r($file_photo);
		//if(is_file($file_photo))
		//	$this->obj_tmpl->addVar('list_kta', 'PHOTOPATH', $file_photo);
		//else
		//	$this->obj_tmpl->addVar('list_kta', 'PHOTOPATH', HTTPPATH."doc/temp/blank.jpg");	
		// cek notification 
		if(isset($this->obj_notify->arr_message['field'])){
			$result = $this->obj_notify->arr_message['field'];
		}
		
		//print_r( $data['nama_lengkap']);
		// parse data
		//$this->obj_tmpl->addVar('list_kta', 'PAGE', $this->arr_routes['params'][0]);
		//$this->obj_tmpl->addVar('list_kta', 'ID_PERSON', $this->arr_routes['params'][1]);
		//$this->obj_tmpl->addVar('list_kta', 'ID_CABANG', $this->arr_routes['params'][2]);
		
		$this->obj_tmpl->addVar('list_kta', 'NAMA_LENGKAP', $data['nama_lengkap']);	
		$this->obj_tmpl->addVar('list_kta', 'TEMPAT_LAHIR', $data['tempat_lahir']);	
		$this->obj_tmpl->addVar('list_kta', 'PREFIX', $data['prefix']);	
		$this->obj_tmpl->addVar('list_kta', 'SUFFIX', $data['suffix']);	
		$this->obj_tmpl->addVar('list_kta', 'ALAMAT', $data['alamat']);	
		$this->obj_tmpl->addVar('list_kta', 'PROPINSI', $data['province_name']);
		$this->obj_tmpl->addVar('list_kta', 'KOTA', $data['kota_komisariat']);	
		$this->obj_tmpl->addVar('list_kta', 'KODEPOS', $data['kodepos']);	
		$this->obj_tmpl->addVar('list_kta', 'TELEPON', $data['telepon']);
		$this->obj_tmpl->addVar('list_kta', 'NO_HP', $data['no_hp']);
		$this->obj_tmpl->addVar('list_kta', 'BARCODE', $data['nama_lengkap'].$data['tempat_lahir'].'ALAMAT', $data['alamat']);
		$this->obj_tmpl->addVar('list_kta', 'TANGGAL_LAHIR', $this->obj_date->GetFullDate($data['tanggal_lahir']));
		
		$result = $this->obj_branch->GetPengurusDaerahById(array($data['id_city_komisariat']));
		$this->obj_tmpl->addVar('list_kta', 'NAME_KETUA_DPD', $result['0']['ketua']);
		$this->obj_tmpl->addVar('list_kta', 'NIRA', $result['0']['no_ketua']);

		
		$tanggal_lahir=0;
		$tangnggal=0;
		$bulan=0;
		$tahun=0;
		$masa_berlaku=0;
		
		$tanggal_lahir=explode("-",($data['tanggal_lahir']));
		$tangnggal=$tanggal_lahir['1'];
		$bulan=$tanggal_lahir['2'];
		$tahun=date('Y')+5;
		$masa_berlaku=$tahun."-".$tangnggal."-".$bulan;
		$this->obj_tmpl->addVar('list_kta', 'MASA_BERLAKU', $this->obj_date->GetFullDate($masa_berlaku));
		$tgl_terbit=date("Y-m-d");
		$this->obj_tmpl->addVar('list_kta', 'TGL_TERBIT', $this->obj_date->GetFullDate($tgl_terbit));
		//print_r($masa_berlaku);
		$this->obj_tmpl->ParseTemplate('list_kta', 'a');
	
			}
		}
	
	}
	
	
	private function PrintPDF(){
	$filename="Kartu Anggota".".pdf"; //ubah untuk menentukan nama file pdf yang dihasilkan nantinya  
	//==========================================================================================================  
	//Copy dan paste langsung script dibawah ini,untuk mengetahui lebih jelas tentang fungsinya silahkan baca-baca tutorial tentang HTML2PDF  
	//==========================================================================================================  
	$content = ob_get_clean();  
	$content = '<page style="font-family: freeserif">'.($content).'</page>';  
	 require_once(dirname(__FILE__).'/html2pdf/html2pdf.class.php');  
	 try  
	 {  
  $html2pdf = new HTML2PDF('P','Legal','en', false, 'ISO-8859-15',array(3,4));  
  $html2pdf->setDefaultFont('arial','2');  
  $html2pdf->writeHTML($content, isset($_GET['vuehtml']));  
  $html2pdf->Output($filename);  
 }  
 catch(HTML2PDF_exception $e) { echo $e; }  
	}
	
	
	
	private function DisplayKeanggotaan(){
		// get data anggota
		$id=$_POST['selector'];
		$N = count($id);
		for($i=0; $i < $N; $i++)
		{
		$result = $this->obj_cv->GetDataKeanggotaanByIdPerson(array($id[$i]));
		if(isset($this->obj_notify->arr_message['field'])){
			$result = $this->obj_notify->arr_message['field'];
		}
		$style = array(
						'position' => 'R',
						'align' => 'C',
						'stretch' => true,
						'fitwidth' => true,
						'border' => true,
						'padding' => 1,
						'fgcolor' => array(0,0,0),
						'bgcolor' => false, //array(255,255,255),
						'text' => true,
						'font' => 'helvetica',
						'fontsize' => 8,
						'stretchtext' => 4
					);
		
		
		
		
					// CODE 128 A
						//$this->obj_tcpdf->Cell(30, 0, 'CODE 128 A', 0, 1);
		$barcode = $this->obj_tcpdf->write1DBarcode($result['no_anggota'], 'C128', 0, 72, '', 15, 0.3, $style, 'N');
		//print_r($barcode);
		$this->obj_tmpl->addVar('content', 'BARCODE', $barcode);
		$this->obj_tmpl->addVar('content', 'NO_IDI', $result['no_idi']);
		$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);
		$this->obj_tmpl->addVar('content', 'STATUS_ANGGOTA', $result['status_anggota']);
		$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);
	}
	}
	
	
	
}

?>