<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_admin;

	protected $obj_registrasi;

	protected $obj_mutasi;
	protected $obj_iuran;

	protected $obj_paging;

	protected $obj_date;

	// var

	protected $str_keyword;

	protected $str_cabang;
	protected $str_cari_par;

	protected $arr_cabang = array();

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		// load object business

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	

		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);	

		$this->obj_mutasi = $this->obj_ctrl->LoadBusiness('mutasi', 'mysql', $this->arr_config['db']);
		$this->obj_iuran = $this->obj_ctrl->LoadBusiness('iuran', 'mysql', $this->arr_config['db']);
		$loaded_query = array('business');
		$this->obj_iuran->SetUsesBusinessQuery($loaded_query);
		// load object pagination

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');	

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();		

		// display cabang

		//self::DisplayCabangAuthority();	

		// display calon anggota

		self::DisplayMutasiAnggota();

		// display notification

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru'));	

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));	

		// keyword

		if(isset($_SESSION['search']['keyword'])){

			$this->str_keyword = "%" . $_SESSION['search']['keyword'] . "%";

			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['keyword']);

		}else{

			$this->str_keyword = "%%";

		}
		
		if(isset($_SESSION['search']['nira']) && $_SESSION['search']['nira']>0){

			$this->int_cabang = $_SESSION['search']['nira'];

			$this->str_cari_par .= " AND a.no_anggota = " .$_SESSION['search']['nira']." " ;
			$this->obj_tmpl->addVar('content', 'NIRA', $_SESSION['search']['nira']);

		}

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayCabangAuthority(){

		if(isset($_SESSION['search']['cabang'])){ $this->str_cabang = $_SESSION['search']['cabang'];}

		// parsing data

		$rs_id = $this->obj_admin->GetListCabangByAdmin(array($this->str_userid));		

		while($rs = mysqli_fetch_assoc($rs_id)){	

			$this->arr_cabang[] = $rs['id_cabang'];

			if($rs['id_cabang'] == $this->str_cabang){

				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', 'selected="selected"');

			}else{

				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', '');

			}

			$this->obj_tmpl->addVar('list_cabang', 'VALUE', $rs['id_cabang']);

			$this->obj_tmpl->addVar('list_cabang', 'NAMA', $rs['nama']);

			$this->obj_tmpl->ParseTemplate('list_cabang', 'a');

		}

		if(empty($this->str_cabang))

			$this->arr_cabang = implode(',', $this->arr_cabang);

		else

			$this->arr_cabang = $this->str_cabang;

	}

	

	private function DisplayMutasiAnggota(){

		/* 

		-- display paging template (bagian atas)

		*/

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][0]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][0];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_mutasi->GetTotalPerizinanAnggotaByAdmin(array( $this->str_keyword,$this->str_cari_par)));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get data

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		//$this->obj_mutasi->DebugQuery("GetDataMutasiAnggotaByAdmin",array($this->str_keyword, $start, $max));	
		//$this->obj_mutasi->DebugQuery("GetDataMutasiAnggotaByAdminppNew",array($this->str_keyword,$this->str_cari_par, $start, $max));
		$rs_id = $this->obj_mutasi->GetDataPerizinannggotaByAdminpp(array($this->str_keyword,$this->str_cari_par, $start, $max));	

		if($rs_id){

			$no = $start + 1;

			while($rs = mysqli_fetch_assoc($rs_id)){				  

				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'detail_sipp_dpp', array( $rs['id'],$rs['id_person']));
				
				$url_rekom = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array( $rs['id'],$rs['id_person']));
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'ID', $rs['no_urut']);
				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama_lengkap']);
				$this->obj_tmpl->addVar('list_data', 'REKOM', $rs['jenis_rekom']);
                $this->obj_tmpl->addVar('list_data', 'NO_ANGGOTA', $rs['no_anggota']);
                $cabang_asal = $this->obj_mutasi->GetDataAsSingleArray("GetCabangByid", array($rs['id_cabang']));
				$this->obj_tmpl->addVar('list_data', 'DPK', $cabang_asal['nama']);
				$propinsi_asal = $this->obj_mutasi->GetDataAsSingleArray("GetPropinsiByid", array($rs['id_province_kom']));
				$this->obj_tmpl->addVar('list_data', 'DPW', $propinsi_asal['province_name']);
				$rs_city = $this->obj_iuran->GetDataAsSingleArray("GetCityById", array($rs['id_city_komisariat']));
				$this->obj_tmpl->addVar("list_data", "DPD", $rs_city['city_name']);
				$this->obj_tmpl->addVar('list_data', 'TGL_USULAN', $this->obj_date->GetFullDate($rs['mdd'], 'ins'));
                $this->obj_tmpl->addVar('list_data', 'URL_REGISTRASI', '<a href="'.$url.'" class="button-edit">Verifikasi</a>');
                if($rs['status_verfikasi']=='yes'){

					$img_dpd = HTTPPATH.'doc/temp/note_next.png';

					}else{

					$img_dpd = HTTPPATH.'doc/temp/note_process.png';

				}
				if($rs['status_bayar']=='yes'){

					$img_byr= HTTPPATH.'doc/temp/note_next.png';

					}else{

					$img_byr = HTTPPATH.'doc/temp/note_process.png';

				}
				$this->obj_tmpl->addVar('list_data', 'IMG_DPD', $img_dpd);
				$this->obj_tmpl->addVar('list_data', 'IMG_BYR', $img_byr);
				
                $this->obj_tmpl->addVar('list_data', 'URL_REKOM', '<a href="'.$url_rekom.'" class="button-edit">Rekomendasi</a>');
                $this->obj_tmpl->ParseTemplate('list_data', 'a');
                $no++;

			}

		}

	}

}



?>