<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_admin;

	protected $obj_cv;

	protected $obj_data;

	protected $obj_notify;

	protected $obj_date;

	private $int_propinsi = 0;

	private $int_kota = 0;

	private $int_kecamatan = 0;

	private $int_kelurahan = 0;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();		

		/* Other object loaded below */

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);

		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);

		$this->obj_data = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);

		$this->obj_data->UseQuery(array('propinsi', 'kota'));	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		// javascript loaded

		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');

		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

		// load object pagination

		$this->obj_ctrl->LoadJavascript('jquery');

		$this->obj_ctrl->LoadJavascript('ajaxify', 'jquery');

		// dhtmlgoodies_calendar loaded

		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');

		// dhtmlgoodies_calendar loaded body event

		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");

		// loaded style

		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');		

	}

	

	public function PageView(){

		

		// display notification

		self::DisplayNotification();

		/* display view content */

		self::DisplayIdentitasPribadi();

		/* display propinsi */

		self::DisplayFormProvinsi();

		// variable display

		self::DisplayVariable();

		// Get Memory Allocation

		//ini_set('memory_limit', '9999M'); //Raise to 512 MB

		//ini_set('max_execution_time', '3600'); //Raise to 512 MBs

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		

		// sub navigasi

		

		// parse url

		$this->obj_tmpl->addVar('content', 'URL_KOTA_KOM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota-komisariat'));

	}

	

	

	private function DisplayFormProvinsi(){

		$prov_selected = ((isset($this->obj_notify->arr_message['field']['prov_alamat']))?$this->obj_notify->arr_message['field']['prov_alamat']:0);

		// display propinsi

		$rs_id = $this->obj_data->GetResourceId("GetListPropinsi", array());

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				if($this->int_propinsi == $rec['id_province'])

					$this->obj_tmpl->addVar('list_province', 'SELECTED', 'selected="selected"');

				else

					$this->obj_tmpl->addVar('list_province', 'SELECTED', '');

				$this->obj_tmpl->addVar('list_province', 'VALUE', $rec['id_province']);

				$this->obj_tmpl->addVar('list_province', 'NAME', $rec['province_name']);

				$this->obj_tmpl->parseTemplate('list_province', 'a');

			}

		}

		// display kota

			

			/*$rs_id = $this->obj_data->GetResourceId("GetListKotaByPropinsi", array($this->int_propinsi));

			if($rs_id){

				while($rec = mysqli_fetch_assoc($rs_id)){

					if( $this->int_kota == $rec['id_city'])

						$this->obj_tmpl->addVar('list_city', 'SELECTED', 'selected="selected"');

					else

						$this->obj_tmpl->addVar('list_city', 'SELECTED', '');

					$this->obj_tmpl->addVar('list_city', 'VALUE', $rec['id_city']);

					$this->obj_tmpl->addVar('list_city', 'NAME', $rec['city_name']);

					$this->obj_tmpl->ParseTemplate('list_city', 'a');

				}

			}*/

	}

		

	private function DisplayIdentitasPribadi(){

		$params = array($this->arr_routes['params'][1]);

		//$this->obj_cv->DebugQuery("GetIdentitasPribadiByMutasi",($params));	

		$result = $this->obj_cv->GetIdentitasPribadiByMutasi($params);	

		// photo

		$file_photo = "doc/foto/".$result['photo'];

		if(is_file($file_photo))

			$this->obj_tmpl->addVar('content', 'PHOTOPATH', HTTPPATH.$file_photo);

		else

			$this->obj_tmpl->addVar('content', 'PHOTOPATH', HTTPPATH."doc/temp/blank.jpg");	

		// cek notification 

		if(isset($this->obj_notify->arr_message['field'])){

			$result = $this->obj_notify->arr_message['field'];

		}

		// parse data

		$this->obj_tmpl->addVar('content', 'PAGE', $this->arr_routes['params'][0]);

		$this->obj_tmpl->addVar('content', 'ID_PERSON', $this->arr_routes['params'][1]);

		$this->obj_tmpl->addVar('content', 'ID_CABANG_ASAL', $this->arr_routes['params'][2]);

		$this->obj_tmpl->addVar('content', 'ID_PROPINSI', $result['id_province_kom']);

		$this->obj_tmpl->addVar('content', 'ID_CITY', $result['id_city_komisariat']);

		$this->obj_tmpl->addVar('content', 'URUT', $result['no_urut']);

		$this->obj_tmpl->addVar('content', 'NAMA_LENGKAP', $result['nama_lengkap']);

		$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);

		$this->obj_tmpl->addVar('content', 'KTP', $result['no_ktp']);	

		$this->obj_tmpl->addVar('content', 'TEMPAT_LAHIR', $result['tempat_lahir']);	

		$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);	

		$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);	

		$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);

		$this->obj_tmpl->addVar('content', 'RELASI', ucwords($result['status_relasi']));

		$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);		

		$this->obj_tmpl->addVar('content', 'PROPINSI', $result['propinsi']);	

		$this->obj_tmpl->addVar('content', 'KOMISARIAT', $result['komisariat']);

		$this->int_propinsi = $result['id_province'];

		$this->int_kota = $result['id_city'];

		$this->int_kecamatan = $result['id_districts'];

		$this->int_kelurahan = $result['id_villages'];

		

		$this->obj_tmpl->addVar('content', 'NO_HP', $result['no_hp']);

		$this->obj_tmpl->addVar('content', $result['jenis_kelamin'], 'selected="selected"');

	

	}

}



?>