<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_admin;
	protected $obj_cv;
	protected $obj_notify;
	protected $obj_date;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();		
		/* Other object loaded below */
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);	
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
		$this->obj_date= $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// load javascript
		$this->obj_ctrl->LoadJavascript('form_event');	
	}
	
	public function PageView(){
		// check authority
		//self::CheckAuthority();
		// variable display
		self::DisplayVariable();
		// display notification
		self::DisplayNotification();
		/* display view content */
		self::DisplayFormData();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function CheckAuthority(){
		$params = array($this->str_userid, $this->arr_routes['params'][2]);
		if(!$this->obj_admin->CheckAuthorityByCabangAdmin($params)){
			// redirect to view page
			$this->obj_ctrl->RedirectUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');
		}
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('form', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));
		// sub navigasi
		$page = $this->arr_routes['params'][0];
		$id_person = $this->arr_routes['params'][1];
		$id_cabang = $this->arr_routes['params'][2];
		$this->obj_tmpl->addVar('form', 'PAGE', $page);
		$this->obj_tmpl->addVar('form', 'ID_PERSON', $id_person);
		$this->obj_tmpl->addVar('form', 'ID_CABANG', $id_cabang);
		// --
		$this->obj_tmpl->addVar('content', 'URL_PRIBADI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_EDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('form', 'URL_EDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_WORK_MAIN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kantor', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_WORK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_PRIVACY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'privacy', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_ACCOUNT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($page, $id_person, $id_cabang)));		
	}
	
	private function DisplayFormData(){	
		if(!isset($this->arr_routes['params'][3])){
			$this->arr_routes['params'][3] = 'default';		
		}
		switch($this->arr_routes['params'][3]){
			case 'add':
				self::DisplayFormAdd();
				break;
			case 'edit':
				self::DisplayFormEdit();
				break;
			default :
				self::DisplayFormList();
				break;
		}
	}
	
	// list
	
	private function DisplayFormList(){	
		// --
		$arr_bulan = array('01' => 'Jan', '02' => 'Feb', '03' => 'Mar', '04' => 'Apr', '05' => 'Mei', '06' => 'Jun', '07' => 'Jul', '08' => 'Ags', '09' => 'Sep', '10' => 'Okt', '11' => 'Nov', '12' => 'Des', "" => "");
		$no = 0;
		$page = $this->arr_routes['params'][0];
		$id_person = $this->arr_routes['params'][1];
		$id_cabang = $this->arr_routes['params'][2];
		// add url
		$this->obj_tmpl->addVar('form', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang, 'add')));
		// --
		$params = array($this->arr_routes['params'][1]);
		$rs_id = $this->obj_cv->GetDataPendidikanByIdPerson($params);
		$num_rows = mysqli_num_rows($rs_id);
		if(empty($num_rows)){ $this->obj_tmpl->setAttribute('list_data', 'visibility', 'hidden');}
		while($rec = mysqli_fetch_assoc($rs_id)){
			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);
			$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_pendidikan']);
			$this->obj_tmpl->addVar('list_data', 'COLLEGE', $rec['college']);
			$this->obj_tmpl->addVar('list_data', 'NO_IJASAH', $rec['no_ijasah']);
			$degree=str_replace('_',' ',$rec['degree']);
			$this->obj_tmpl->addVar('list_data', 'DEGREE',$degree);
			$this->obj_tmpl->addVar('list_data', 'SPESIALIS_1', $rec['concentration']);
			$this->obj_tmpl->addVar('list_data', 'SPESIALIS_2', $rec['concentration_2']);
			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang, 'edit', $rec['id_pendidikan'])));
			// awal
			$tgl_awal = explode('-', $rec['tahun_masuk']);
			if(isset($tgl_awal[0]) AND isset($tgl_awal[1])){
				$this->obj_tmpl->addVar('list_data', 'AWAL', $tgl_awal[0].' '.$arr_bulan[$tgl_awal[1]]);
			}
			// akhir
			$tgl_akhir = explode('-', $rec['tahun_lulus']);
			if(isset($tgl_akhir[0]) AND isset($tgl_akhir[1])){
				$this->obj_tmpl->addVar('list_data', 'AKHIR', $tgl_akhir[0].' '.$arr_bulan[$tgl_akhir[1]]);
			}
			$this->obj_tmpl->ParseTemplate('list_data', 'a');	
			$no++;
		}	
		$this->obj_tmpl->addVar('form', 'TOTAL_DATA', $no);
	}
	
	// add
	
	private function DisplayFormAdd(){	
		// set template
		$this->obj_tmpl->addVar('form', 'display', 'add');
		// --
		$t = date('Y');
		$b = date('m');
		$h = date('d');
		$this->obj_date->SetPatTemplates($this->obj_tmpl);
		// mulai
		if(isset($this->obj_notify->arr_message['field'])){
			$ts = $this->obj_notify->arr_message['field']['tahun_awal'];
			$bs = $this->obj_notify->arr_message['field']['bulan_awal'];
		}else{
			$ts = '';
			$bs = '';
		}
		$this->obj_date->DhtmlgoodiesStandardDate('list_year_start','list_month_start','list_day_start',$ts,$bs,$h,$t - 75,$t);
		// selesai	
		if(isset($this->obj_notify->arr_message['field'])){
			$ts = $this->obj_notify->arr_message['field']['tahun_akhir'];
			$bs = $this->obj_notify->arr_message['field']['bulan_akhir'];
		}else{
			$ts = '';
			$bs = '';
		}
		$this->obj_date->DhtmlgoodiesStandardDate('list_year_end','list_month_end','list_day_end',$ts,$bs,$h,$t - 75,$t);
	}
	
	// edit
	
	private function DisplayFormEdit(){
		// set template
		$this->obj_tmpl->addVar('form', 'display', 'edit');
		// --
		$t = date('Y');
		$b = date('m');
		$h = date('d');
		$this->obj_date->SetPatTemplates($this->obj_tmpl);
		// --
		$params = array($this->arr_routes['params'][4], $this->arr_routes['params'][1]);
		$result = $this->obj_cv->GetDetailPendidikanById($params);
		// id
		$this->obj_tmpl->addVar('form', 'ID', $result['id_pendidikan']);		
		// parse
		if(!isset($this->obj_notify->arr_message['field'])){
			$this->obj_tmpl->addVar('form', 'COLLEGE', $result['college']);
			$degree=str_replace('_',' ',$result['degree']);
			$this->obj_tmpl->addVar('form', strtoupper($result['degree']), 'selected="selected"');
			$this->obj_tmpl->addVar('form', 'DEGREE', $result['degree']);
			$this->obj_tmpl->addVar('form', 'CONCENTRATION', $result['concentration']);
			$this->obj_tmpl->addVar('form', 'CONCENTRATION_2', $result['concentration_2']);	
			$this->obj_tmpl->addVar('form', 'NO_IJASAH', $result['no_ijasah']);
			$file_path = "doc/ijazah/".$result['id_person'].'/'.$result['name_ijazah'];
					//print_r(HTTPPATH.$file_path);
			$this->obj_tmpl->addVar('form', 'IJAZAHPATH', HTTPPATH.$file_path );
			$this->obj_tmpl->addVar('form', 'NAMA_IJAZAH', $result['name_ijazah'] );
			$awal = explode('-', $result['tahun_masuk']);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year_start','list_month_start','list_day_start',$awal[0],$awal[1],$h,$t - 75,$t);
			$akhir = explode('-', $result['tahun_lulus']);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year_end','list_month_end','list_day_end',$akhir[0],$akhir[1],$h,$t - 75,$t);
		}else{
			$ts = $this->obj_notify->arr_message['field']['tahun_awal'];
			$bs = $this->obj_notify->arr_message['field']['bulan_awal'];
			$this->obj_date->DhtmlgoodiesStandardDate('list_year_start','list_month_start','list_day_start',$ts,$bs,$h,$t - 75,$t);
			$ts = $this->obj_notify->arr_message['field']['tahun_akhir'];
			$bs = $this->obj_notify->arr_message['field']['bulan_akhir'];
			$this->obj_date->DhtmlgoodiesStandardDate('list_year_end','list_month_end','list_day_end',$ts,$bs,$h,$t - 75,$t);
		}
	}
	
	
}

?>