<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_admin;
	protected $obj_anggota;
	protected $obj_paging;
	protected $obj_date;
	protected $obj_workbook;
	protected $obj_worksheet;
	// variable definition
	protected $str_keyword;
	protected $str_cabang;
	protected $str_nama_cabang;
	protected $str_nama_city;
	protected $arr_cabang = array();	
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		// excel	
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		// load object business
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	
		$this->obj_anggota = $this->obj_ctrl->LoadBusiness('anggota', 'mysql', $this->arr_config['db']);	
		// load object pagination
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');	
		// load plugins
		$this->obj_ctrl->LoadFile('excel/class.writeexcel_workbook.inc.php', 'plugins');
		$this->obj_ctrl->LoadFile('excel/class.writeexcel_worksheet.inc.php', 'plugins');
		$this->str_excel_name = tempnam("doc/temp/excel/", "excel_file.xls");
		// load class excel
		$this->obj_workbook = new writeexcel_workbook($this->str_excel_name);
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();		
		// authority
		//self::DisplayCabangAuthority();	
		// display pdf download
		self::DownloadLaporan();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
		
	// operation
	private function DisplayVariable(){
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));	
		
		$this->obj_tmpl->addVar('content', 'URL_REKAP', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list-wilayah'));	
		
		$this->obj_tmpl->addVar('content', 'URL_PROCESS2', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kta'));
		
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));	
		$this->obj_tmpl->addVar('content', 'URL_KOTA_KOM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota-komisariat'));
		

			$result = $this->obj_admin->GetDataAsSingleArray("GetListCabangAdminByiddpd", array($this->str_userid, $this->str_userid));

		//print_r($result);

		$this->int_kota = $result['id_city'];

		$this->str_cari_par .= " AND b.id_city_komisariat = " . $this->int_kota." " ;

		

		// keyword

		if(isset($_SESSION['search']['keyword'])){

			$this->str_keyword = "%" . $_SESSION['search']['keyword'] . "%";

			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['keyword']);

		}else{

			$this->str_keyword = "%%";

		}

		if(isset($_SESSION['search']['prov_kom']) && $_SESSION['search']['prov_kom']>0){

			$this->int_propinsi = $_SESSION['search']['prov_kom'];

			$this->str_cari_par .= " AND b.id_province_kom = " . $this->int_propinsi." ";

		}

		if(isset($_SESSION['search']['city']) && $_SESSION['search']['city']>0){

			$this->int_kota = $_SESSION['search']['city'];

			$this->str_cari_par .= " AND b.id_city_komisariat = " . $this->int_kota." " ;

		}

		if(isset($_SESSION['search']['id_cabang']) && $_SESSION['search']['id_cabang']>0){

			$this->int_cabang = $_SESSION['search']['id_cabang'];

			$this->str_cari_par .= " AND b.id_cabang = " . $this->int_cabang." " ;

		}
		
			$rs_city = $this->obj_anggota->GetDataAsSingleArray("GetCityById", array($this->int_kota));
		//print_r($rs_city);exit;
		$this->str_nama_city = $rs_city['city_name'];
		//print_r($this->str_nama_city);exit;
		
		ini_set('memory_limit', '9999M'); //Raise to 512 MB
		ini_set('max_execution_time', '3600'); //Raise to 512 MBs
	}
	private function DisplayCabangAuthority(){
		// cabang
		$this->str_cabang = "";
		if(isset($_SESSION['search']['cabang'])){ $this->str_cabang = $_SESSION['search']['cabang'];}
		// parsing data
		$rs_id = $this->obj_admin->GetListCabangByAdmin(array($this->str_userid));		
		while($rs = mysqli_fetch_assoc($rs_id)){	
			if($rs['id_cabang'] == $this->str_cabang){
				$this->str_nama_cabang = $rs['nama'];
			}
			$this->arr_cabang[] = $rs['id_cabang'];
		}
		if(!in_array($this->str_cabang, $this->arr_cabang)){
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');
		}
	}
	
	private function DownloadLaporan(){
		// disable error warning
		error_reporting(E_ERROR);
		// create worksheet
		$this->obj_worksheet = $this->obj_workbook->addworksheet('Data Anggota');
		$this->obj_worksheet->set_margins(0.4);
		// set column width
		$this->obj_worksheet->set_column('A:A', 5);
		$this->obj_worksheet->set_column('B:B', 45);
		$this->obj_worksheet->set_column('C:C', 35);
		$this->obj_worksheet->set_column('D:D', 20);
		$this->obj_worksheet->set_column('E:E', 30);
		$this->obj_worksheet->set_column('F:F', 20);
		$this->obj_worksheet->set_column('G:G', 20);
		$this->obj_worksheet->set_column('H:H', 20);
		$this->obj_worksheet->set_column('I:I', 20);
		$this->obj_worksheet->set_column('J:J', 40);
		$this->obj_worksheet->set_column('K:K', 20);
		$this->obj_worksheet->set_column('L:L', 20);
		$this->obj_worksheet->set_column('M:M', 20);
		$this->obj_worksheet->set_column('N:N', 20);
		$this->obj_worksheet->set_column('O:O', 20);
		$this->obj_worksheet->set_column('P:P', 20);
		$this->obj_worksheet->set_column('Q:Q', 20);
		$this->obj_worksheet->set_column('R:R', 35);
		
		// create format
		// title
		$title = $this->obj_workbook->addformat();
		$title->set_size(10);
		$title->set_font('arial');
		$title->set_border(0);
		$title->set_bold();
		// border 
		$text = $this->obj_workbook->addformat();
		$text->set_color('black');
		$text->set_size(9);
		$text->set_fg_color('white');
		$text->set_border_color('black');
		$text->set_border(1);
		$text->set_align('left');
		$text->set_align('top');
		// border center
		$text_center = $this->obj_workbook->addformat();
		$text_center->set_color('black');
		$text_center->set_size(9);
		$text_center->set_fg_color('white');
		$text_center->set_border_color('black');
		$text_center->set_border(0);
		$text_center->set_align('center');
		$text_center->set_align('top');
		// border center
		$text_title= $this->obj_workbook->addformat();
		$text_title->set_color('black');
		$text_title->set_size(10);
		$text_title->set_fg_color('white');
		$text_title->set_border_color('black');
		$text_title->set_border(1);
		$text_title->set_align('left');
		$text_title->set_align('top');
		$text_title->set_bold();
		// --
		$this->obj_worksheet->repeat_rows(4, 5);
		// judul
		$this->obj_worksheet->write('A1', " Anggota PPNI", $title);
		$this->obj_worksheet->write('A2', "DPD " . $this->str_nama_city, $title);
		// table header
		$this->obj_worksheet->write('A5', "No", $text_title);
		// --
		$this->obj_worksheet->write('B5', "Nama", $text_title);
		// --
		$this->obj_worksheet->write('C5', "NO KTP", $text_title);
		// --
		$this->obj_worksheet->write('D5', "NIRA", $text_title);
		// --
		$this->obj_worksheet->write('E5', "Tanggal Registrasi", $text_title);
		// --
		$this->obj_worksheet->write('F5', "DPK", $text_title);
		// --
		$this->obj_worksheet->write('G5', "DPD", $text_title);
		// --
		$this->obj_worksheet->write('H5', "DPW", $text_title);
		//$this->obj_anggota->DebugQuery("GetCityById", array($this->int_kota));exit;
		$rs_city = $this->obj_anggota->GetDataAsSingleArray("GetCityById", array($this->int_kota));
		
		// parse data
		// set total record
		//$int_total = $this->obj_anggota->GetTotalAnggotaByAdmin(array($this->str_cabang, '%%'));		
		$rs_id = $this->obj_anggota->GetDataAnggotaByAdminPrint2(array($this->str_keyword, $this->str_cari_par));		
		if($rs_id){
			$no = 1;
			
			while($rec = mysqli_fetch_assoc($rs_id)){
				$this->obj_worksheet->write('A' . ($no + 6), $no . ".", $text);
				$nama_lengkap = $rec['prefix'].' '.$rec['nama_lengkap'].' '.$rec['suffix'];
				$this->obj_worksheet->write('B' . ($no + 6), $nama_lengkap, $text);
				$this->obj_worksheet->write('C' . ($no + 6),"'". $rec['no_ktp'], $text);
				
				$this->obj_worksheet->write('D' . ($no + 6), $rec['no_anggota'], $text);
				$this->obj_worksheet->write('E' . ($no + 6), $rec['tgl_registrasi'], $text);
				$this->obj_worksheet->write('F' . ($no + 6), $rec['komisariat'].'('.$rec['kode_cabang'].')', $text);
				$this->obj_worksheet->write('G' . ($no + 6), $rec['city_name'], $text);
				$this->obj_worksheet->write('H' . ($no + 6), $rec['province_name'], $text);
				
				
				$no++;
			}
		}
		// close work book
		$this->obj_worksheet->set_landscape();
		$this->obj_workbook->close();
		// header download
		$file_name = "data_anggota".$this->str_nama_city;
		header("Content-Type: application/x-msexcel; name=\"".$file_name."xls\"");
		header("Content-Disposition: inline; filename=\"".$file_name.".xls\"");
		$fh = fopen($this->str_excel_name, "rb");
		echo stream_get_contents($fh);
		//fpassthru($fh);
		// remove temporari file
		self::RemoveTemporaryFile();
	}
	
	private function RemoveTemporaryFile(){
		$dir = "doc/temp/excel/";
		if(is_dir($dir)){
			$folder = opendir($dir);
			while($file = readdir($folder))
			{
				if ($file == '.' || $file == '..') {
					continue;
				}				
				if(is_file($dir.'/'.$file))
				{
					unlink($dir.'/'.$file);
				}
				  
			}
			closedir($folder);
		}
	}
	
}

?>