<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_admin;

	protected $obj_cv;

	protected $obj_account;

	protected $obj_notify;

	protected $obj_upload;

	protected $obj_mail;

	protected $obj_crypt;

	// variable definition

	protected $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');	

	}

	

	protected function PageLoad(){ 

		/* -- Other object loaded below */

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);

		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);

		$this->obj_account = $this->obj_ctrl->LoadBusiness('account', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_account->SetUsesBusinessQuery($loaded_query);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');

		// plugins 

		$this->obj_ctrl->LoadFile('class.phpmailer.php', 'plugins/phpmailer');

		$this->obj_mail = new PHPMailer;

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'search':

				self::SearchData();

				break;

			case 'search':

				self::SearchData();

				break;

			case 'identitas':

				self::UpdateIdentitasPribadi();

				break;

			case 'insert_pendidikan':

				self::InsertDataPendidikan();

				break;

			case 'update_pendidikan':

				self::UpdateDataPendidikan();

				break;

			case 'delete_pendidikan':

				self::DeleteDataPendidikan();

				break;

			case 'insert_workplace':

				self::InsertTempatKerja();

				break;

			case 'update_workplace':

				self::UpdateTempatKerja();

				break;

			case 'delete_workplace':

				self::DeleteTempatKerja();

				break;

			case 'update_kantor':

				self::UpdateTempatKerjaUtama();

				break;

			case 'email':

				self::UpdateEmail();

				break;

			case 'userid':

				self::UpdateUserId();

				break;

			case 'password':

				self::UpdatePassword();

				break;

			case 'privacy':

				self::UpdatePrivacySetting();

				break;

			case 'keanggotaan':

				self::UpdateDataKeanggotaan();

				break;

			case 'access':

				self::UpdateHakAksesAnggota();

				break;

			case 'kelompok':

				self::UpdateKelompokStudi();

				break;

			case 'tim':

				self::UpdateTimP2KB();

				break;

			case 'hapus':

				self::HapusDataAnggota();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

/*		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

*/		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	private function SearchData(){

		$_SESSION['search']['cabang'] = $this->arr_params['id_cabang'];

		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];

	}

	

	// identitas pribadi

	

	private function UpdateIdentitasPribadi(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// data

		$tgl_lahir = $this->arr_params['tahun'].'-'.$this->arr_params['bulan'].'-'.$this->arr_params['hari'];

		if(empty($this->arr_params['nama_lengkap'])){ $err[] = '<br /><strong>Nama lengkap</strong> harus diisi'; }

		if(empty($this->arr_params['tempat_lahir'])){ $err[] = '<br /><strong>Tempat lahir</strong> harus diisi'; }

		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }

		// id city

		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));

		if(empty($kota)){ $err[] = '<br /><strong>Data kota</strong> tidak ditemukan'; }

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['nama_lengkap'], $this->arr_params['tempat_lahir'], $tgl_lahir, $this->arr_params['jenis_kelamin'], $this->arr_params['prefix'], $this->arr_params['suffix'], $this->arr_params['alamat'], $this->arr_params['telepon'], $this->arr_params['no_hp'], $kota, $this->arr_params['kodepos'], $this->arr_params['agama'], $this->str_userid, $this->arr_params['id_person']);

			// execute process

			if($this->obj_cv->UpdateIdentitasPribadi($params)){

				// uploadfile		

				$err[] = self::UploadFoto();

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, $this->arr_params['jenis_kelamin'] => 'selected="selected"', "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, $this->arr_params['jenis_kelamin'] => 'selected="selected"', "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}	

	

	private function UploadFoto(){

		// allowed type

		$err = "";

		if(isset($_FILES['foto']['tmp_name']) AND !empty($_FILES['foto']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['foto']['name']);

			$file_path = "doc/foto/";

			// delete last 

			if(is_dir($file_path))

				$this->obj_upload->RemoveDir($file_path);

			// processing

			if($this->obj_upload->ImageUpload($_FILES['foto'], $file_path, 120)){

				// insert to database

				$params = array($file_name, $this->arr_params['id_person']);

				$this->obj_cv->UpdateFotoPribadi($params);

				$err = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 

			}else{

				$err = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}

		}

		return $err;

	}

	// pendidikan

	

	private function InsertDataPendidikan(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		$tgl_mulai = $this->arr_params['tahun_awal'].'-'.$this->arr_params['bulan_awal'];

		$tgl_selesai = $this->arr_params['tahun_akhir'].'-'.$this->arr_params['bulan_akhir'];

		if(empty($this->arr_params['college'])){ $err[] = '<br /><strong>Universitas</strong> harus diisi'; }

		if(empty($this->arr_params['degree'])){ $err[] = '<br /><strong>Tingkatan gelar</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['id_person'], $this->arr_params['college'], $this->arr_params['degree'], $this->arr_params['concentration'], $this->arr_params['concentration_2'], $tgl_mulai, $tgl_selesai, $this->arr_params['no_ijasah'], $this->str_userid);

			// execute process

			if($this->obj_cv->InsertDataPendidikan($params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("college" => $this->arr_params['college'], "degree" => $this->arr_params['degree'], "tahun_awal" => $this->arr_params['tahun_awal'], "bulan_awal" => $this->arr_params['bulan_awal'], "tahun_akhir" => $this->arr_params['tahun_akhir'], "bulan_akhir" => $this->arr_params['bulan_akhir'], "concentration" => $this->arr_params['concentration'], "concentration_2" => $this->arr_params['concentration_2'], "no_ijasah" => $this->arr_params['no_ijasah']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("college" => $this->arr_params['college'], "degree" => $this->arr_params['degree'], "tahun_awal" => $this->arr_params['tahun_awal'], "bulan_awal" => $this->arr_params['bulan_awal'], "tahun_akhir" => $this->arr_params['tahun_akhir'], "bulan_akhir" => $this->arr_params['bulan_akhir'], "concentration" => $this->arr_params['concentration'], "concentration_2" => $this->arr_params['concentration_2'], "no_ijasah" => $this->arr_params['no_ijasah']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang'], 'add'));

	}	

	

	private function UpdateDataPendidikan(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		$tgl_mulai = $this->arr_params['tahun_awal'].'-'.$this->arr_params['bulan_awal'];

		$tgl_selesai = $this->arr_params['tahun_akhir'].'-'.$this->arr_params['bulan_akhir'];

		if(empty($this->arr_params['id_pendidikan'])){ $err[] = '<br /><strong>Id</strong> tidak terpilih'; }

		if(empty($this->arr_params['college'])){ $err[] = '<br /><strong>Universitas</strong> harus diisi'; }

		if(empty($this->arr_params['degree'])){ $err[] = '<br /><strong>Tingkatan gelar</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['college'], $this->arr_params['degree'], $this->arr_params['concentration'], $this->arr_params['concentration_2'], $tgl_mulai, $tgl_selesai, $this->arr_params['no_ijasah'], $this->str_userid, $this->arr_params['id_pendidikan'], $this->arr_params['id_person']);

			// execute process

			if($this->obj_cv->UpdateDataPendidikan($params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("college" => $this->arr_params['college'], "degree" => $this->arr_params['degree'], "tahun_awal" => $this->arr_params['tahun_awal'], "bulan_awal" => $this->arr_params['bulan_awal'], "tahun_akhir" => $this->arr_params['tahun_akhir'], "bulan_akhir" => $this->arr_params['bulan_akhir'], "concentration" => $this->arr_params['concentration'], "concentration_2" => $this->arr_params['concentration_2'], "no_ijasah" => $this->arr_params['no_ijasah']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("college" => $this->arr_params['college'], "degree" => $this->arr_params['degree'], "tahun_awal" => $this->arr_params['tahun_awal'], "bulan_awal" => $this->arr_params['bulan_awal'], "tahun_akhir" => $this->arr_params['tahun_akhir'], "bulan_akhir" => $this->arr_params['bulan_akhir'], "concentration" => $this->arr_params['concentration'], "concentration_2" => $this->arr_params['concentration_2'], "no_ijasah" => $this->arr_params['no_ijasah']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang'], 'edit', $this->arr_params['id_pendidikan']));

	}	

	

	private function DeleteDataPendidikan(){

		// check / validate parameter 

		$err = array();	

		$filled = array();	

		// required

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				$params = array($id, $this->arr_params['id_person']);

				if($this->obj_cv->DeleteDataPendidikan($params)){

					// notification message			

					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

					// redirect to success page ------------------------------------

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'Business process failure.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}

	

	// workplace

	

	private function InsertTempatKerja(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		$this->arr_params['berkas'] = $_FILES['berkas'];

		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> harus diisi'; }

		if(empty($this->arr_params['jabatan'])){ $err[] = '<br /><strong>Jabatan</strong> harus diisi'; }

		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }

		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));

		if(empty($kota)){ $err[] = '<br /><strong>Kota</strong> harus diisi'; }

		// check if more than 2

		$total = $this->obj_cv->GetTotalTempatKerjaById(array($this->str_userid));

		/*if($total['total'] >= 2){

			$err[] = '<br /><strong>Tempat praktik</strong> melebihi batas yang disarankan'; 

		}*/

		// processing -----------------------------------------------------

		if(!empty($this->arr_params['berkas']['tmp_name']) AND empty($err)){

			$no_file = false;

			// allowed type

			$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');

			// name and path file

			$file_name = str_replace(' ', '_', $this->arr_params['berkas']['name']);

			$file_path = "doc/person/".$this->str_userid."/lampiran_praktik/";

			// processing

			if(!$this->obj_upload->FileUpload($this->arr_params['berkas'], $file_path)){

				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}

		}else{

			$no_file = true;

		}

		if(empty($err)){

			$params = array($this->arr_params['id_person'], $this->arr_params['tempat'], $kota, $this->arr_params['nomor_sk'], $this->arr_params['keterangan_sk'], $this->arr_params['jabatan'], $this->arr_params['alamat'], $this->arr_params['telepon'],$file_name, $file_path, $this->str_userid);

			// execute process

			if($this->obj_cv->InsertTempatKerja($params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang'], 'add'));

	}	

	

	private function UpdateTempatKerja(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		$this->arr_params['berkas'] = $_FILES['berkas'];

		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> harus diisi'; }

		if(empty($this->arr_params['jabatan'])){ $err[] = '<br /><strong>Jabatan</strong> harus diisi'; }

		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }

		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));

		if(empty($kota)){ $err[] = '<br /><strong>Kota</strong> harus diisi'; }

		// check if more than 2

		$total = $this->obj_cv->GetTotalTempatKerjaById(array($this->str_userid));

		/*if($total['total'] >= 2){

			$err[] = '<br /><strong>Tempat praktik</strong> melebihi batas yang disarankan'; 

		}*/

		// processing -----------------------------------------------------

		if(!empty($this->arr_params['berkas']['tmp_name']) AND empty($err)){

			$no_file = false;

			// allowed type

			$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');

			// name and path file

			$file_name = str_replace(' ', '_', $this->arr_params['berkas']['name']);

			$file_path = "doc/person/".$this->str_userid."/lampiran_praktik/";

			// processing

			if(!$this->obj_upload->FileUpload($this->arr_params['berkas'], $file_path)){

				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}

		}else{

			$no_file = true;

		}

		if(empty($err)){

			$params = array($this->arr_params['tempat'], $kota, $this->arr_params['nomor_sk'], $this->arr_params['keterangan_sk'], $this->arr_params['jabatan'], $this->arr_params['alamat'], $this->arr_params['telepon'],$file_name, $file_path, $this->str_userid, $this->arr_params['id_job'], $this->arr_params['id_person']);

			// execute process

			if($this->obj_cv->UpdateTempatKerja($params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang'], 'edit', $this->arr_params['id_job']));

	}	

	

	private function DeleteTempatKerja(){

		// check / validate parameter 

		$err = array();	

		$filled = array();	

		// required

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				$params = array($id, $this->arr_params['id_person']);

				if($this->obj_cv->DeleteTempatKerja($params)){

					// notification message			

					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

					// redirect to success page ------------------------------------

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'Business process failure.', 'error');

			// redirect to page error page ------------------------------------		

		}

		// redirect to ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}	

	

	private function UpdateTempatKerjaUtama(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		$this->arr_params['berkas'] = $_FILES['berkas'];

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> harus diisi'; }

		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }

		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));

		if(empty($kota)){ $err[] = '<br /><strong>Kota</strong> harus diisi';}

		// processing -----------------------------------------------------

		if(empty($err)){		

			// check if data exists or not

			$result = $this->obj_cv->CheckTempatKerjaUtamaByPerson(array($this->arr_params['id_person']));

			if(!empty($result)){

			

			$err = "";

		if(isset($_FILES['berkas']['tmp_name']) AND !empty($_FILES['berkas']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['berkas']['name']);

			$file_path = "doc/person/".$this->str_userid."/berkas/";

			// delete last 

			$this->obj_upload->RemoveDir($file_path);

			// processing

			if($this->obj_upload->ImageUpload($_FILES['berkas'], $file_path, 120)){

				// insert to database

				$params = array($file_name, $this->str_userid);

				$this->obj_cv->UpdateSipPribadi($params);

				$err = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 

			}else{

				$err = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}

		}

				// params

				$params = array($this->arr_params['tempat'], $kota, $this->arr_params['status_pegawai'], $this->arr_params['nomor_sk'], $this->arr_params['keterangan_sk'], $this->arr_params['jabatan'], $this->arr_params['alamat'], $this->arr_params['telepon'], $this->arr_params['fax'], $file_name, $file_path,$this->str_userid,  $this->arr_params['id_person']);

		//print_r($params);exit;

				// execute

				$rs_exe = $this->obj_cv->UpdateTempatKerjaUtama($params);

			}else{

				$params = array($this->arr_params['id_person'], $this->arr_params['tempat'], $kota, $this->arr_params['status_pegawai'], $this->arr_params['nomor_sk'], $this->arr_params['keterangan_sk'], $this->arr_params['jabatan'], $this->arr_params['alamat'], $this->arr_params['telepon'], $this->arr_params['fax'], $this->str_userid);

				$rs_exe = $this->obj_cv->InsertTempatKerjaUtama($params);

			}			

			// execute process

			if($rs_exe){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon'], "fax" => $this->arr_params['fax'], $this->arr_params['status_pegawai'] => 'selected="selected"');

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("tempat" => $this->arr_params['tempat'], "kota" => $this->arr_params['kota'], "jabatan" => $this->arr_params['jabatan'], "alamat" => $this->arr_params['alamat'], "nomor_sk" => $this->arr_params['nomor_sk'], "keterangan_sk" => $this->arr_params['keterangan_sk'], "telepon" => $this->arr_params['telepon'], "fax" => $this->arr_params['fax'], $this->arr_params['status_pegawai'] => 'selected="selected"');

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kantor', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}	

	

	// account

	

	private function UpdateEmail(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['email'])){ 

			$err[] = '<br /><strong>Email baru</strong> harus diisi'; 

		}else{

			// eregi email

			$normal = "^[a-z0-9_\+-]+(\.[a-z0-9_\+-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*\.([a-z]{2,4})$";

			if(!eregi($normal, $this->arr_params['email'])){

			  $err[] = '<br /><b>Format Email</b> tidak diperkenankan';

			}

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['email'], $this->arr_params['id_person']);

			// execute process

			if($this->obj_account->ProcessingData("UpdateEmail", $params)){				

				// try to send mail

				if(!self::SendEmailAccount()){

					$err[] = '<br /><b>Email</b> tidak dapat terkirim, pastikan alamat email anda valid';

				}

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("EMAIL_NOTIFIKASI" => $this->arr_params['email']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("EMAIL_NOTIFIKASI" => $this->arr_params['email']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));	

	}

	

	private function UpdatePrivacySetting(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['personal'], $this->arr_params['education'], $this->arr_params['workplace'], $this->arr_params['address'], $this->str_userid, $this->arr_params['id_person']);

			// execute process

			if($this->obj_account->ProcessingData("UpdatePrivacySetting", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array();

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}

	

	private function UpdateUserId(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		$userid = trim($this->arr_params['userid']);

		if(empty($userid)){ 

			$err[] = '<br /><strong>User Id baru</strong> harus diisi'; 

		}else{

			if(strlen($userid) < 6 OR strlen($userid) > 30){

				$err[] = '<br /><strong>User Id baru</strong> melebihi atau kurang dari karakter yang diharuskan'; 

			}else{

				$rs = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->arr_params['id_person']));

				if($rs['userid'] == $this->arr_params['userid']){

					$err[] = '<br /><strong>User Id baru</strong> tidak bisa digunakan (gunakan User Id yang lebih unik)'; 

				}

			}

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['userid'], $this->arr_params['id_person']);

			// execute process



			

			if($this->obj_account->ProcessingData("UpdateUserId", $params)){

				// try to send mail

				if(!self::SendEmailUserid()){

					$err[] = '<br /><b>Email</b> tidak dapat terkirim';

				}

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("USERID_NEW" => $this->arr_params['userid']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("USERID_NEW" => $this->arr_params['userid']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));	

	}

	

	private function UpdatePassword(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		$pass_old = trim($this->arr_params['pass_old']);

		$pass_new = trim($this->arr_params['pass_new']);

		$pass_confirm = trim($this->arr_params['pass_confirm']);

		if(empty($pass_old)){ $err[] = '<br /><strong>Kata kunci lama</strong> harus diisi'; }

		if(empty($pass_new)){ $err[] = '<br /><strong>Kata kunci baru</strong> harus diisi'; }

		if(strlen($pass_new) < 6 OR strlen($pass_new) > 30){

			$err[] = '<br /><strong>Kata kunci baru</strong> melebihi atau kurang dari karakter yang diharuskan'; 

		}

		if(strcmp($pass_new, $pass_confirm)){

			$err[] = '<br /><strong>Kata kunci baru</strong> tidak valid, pastikan kembali kata kunci anda'; 

		}

		// check old password

		$rs = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->arr_params['id_person']));

		$pass_valid = $this->obj_crypt->StandardDecrypt($rs['pass'], $rs['hash_key']);

		if($pass_valid != $pass_old){

			$err[] = '<br /><strong>Password lama</strong> tidak cocok (tidak dapat ditemukan)'; 

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			// encrypt password

			$pass_new = $this->obj_crypt->StandardEncrypt($pass_new, $rs['hash_key']);

			$params = array($pass_new, $this->arr_params['id_person']);

			// execute process

			if($this->obj_account->ProcessingData("UpdatePassword", $params)){

				// try to send mail

				if(!self::SendEmailPassword($pass_confirm)){

					$err[] = '<br /><b>Email</b> tidak dapat terkirim';

				}

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array();

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		// redirect page --------------------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));	

	}

	

	// send email

	

	private function SendEmailUpdate(){

		// get detail member

		$params = array($this->arr_params['id_person']);

		$rs = $this->obj_account->GetDataAsSingleArray("GetDetailMember", $params);

		// body

		$body	= "<body bgcolor=\"#CCCCCC\">

					<style>

					.page {

						margin: auto;

						padding: 5px 5px 5px 5px;

						width: 400px;

						background-color: #FFFFFF;

						border: 1px solid #999999;

						font-family: Verdana, Arial, Helvetica, sans-serif;

					}

					.page p {

						margin: 0px 0px 10px 0px;

						font-size: 11px;

						line-height: 16px;

					}

					.page H3 {

						margin: 0px 0px 10px 0px;

						font-size: 12px;

					}

					</style>

					<div class=\"page\">

						<h3>Perhimpunan Dokter Spesialis Kulit dan Kelamin</h3>

						<h3>Komisariat ".$rs['cabang']."</h3>

						<p><small>".$rs['alamat']."</small></p>

						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>

						Kami melakukan konfirmasi bahwa alamat email anda telah diperbaharui. Untuk konfirmasi lain yang terkait dengan kegiatan anda dalam web organisasi akan ditujukan disini.<br></p>

						<p>Terima kasih.</p>

					</div>

					</body>";	

		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');

		$body             = eregi_replace("[\]",'',$body);

		// this script will auto generate setting

		$this->obj_mail->IsSMTP();

		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication

		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier

		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server

		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		

		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username

		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		

		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		

		$this->obj_mail->From       = $this->arr_system_default['siteemail'];

		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		

		$this->obj_mail->Subject    = "Perubahan alamat email";		

		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      

		//HTML Body

		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 

		// optional, comment out and test

		$this->obj_mail->WordWrap   = 50; // set word wrap		

		$this->obj_mail->MsgHTML($body);		

		$this->obj_mail->AddAddress($rs['email'], $rs['nama_lengkap']);		

		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment

		$this->obj_mail->IsHTML(true); // send as HTML		

		if(!$this->obj_mail->Send())

			return false;

		else

			return true;

	}

	

	private function SendEmailUserid(){

		// get detail member

		$params = array($this->arr_params['id_person']);

		$rs = $this->obj_account->GetDataAsSingleArray("GetDetailMember", $params);

		// body

		$body	= "<body bgcolor=\"#CCCCCC\">

					<style>

					.page {

						margin: auto;

						padding: 5px 5px 5px 5px;

						width: 400px;

						background-color: #FFFFFF;

						border: 1px solid #999999;

						font-family: Verdana, Arial, Helvetica, sans-serif;

					}

					.page p {

						margin: 0px 0px 10px 0px;

						font-size: 11px;

						line-height: 16px;

					}

					.page H3 {

						margin: 0px 0px 10px 0px;

						font-size: 12px;

					}

					</style>

					<div class=\"page\">

						<h3>Perhimpunan Dokter Spesialis Kulit dan Kelamin</h3>

						<h3>Komisariat ".$rs['cabang']."</h3>

						<p><small>".$rs['alamat']."</small></p>

						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>

						Email ini memberikan konfirmasi kepada anda bahwa User Id dalam web organisasi telah berhasil diubah sebagai berikut : <strong>".$rs['userid']."</strong>.<br></p>

						<p>Terima kasih.</p>

					</div>

					</body>";	

		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');

		$body             = eregi_replace("[\]",'',$body);

		// this script will auto generate setting

		$this->obj_mail->IsSMTP();

		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication

		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier

		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server

		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		

		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username

		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		

		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		

		$this->obj_mail->From       = $this->arr_system_default['siteemail'];

		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		

		$this->obj_mail->Subject    = "Perubahan User Id";		

		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      

		//HTML Body

		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 

		// optional, comment out and test

		$this->obj_mail->WordWrap   = 50; // set word wrap		

		$this->obj_mail->MsgHTML($body);		

		$this->obj_mail->AddAddress($rs['email'], $rs['nama_lengkap']);		

		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment

		$this->obj_mail->IsHTML(true); // send as HTML		

		if(!$this->obj_mail->Send())

			return false;

		else

			return true;

	}

	

	private function SendEmailPassword($pass_confirm){

		// get detail member

		$params = array($this->arr_params['id_person']);

		$rs = $this->obj_account->GetDataAsSingleArray("GetDetailMember", $params);

		// body

		$body	= "<body bgcolor=\"#CCCCCC\">

					<style>

					.page {

						margin: auto;

						padding: 5px 5px 5px 5px;

						width: 400px;

						background-color: #FFFFFF;

						border: 1px solid #999999;

						font-family: Verdana, Arial, Helvetica, sans-serif;

					}

					.page p {

						margin: 0px 0px 10px 0px;

						font-size: 11px;

						line-height: 16px;

					}

					.page H3 {

						margin: 0px 0px 10px 0px;

						font-size: 12px;

					}

					</style>

					<div class=\"page\">

						<h3>Perhimpunan Dokter Spesialis Kulit dan Kelamin</h3>

						<h3>Komisariat ".$rs['cabang']."</h3>

						<p><small>".$rs['alamat']."</small></p>

						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>

						Email ini memberikan konfirmasi kepada anda bahwa Password dalam web organisasi telah berhasil diubah sebagai berikut : <strong>".$pass_confirm."</strong>.<br></p>

						<p>Terima kasih.</p>

					</div>

					</body>";	

		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');

		$body             = eregi_replace("[\]",'',$body);

		// this script will auto generate setting

		$this->obj_mail->IsSMTP();

		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication

		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier

		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server

		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		

		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username

		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		

		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		

		$this->obj_mail->From       = $this->arr_system_default['siteemail'];

		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		

		$this->obj_mail->Subject    = "Perubahan kata kunci (password)";		

		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      

		//HTML Body

		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 

		// optional, comment out and test

		$this->obj_mail->WordWrap   = 50; // set word wrap		

		$this->obj_mail->MsgHTML($body);		

		$this->obj_mail->AddAddress($rs['email'], $rs['nama_lengkap']);		

		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment

		$this->obj_mail->IsHTML(true); // send as HTML		

		if(!$this->obj_mail->Send())

			return false;

		else

			return true;

	}	

	

	private function SendEmailAccount(){

		// get detail member

		$params = array($this->arr_params['id_person']);

		// person

		$person = $this->obj_account->GetDataAsSingleArray("GetDetailMember", $params);

		// account

		$account = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->arr_params['id_person']));

		$password = $this->obj_crypt->StandardDecrypt($account['pass'], $account['hash_key']);

		// body

		$body	= "<body bgcolor=\"#CCCCCC\">

					<style>

					.page {

						margin: auto;

						padding: 5px 5px 5px 5px;

						width: 400px;

						background-color: #FFFFFF;

						border: 1px solid #999999;

						font-family: Verdana, Arial, Helvetica, sans-serif;

					}

					.page p {

						margin: 0px 0px 10px 0px;

						font-size: 11px;

						line-height: 16px;

					}

					.page H3 {

						margin: 0px 0px 10px 0px;

						font-size: 12px;

					}

					</style>

					<div class=\"page\">

						<h3>Perhimpunan Dokter Spesialis Kulit dan Kelamin</h3>

						<h3>Komisariat ".$person['cabang']."</h3>

						<p><small>".$person['alamat']."</small></p>

						<p><strong>".$person['prefix'].' '.$person['nama_lengkap'].' '.$person['suffix']."</strong>,<br>

						Email ini memberikan konfirmasi kepada anda bahwa user account dalam web organisasi adalah sebagai berikut :</p>

						<p>

						User ID : <b>".$account['userid']."</b><br />

						Password :  <b>".$password."</b>

						</p>

						<p>Terima kasih.</p>

					</div>

					</body>";	

		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');

		$body             = eregi_replace("[\]",'',$body);

		// this script will auto generate setting

		$this->obj_mail->IsSMTP();

		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication

		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier

		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server

		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		

		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username

		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		

		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		

		$this->obj_mail->From       = $this->arr_system_default['siteemail'];

		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		

		$this->obj_mail->Subject    = "User Account";		

		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      

		//HTML Body

		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 

		// optional, comment out and test

		$this->obj_mail->WordWrap   = 50; // set word wrap		

		$this->obj_mail->MsgHTML($body);		

		$this->obj_mail->AddAddress($person['email'], $person['nama_lengkap']);		

		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment

		$this->obj_mail->IsHTML(true); // send as HTML		

		if(!$this->obj_mail->Send())

			return false;

		else

			return true;

	}	

	

	// keanggotaan

	

	private function UpdateDataKeanggotaan(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['no_anggota'])){ $err[] = '<br /><strong>No Anggota</strong> harus diisi'; }

		if(empty($this->arr_params['status_anggota'])){ $err[] = '<br /><strong>Status anggota</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['no_idi'], $this->arr_params['no_anggota'], $this->arr_params['id_cabang'], $this->str_userid, $this->arr_params['status_anggota'], $this->arr_params['id_person']);

			// execute process

			if($this->obj_cv->UpdateKeanggotaan($params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("no_idi" => $this->arr_params['no_idi'], "no_anggota" => $this->arr_params['no_anggota'], "id_cabang" => $this->arr_params['id_cabang'], $this->arr_params['status_anggota'] => 'selected="selected"');

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("no_idi" => $this->arr_params['no_idi'], "no_anggota" => $this->arr_params['no_anggota'], "id_cabang" => $this->arr_params['id_cabang'], $this->arr_params['status_anggota'] => 'selected="selected"');

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));	

	}

	

	private function UpdateHakAksesAnggota(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['access'])){ $err[] = '<br /><strong>Hak akses</strong> tidak boleh kosong'; }

		// processing -----------------------------------------------------

		if(empty($err)){

			// execute process

			// delete berdasarkan group 

			$this->obj_cv->DeleteHakAksesByGroup(array($this->arr_params['id_person'], $this->arr_config['app_group']['private']));

			foreach($this->arr_params['access'] as $val){

				$this->obj_cv->InsertHakAksesByGroupPerson(array($this->arr_params['id_person'], $val));

			}

			// sukses message				

			self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			// redirect to success page ----------------------------------			

		}else{

			// filled last field

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}

	

	private function UpdateKelompokStudi(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['ks'])){ $this->arr_params['ks'] = array(); }

		// processing -----------------------------------------------------

		if(empty($err)){

			// execute process

			// delete berdasarkan group 

			$this->obj_cv->DeleteKelompokStudiByPerson(array($this->arr_params['id_person']));

			foreach($this->arr_params['ks'] as $val){

				$this->obj_cv->InsertKelompokStudiByPerson(array($this->arr_params['id_person'], $val));

			}

			// sukses message				

			self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			// redirect to success page ----------------------------------			

		}else{

			// filled last field

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}

	

	private function UpdateTimP2KB(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// --

		if(empty($this->arr_params['tim'])){ $this->arr_params['tim'] = array(); }

		// processing -----------------------------------------------------

		if(empty($err)){

			// execute process

			// delete berdasarkan group 

			$this->obj_cv->DeleteTimP2KBByPerson(array($this->arr_params['id_person']));

			foreach($this->arr_params['tim'] as $val){

				$this->obj_cv->InsertTimP2KBByPerson(array($this->arr_params['id_person'], $val));

			}

			// sukses message				

			self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			// redirect to success page ----------------------------------			

		}else{

			// filled last field

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($this->arr_params['page'], $this->arr_params['id_person'], $this->arr_params['id_cabang']));

	}

	

	// hapus data

	

	private function HapusDataAnggota(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Id cabang</strong> tidak terpilih'; }

		// processing -----------------------------------------------------

		if(empty($err)){

			// check data member

			$params = array($this->arr_params['id_person']);

			if($this->obj_admin->HapusDataPerson($params)){

				// remove direktori

				$uploader = $this->obj_ctrl->LoadLibrary('Uploader');

				$path_folder = "doc/person/".$this->arr_params['id_person']."/";

				if(is_dir($path_folder)){

					$uploader->RemoveDir($path_folder);

				}

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		// redirect page --------------------------------------------------

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['page']));

	}

}



?>