<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_admin;

	protected $obj_anggota;

	protected $obj_paging;

	protected $obj_date;

	// var

	protected $str_keyword;

	protected $str_cabang;

	protected $arr_cabang = array();

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		// load object business

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	

		$this->obj_anggota = $this->obj_ctrl->LoadBusiness('anggota', 'mysql', $this->arr_config['db']);	

		// load object pagination

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');	

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();		

		// display cabang

		self::DisplayCabangAuthority();	

		// display calon anggota

		self::DisplayListAnggota();

		// display calon anggota

		self::DisplayPrintLink();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));	

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));	

		// keyword

		if(isset($_SESSION['search']['keyword'])){

			$this->str_keyword = "%" . $_SESSION['search']['keyword'] . "%";

			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['keyword']);

		}else{

			$this->str_keyword = "%%";

		}

	}

	

	private function DisplayCabangAuthority(){

		// cabang

		$cabang = "";

		if(isset($_SESSION['search']['cabang'])){ $this->str_cabang = $_SESSION['search']['cabang'];}

		// parsing data

		$rs_id = $this->obj_admin->GetListCabangByAdmin(array($this->str_userid));		

		while($rs = mysqli_fetch_assoc($rs_id)){	

			$this->arr_cabang[] = $rs['id_cabang'];

			if($rs['id_cabang'] == $this->str_cabang){

				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', 'selected="selected"');

			}else{

				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', '');

			}

			$this->obj_tmpl->addVar('list_cabang', 'VALUE', $rs['id_cabang']);

			$this->obj_tmpl->addVar('list_cabang', 'NAMA', $rs['nama']);

			$this->obj_tmpl->ParseTemplate('list_cabang', 'a');

		}

		if(empty($this->str_cabang))

			$this->arr_cabang = implode(',', $this->arr_cabang);

		else

			$this->arr_cabang = $this->str_cabang;

	}

	

	private function DisplayListAnggota(){

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][0]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][0];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$int_total = $this->obj_anggota->GetTotalAnggotaByAdmin(array($this->arr_cabang, $this->str_keyword));

		$this->obj_paging->SetTotalRecord($int_total);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get data

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$rs_id = $this->obj_anggota->GetDataAnggotaByAdmin(array($this->arr_cabang, $this->str_keyword, $start, $max));	

		if($rs_id){

			$no = $start + 1;

			while($rs = mysqli_fetch_assoc($rs_id)){		

				// url		  

				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $rs['id_person'], $rs['id_cabang']));			  

				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'hapus', array($page, $rs['id_person'], $rs['id_cabang']));

				// parse data

				$this->obj_tmpl->addVar('list_data', 'NO', $no);

				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama_lengkap']);

				$this->obj_tmpl->addVar('list_data', 'PREFIX', $rs['prefix']);

				$this->obj_tmpl->addVar('list_data', 'SUFFIX', $rs['suffix']);

				$this->obj_tmpl->addVar('list_data', 'CABANG', $rs['cabang']);

				$this->obj_tmpl->addVar('list_data', 'NO_ANGGOTA', $rs['no_anggota']);

				$this->obj_tmpl->addVar('list_data', 'EMAIL', $rs['email']);

				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $url_edit);

				$this->obj_tmpl->addVar('list_data', 'URL_HAPUS', $url_hapus);

				// new member

				$new_path = HTTPPATH."doc/temp/new-member.png";

				$new_path = '<img src="'.$new_path.'" alt="" title="Anggota baru" width=\"25px\" />';

				$reg_date = explode('-', $rs['registration_date']);

				$reg_date = trim(date("Ym", mktime(0, 0, 0, $reg_date[1], 1, $reg_date[0])));

				$now = strval(date('Y').date('m'));

				if($now == $reg_date)

					$this->obj_tmpl->addVar('list_data', 'NEW', $new_path);

				else

					$this->obj_tmpl->addVar('list_data', 'NEW', '');

				// --

				$this->obj_tmpl->ParseTemplate('list_data', 'a');

				$no++;

			}

		}

	}

	

	private function DisplayPrintLink(){

		if(!empty($this->str_cabang)){

			$this->obj_tmpl->setAttribute('print_out', 'visibility', 'show');

			$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'print-out', array($this->str_cabang));

			$this->obj_tmpl->addVar('print_out', 'URL_PRINT', $url_download);

		}

	}

}



?>