<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_admin;
	protected $obj_cv;
	protected $obj_notify;
	protected $obj_date;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();		
		/* Other object loaded below */
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);	
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
		$this->obj_date= $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// load javascript
		$this->obj_ctrl->LoadJavascript('form_event');	
	}
	
	public function PageView(){
		// check authority
		//self::CheckAuthority();
		// variable display
		self::DisplayVariable();
		// display notification
		self::DisplayNotification();
		/* display view content */
		self::DisplayFormData();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function CheckAuthority(){
		$params = array($this->str_userid, $this->arr_routes['params'][2]);
		if(!$this->obj_admin->CheckAuthorityByCabangAdmin($params)){
			// redirect to view page
			$this->obj_ctrl->RedirectUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');
		}
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('form', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));
		// sub navigasi
		$page = $this->arr_routes['params'][0];
		$id_person = $this->arr_routes['params'][1];
		$id_cabang = $this->arr_routes['params'][2];
		$this->obj_tmpl->addVar('form', 'PAGE', $page);
		$this->obj_tmpl->addVar('form', 'ID_PERSON', $id_person);
		$this->obj_tmpl->addVar('form', 'ID_CABANG', $id_cabang);
		// --
		$this->obj_tmpl->addVar('content', 'URL_PRIBADI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_EDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pendidikan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_WORK_MAIN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kantor', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('form', 'URL_WORK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'keanggotaan', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_PRIVACY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'privacy', array($page, $id_person, $id_cabang)));
		$this->obj_tmpl->addVar('content', 'URL_ACCOUNT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account', array($page, $id_person, $id_cabang)));	
		// remote data
		$this->obj_tmpl->addVar('content', 'URL_REMOTEKOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota'));
		$this->obj_tmpl->addVar('content', 'URL_REMOTEPRAKTIK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tempat-praktik'));	
	}
	
	private function DisplayFormData(){	
		if(!isset($this->arr_routes['params'][3])){
			$this->arr_routes['params'][3] = 'default';		
		}
		switch($this->arr_routes['params'][3]){
			case 'add':
				self::DisplayFormAdd();
				break;
			case 'edit':
				self::DisplayFormEdit();
				break;
			default :
				self::DisplayFormList();
				break;
		}
	}
	
	// list
	
	private function DisplayFormList(){	
		// --
		$no = 0;
		$page = $this->arr_routes['params'][0];
		$id_person = $this->arr_routes['params'][1];
		$id_cabang = $this->arr_routes['params'][2];
		// add url
		$this->obj_tmpl->addVar('form', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang, 'add')));
		// --
		$params = array($this->arr_routes['params'][1]);
		$rs_id = $this->obj_cv->GetTempatKerjaByIdPerson($params);
		$num_rows = mysqli_num_rows($rs_id);
		if(empty($num_rows)){ $this->obj_tmpl->setAttribute('list_data', 'visibility', 'hidden');}
		while($rec = mysqli_fetch_assoc($rs_id)){
			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);
			$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_job']);
			$this->obj_tmpl->addVar('list_data', 'TEMPAT', $rec['tempat']);
			$this->obj_tmpl->addVar('list_data', 'ALAMAT', $rec['alamat']);
			$this->obj_tmpl->addVar('list_data', 'KOTA', $rec['kota']);
			$this->obj_tmpl->addVar('list_data', 'JABATAN', $rec['jabatan']);
			$this->obj_tmpl->addVar('list_data', 'NOMOR_SK', $rec['nomor_sk']);
			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'workplace', array($page, $id_person, $id_cabang, 'edit', $rec['id_job'])));
			$this->obj_tmpl->ParseTemplate('list_data', 'a');	
			$no++;
		}	
		$this->obj_tmpl->addVar('form', 'TOTAL_DATA', $no);
	}
	
	// add
	
	private function DisplayFormAdd(){	
		// set template
		$this->obj_tmpl->addVar('form', 'display', 'add');
		// --
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
		// loaded style
		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
	}
	
	// edit
	
	private function DisplayFormEdit(){	
		// set template
		$this->obj_tmpl->addVar('form', 'display', 'edit');
		// --
		$page = $this->arr_routes['params'][0];
		$id_person = $this->arr_routes['params'][1];
		$id_cabang = $this->arr_routes['params'][2];
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
		// loaded style
		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
		// --
		$params = array($this->arr_routes['params'][4], $id_person);
		$result = $this->obj_cv->GetDetailTempatKerjaById($params);
		// id
		$this->obj_tmpl->addVar('form', 'ID', $result['id_job']);		
		// parse
		if(!isset($this->obj_notify->arr_message['field'])){
			$this->obj_tmpl->addVar('form', 'TEMPAT', $result['tempat']);
			$this->obj_tmpl->addVar('form', 'KOTA', $result['kota']);
			$this->obj_tmpl->addVar('form', 'NOMOR_SK', $result['nomor_sk']);
			$this->obj_tmpl->addVar('form', 'KETERANGAN_SK', $result['keterangan_sk']);	
			$this->obj_tmpl->addVar('form', 'JABATAN', $result['jabatan']);
			$this->obj_tmpl->addVar('form', 'DOKUMEN', $result['sip_dokumen']);
			$this->obj_tmpl->addVar('form', 'ALAMAT', $result['alamat']);	
			$this->obj_tmpl->addVar('form', 'TELEPON', $result['telepon']);
		}
	}
	
	
}

?>