<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	var $obj_notify;

	var $obj_system;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		// load business object

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		

	}

	

	public function PageView(){

		/* 

		-- display view content

		*/

		parent::DisplayWebTitle('Access Authority');

		// display page link navigation

		self::DisplayPageLink();

		// display template (add, view, edit)

		self::TemplateToDisplay();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'akses', array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'akses'));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function TemplateToDisplay(){

		// display list data

		if(empty($this->arr_routes['params'])){

			self::DisplayTableData();

		}elseif(isset($this->arr_routes['params'][0]) AND $this->arr_routes['params'][0] == 'add'){

			self::DisplayAddForm();

		}elseif(isset($this->arr_routes['params'][0]) AND $this->arr_routes['params'][0] == 'edit'){

			self::DisplayEditForm();

		}

		// display test cookies

		self::DisplayNotification();

	}

	

	private function DisplayTableData(){

		// activated template

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		// parse data

		// parameter input 

		// 1. table, format : array( 'alias' => 'nama table' )

		$table = array("tbl" => "sys_authority_m");

		// 2. field, format	: array('nama field' => 'alias')

		$fields = array("id_auth" => "id_auth", "id_group" => "id_group", "auth_name" => "auth_name", "deskripsi" => "deskripsi");

		// 3. params, format : array('nama field:AND/OR' => type:value) 

		$params = array();

		// 4. limits, format : array(offset, limit)

		$limits = array();

		// 5. orders, format : array('field' => 'ASC/DESC') 

		$orders = array("id_group" => "ASC", "auth_name" => "ASC");

		// ------------------------------------------------------------------

		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);

		$no = 0;

		while($rec = mysqli_fetch_assoc($rs_id)){

			// url link

			$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'akses', array('edit', $rec['id_auth']));

			// get name group

			$group = $this->obj_system->GetDetailData('sys_group_m', array('id_group' => "int:" . $rec['id_group']));

			// parse data

			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

			$this->obj_tmpl->addVar('list_data', 'NO', $no + 1);

			$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_auth']);	

			$this->obj_tmpl->addVar('list_data', 'AUTH_NAME', $rec['auth_name']);

			$this->obj_tmpl->addVar('list_data', 'GROUP_NAME', $group['name_group']);

			$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $rec['deskripsi']);

			$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');	

			$no++;

		}

		$this->obj_tmpl->addVar('display', 'TOTAL_DATA', $no);	

	}

	

	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

		// parse data	

		// display group

		$table = array("tbl" => "sys_group_m");

		$fields = array("id_group" => "id_group", "name_group" => "name_group");

		$params = array();

		$limits = array(0, 5);

		$orders = array("id_group" => "ASC");

		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);		

		while($rec = mysqli_fetch_assoc($rs_id)){

			$this->obj_tmpl->addVar('list_group', 'ID', $rec['id_group']);

			$this->obj_tmpl->addVar('list_group', 'NAME', $rec['name_group']);

			$this->obj_tmpl->ParseTemplate('list_group', 'a');	

		}

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$result = $this->obj_system->GetDetailData('sys_authority_m', array('id_auth' => "int:" . $this->arr_routes['params'][1]));

		$this->obj_tmpl->addVar('display', 'ID', $result['id_auth']);	

		$this->obj_tmpl->addVar('display', 'AUTH_NAME', $result['auth_name']);

		$this->obj_tmpl->addVar('display', 'DESKRIPSI', $result['deskripsi']);

		// display group 

		// display group

		$table = array("tbl" => "sys_group_m");

		$fields = array("id_group" => "id_group", "name_group" => "name_group");

		$params = array();

		$limits = array(0, 5);

		$orders = array("id_group" => "ASC");

		$rs_id = $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);		

		while($rec = mysqli_fetch_assoc($rs_id)){

			if($rec['id_group'] == $result['id_group'])

				$this->obj_tmpl->addVar('list_group', 'SELECTED', 'selected="selected"');

			else

				$this->obj_tmpl->addVar('list_group', 'SELECTED', '');

			$this->obj_tmpl->addVar('list_group', 'ID', $rec['id_group']);

			$this->obj_tmpl->addVar('list_group', 'NAME', $rec['name_group']);

			$this->obj_tmpl->ParseTemplate('list_group', 'a');	

		}

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>