<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	var $obj_system;

	var $obj_notify;

	var $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'akses');	

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['id_group'])){ $err[] = '<br /><strong>Group name</strong> must be filled'; }

		if(empty($this->arr_params['auth_name'])){ $err[] = '<br /><strong>Authority name</strong> must be filled'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Authority description</strong> must be filled'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array("id_group" => "int:" . $this->arr_params['id_group'],

							"auth_name" => "str:" . $this->arr_params['auth_name'],

							"deskripsi" => "str:" . $this->arr_params['deskripsi']);

			if($this->obj_system->InsertData('sys_authority_m', $params)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

				// redirect to page error page ------------------------------------	

				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			$this->obj_notify->SetField('AUTH_NAME', $this->arr_params['auth_name']);

			$this->obj_notify->SetField('DESKRIPSI', $this->arr_params['deskripsi']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'akses', array('add'));	

		}

	}

	

	private function UpdateData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['auth_name'])){ $err[] = '<br /><strong>Authority name</strong> must be filled'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Description</strong> must be filled'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$values = array("id_group:int" 	=> "" . $this->arr_params['id_group'],

							"auth_name:str" 	=> "" . $this->arr_params['auth_name'],

							"deskripsi:str" 	=> "" . $this->arr_params['deskripsi']);

			$params = array("id_auth:AND" => "int:" . $this->arr_params['id_auth']);

			if($this->obj_system->UpdateData('sys_authority_m', $values, $params)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

				//

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

				// redirect to page error page ------------------------------------	

				//

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			$this->obj_notify->SetField('AUTH_NAME', $this->arr_params['auth_name']);

			$this->obj_notify->SetField('DESKRIPSI', $this->arr_params['deskripsi']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			//

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'akses', array('edit', $this->arr_params['id_auth']));	

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_system->DeleteData('sys_authority_m', 'int', 'id_auth', $id)){

					// notification message				

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("success", "Data has been deleted.");

					$this->obj_notify->SentMessage();

					// redirect to success page ------------------------------------

					//

				}else{

					// error message

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

					$this->obj_notify->SentMessage();

					// redirect to page error page ------------------------------------	

					//

				}

			}				

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			//

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			//

		}

	}

}



?>