<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// init object

	private $obj_admin;

	private $obj_anggota;

	private $obj_paging;

	private $obj_date;

	// init variable

	private $str_cabang = 0;

	private $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

        $this->obj_tmpl->readTemplatesFromFile('styles.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('content');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		// load object business

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	

		// load object pagination

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

	}

	

	public function PageView(){

		$this->arr_params = $_POST;

		unset($_POST);

		// display data cabang

		self::DisplayDetailCabang();

		// display calon anggota

		self::DisplayListAnggota();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayDetailCabang(){

		// parsing data

		$result = $this->obj_admin->GetDataAsSingleArray("GetDetailCabangById", array($this->arr_params['id_cabang']));	

		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'CABANG', $result['nama']);

			$this->obj_tmpl->addVar('content', 'ALAMAT_SEKRETARIAT', $result['alamat']);

			$this->obj_tmpl->addVar('content', 'TELEPON', $result['telephone']);

			$this->obj_tmpl->addVar('content', 'FAX', $result['fax']);

		}

	}

	

	private function DisplayListAnggota(){

		$start = intval($this->arr_params['start'] - 1);

		$end = intval($this->arr_params['end']);

		// parsing data

		$rs_id = $this->obj_admin->GetResourceId("GetListAnggotaLengkap", array($this->arr_params['id_cabang'], $start, $end));	

		if($rs_id){

			$no = 1;

			$index = $start + 1;

			while($rec = mysqli_fetch_assoc($rs_id)){		

				$this->obj_tmpl->clearTemplate('numbering');

				// parse data

				$this->obj_tmpl->addVar('numbering', 'NO', $index);

				$this->obj_tmpl->addVar('list_data', 'NAMA', $rec['nama_lengkap']);

				$this->obj_tmpl->addVar('list_data', 'NO_ANGGOTA', $rec['no_anggota']);

				$status_anggota = array('AM' =>'Anggota Muda','AB' => 'Anggota Biasa','PP' => 'Pengurus Pusat');

				$this->obj_tmpl->addVar('list_data', 'STATUS_ANGGOTA', $status_anggota[$rec['status_anggota']]);

				$this->obj_tmpl->addVar('list_data', 'TMP_LAHIR', $rec['tempat_lahir']);

				$this->obj_tmpl->addVar('list_data', 'TGL_LAHIR', $this->obj_date->GetFullDate($rec['tanggal_lahir'], 'in'));

				$this->obj_tmpl->addVar('list_data', 'AGAMA', $rec['agama']);

				$this->obj_tmpl->addVar('list_data', 'KOTA', $rec['kota']);

				$this->obj_tmpl->addVar('list_data', 'ALAMAT_TINGGAL', $rec['alamat']);

				$this->obj_tmpl->addVar('list_data', 'TELEPON_TINGGAL', $rec['telepon']);

				$this->obj_tmpl->addVar('list_data', 'EMAIL', $rec['email']);

				// pendidikan

				$this->obj_tmpl->addVar('list_data', 'PENDIDIKAN', self::GetEducationInfo($rec['id_person']));

				// kantor

				$this->obj_tmpl->addVar('list_data', 'KANTOR', $rec['kantor']);

				$this->obj_tmpl->addVar('list_data', 'KOTA_KANTOR', $rec['kota_kantor']);

				$this->obj_tmpl->addVar('list_data', 'ALAMAT_KANTOR', $rec['alamat_kantor']);

				$this->obj_tmpl->addVar('list_data', 'TELEPON_KANTOR', $rec['telepon_kantor']);

				$this->obj_tmpl->addVar('list_data', 'JABATAN', $rec['jabatan']);

				// praktik

				$this->obj_tmpl->addVar('list_data', 'PRAKTIK', self::GetPrakrikInfo($rec['id_person']));

				// photo

				$file_photo = "doc/foto/".$rec['photo'];

				if(is_file($file_photo))

					$this->obj_tmpl->addVar('list_data', 'PHOTOPATH', HTTPPATH.$file_photo);

				else

					$this->obj_tmpl->addVar('list_data', 'PHOTOPATH', HTTPPATH."doc/temp/blank.gif");	

				// pages

				if(($no % 2) == 1){

					$this->obj_tmpl->setAttribute('numbering', 'visibility', 'show');

					$this->obj_tmpl->addVar('list_data', 'CLASS', 'first');

				}else{

					$this->obj_tmpl->setAttribute('numbering', 'visibility', 'hidden');

					$this->obj_tmpl->addVar('list_data', 'CLASS', 'second');

					$index++;

				}

				// append

				$this->obj_tmpl->parseTemplate('list_data', 'a');

				$no++;

			}

		}

	}

	

	// utility

	

	private function GetEducationInfo($id_person){

		$str = "";

		$break = "";

		$rs_id = $this->obj_admin->GetResourceId("GetEducationByPerson", array($id_person));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$tahun_lulus = explode('-', $rec['tahun_lulus']);

				$str .= $break . $rec['college'].' ('.$tahun_lulus[0].', '.$rec['concentration'].')';

				$break = "<br />";

			}

		}

		return $str;

	}

	

	private function GetPrakrikInfo($id_person){

		$str = "";

		$break = "";

		$rs_id = $this->obj_admin->GetResourceId("GetPraktikByPerson", array($id_person));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$str .= $break . $rec['tempat']."<br>&nbsp;&nbsp;&nbsp;".$rec['alamat'].", Telp. ".$rec['telepon'];

				$break = "<br />";

			}

		}

		return $str;

	}

}



?>