<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object
	protected $obj_admin;
	protected $obj_registrasi;
	protected $obj_cv;
	protected $obj_account;
	protected $obj_upload;
	protected $obj_crypt;
	protected $obj_notify;
	protected $obj_mail;
	//protected $obj_insert;
	protected $obj_bnihashing;
	// post
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		$this->obj_account = $this->obj_ctrl->LoadBusiness('account', 'mysql', $this->arr_config['db']);
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
		$this->obj_bnihashing = $this->obj_ctrl->LoadLibrary('Bnihashing');	
		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		// plugins 
		$this->obj_ctrl->LoadFile('class.phpmailer.php', 'plugins/phpmailer');
		$this->obj_mail = new PHPMailer;
		$this->obj_ctrl->LoadFile('excel_reader.php','plugins/external');
		//$this->obj_ctrl->LoadFile('reader.php','plugins/external');
		//$this->obj_insert = new PHPMailer;
		//$this->obj_insert = new Spreadsheet_Excel_Reader();
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'search':
				self::SearchData();
				break;
			case 'search_monitoring':
				self::SearchDataMonitoring();
				break;	
          
		   case 'search_dpw':
				self::SearchDataDpw();
				break;
			case 'search_dpd':
				self::SearchDataDpd();
				break;
			case 'search_dpk':
				self::SearchDataDpk();
				break;			
			case 'register_dpk':
				self::UpdateVerifikasidpk();
				break;
			case 'register_dpk_dpd':
				self::UpdateVerifikasidpkDpd();
				break;	
			
			case 'register_dpk_dpw':
				self::UpdateVerifikasidpkdpw();
				break;	
						
			case 'register_dpk_pp':
				//print_r($this->arr_params['id_calon']);exit;
				self::UpdateVerifikasidpkBydpp();
				break;
			case 'registerdppdpk_all':
				self::UpdateVerifikasidppdpkAll();
				break;	
			case 'registerdpk_all':
				self::UpdateVerifikasidpkAll();
				break;		
			case 'registerdpd_all':
				self::UpdateVerifikasidpdAll();
				break;		
			case 'register':
				self::RegisterAnggota();
				break;
                 
			case 'register_dpd':
				self::UpdateVerifikasidpd();

			case 'register_dpw':
				self::UpdateVerifikasidpw();
				break;		
			case 'registerdpw_all':
				self::UpdateVerifikasidpwAll();
				break;
			case 'hapus':
				self::HapusCalonAnggota();
				break;
			case 'hapus_aktif':
				self::HapusCalonAnggotaMonitoring();
				break;
			case 'hapus_permintaan':
				self::HapusAccountRequest();
				break;
			case 'upload':
				self::SaveFile();
				break;
			case 'update_email':
				self::UpdateEmail();
				break;	
			case 'komisariat':	
				self::UpdateKomisariat();
				break;		
			case 'register_masal':
				self::RegisterCalonAnggotaMasal();
				break;	
			case 'register_anggota':
				self::AddAnggota();
				break;		
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	private function SearchData(){
		$_SESSION['search']['prov_kom'] = $this->arr_params['prov_kom'];
		$_SESSION['search']['city'] = $this->arr_params['city'];
		$_SESSION['search']['id_cabang'] = $this->arr_params['id_cabang'];
		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];
	}
	
	private function SearchDataMonitoring(){
		$_SESSION['search']['prov_kom'] = $this->arr_params['prov_kom'];
		$_SESSION['search']['city'] = $this->arr_params['city'];
		$_SESSION['search']['cabang'] = $this->arr_params['cabang'];
		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_monitoring');
	}
      private function SearchDatadpw(){
		$_SESSION['search']['city'] = $this->arr_params['city'];
		$_SESSION['search']['id_cabang'] = $this->arr_params['id_cabang'];
		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpw');
	}
	
	private function SearchDatadpd(){
		$_SESSION['search']['id_cabang'] = $this->arr_params['id_cabang'];
		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpd');
	}
	
	private function SearchDatadpk(){
		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpk');
	}
	
	// add data
	private function UpdateEmail(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		
		if(empty($this->arr_params['id_calon'])){ $err[] = '<br /><strong>Id anggota</strong> tidak terpilih'; }
		
		// processing -----------------------------------------------------
		if(empty($err)){		
			// check if data exists or not
			$params = array($this->arr_params['email'], $this->arr_params['id_calon']);
				// execute
				//$this->obj_registrasi->DebugQuery("UpdateEmail",$params);exit;
				$rs_exe = $this->obj_registrasi->UpdateEmail($params);		
			// execute process
			if($rs_exe){
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("email" => $this->arr_params['email'], "id_calon" => $this->arr_params['id_calon']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("email" => $this->arr_params['email'], "id_calon" => $this->arr_params['id_calon']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru', array($this->arr_params['page']));
	}	
	
	
	
	private function RegisterAnggota(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		$no_max =array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['page'])){ $this->arr_params['page'] = 1; }
		if(empty($this->arr_params['id_calon'])){ $err[] = '<br /><b>Id</b> tidak terpilih'; }
		if(empty($this->arr_params['id_city'])){ $err[] = '<br /><b>Id Kota</b> tidak terpilih'; }
		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><b>Id Komisariat</b> tidak terisi'; }
		if(empty($this->arr_params['authority'])){ $err[] = '<br /><b>Hak akses</b> belum ditentukan'; }
		// processing --------------------------------------------------
		if(empty($err)){
			// get id person
			//$this_day = date('Y').date('m').date('d');
			//$id = $this->obj_admin->GetIdPerson(array($this_day . "%"));
			//if(!empty($id)){
				//$id = explode('-', $id);
				//$id_person = $this_day . '-' . strval(intval($id[1]) + 1);
			//}else{
			//	$id_person = $this_day . '-1';
			//}
			// get userid
			// data calon anggota
			$params = array($this->arr_params['id_calon']);
			$result = $this->obj_registrasi->GetCalonAnggotaById($params);
                        $id_person =$result['id_person'];
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordAnggotaMax($params2);
			$no_max = $MaxId['no_urut']+ 1;
			//print_r($result);exit;
			$angka = self::tambah_nol($no_max ,7);
			$no_anggota= $result['id_city_komisariat'].$angka;
			//print_r($no_max);exit;
			
			$CekNoAnggota = $this->obj_registrasi->GetCekNoAnggota($no_anggota);
			if($result['gender']=='pria'){
				$kode_gender=01;
				}else{
				$kode_gender=02;
				}
			$virtual_account=$result['id_city'].$kode_gender.$angka;	
			if(!empty($CekNoAnggota['no_anggota'])){ $err[] = '<br /><b>No ANggota</b> Sudah Ada'; }
			
			$user_id = str_replace(".", "", $no_anggota);
			// get password
			$hask_key = $this->obj_crypt->CreateUserKey($user_id);
			$pass = substr($this->obj_crypt->CreateUserKey($hask_key), 0, 6);
			$pass_decrypt = $this->obj_crypt->StandardEncrypt($pass, $hask_key);
			
			// person 
			$arr_urut=array($no_max,$id_person,$this->str_userid);
			//$this->obj_registrasi->DebugQuery('InsertNoUrutMember',$arr_urut);exit;
			$arr_person = array($id_person, $this->arr_params['id_calon'], $result['nama'],$result['no_ktp'],$result['status_relasi'], $result['tmp_lahir'], $result['tgl_lahir'], $result['gender'], $result['prefix'], $result['suffix'],   $result['alamat'], $result['telepon'], $result['handphone'], $result['id_province'],$result['id_city'],$result['id_districts'],$result['id_vellage'], $result['kodepos'],  $this->str_userid, $result['agama']);

			// member
			$arr_member = array($id_person,$result['id_province_kom'],$result['id_city_komisariat'], $result['id_cabang'], $result['no_idi'],
			$result['no_anggota'], $no_anggota, $virtual_account,$result['status_anggota'], $result['status_perawat'],$this->str_userid);
			
			// pendidikan
			$arr_edu = array($id_person, $result['universitas'], $result['jenjang'], $result['spesialis_1'], $result['spesialis_2'], $result['periode_awal'], $result['periode_akhir'], $result['no_ijasah'],$result['name_ijazah'],$result['paht_ijazah'],$id_person);
			// tempat kerja utama
			$arr_workplace = array($id_person, $result['nama_kantor'], $result['alamat_kantor'], $result['id_city_kantor'], $result['status_kepegawaian'], $result['jabatan'], $result['telepon_kantor'], $id_person);
			// authority
			$params_access = $this->arr_params['authority'];
			// account
			$params_account = array($id_person,$user_id,$pass_decrypt,$hask_key,$result['email'],$this->str_userid);
			// processing data
			//$this->obj_registrasi->DebugQuery("InsertDataMember",$arr_member);exit;
			if($this->obj_registrasi->InsertMemberRegistration($arr_person, $arr_member, $params_access, $params_account, $arr_edu, $arr_workplace,$arr_urut)){
			$this->obj_registrasi->ProcessingData("InsertDataMember",$arr_member);
			$this->obj_registrasi->ProcessingData("InsertDataEducation",$arr_edu);
				// delete calon anggota
				//$this->obj_registrasi->DeleteCalonAnggota(array($this->arr_params['id_calon']));
                 //$this->obj_registrasi->MemberAnggota($arr_member);
                 $this->obj_registrasi->UpdateCalonAnggota(array($this->arr_params['id_calon']));
				// try to send mail
				if(!self::SendEmailRegistrasi($result['id_cabang'], $result, $user_id, $pass,$no_anggota)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// sukses message			
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
				//$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'anggota', 'edit', array('1', $id_person, $result['id_cabang']));
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'anggota', 'registrasi','terbaru');
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'member', array($this->arr_params['page'], $this->arr_params['id_calon']));
			}
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page ------------------------------------	
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'member', array($this->arr_params['page'], $this->arr_params['id_calon']));	
		}
	}
	
		
	private function UpdateKomisariat(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		
		if(empty($this->arr_params['prov_kom'])){ $err[] = '<br /><strong>DPW</strong> tidak terpilih'; }
		if(empty($this->arr_params['city'])){ $err[] = '<br /><strong>DPD</strong> tidak terpilih'; }
		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Komisariat</strong> tidak terpilih'; }
		
		// processing -----------------------------------------------------
		if(empty($err)){		
			// check if data exists or not
			$params = array($this->arr_params['prov_kom'],$this->arr_params['city'],$this->arr_params['id_cabang'], $this->arr_params['id_calon']);
				// execute
				//$this->obj_registrasi->DebugQuery("UpdateKomisariat",$params);exit;
				$rs_exe = $this->obj_registrasi->UpdateKomisariat($params);		
			// execute process
			if($rs_exe){
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
					$filled = array("PROV_KOM" => $this->arr_params['prov_kom'], "CITY" => $this->arr_params['city'], "CABANG" => $this->arr_params['cabang'], "id_calon" => $this->arr_params['id_calon']);
		
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("PROV_KOM" => $this->arr_params['prov_kom'], "CITY" => $this->arr_params['city'], "CABANG" => $this->arr_params['cabang'], "id_calon" => $this->arr_params['id_calon']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru', array($this->arr_params['page']));
	}		
		
		
		
	private function RegisterCalonAnggotaMasal(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Id</b> tidak terpilih'; }
		//$params = array($this->arr_params['downcheck']);
		//$this->obj_registrasi->DebugQuery("GetCalonAnggotaByIdverifikasidpk",$this->arr_params['downcheck']);exit;
		$result = $this->obj_registrasi->GetCalonAnggotaByIdverifikasidpk($this->arr_params['downcheck']);
		//print_r($result);exit;
		if(!empty($result)){ $err[] = '<br /><b>Calon Anggota </b> Sudah di terbitkan Virtual Accountnya'; }	
		// processing --------------------------------------------------
		if(empty($err)){			
			foreach($this->arr_params['downcheck'] as $id){
				// delete calon anggota
			$params = array($id);
			$result = $this->obj_registrasi->GetCalonAnggotaById($params);
                        $id_person =$result['id_person'];
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordAnggotaMax($params2);
			$no_max = $MaxId['no_urut']+ 1;
			//print_r($result);exit;
			$angka = self::tambah_nol($no_max ,7);
			$no_anggota= $result['id_city_komisariat'].$angka;
			//print_r($no_max);exit;
			
			$CekNoAnggota = $this->obj_registrasi->GetCekNoAnggota($no_anggota);
			if($result['gender']=='pria'){
				$kode_gender=01;
				}else{
				$kode_gender=02;
				}
			$virtual_account=$result['id_city'].$kode_gender.$angka;	
			if(!empty($CekNoAnggota['no_anggota'])){ $err[] = '<br /><b>No ANggota</b> Sudah Ada'; }
			
			$user_id = str_replace(".", "", $no_anggota);
			// get password
			$hask_key = $this->obj_crypt->CreateUserKey($user_id);
			$pass = substr($this->obj_crypt->CreateUserKey($hask_key), 0, 6);
			$pass_decrypt = $this->obj_crypt->StandardEncrypt($pass, $hask_key);
			
			// person 
			$arr_urut=array($no_max,$id_person,$this->str_userid);
			//$this->obj_registrasi->DebugQuery('InsertNoUrutMember',$arr_urut);exit;
			$arr_person = array($id_person, $id, $result['nama'],$result['no_ktp'],$result['status_relasi'], $result['tmp_lahir'], $result['tgl_lahir'], $result['gender'], $result['prefix'], $result['suffix'],   $result['alamat'], $result['telepon'], $result['handphone'], $result['id_province'],$result['id_city'],$result['id_districts'],$result['id_vellage'], $result['kodepos'],  $this->str_userid, $result['agama']);

			// member
			$arr_member = array($id_person,$result['id_province_kom'],$result['id_city_komisariat'], $result['id_cabang'], $result['no_idi'],
			$result['no_anggota'], $no_anggota, $virtual_account,$result['status_anggota'], $result['status_perawat'],$this->str_userid);
			
			// pendidikan
			$arr_edu = array($id_person, $result['universitas'], $result['jenjang'], $result['spesialis_1'], $result['spesialis_2'], $result['periode_awal'], $result['periode_akhir'], $result['no_ijasah'],$result['name_ijazah'],$result['paht_ijazah'],$id_person);
			// tempat kerja utama
			$arr_workplace = array($id_person, $result['nama_kantor'], $result['alamat_kantor'], $result['id_city_kantor'], $result['status_kepegawaian'], $result['jabatan'], $result['telepon_kantor'], $id_person);
			// authority
			$params_access =array("13");
			// account
			$params_account = array($id_person,$user_id,$pass_decrypt,$hask_key,$result['email'],$this->str_userid);
			// processing data
			//$this->obj_registrasi->DebugQuery("InsertDataMember",$arr_member);exit;
			$this->obj_registrasi->InsertMemberRegistration($arr_person, $arr_member, $params_access, $params_account, $arr_edu, $arr_workplace,$arr_urut);
				// delete calon anggota
				//$this->obj_registrasi->DeleteCalonAnggota(array($this->arr_params['id_calon']));
                 $this->obj_registrasi->UpdateCalonAnggota(array($id));
				// try to send mail
				if(!self::SendEmailRegistrasi($result['id_cabang'], $result, $user_id, $pass,$no_anggota)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// sukses message			
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
				//$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'anggota', 'edit', array('1', $id_person, $result['id_cabang']));
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'anggota', 'registrasi','terbaru');
			
		  }
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru');	
	}	
	
	
	private function SendEmailRegistrasi($id_cabang, $result, $userid, $pass,$no_anggota, $virtual_account){
		// get data cabang
		$cabang = $this->obj_registrasi->GetInformasiCabangById(array($id_cabang));
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Nasional Indonesia</h3>
						<h3>Komisariat ".$cabang['nama']."</h3>
						<p><small>".$cabang['alamat']."</small></p>
						<p><strong>".$result['prefix'].' '.$result['nama'].' '.$result['suffix']."</strong>,<br>
						Data anda telah diverifikasi. Berikut ini adalah account setting anda dalam web aplikasi PPNI :<br>
						Nira Anda  : $no_anggota<br />
						Virtual Account  : $virtual_account<br />
						User id : $userid<br />
						Password : $pass
						</p>
						<p> Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Verifikasi pendaftaran";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($result['email'], $result['prefix'].' '.$result['nama'].' '.$result['suffix']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	// --
	
	private function HapusCalonAnggota(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Id</b> tidak terpilih'; }
		//$params = array($this->arr_params['downcheck']);
		//$this->obj_registrasi->DebugQuery("GetCalonAnggotaByIdverifikasidpk",$this->arr_params['downcheck']);exit;
		$result = $this->obj_registrasi->GetCalonAnggotaByIdverifikasidpk($this->arr_params['downcheck']);
		//print_r($result);exit;
		if(!empty($result)){ $err[] = '<br /><b>Calon Anggota </b> Sudah di terbitkan Virtual Accountnya'; }	
		// processing --------------------------------------------------
		if(empty($err)){
		   
			foreach($this->arr_params['downcheck'] as $id){
				// delete calon anggota
				// $this->obj_registrasi->DebugQuery("DeleteCalonAnggota",array($id));exit;	
				$this->obj_registrasi->DeleteCalonAnggota(array($id));
			}
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru');	
	}
	
	private function HapusCalonAnggotaMonitoring(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Id</b> tidak terpilih'; }
		// processing --------------------------------------------------
		if(empty($err)){			
			foreach($this->arr_params['downcheck'] as $id){
				// delete calon anggota
				$this->obj_registrasi->UpdateCalonAnggota(array($id));
			}
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_monitoring');	
	}
	
	private function HapusAccountRequest(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Id</b> tidak terpilih'; }
		// processing --------------------------------------------------
		if(empty($err)){			
			foreach($this->arr_params['downcheck'] as $id){
				// delete calon anggota
				$this->obj_registrasi->DeleteAccountRequest(array($id));
			}
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'account');	
	}
	
	
	private function UpdateVerifikasidpk(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		//sleep(10);
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
			$params = array($this->arr_params['id_calon']);
	    	$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
		//print_r($this->arr_params['valid']);exit;	
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = strval(intval($MaxId['id'])+ 1);
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,6);
			$fix='988';
			$clienID='19194';
			
			$pembeda=substr($result[handphone],-2);
			if($pembeda>0){
			   $pembeda_hp=substr($result[handphone],-1);
			    
			}else{
			 $pembeda_hp=1;   
			}
			
			$virtual_accout=$fix.$clienID.$pembeda.$angka_urut_va;
			
		if(empty($err)){
		
			//print_r($pembeda_hp);exit;
			
			//print_r($virtual_accout);exit;
			//$expired_unit=date('c', time() + 168 * 3600);
			$expired_unit=date('Y-m-d',strtotime(date("Y-m-d", mktime()) . " + 7 day"));
			$tahun = date('Y');
			$mount='360000';
			$desk='DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'];
			$param_virtual_acount2=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$desk,$mount,$tahun, $expired_unit,'mandiri', $this->arr_params['id_person']);
			
			$param_virtual_acount=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$mount,$tahun, $expired_unit,'DPK', $this->arr_params['id_person']);
				// delete calon anggota
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				$this->obj_registrasi->Update_verifikasidpk(array($this->arr_params['valid'],$this->arr_params['id_person']));
				if($this->arr_params['valid']=='yes'){
				
				$dpp_split='54000';
			    $icn_split='0';
			    $dpw_split='72000';
			    $dpd_split='118800';
			    $dpk_split='115200';
			    
			    
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				// Create Virtual Account
				
				$param_urut_va=array($this->arr_params['id_person'],  $virtual_accout);
				
				$cekva = $this->obj_registrasi->CekVirtualAcountMax($virtual_accout);
				if(!empty($cekva)){
				   
				    $err[] = '<br /><b>Nomor Virtual Account sudah di gunakan</b> mohon ulangi proses verifikasi tingkat DPK'; }
				
				
				// BNI Create VA BNIHashing
					$client_id = '19194';
					$secret_key = '51d4dd95e80c217756e502c9e68b639c';
					//$url = 'https://api.bni-ecollection.com/';
					$url = 'https://va-splitter.com/api/va/v1';
					$kode_dpp='DPPIK';
		            $kode_icn='DPPICN';
					$data_asli = array(
						'type' => 'createbilling',
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 168 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama'],
						'customer_email' =>  $result['email'],
						'customer_phone' => $result['handphone'],
						'description' => 'DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'],
						'split' => 'true',
                         'splitDescription' => $kode_dpp.'_'.$dpp_split.'_'.'distribusiDPPIK'.';'.'DPW'.$result['id_province_kom'].'_'.$dpw_split.'_'.'DistribusiDPW'.';'.'DPD'.$result['id_city_komisariat'].'_'.$dpd_split.'_'.'DistribusiDPD'.';'.'DPK'.$result['id_cabang'].'_'.$dpk_split.'_'.'DistribusiDPK'
					);
					
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					
					if ($response_json['status'] !== '000') {
						// handling jika gagal
						var_dump($response_json);
					}
					else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
						$this->obj_registrasi->MemberVirtualAcountBackup($param_virtual_acount2);
				
				$this->obj_registrasi->MemberVirtualAcount($param_virtual_acount);
				//urutvirtual_account
				$this->obj_registrasi->InsertNourutVirtualAcount($param_urut_va);
					
				if(!self::SendEmailVirtualAcoaunt($result['id_cabang'], $result, $virtual_accout)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						
						var_dump($data_response);
					}
				// batas Va BNI 
				
				
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpk');	
	}
	
	private function UpdateVerifikasidpkDpd(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		//sleep(10);
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
			$params = array($this->arr_params['id_calon']);
	    	$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
		//print_r($this->arr_params['valid']);exit;	
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = strval(intval($MaxId['id'])+ 1);
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,6);
			$fix='988';
			$clienID='19194';
			
			$pembeda=substr($result[handphone],-2);
			if($pembeda>0){
			   $pembeda_hp=substr($result[handphone],-2);
			    
			}else{
			 $pembeda_hp=11;   
			}
			
			$virtual_accout=$fix.$clienID.$pembeda.$angka_urut_va;
			
		if(empty($err)){
		
			//print_r($pembeda_hp);exit;
			
			//print_r($virtual_accout);exit;
			//$expired_unit=date('c', time() + 168 * 3600);
		    $expired_unit=date('Y-m-d',strtotime(date("Y-m-d", mktime()) . " + 7 day"));
			$tahun = date('Y');
			$mount='360000';
			$desk='DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'];
			$param_virtual_acount2=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$desk,$mount,$tahun, $expired_unit,'mandiri', $this->arr_params['id_person']);
			
			$param_virtual_acount=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$mount,$tahun, $expired_unit,'DPD', $this->arr_params['id_person']);
				// delete calon anggota
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				$this->obj_registrasi->Update_verifikasidpk(array($this->arr_params['valid'],$this->arr_params['id_person']));
				if($this->arr_params['valid']=='yes'){
				
				$dpp_split='54000';
			    $icn_split='0';
			    $dpw_split='72000';
			    $dpd_split='118800';
			    $dpk_split='115200';
			    
			    
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				// Create Virtual Account
				
				$param_urut_va=array($this->arr_params['id_person'],  $virtual_accout);
				
				$cekva = $this->obj_registrasi->CekVirtualAcountMax($virtual_accout);
				if(!empty($cekva)){
				   
				    $err[] = '<br /><b>Nomor Virtual Account sudah di gunakan</b> mohon ulangi proses verifikasi tingkat DPK'; }
				
			
				// BNI Create VA BNIHashing
					$client_id = '19194';
					$secret_key = '51d4dd95e80c217756e502c9e68b639c';
					//$url = 'https://api.bni-ecollection.com/';
					$url = 'https://va-splitter.com/api/va/v1';
					$kode_dpp='DPPIK';
		            $kode_icn='DPPICN';
					$data_asli = array(
						'type' => 'createbilling',
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 168 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama'],
						'customer_email' =>  $result['email'],
						'customer_phone' => $result['handphone'],
						'description' => 'DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'],
						'split' => 'true',
                         'splitDescription' => $kode_dpp.'_'.$dpp_split.'_'.'distribusiDPPIK'.';'.'DPW'.$result['id_province_kom'].'_'.$dpw_split.'_'.'DistribusiDPW'.';'.'DPD'.$result['id_city_komisariat'].'_'.$dpd_split.'_'.'DistribusiDPD'.';'.'DPK'.$result['id_cabang'].'_'.$dpk_split.'_'.'DistribusiDPK'
					);
					
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					
					if ($response_json['status'] !== '000') {
						// handling jika gagal
						var_dump($response_json);
					}
					else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
							$this->obj_registrasi->MemberVirtualAcountBackup($param_virtual_acount2);
				
				$this->obj_registrasi->MemberVirtualAcount($param_virtual_acount);
				//urutvirtual_account
				$this->obj_registrasi->InsertNourutVirtualAcount($param_urut_va);
					
				if(!self::SendEmailVirtualAcoaunt($result['id_cabang'], $result, $virtual_accout)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						
						var_dump($data_response);
					}
				// batas Va BNI 
				
				
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpd');	
	}
	
	
	private function UpdateVerifikasidpkdpw(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			$params = array($this->arr_params['id_calon']);
		$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
		//print_r($this->arr_params['valid']);exit;	
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = strval(intval($MaxId['id'])+ 1);
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,6);
			$fix='988';
			$clienID='19194';
			$pembeda=substr($result[handphone],-2);
			if($pembeda>0){
			   $pembeda_hp=substr($result[handphone],-2);
			    
			}else{
			 $pembeda_hp=1;   
			}
			$virtual_accout=$fix.$clienID.$pembeda.$angka_urut_va;
			
			//$expired_unit=date('c', time() + 168 * 3600);
			$expired_unit=date('Y-m-d',strtotime(date("Y-m-d", mktime()) . " + 7 day"));
			$tahun = date('Y');
			$mount='360000';
			$desk='DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'];

            $param_virtual_acount2=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$desk,$mount,$tahun, $expired_unit,'mandiri', $this->arr_params['id_person']);

			$param_virtual_acount=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$mount,$tahun, $expired_unit,'DPW', $this->arr_params['id_person']);
			
			$param_urut_va=array($this->arr_params['id_person'],  $virtual_accout);
				// delete calon anggota
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				if($this->arr_params['valid']=='yes'){
				$this->obj_registrasi->Update_verifikasidpk(array($this->arr_params['valid'],$this->arr_params['id_person']));
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				// Create Virtual Account
				
				$dpp_split='54000';
			    $icn_split='0';
			    $dpw_split='72000';
			    $dpd_split='118800';
			    $dpk_split='115200';
			    
			    
			
				// BNI Create VA BNIHashing
					$client_id = '19194';
					$secret_key = '51d4dd95e80c217756e502c9e68b639c';
					//$url = 'https://api.bni-ecollection.com/';
					$url = 'https://va-splitter.com/api/va/v1';
					
					$kode_dpp='DPPIK';
		            $kode_icn='DPPICN';
						$data_asli = array(
						'type' => 'createbilling',
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 168 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama'],
						'customer_email' =>  $result['email'],
						'customer_phone' => $result['handphone'],
						'description' => 'DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'],
						'split' => 'true',
                         'splitDescription' => $kode_dpp.'_'.$dpp_split.'_'.'distribusiDPPIK'.';'.'DPW'.$result['id_province_kom'].'_'.$dpw_split.'_'.'DistribusiDPW'.';'.'DPD'.$result['id_city_komisariat'].'_'.$dpd_split.'_'.'DistribusiDPD'.';'.'DPK'.$result['id_cabang'].'_'.$dpk_split.'_'.'DistribusiDPK'
					);
					
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					
					if ($response_json['status'] !== '000') {
						// handling jika gagal
						var_dump($response_json);
					}
					else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
							$this->obj_registrasi->MemberVirtualAcountBackup($param_virtual_acount2);
				
				$this->obj_registrasi->MemberVirtualAcount($param_virtual_acount);
				$this->obj_registrasi->InsertNourutVirtualAcount($param_urut_va);
				if(!self::SendEmailVirtualAcoaunt($result['id_cabang'], $result, $virtual_accout)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						
						var_dump($data_response);
					}
				// batas Va BNI 
				
				
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpw');	
	}
	
		private function UpdateVerifikasidpkBydpp(){
		// inisialize variable --------------------------------------------
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		//sleep(10);
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
			$params = array($this->arr_params['id_calon']);
	    	$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
		//print_r($this->arr_params['valid']);exit;	
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = strval(intval($MaxId['id'])+ 1);
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,6);
			$fix='988';
			$clienID='19194';
			
			$pembeda=substr($result[handphone],-2);
			if($pembeda>0){
			   $pembeda_hp=substr($result[handphone],-1);
			    
			}else{
			 $pembeda_hp=1;   
			}
			
			$virtual_accout=$fix.$clienID.$pembeda.$angka_urut_va;
			
		if(empty($err)){
		
			//print_r($pembeda_hp);exit;
			
			//print_r($virtual_accout);exit;
			//$expired_unit=date('c', time() + 168 * 3600);
		    $expired_unit=date('Y-m-d',strtotime(date("Y-m-d", mktime()) . " + 7 day"));
			$tahun = date('Y');
			$mount='360000';
			$desk='DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'];
			$param_virtual_acount2=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$desk,$mount,$tahun, $expired_unit,'mandiri', $this->arr_params['id_person']);
			
			$param_virtual_acount=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$mount,$tahun, $expired_unit,'DPP', $this->arr_params['id_person']);
				// delete calon anggota
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				$this->obj_registrasi->Update_verifikasidpk(array($this->arr_params['valid'],$this->arr_params['id_person']));
				if($this->arr_params['valid']=='yes'){
				
				$dpp_split='54000';
			    $icn_split='0';
			    $dpw_split='72000';
			    $dpd_split='118800';
			    $dpk_split='115200';
			    
			    
				//$this->obj_registrasi->DebugQuery("InsertVirtualAcount",$param_virtual_acount);exit;
				// Create Virtual Account
				
				$param_urut_va=array($this->arr_params['id_person'],  $virtual_accout);
				
				$cekva = $this->obj_registrasi->CekVirtualAcountMax($virtual_accout);
				if(!empty($cekva)){
				   
				    $err[] = '<br /><b>Nomor Virtual Account sudah di gunakan</b> mohon ulangi proses verifikasi tingkat DPK'; }
				
				$this->obj_registrasi->MemberVirtualAcountBackup($param_virtual_acount2);
				
				//$this->obj_registrasi->MemberVirtualAcount($param_virtual_acount);
				//urutvirtual_account
				//$this->obj_registrasi->InsertNourutVirtualAcount($param_urut_va);
                
				//if(!self::SendEmailVirtualAcoaunt($result['id_cabang'], $result, $virtual_accout)){
				//	$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				//}
				// BNI Create VA BNIHashing
					$client_id = '19194';
					$secret_key = '51d4dd95e80c217756e502c9e68b639c';
					//$url = 'https://api.bni-ecollection.com/';
					$url = 'https://va-splitter.com/api/va/v1';
					$kode_dpp='DPPIK';
		            $kode_icn='DPPICN';
						$data_asli = array(
						'type' => 'createbilling',
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 168 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama'],
						'customer_email' =>  $result['email'],
						'customer_phone' => $result['handphone'],
						'description' => 'DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'],
						'split' => 'true',
                         'splitDescription' => $kode_dpp.'_'.$dpp_split.'_'.'distribusiDPPIK'.';'.'DPW'.$result['id_province_kom'].'_'.$dpw_split.'_'.'DistribusiDPW'.';'.'DPD'.$result['id_city_komisariat'].'_'.$dpd_split.'_'.'DistribusiDPD'.';'.'DPK'.$result['id_cabang'].'_'.$dpk_split.'_'.'DistribusiDPK'
					);
					
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					//print_r($response_json['status'] );exit;
					if ($response_json['status'] !== '000') {
						// handling jika gagal
						 $err[] = '<br /><b>Nomor Virtual tidak dapat di</b> mohon ulangi proses verifikasi tingkat DPK';
						var_dump($response_json);
					}
					else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
						$this->obj_registrasi->MemberVirtualAcount($param_virtual_acount);
				//urutvirtual_account
				    $this->obj_registrasi->InsertNourutVirtualAcount($param_urut_va);
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						
						var_dump($data_response);
					}
				// batas Va BNI 
				
				
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru');	
	}
	
	private function UpdateVerifikasidpkAll(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		
		//print_r($result['email']);exit;
		// required -------------------------------------------
		
		// processing -----------------------------------------------------
		if(empty($err)){
			//$this->obj_anggota->DebugQuery("GetAnggotaByAdmindpkVa",array($this->arr_params['id_cabang']));	exit;
			//$rs_id = $this->obj_anggota->GetDatasetAsArray("GetAnggotaByAdmindpkVa",array($this->arr_params['id_cabang']));	
			foreach($this->arr_params['downcheck'] as $id){
			
			//$params_userid = array($this->arr_params['user_id']);
			//$this->obj_cv->DebugQuery("GetIdentitasPribadiByIdPersonVirtual",array($id));exit;
			$result = $this->obj_registrasi->GetCalonAnggotaById($id);	
			//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
			//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = strval(intval($MaxId['id'])+ 1);
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,6);
			$fix='988';
			$clienID='19194';
			$pembeda=substr($result[id_person],-2);
			if($pembeda>0){
			   $pembeda_hp=substr($result[id_person],-1);
			    
			}else{
			 $pembeda_hp=1;   
			}
			$virtual_accout=$fix.$clienID.$pembeda.$angka_urut_va;
			//$expired_unit=date('c', time() + 168 * 3600);
			$expired_unit=date('Y-m-d',strtotime(date("Y-m-d", mktime()) . " + 7 day"));
			$periode=array($this->arr_params['year'].'-'.'01'.'-'.'02');
			$mount='360000';
			$param_virtual_acount=array($result['id_person'], $result['nama_lengkap'], $result['email'],$result['no_hp'], $virtual_accout,
			$mount['besaran'],$this->arr_params['year'],$this->arr_params['tahap'],$expired_unit,'kolektif', $result['id_person']);
			
			//print_r($result);exit;
			// execute process
			//$this->obj_registrasi->debugQuery("InsertVirtualAcountKolektif",$param_virtual_acount);exit;
			$this->obj_registrasi->Update_verifikasidpk(array($this->arr_params['valid'],$result['id_person']));
				
			$param_urut_va=array($this->arr_params['id_person'],  $virtual_accout);
			
				$dpp_split='54000';
			    $icn_split='0';
			    $dpw_split='72000';
			    $dpd_split='118800';
			    $dpk_split='115200';
			    
			$this->obj_registrasi->MemberVirtualAcountBackup($param_virtual_acount2);	
			if($this->obj_registrasi->MemberVirtualAcount($param_virtual_acount)){
			    
			    //urutvirtual_account
                $this->obj_registrasi->InsertNourutVirtualAcount($param_urut_va);
			    if(!self::SendEmailVirtualAcoaunt($result['id_cabang'], $result, $virtual_accout)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// BNI Create VA BNIHashing
					$client_id = '19194';
					$secret_key = '51d4dd95e80c217756e502c9e68b639c';
					//$url = 'https://api.bni-ecollection.com/';
					$url = 'https://va-splitter.com/api/va/v1';
					$kode_dpp='DPPIK';
		            $kode_icn='DPPICN';
						$data_asli = array(
						'type' => 'createbilling',
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 168 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama'],
						'customer_email' =>  $result['email'],
						'customer_phone' => $result['handphone'],
						'description' => 'DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'],
						'split' => 'true',
                         'splitDescription' => $kode_dpp.'_'.$dpp_split.'_'.'distribusiDPPIK'.';'.'DPW'.$result['id_province_kom'].'_'.$dpw_split.'_'.'DistribusiDPW'.';'.'DPD'.$result['id_city_komisariat'].'_'.$dpd_split.'_'.'DistribusiDPD'.';'.'DPK'.$result['id_cabang'].'_'.$dpk_split.'_'.'DistribusiDPK'
					);

					echo "$data_asli";
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					//$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					
					if ($response_json['status'] !== '000') {
						// handling jika gagal
                                             
						var_dump($response_json);
  //echo"test_gagal";exit;
					}else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						//echo"test_sukses";exit;
						var_dump($data_response);
					}
				// batas Va BNI 
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
			}
		}else{
			// filled last field
			
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		
			
				
		}  		
// redirect page --------------------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'terbaru_dpk');
	}	
	
	private function UpdateVerifikasidpkAll2(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			//$params = array($this->arr_params['id_calon']);
			//$this->obj_registrasi->DebugQuery("GetCalonAnggotaByAdminDpkVerAll",array($this->arr_params['id_cabang'],'no'));exit;	
		$rs_id = $this->obj_registrasi->GetDatasetAsArray("GetCalonAnggotaByAdminDpkVerAll",array($this->arr_params['id_cabang'],'no'));	
		//print_r($rs_id);exit;	
		foreach($this->arr_params['downcheck'] as $id){
				// delete calon anggota
				//$this->obj_registrasi->DeleteCalonAnggota(array($id));
				
			$result = $this->obj_registrasi->GetCalonAnggotaById($id);	
		//print_r($this->arr_params['valid']);exit;	
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = strval(intval($MaxId['id'])+ 1);
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,6);
			$fix='988';
			$clienID='19194';
				$pembeda=substr($result[id_person],-2);
			if($pembeda>0){
			   $pembeda_hp=substr($result[id_person],-1);
			    
			}else{
			 $pembeda_hp=1;   
			}
			$virtual_accout=$fix.$clienID.$pembeda.$angka_urut_va;
			$expired_unit=date('c', time() + 168 * 3600);
			$tahun = date('Y');
			$mount='360000';
			$desk='DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'];

            $param_virtual_acount2=array($this->arr_params['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$desk,$mount,$tahun, $expired_unit,'mandiri', $this->arr_params['id_person']);

			$param_virtual_acount=array($result['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$mount,$tahun, $expired_unit,'mandiri', $result['id_person']);
			
			$param_urut_va=array($this->arr_params['id_person'],  $virtual_accout);
			//$param_virtual_acount=array($result['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout, $expired_unit, $result['id_person']);
				
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				if($this->arr_params['valid']=='yes'){
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$result['id_person']));exit;
				$this->obj_registrasi->Update_verifikasidpk(array($this->arr_params['valid'],$result['id_person']));
				
				$this->obj_registrasi->MemberVirtualAcountBackup($param_virtual_acount2);
				$this->obj_registrasi->MemberVirtualAcount($param_virtual_acount);
				
				//urutvirtual_account
                $this->obj_registrasi->InsertNourutVirtualAcount($param_urut_va);
				if(!self::SendEmailVirtualAcoaunt($result['id_cabang'], $result, $virtual_accout)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// BNI Create VA BNIHashing
					$client_id = '19194';
					$secret_key = '51d4dd95e80c217756e502c9e68b639c';
					$url = 'https://va-splitter.com/api/va/v1';
					
					
						$data_asli = array(
						'type' => 'createbilling',
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 168 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama'],
						'customer_email' =>  $result['email'],
						'customer_phone' => $result['handphone'],
						'description' => 'DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'],
						'split' => 'true',
                         'splitDescription' => $kode_dpp.'_'.$dpp_split.'_'.'distribusiDPPIK'.';'.'DPW'.$result['id_province_kom'].'_'.$dpw_split.'_'.'DistribusiDPW'.';'.'DPD'.$result['id_city_komisariat'].'_'.$dpd_split.'_'.'DistribusiDPD'.';'.'DPK'.$result['id_cabang'].'_'.$dpk_split.'_'.'DistribusiDPK'
					);
					
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					
					if ($response_json['status'] !== '000') {
						// handling jika gagal
						var_dump($response_json);
					}else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						
						var_dump($data_response);
					}
				// batas Va BNI 
				
				
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
			
				}
				//penutup perulangan
			}
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpk');	
	}
	
private function UpdateVerifikasidppdpkAll(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			//$params = array($this->arr_params['id_calon']);
		$rs_id = $this->obj_registrasi->GetDatasetAsArray("GetCalonAnggotaByAdminDppDpkVerAll",array('no'));	
		//print_r($rs_id);exit;	
		foreach($rs_id as $id){
				// delete calon anggota
				//$this->obj_registrasi->DeleteCalonAnggota(array($id));
				
		$result = $this->obj_registrasi->GetCalonAnggotaById($id);	
		//print_r($this->arr_params['valid']);exit;	
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordVirtualAcountMax($params2);
			$angka_urut = strval(intval($MaxId['id'])+ 1);
			//print_r($result);exit;
			$angka_urut_va = self::tambah_nol($angka_urut ,6);
			$fix='988';
			$clienID='19194';
				$pembeda=substr($result[id_person],-2);
			if($pembeda>0){
			   $pembeda_hp=substr($result[id_person],-1);
			    
			}else{
			 $pembeda_hp=1;   
			}
			$virtual_accout=$fix.$clienID.$pembeda.$angka_urut_va;
		//	$expired_unit=date('c', time() + 168 * 3600);
			$expired_unit=date('Y-m-d',strtotime(date("Y-m-d", mktime()) . " + 7 day"));
			$tahun = date('Y');
			$mount='360000';
			$param_virtual_acount=array($result['id_person'], $result['nama'], $result['email'],$result['handphone'], $virtual_accout,$mount,$tahun, $expired_unit,'mandiri', $result['id_person']);
				// delete calon anggota
				//$this->obj_registrasi->DebugQuery("MemberVirtualAcount",$param_virtual_acount);exit;
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				if($this->arr_params['valid']=='yes'){
				//$this->obj_registrasi->DebugQuery("Update_verifikasidpk",array($this->arr_params['valid'],$result['id_person']));exit;
				$this->obj_registrasi->Update_verifikasidpk(array($this->arr_params['valid'],$result['id_person']));
				
				$dpp_split='54000';
			    $icn_split='0';
			    $dpw_split='72000';
			    $dpd_split='118800';
			    $dpk_split='115200';
			    
				// Create Virtual Account
				//print_r($param_virtual_acount);exit;
				//$this->obj_registrasi->DebugQuery("InsertVirtualAcount2",$param_virtual_acount);exit;
				$this->obj_registrasi->MemberVirtualAcount2($param_virtual_acount);
				if(!self::SendEmailVirtualAcoaunt($result['id_cabang'], $result, $virtual_accout)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
					// BNI Create VA BNIHashing
					$client_id = '19194';
					$secret_key = '51d4dd95e80c217756e502c9e68b639c';
					//$url = 'https://api.bni-ecollection.com/';
					$url = 'https://va-splitter.com/api/va/v1';
					$kode_dpp='DPPIK';
		            $kode_icn='DPPICN';
						$data_asli = array(
						'type' => 'createbilling',
						'client_id' => $client_id,
						'trx_id' => mt_rand(), // fill with Billing ID
						'trx_amount' => 360000,
						'billing_type' => 'c',
						'datetime_expired' => date('c', time() + 168 * 3600), // billing will be expired in 2 hours
						'virtual_account' => $virtual_accout,
						'customer_name' => $result['nama'],
						'customer_email' =>  $result['email'],
						'customer_phone' => $result['handphone'],
						'description' => 'DPW'.$result['id_province_kom'].'|'.'DPD'.$result['id_city_komisariat'].'|'.'DPK'.$result['id_cabang'],
						'split' => 'true',
                         'splitDescription' => $kode_dpp.'_'.$dpp_split.'_'.'distribusiDPPIK'.';'.'DPW'.$result['id_province_kom'].'_'.$dpw_split.'_'.'DistribusiDPW'.';'.'DPD'.$result['id_city_komisariat'].'_'.$dpd_split.'_'.'DistribusiDPD'.';'.'DPK'.$result['id_cabang'].'_'.$dpk_split.'_'.'DistribusiDPK'
					);
					$hashed_string = $this->obj_bnihashing->hashData(
						$data_asli,
						$client_id,
						$secret_key
					);
					
					$data = array(
						'client_id' => $client_id,
						'data' => $hashed_string,
					);
					
					$response = self::get_content($url, json_encode($data));
					$response_json = json_decode($response, true);
					
					if ($response_json['status'] !== '000') {
						// handling jika gagal
						var_dump($response_json);
					}
					else {
						$data_response =  $this->obj_bnihashing->parseData($response_json['data'], $client_id, $secret_key);
						// $data_response will contains something like this: 
						// array(
						// 	'virtual_account' => 'xxxxx',
						// 	'trx_id' => 'xxx',
						// );
						
						var_dump($data_response);
					}
				// batas Va BNI 
				
				
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
			
				}
				//penutup perulangan
			}
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpk');	
	}
	
private function get_content($url, $post = '') {
	$usecookie = HTTPPATH.doc."/cookie.txt";
	$header[] = 'Content-Type: application/json';
	$header[] = "Accept-Encoding: gzip, deflate";
	$header[] = "Cache-Control: max-age=0";
	$header[] = "Connection: keep-alive";
	$header[] = "Accept-Language: en-US,en;q=0.8,id;q=0.6";

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_VERBOSE, false);
	// curl_setopt($ch, CURLOPT_NOBODY, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_ENCODING, true);
	curl_setopt($ch, CURLOPT_AUTOREFERER, true);
	curl_setopt($ch, CURLOPT_MAXREDIRS, 5);

	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.120 Safari/537.36");

	if ($post)
	{
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
	}

	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

	$rs = curl_exec($ch);

	if(empty($rs)){
		var_dump($rs, curl_error($ch));
                echo "$usecookie";exit;
		curl_close($ch);
		return false;
	}
	curl_close($ch);
	return $rs;
	}
	
	
	private  function tambah_nol($angka,$jumlah){	
		   $jumlah_nol = strlen($angka);
		   $angka_nol = $jumlah - $jumlah_nol;
		   $nol = "";
		   for($i=1;$i<=$angka_nol;$i++)
		   {
			  $nol .= '0';
		   }
		   return $nol.$angka;
	}	
	
	private function SendEmailVirtualAcoaunt($id_cabang, $result,  $virtual_accout){
		// get data cabang
		$cabang = $this->obj_registrasi->GetInformasiCabangById(array($id_cabang));
                //$img_pembayaran = HTTPPATH.'doc/temp/pembayaran.jpg';
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Nasional Indonesia</h3>
						<h3>Komisariat ".$cabang['nama']."</h3>
						<p><small>".$cabang['alamat']."</small></p>
						<p><strong>".$result['prefix'].' '.$result['nama'].' '.$result['suffix']."</strong>,<br>
						Data anda telah diverifikasi oleh pengurus Komisariat. Selanjutnya silahkan anda melakukan pembayaran menngunakan virtual acount dari Bank BNI di bawah:<br>
						Virtual Acount:<strong> $virtual_accout</strong><br />
						Besaran yang harus di bayarkan sebesar <strong> Rp. 360.000</strong> dengan rincian sebagai berikut :
						<br />
						- Uang Pangkal : 100.000<br />
						- iuran tahunan : 260.000<br />
						silahkan anda melakukan pembayaran melalui ATM, Setor Tunai atau Internet Banking Bank BNI
						
						Setelah anda melakukan pembayaran akan dilakukan verifikasi administrasi lebih lanjut untuk penerbitan NIRA,user id dan Password yang akan di kirim via email.
						<img src='http://ppni-inna.org/doc/temp/pembayaran1.jpg' alt='test image 2'>
						
						</p>
						<p> Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
                $this->obj_mail->AddEmbeddedImage('http://ppni-inna.org/doc/temp/pembayaran1.jpg', 'logo_2u');
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Verifikasi pendaftaran";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($result['email'], $result['prefix'].' '.$result['nama'].' '.$result['suffix']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}

    private function UpdateVerifikasidpd(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			
				if($this->arr_params['valid']=='yes'){
//$this->obj_registrasi->DebugQuery("Update_verifikasidpd",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				$this->obj_registrasi->Update_verifikasidpd(array($this->arr_params['valid'],$this->arr_params['id_person']));
				$params = array($this->arr_params['id_calon']);
				$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
				if(!self::SendEmailVerifikasiDPD($result)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpd');	
	}
	
	
	private function UpdateVerifikasidpdBydpp(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			
				if($this->arr_params['valid']=='yes'){
//$this->obj_registrasi->DebugQuery("Update_verifikasidpd",array($this->arr_params['valid'],$this->arr_params['id_person']));exit;
				$this->obj_registrasi->Update_verifikasidpd(array($this->arr_params['valid'],$this->arr_params['id_person']));
				$params = array($this->arr_params['id_calon']);
				$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
				if(!self::SendEmailVerifikasiDPD($result)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru');	
	}
	
	private function UpdateVerifikasidpdAll(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			$rs_id = $this->obj_registrasi->GetDatasetAsArray("GetCalonAnggotaByDpdVerAll",array($this->arr_params['id_dpd'],'no'));	
			foreach($rs_id as $id){
			
				if($this->arr_params['valid']=='yes'){
				
				$result = $this->obj_registrasi->GetCalonAnggotaById($id);	
				$this->obj_registrasi->Update_verifikasidpd(array($this->arr_params['valid'],$result['id_person']));
				}else{
				//$this->obj_registrasi->Delete_calon(array($result['id_person']));
				//$this->obj_registrasi->Delete_person(array($result['id_person']));
				}
			// Penutup Perulangan			
				
			}
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpd');	
	}
	
	private function UpdateVerifikasidpw(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			$params = array($this->arr_params['id_calon']);
			$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
				if($this->arr_params['valid']=='yes'){
				$this->obj_registrasi->Update_verifikasidpw(array($this->arr_params['valid'],$this->arr_params['id_person']));
				$params = array($this->arr_params['id_calon']);
				$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
				if(!self::SendEmailVerifikasiDPW($result)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpw');	
	}
	
	private function UpdateVerifikasidpwBydpp(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
			$params = array($this->arr_params['id_calon']);
			$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
				if($this->arr_params['valid']=='yes'){
				$this->obj_registrasi->Update_verifikasidpw(array($this->arr_params['valid'],$this->arr_params['id_person']));
				$params = array($this->arr_params['id_calon']);
				$result = $this->obj_registrasi->GetCalonAnggotaById($params);	
				if(!self::SendEmailVerifikasiDPW($result)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru');	
	}
	
	
	
	
	private function UpdateVerifikasidpwAll(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['valid'])){ $err[] = '<br /><b>Verifikasi </b>tidak terchecklis'; }
		//if(empty($result['email'])){ $err[] = '<br /><strong>Email</strong> harus diisi'; }
		//if(empty($result['no_hp'])){ $err[] = '<br /><strong>harus disii</strong> harus diisi'; }
		// processing --------------------------------------------------
		
		if(empty($err)){
				
			$rs_id = $this->obj_registrasi->GetDatasetAsArray("GetCalonAnggotaByDpwVerAll",array($this->arr_params['id_dpw'],'no'));	
			foreach($rs_id as $id){
				if($this->arr_params['valid']=='yes'){
				$result = $this->obj_registrasi->GetCalonAnggotaById($id);
				$this->obj_registrasi->Update_verifikasidpw(array($this->arr_params['valid'],$result['id_person']));
				}else{
				//$this->obj_registrasi->Delete_calon(array($this->arr_params['id_person']));
				//$this->obj_registrasi->Delete_person(array($this->arr_params['id_person']));
				}
			}
		}
		// redirect to page ------------------------------------	
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpw');	
	}
	
	private function SendEmailVerifikasiDPD($result){
		// get data cabang
		//$cabang = $this->obj_registrasi->GetInformasiCabangById(array($id_cabang));
                //$img_pembayaran = HTTPPATH.'doc/temp/pembayaran.jpg';
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Nasional Indonesia</h3>
						<p><strong>".$result['prefix'].' '.$result['nama'].' '.$result['suffix']."</strong>,<br>
						Data anda telah diverifikasi oleh  Dewan Pengurus Daerah. Selanjutnya akan di verifikasi oleh Dewan Pengurus Wilayah:<br>
						
						
						</p>
						<p> Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
                $this->obj_mail->AddEmbeddedImage('http://ppni-inna.org/doc/temp/pembayaran1.jpg', 'logo_2u');
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Verifikasi pendaftaran";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($result['email'], $result['prefix'].' '.$result['nama'].' '.$result['suffix']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	private function SendEmailVerifikasiDPW($person, $result){
		// get data cabang
		$cabang = $this->obj_registrasi->GetInformasiCabangById(array($id_cabang));
                //$img_pembayaran = HTTPPATH.'doc/temp/pembayaran.jpg';
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Nasional Indonesia</h3>
						<p><strong>".$result['prefix'].' '.$result['nama'].' '.$result['suffix']."</strong>,<br>
						Data anda telah diverifikasi oleh Dewan Pengurus Wilayah. 
						Setelah anda melakukan pembayaran akan dilakukan verifikasi administrasi lebih lanjut untuk penerbitan NIRA,user id dan Password yang akan di kirim via email.
						
						</p>
						<p> Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
                $this->obj_mail->AddEmbeddedImage('http://ppni-inna.org/doc/temp/pembayaran1.jpg', 'logo_2u');
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Verifikasi pendaftaran";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($result['email'], $result['prefix'].' '.$result['nama'].' '.$result['suffix']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	
	private function SaveFile(){
		$err = array();	
		$filled = array();	
		// check / validate parameter 
		//if(empty($this->arr_params['file_attach'])){ $err[] = '<br /><strong>Berkas</strong> kosong'; }
		
		// gambar
		// berkas
		$berkas = $_FILES['file_attach'];
		if(empty($berkas['tmp_name'])){ $err[] = '<br /><strong>Berkas</strong> must be filled'; }
		
			//print_r($params);exit;
		// processing --------------------------------------------------
		if(empty($err)){
			$params = array($berkas['name'],$this->str_userid);
			//$this->obj_registrasi->DebugQuery("InsertFileRegistrasi", $params);exit;
			
			if($this->obj_registrasi->ProcessingData("InsertFileRegistrasi", $params)){
				// get last id
				$id = $this->obj_registrasi->GetLastInsertedId();
				// upload file 
				//self::UploadBerkas($berkas,$id);
				self::ProcessingInsert($id);
				// sukses message				
				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');
			}else{
				$filled = array('FILE_ATTACH' => $this->arr_params['file_attach']);
				// error message
				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');
			}	
		}else{
			$filled = array('FILE_ATTACH' => $this->arr_params['file_attach']);
			// error message
			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');
		}
		// Redirect page
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'upload_masal',array());
	}
	
	private function UploadBerkas($berkas, $id){
		$err = array();
		// allowed type
		//$this->obj_upload->file_accept = array( 'xls');
		// --
		if(!empty($berkas['tmp_name']) AND $berkas['size'] <= 1000000){
			// name and path file
			$file_name = str_replace(' ', '_', $berkas['name']);
			$file_path = "doc/registasi/upload/".$id."/";
			// processing
			if($this->obj_upload->FileUpload($berkas, $file_path)){
				// insert to database
				$params = array($file_name, $file_path,$this->str_userid, $id);
				//$this->obj_registrasi->DebugQuery("UpdateFilePathRegistrasi", $params);exit;
				$this->obj_registrasi->ProcessingData("UpdateFilePathRegistrasi", $params);
				// --
				$err[] = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 
			}else{
				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
			}		
		}else{
			$err[] = '<br />Berkas <strong>tidak berhasil</strong> diupload'; 
		}		
		// return
		return $err;
	}
	
	private function ProcessingInsert(){
	$target = basename($_FILES['file_attach']['name']) ;
    move_uploaded_file($_FILES['file_attach']['tmp_name'], $target);
    
    $data = new Spreadsheet_Excel_Reader($_FILES['file_attach']['name'],false);
    //print_r($data);exit;
//    menghitung jumlah baris file xls
    $baris = $data->rowcount($sheet_index=0);
    
//    jika kosongkan data dicentang jalankan kode berikut
    $drop = isset( $_POST["drop"] ) ? $_POST["drop"] : 0 ;
  
    
//    import data excel mulai baris ke-2 (karena tabel xls ada header pada baris 1)
    for ($i=2; $i<=$baris; $i++)
    {
//       membaca data (kolom ke-1 sd terakhir)
		$this_day = date('Y').date('m').date('d');
			$id = $this->obj_admin->GetIdPerson(array($this_day . "%"));
			if(!empty($id)){
				$id = explode('-', $id);
				$id_person = $this_day . '-' . strval(intval($id[1]) + 1);
			}else{
				$id_person = $this_day . '-1';
			}
		$nama_province  		= $data->val($i, 12); 
      	$nama_city  			= $data->val($i, 13);
      	$nama_districts  		= $data->val($i, 14);
		$nama_villages  		= $data->val($i, 15);
		//print_r($nama_province);
		//$person=mysql_query("select * from member_virtuaacount_m where virtual_account='$virtual_acount'");
           // $row=mysql_fetch_row($person);
		$cek_province=mysql_query("SELECT id_province FROM spt_provincy_m WHERE province_name='$nama_province'");
		$row_cek_province=mysql_fetch_row($cek_province);
		$id_cek_province = $row_cek_province[0];
		
		$cek_city=mysql_query("SELECT id_city FROM spt_city_m WHERE city_name='$nama_city'");
		$row_cek_city=mysql_fetch_row($cek_city);
		$id_cek_city=$row_cek_city[0];
		
		$cek_districts=mysql_query("SELECT id_districts FROM spt_districts_m WHERE name='$nama_districts'");
		$row_cek_districts=mysql_fetch_row($cek_districts);
		$id_cek_districts=$row_cek_districts[0];
		
		$cek_villages=mysql_query("SELECT id_villages FROM spt_villages_m WHERE name='$nama_villages'");
		$row_cek_id_villages=mysql_fetch_row($cek_villages);
		$id_cek_villages=$row_cek_id_villages[0];
		
		$result = $this->obj_admin->GetDataAsSingleArray("GetListCabangAdminByid", array($this->str_userid, $this->str_userid));
		//print_r($result['id_cabang']);
		 $id_komisariat=$result['id_cabang'];
		 //print_r($id_komisariat);exit;
		 
		 $cek_districts=mysql_query("SELECT id_city FROM spt_cabang_m WHERE id_cabang='$id_komisariat'");
		$row_cek_districts=mysql_fetch_row($cek_districts);
		$id_cek_districts=$row_cek_districts[0];
		
		$id_prov=substr($id_cek_districts,0,-2);
		$id_city_kom=$id_cek_districts;
		//$id_prov=substr($id_cek_districts,0,-2);
		//$id_city_kom=$id_cek_districts;
		
		//print_r($id_cek_districts).','.
		//print_r($id_prov);exit;
		//print_r($id_city_kom);
		//print_r($id_cek_districts).','.
		//print_r($id_prov).','.
		//print_r($id_city_kom);
      $id_person            = $id_person;
      $nama	      			= $data->val($i, 2);
	  $tgl_lahir      		= $data->val($i, 3);
      $tmp_lahir			= $data->val($i, 4);
      $gender     			= $data->val($i, 5);
      $no_ktp    			= $data->val($i, 6);
      $status_relasi    	= $data->val($i, 7);
      $prefix  				= $data->val($i, 8);
      $suffix  				= $data->val($i, 9);
      $alamat  				= $data->val($i, 10);
      $id_province  		= $id_prov; 
      $id_city  			= $id_city_kom;
      $id_districts  		= $id_cek_districts;
      $id_vellage  			= $id_cek_villages;
      $kodepos  			= $data->val($i, 11);
      $telepon  			= $data->val($i, 12);
      $handphone  			= $data->val($i, 13);
      $status_perawat  		= $data->val($i, 14);
      $id_province_kom   	= $id_prov;
      $id_city_komisariat   = $id_city_kom;
      $id_cabang     		= $id_komisariat; 
	  $email  				= $data->val($i, 15);
      $agama  				= $data->val($i, 16);
      $institusi   			= $data->val($i, 17);
	  $jenjang    			= $data->val($i, 18);
      $spesialis_1    		= $data->val($i, 19);
      $spesialis_2     		= $data->val($i, 20); 
	  $periode_awal  		= $data->val($i, 21);
      $periode_akhir  		= $data->val($i, 22);
      $no_ijasah    		= $data->val($i, 23);
      $nama_kantor   		= $data->val($i, 24);
               
      $alamat_kantor     	= $data->val($i, 25); 
	  $id_city_kantor  		= $id_city_kom;
      $status_kepegawaian 	= $data->val($i, 26);
      $jabatan   			= $data->val($i, 27);
      $telepon_kantor    	= $data->val($i, 28);
       
	  $arrCalon = array($id_person,$nama,$tgl_lahir,$tmp_lahir,$gender,
	  $no_ktp,$status_relasi,$prefix,$suffix,$alamat,
	  $id_province,$id_city,$id_districts,$id_vellage,$kodepos,
	  $telepon,$handphone,$status_perawat,$id_province_kom,$id_city_komisariat,
	  $id_cabang,$email,$agama, $institusi,$jenjang,
	  $spesialis_1,$spesialis_2,$periode_awal,$periode_akhir,$no_ijasah,
	  $nama_kantor,$alamat_kantor,$id_city_kantor,$status_kepegawaian,$jabatan,
	  $telepon_kantor);
	  $this_day = date('Y').date('m').date('d');
	  $arrCalonperson = array($id_person,'',$nama,$no_ktp,$status_relasi,
	  $tmp_lahir,$tgl_lahir,$gender,$prefix,$suffix,
	  $alamat,$telepon,$handphone,$id_province,$id_city,
	  $id_districts,$id_vellage,$kodepos,$this_day,$this->str_userid,$agama );
	  
	 
	  
	  //print_r($arrCalon);exit;    
 					
//      setelah data dibaca, masukkan ke tabel pegawai sql
   //$this->obj_registrasi->DebugQuery('MemberRegistrationUpload', $arrCalo);exit;
	  $hasil=$this->obj_registrasi->ProcessingData('MemberRegistrationUpload', $arrCalon);
	  //$hasil_personon=$this->obj_registrasi->ProcessingData('InsertDataPerson', $arrCalonperson);
    
    }
    $this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpk');
    if(!$hasil){
//          jika import gagal
          die(mysql_error());
		  	$err[] = '<br />Berkas <strong>tidak berhasil</strong> diupload';
      }else{
//          jika impor berhasil
          echo '<div class="alert alert-success alert-dismissable"><button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>Data berhasil di import</div>';
		  $err[] = '<br />Berkas <strong>tidak berhasil</strong> diupload'; 
    }
    $this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru_dpk');	
//    hapus file xls yang udah dibaca
    unlink($_FILES['filepegawaiall']['name']);
}
	
	
	
	// register anggota by admin
	private function AddAnggota(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['page'])){ $this->arr_params['page'] = 1; }
		if(empty($this->arr_params['nama'])){ $err[] = '<br /><b>Id</b> tidak Boleh Kosong'; }
			if(empty($this->arr_params['nap'])){ $err[] = '<br /><b>NIRA</b> tidak Boleh Kosong'; }
		if(empty($this->arr_params['prov_kom'])){ $err[] = '<br /><b>DPW</b> tidak terpilih'; }
		if(empty($this->arr_params['city_komisariat'])){ $err[] = '<br /><b> DPD</b> tidak terpilih'; }
			if(empty($this->arr_params['cabang'])){ $err[] = '<br /><b> DPK</b> tidak terpilih'; }
	
		// processing --------------------------------------------------
		if(empty($err)){
			// get id person
			// get id person
			$this_day = date('Y').date('m').date('d');
			$params2 = array();
			$MaxId = $this->obj_registrasi->GetRecordIdPersonMax($params2);
			
			
			// data calon anggota
			$id_person = '2011'.$this->arr_params['nap']. '-' . strval(intval($MaxId['total']) + 1);
			$no_anggota= $this->arr_params['nap'];
			//print_r($id_person);exit;
			
			//$CekNoAnggota = $this->obj_registrasi->GetCekNoAnggota($no_anggota);
			//print_r($CekNoAnggota);exit;
			//if(!empty($CekNoAnggota['no_anggota'])){ $err[] = '<br /><b>No ANggota</b> Sudah Ada'; }
			// get userid
			$user_id = str_replace("-", "", $no_anggota);
			// get password
			$hask_key = $this->obj_crypt->CreateUserKey($user_id);
			$pass = substr($this->obj_crypt->CreateUserKey($hask_key), 0, 6);
			$pass_decrypt = $this->obj_crypt->StandardEncrypt($pass, $hask_key);
			// data calon anggota
			//$params = array($this->arr_params['id_calon']);
			//$result = $this->obj_registrasi->GetCalonAnggotaById($params);
			
			//urut anggota
			//$arr_urut=array($id_person,$no_max,$this->str_userid);
			//$this->obj_registrasi->DebugQuery('InsertNoUrutMember',$arr_urut);exit;
			//print_r($arr_urut);exit;
			// person 
			
			// authority
			$params_access =array($id_person,13) ;
			// account
			
			$arr_person = array($id_person, '-', $this->arr_params['nama'],'-','-', '-', '-', '-','-', '-','-', '-','-', '-',$this->arr_params['cabang'],'-','-', '-','-', $this->str_userid, '-');

			// member
			$arr_member = array($id_person,$this->arr_params['prov_kom'],$this->arr_params['city_komisariat'],$this->arr_params['cabang'],'-',
			$no_anggota, $no_anggota, '-','AB','-',$this->str_userid);
			
			// pendidikan
			$arr_edu = array($id_person, '-', '-', '-', '-', '-', '-', '-','-','-',$id_person);
			// tempat kerja utama
			$arr_workplace = array($id_person, '-', '-', '-', '-', '-', '-', $id_person);
			
			$params_account = array($id_person,$user_id,$pass_decrypt,$hask_key,$this->arr_params['email'],$this->str_userid);
			// processing data
			//print_r($params_access);exit;
			//$this->obj_registrasi->DebugQuery('InsertNoUrutMember',$arr_urut);exit;
			//$this->obj_registrasi->DebugQuery('InsertDataPerson',$arr_person);exit;
			if($this->obj_registrasi->ProcessingData('InsertDataPerson', $arr_person)){
			   
			    $this->obj_registrasi->ProcessingData('InsertDataMember', $arr_member);
			    $this->obj_registrasi->ProcessingData('InsertDataWorkplace', $arr_workplace);
			    $this->obj_registrasi->ProcessingData('InsertDataAccount', $params_account);
			    $this->obj_registrasi->ProcessingData('InsertDataAkses', $params_access);
			    
			    //updte data calon
			    // $this->obj_registrasi->UpdateCalonAnggota(array($this->arr_params['id_calon']));
				// delete calon anggota
				//$this->obj_registrasi->DeleteCalonAnggota(array($this->arr_params['id_calon']));
				// try to send mail
				$email_anggota=$this->arr_params['email'];
				if(!self::SendEmailRegistrasiAnggota($email_anggota, $user_id, $pass)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// sukses message			
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add', array());
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add', array());
			}
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page ------------------------------------	
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add', array());
		}
	}
	
private function SendEmailRegistrasiAnggota($email_anggota, $userid, $pass){
		
		// get data cabang
		$cabang = $this->obj_registrasi->GetInformasiCabangById(array($id_cabang));
		//print_r($result['nama']);exit;
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>PERSATUAN PERAWAT NASIONAL INDONESIA</h3>
						<br>
						Data anda telah ditambahkan di SIMK Berikut ini adalah account setting anda dalam web aplikasi PPNI :<br>
							Nira Sebagai Berikut:<br>
						User id : $userid<br />
						Password : $pass
						</p>

						<p> Terima kasih.</p>
                                                
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
	$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];				
		$this->obj_mail->Subject    = "Verifikasi pendaftaran";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($email_anggota);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
    
	// function to process
	
}

?>