<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_admin;
	protected $obj_registrasi;
	protected $obj_notify;
	protected $obj_date;
	protected $obj_data;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('content');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();		
		// load object business
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);	
		$this->obj_data = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');		
	}
	
	public function PageView(){
		// variable display
		self::DisplayVariable();
		// display data calon anggota
		self::DisplayCalonAnggota();
		// display notification
		self::DisplayNotification();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru', array($this->arr_routes['params'][0])));
		$this->obj_tmpl->addVar('content', 'PAGE', $this->arr_routes['params'][0]);
	}
	
	private function CheckAuthority($id_cabang){
		$params = array($this->str_userid, $id_cabang);
		if(!$this->obj_admin->CheckAuthorityByCabangAdmin($params)){
			// redirect to view page
			$this->obj_ctrl->RedirectUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'terbaru');
		}
	}
	
	private function DisplayCalonAnggota(){
		$params = array($this->arr_routes['params'][1]);
		$result = $this->obj_registrasi->GetCalonAnggotaById($params);
		// check authority
		//self::CheckAuthority($result['id_cabang']);
		// parse data
		$this->obj_tmpl->addVar('content', 'ID_CALON', $result['id_calon']);	
		$this->obj_tmpl->addVar('content', 'NAMA_LENGKAP', $result['nama']);	
		$this->obj_tmpl->addVar('content', 'TEMPAT_LAHIR', $result['tmp_lahir']);
		if($result['gender'] == "wanita")
			$this->obj_tmpl->addVar('content', 'GENDER', 'Wanita');	
		else
			$this->obj_tmpl->addVar('content', 'GENDER', 'Laki - laki');
		$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);	
		$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);	
		$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);	
		$this->obj_tmpl->addVar('content', 'ID_CITY', $result['id_city']);	
		$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);	
		$this->obj_tmpl->addVar('content', 'KODEPOS', $result['kodepos']);	
		$this->obj_tmpl->addVar('content', 'TELEPON', $result['telepon']);
		$this->obj_tmpl->addVar('content', 'NO_HP', $result['handphone']);
		$this->obj_tmpl->addVar('content', 'EMAIL', $result['email']);
		$this->obj_tmpl->addVar('content', 'TGL_LAHIR', $this->obj_date->GetFullDate($result['tgl_lahir']));
		$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);
		$this->obj_tmpl->addVar('content', 'NO_IDI', $result['no_idi']);
		$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);
		$this->obj_tmpl->addVar('content', 'STATUS', $result['status_anggota']);
		}
}

?>