<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



abstract class ApplicationBase

{		

	// default object 

	protected $obj_ctrl;

	protected $obj_tmpl;

	protected $arr_config;

	protected $arr_routes;	

	// global variable

	protected $str_userid;

	protected $arr_system_default;

	// parameter navigasi

	private $int_nav;

	private $int_parent;

	private $int_parent_blok;

	private $int_parent_group;

	// business object 

	protected $obj_system;

	protected $obj_site;

	protected $obj_nav;

	

	function __construct(){	

	}

	

	function __destruct(){

	}

	

	/** important 

	| ---------------------------------------------------------------------------------	

	| if you not understand, do not change code below !!!

	| ---------------------------------------------------------------------------------

	*/	

	protected final function LoadController(){

		// instance controller must be loaded

		$this->obj_ctrl = BaseController::Instance();

		// load configuration

		$this->arr_config = $this->obj_ctrl->LoadConfiguration('config.php');

	}

	

	protected final function LoadPatTemplate($loaded = TRUE){

		if($loaded == TRUE){

			/*

			| patTemplate must be loaded

			| Do not remove code below

			*/

			$this->obj_ctrl->LoadFile('pattemplate/patError.php', 'plugins');

			$this->obj_ctrl->LoadFile('pattemplate/patErrorManager.php', 'plugins');

			$this->obj_ctrl->LoadFile('pattemplate/patTemplate.php', 'plugins');

			$this->obj_tmpl = $this->obj_ctrl->LoadClass('patTemplate');

			// asossiate patTemplate with controller

			$this->obj_ctrl->SetTemplateObject($this->obj_tmpl);

		}else{

			// patTemplate object not define on process page

		}

	}	

	

	public final function PageDisplay($routes){

		/** 

		| final method 

		*/

		// get aktif routes variable

		$this->arr_routes = $routes;		

		// load controller object

		$this->LoadController();		

		/** 

		| override method 

		*/

		// load object on base

		$this->BaseLoad();

		// view base content

		$this->BaseView();	

		/** 

		| abstract method 

		*/

		// load object on content

		$this->PageLoad();

		// view page content

		$this->PageView();

		// parsing output

		$this->ParseDocumentOutput();

	}

	

	protected abstract function PageLoad();

	protected abstract function PageView();

	protected abstract function ParseDocumentOutput();

	/** end of important 

	| ---------------------------------------------------------------------------------

	*/	

	protected function SetBaseTemplates(){

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/base/templates');		

        $this->obj_tmpl->readTemplatesFromFile('document-base.html');	

        $this->obj_tmpl->readTemplatesFromFile('header-base.html');	

        $this->obj_tmpl->readTemplatesFromFile('sidebar-base.html');

        $this->obj_tmpl->readTemplatesFromFile('footer-base.html');

	}		

	

	protected function BaseLoad(){

		// load patTemplate object

		$this->LoadPatTemplate();

		// set document templates 

		$this->SetBaseTemplates();

		// default application themes

		$this->obj_ctrl->SetApplicationThemes('cpanel');

		// default application layout

		$this->obj_ctrl->SetBaseLayout();

		/*

		-- Other object loaded below 

		*/

		// javascript loaded

		

		// business loaded

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		$this->obj_site = $this->obj_ctrl->LoadBusiness('website', 'mysql', $this->arr_config['db']);

		$this->obj_nav = $this->obj_ctrl->LoadBusiness('navigation', 'mysql', $this->arr_config['db']);

	}

	

	protected function BaseView(){

		/* 

		-- display view general

		*/

		// authority

		if(!isset($_SESSION['admin_login'])){

			$this->obj_ctrl->RedirectPage('login_member', 'home', 'login', 'view');

		}else{

			// set global variable

			$this->str_userid = $_SESSION['admin_id'];

			// check authority ----------

			self::CheckUserAuthority();

			// web title

			self::DisplayWebTitle();

			// display features

			self::DisplayTopNavigation();

			// display features

			self::DisplaySidebarNavigation();

			// get system settings

			self::GetSystemSettings();

			// ---------------------

		}		

	}	

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	// check authority

	protected function CheckUserAuthority(){

		// get settings

		$params = array($this->str_userid, $this->arr_config['app_group']['cpanel'], $this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']);

		if(!$this->obj_nav->GetUserAuthority($params)){

			// redirect to forbiden access

			$this->obj_ctrl->RedirectPage('login_member', 'home', 'login', 'view');

		}

	}

	

	// system setting

	protected function GetSystemSettings(){

		// get settings

		$result = $this->obj_site->GetSystemSettings();

		$this->arr_system_default = $result;

	}

	

	// title

	protected function DisplayWebTitle(){

		// url logout

		$this->obj_tmpl->addGlobalVar('URL_LOGOUT', $this->obj_ctrl->GetUrl('cpanel', 'home', 'private', 'logout'));

		// display web title

		$str_web_page = $this->obj_nav->GetPageTitle($this->arr_routes);

		$this->obj_tmpl->addVar('head', 'SITE_TITLE', $str_web_page['group_title']);

		$this->obj_tmpl->addVar('head', 'PAGE_TITLE', $str_web_page['page_title']);

		$this->int_nav = $str_web_page['id_nav'];

		$this->int_parent = $str_web_page['id_parent'];

		// get parent group

		$this->int_parent_group = $this->obj_nav->GetParentGroupByIdNav(array($this->int_parent), 0);

		if(empty($this->int_parent_group)){

			$this->int_parent_group = $this->int_nav;

		}

		// latest info

		// $url_home = $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'private', 'info', 'terbaru');

		$this->obj_tmpl->addVar('layout', 'URL_HOME', HTTPPATH);

	}

	

	// navigation

	private function DisplayTopNavigation(){

		$no = 0;

		$params = array($this->str_userid, $this->arr_config['app_group']['cpanel'], 0);

		$rs_id = $this->obj_nav->GetNavigationByParent($params);

		while($rec = mysqli_fetch_assoc($rs_id)){

			if($this->int_parent_group == $rec['id_nav'])

				$this->obj_tmpl->addVar('list_navigation', 'SELECTED', 'class="active"');

			else

				$this->obj_tmpl->addVar('list_navigation', 'SELECTED', '');

			$url = $this->obj_ctrl->GetUrl($rec['app'], $rec['group'], $rec['module'], $rec['page']);

			$this->obj_tmpl->addVar('list_navigation', 'JUDUL', $rec['title']);

			$this->obj_tmpl->addVar('list_navigation', 'URL', $url);

			$this->obj_tmpl->ParseTemplate('list_navigation', 'a');			

			$no++;

		}

	}

	

	private function DisplaySidebarNavigation(){

		// get parent blok

		$this->int_parent_blok = $this->obj_nav->GetParentGroupByIdNav(array($this->int_nav), $this->int_parent_group);

		// parse child menu

		$params = array($this->str_userid, $this->arr_config['app_group']['cpanel'], $this->int_parent_group);

		$rs_id = $this->obj_nav->GetNavigationByParent($params);

		$no = 0;

		while($rec = mysqli_fetch_assoc($rs_id)){

			if($this->int_parent_blok == $rec['id_nav'])

				$this->obj_tmpl->addVar('list_sidebar_nav', 'SELECTED', 'class="side-active"');

			else

				$this->obj_tmpl->addVar('list_sidebar_nav', 'SELECTED', '');

			// title

			$this->obj_tmpl->addVar('list_sidebar_nav', 'JUDUL', $rec['title']);

			$url = $this->obj_ctrl->GetUrl($rec['app'], $rec['group'], $rec['module'], $rec['page']);

			$this->obj_tmpl->addVar('list_sidebar_nav', 'URL', $url);

			// child display

			$str_child = self::DisplayChildNavigation($rec['id_nav']);

			$this->obj_tmpl->addVar('list_sidebar_nav', 'CHILD', $str_child);

			// repeat

			$this->obj_tmpl->ParseTemplate('list_sidebar_nav', 'a');		

			$no++;

		}

		if($no == 0) {$this->obj_tmpl->setAttribute('list_sidebar_nav', 'visibility', 'hidden');}

	}

	

	private function DisplayChildNavigation($parent){

		$int_parent_active = $this->obj_nav->GetParentGroupByIdNav(array($this->int_nav), $this->int_parent_blok);

		$str_child = "";

		// parse child menu

		$params = array($this->str_userid, $this->arr_config['app_group']['cpanel'], $parent);

		$rs_id = $this->obj_nav->GetNavigationByParent($params);

		$nums = mysqli_num_rows($rs_id);

		if(!empty($nums)){

			$str_child = "<ul>";

			$selected = "";

			while($rec = mysqli_fetch_assoc($rs_id)){

				if($int_parent_active == $rec['id_nav'])

					$selected = 'class="side-active"';

				else

					$selected = '';

				$url = $this->obj_ctrl->GetUrl($rec['app'], $rec['group'], $rec['module'], $rec['page']);

				$str_child .= "<li>";

				$str_child .= "<a href=\"$url\" $selected>";

				$str_child .= $rec['title'];

				$str_child .= "</a>";

				$str_child .= self::DisplayChildNavigation($rec['id_nav']);

				$str_child .= "</li>";

			}

			$str_child .= "</ul>";

		}

		return $str_child;

	}

}

?>