<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	private $obj_course;
	private $obj_notify;
	private $obj_date;
	private $obj_registrasi;
	// init variabel
	private $str_tgl;
	private $str_desc;
	private $str_idjadwal;
	private $obj_harga;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// business object loaded
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		$this->obj_harga= $this->obj_ctrl->LoadBusiness('course_wilayah', 'mysql', $this->arr_config['db']);
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		//display variabel
		self::DisplayVariabel();
		// display form
		self::DisplayForm();
		// display test cookies
		self::DisplayNotification();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	// get city name
	private function GetNameCityById($idcity){
		$result = $this->obj_registrasi->GetDataAsSingleArray("GetCityById", array($idcity));
		return $result['city_name'];
	}
	// declare variable
	private function DisplayVariabel(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->arr_routes['params'][0])));
		
		$this->obj_tmpl->addVar('content', 'PAGE', $this->arr_routes['params'][0]);
	}
	// function display information
	private function DisplayForm(){
		$params = array($this->arr_routes['params'][1]);
		$result = $this->obj_course->GetDataAsSingleArray("GetDetailCourseById", $params);
		if(!empty($result)){
			$this->obj_tmpl->addVar('content', 'ID_COURSE', $result['id_course']);
			$this->obj_tmpl->addVar('content', 'TEMPAT_UTAMA', $result['tempat']);
			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);
			$this->obj_tmpl->addVar('content', 'PJ', $result['penanggung_jawab']);
			$this->obj_tmpl->addVar('content', 'TEKNISI', $result['teknisi']);
			$this->obj_tmpl->addVar('content', 'NURSE', $result['perawat']);
			$this->obj_tmpl->addVar('content', 'SESI', $result['nomor_pelatihan']);
			$this->obj_tmpl->addVar('content', 'KAPASITAS', $result['kapasitas']);
			
			$rs_city = $this->obj_harga->GetDataAsSingleArray("GetCityPenyelenggara", array($result['id_penyelenggara']));
			
		  	if(!empty($rs_city)){
				$cost = $this->obj_harga->GetDataAsSingleArray("GetCostPenyelenggaraByIdCity", array($rs_city['id_city']));
				if(!empty($cost)){
				  $this->obj_tmpl->addVar('content', 'HARGA', "Rp ". number_format($cost['biaya'],0,',','.'));
				}
			}
			
			$tgl = explode(" ", self::GetTanggalCourseById($result['id_course']));
			$tgl = $this->obj_date->GetFullDate($tgl[1])."-".$this->obj_date->GetFullDate($tgl[2]);
			$this->obj_tmpl->addVar('content', 'TGL', $tgl);
			$this->obj_tmpl->addVar('content', 'KOTA', self::GetNameCityById($result['id_city']));
		}
	}
	//get all tanggal
	private function GetTanggalCourseById($id_course){
		$this->str_tgl = "";
		$rs_id = $this->obj_course->GetResourceId("GetTanggalCourseById", array($id_course, $id_course));
		if($rs_id){
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->str_tgl = $this->str_tgl.' '.$rs['tanggal'];
			}
		}
		return $this->str_tgl;
	}
	
	// function show notify
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>
