<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	protected $obj_data;
	protected $obj_notify;
	protected $obj_upload;
	// init variable
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'view');	
	}
	
	protected function PageLoad(){ 
		// load business
		$this->obj_data = $this->obj_ctrl->LoadBusiness('files', 'mysql', $this->arr_config['db']);
		// load library
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'upload_file':
				self::UploadFiles();
				break;
			case 'update_file':
				self::UpdateFiles();
				break;
			case 'delete_file':
				self::DeleteFiles();
				break;		
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	
	
	//Function Upload File
	private function UploadFiles(){
		$err = array();	
		$filled = array();	
		// check / validate parameter 
		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><strong>ID Category</strong> must be filled'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Page</strong> must be filled'; }
		if(empty($this->arr_params['mod'])){ $err[] = '<br /><strong>Modul</strong> must be filled'; }
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> must be filled'; }
		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> must be filled'; }
		
		// berkas
		$berkas = $_FILES['berkas'];
		if(empty($berkas['tmp_name'])){ $err[] = '<br /><strong>Berkas</strong> must be filled'; }
		// processing --------------------------------------------------
		if(empty($err)){
			// get last id
			$id = $this->obj_data->GetLastIdDataCourse();
			
			$params = array($this->arr_params['id_cat'],$id,$this->arr_params['judul'], $this->arr_params['deskripsi'],$this->str_userid);
			if($this->obj_data->ProcessingData("InsertFilesCourse", $params)){
				// upload file 
				
				self::UploadBerkas($berkas, $id);
				// upload file 
				//self::UploadGambar($gambar, $id);
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				$filled = array('id_cat' => $this->arr_params['id_cat'],'page' => $this->arr_params['page'],'mod' => $this->arr_params['mod'],'judul' => $this->arr_params['judul'], 'deskripsi' => $this->arr_params['deskripsi']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}	
		}else{
			$filled = array('id_cat' => $this->arr_params['id_cat'],'page' => $this->arr_params['page'],'mod' => $this->arr_params['mod'],'judul' => $this->arr_params['judul'], 'deskripsi' => $this->arr_params['deskripsi']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view',array($this->arr_params['id_cat'],$this->arr_params['page'],'add'));
	}	
	
	//Function Update Files
	private function UpdateFiles(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><strong>ID Category</strong> must be filled'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Page</strong> must be filled'; }
		if(empty($this->arr_params['mod'])){ $err[] = '<br /><strong>Modul</strong> must be filled'; }
		if(empty($this->arr_params['id'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }
		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }
		//if(empty($this->arr_params['status'])){ $err[] = '<br /><strong>Active Status</strong> must be filled'; }
		//
		if(!empty($_FILES['berkas']['tmp_name'])){ 
			$file_name = str_replace(' ', '_', $_FILES['berkas']['name']);
		}else{
			$file_name = '';
		}
		// processing -----------------------------------------------------
		if(empty($err)){		
			// insert (judul, filepath, urutan, mdb)
			$params = array($this->arr_params['cat'],$this->arr_params['judul'], $this->arr_params['deskripsi'], $this->str_userid,$this->arr_params['status'], $this->arr_params['id']);
			if($this->obj_data->ProcessingData("UpdateFilesTitleCourse", $params)){
				// upload file
				
					$err = self::UploadBerkas($_FILES['berkas'],$this->arr_params['id'] );
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				$filled = array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);
				// error message
				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
				// redirect to page error page --------------------------------
			}
		}else{
			$filled =array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['id_cat'],$this->arr_params['page']));
	}
	
	//Function Delete Files
	private function DeleteFiles(){
		$err = array();		
		$filled = array();
		// check / validate parameter 
		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><strong>ID Category</strong> must be filled'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><strong>Page</strong> must be filled'; }
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }
		// processing --------------------------------------------------
		if(empty($err)){
			foreach($this->arr_params['downcheck'] as $id){
				if($this->obj_data->ProcessingData("DeleteFilesCourse", array(intval($id)))){
					// unlink source
					$file_path = "doc/course/".$id."/";
					if(is_dir($file_path)){
						$this->obj_upload->RemoveDir($file_path);
					}
					// sukses message				
					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');
					// redirect to success page ------------------------------------
				}else{
					// error message
					self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
					// redirect to page error page --------------------------------
				}
			}				
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'view',array($this->arr_params['id_cat'],$this->arr_params['page']));
	}
	
	private function UploadBerkas($berkas, $id){
		$err = array();
		// allowed type
		$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');
		// --
		if(!empty($berkas['tmp_name']) AND $berkas['size'] <= 300000){
			// name and path file
			$file_name = str_replace(' ', '_', ($berkas['name']));
			$file_path = "doc/course/".$id."/";
			$type = explode('.', $file_name);
			$type = $type[1];
			// processing
					if(is_dir($file_path)){
						$this->obj_upload->RemoveDir($file_path);
					}
			if($this->obj_upload->FileUpload($berkas, $file_path)){
				// insert to database
				
				$params = array($file_name,$type,$file_path, $id);
				$this->obj_data->ProcessingData("UpdateFilesPathCourse", $params);
				// --
				$err[] = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 
			}else{
				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
			}		
		}else{
			$err[] = '<br />Berkas <strong>tidak berhasil</strong> diupload'; 
		}		
		// return
		return $err;
	}
	
	private function UploadGambar($gambar, $id){
		// allowed type
		$err = "";
		if(isset($gambar['tmp_name']) AND !empty($gambar['tmp_name'])){
			// name and path file
			$file_name = str_replace(' ', '_', $gambar['name']);
			$file_path = "doc/images/".$id."/";
			// delete last 
			$this->obj_upload->RemoveDir($file_path);
			// processing
			if($this->obj_upload->ImageUpload($gambar, $file_path, 50)){
				// insert to database
				$params = array($file_name, $id);
				$this->obj_data->ProcessingData("UpdateGambar", $params);
				// --
				$err = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 
			}else{
				$err = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
			}
		}
		return $err;
	}
}

?>