<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	private $obj_files;
	private $obj_administrator;
	private $obj_date;
	private $obj_paging;
	private $obj_notify;

	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load business
		$this->obj_files = $this->obj_ctrl->LoadBusiness('files', 'mysql', $this->arr_config['db']);
		$this->obj_administrator = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		// display page link
		self::DisplayPageLink();
		// display form
		self::DisplayForm();
		// display notification
		self::DisplayNotification();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	private function DisplayPageLink(){
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('add')));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process-category'));
	}

   private function DisplayForm() {
		if(isset($this->arr_routes['params'][0]) && $this->arr_routes['params'][0] == "add") {
			self::DisplayAddForm();
		}elseif(isset($this->arr_routes['params'][0]) && $this->arr_routes['params'][0] == "edit") {
			self::DisplayEditForm();
		}else{
			self::DisplayListArchive();
		}
   }
   
	private function DisplayListArchive(){
		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');
  		$rs_id = $this->obj_files->GetResourceId("GetListKategori", array(0, 100));
		if($rs_id){
			$no = 1;
			while($value = mysqli_fetch_assoc($rs_id)){
				$url_galeri = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($value['id_cat'],'1'));
				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array("edit", $value['id_cat']));
				// display last update
				$person = $this->obj_administrator->GetDataAsSingleArray("GetPersonNameById", array($value['mdb']));
				$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($value['mdd']));
				$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);
				// --
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'ID', $value['id_cat']);	
				$this->obj_tmpl->addVar('list_data', 'NAME', $value['judul']);
				$this->obj_tmpl->addVar('list_data', 'DESCRIPTION', $value['deskripsi']);
				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $url_edit);
				$this->obj_tmpl->addVar('list_data', 'URL_NEWS', $url_galeri);
				$this->obj_tmpl->ParseTemplate('list_data', 'a');
				$no++;
			}
		}
	}	

	private function DisplayAddForm(){
		// activated template
		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');
		$this->obj_tmpl->addVar('display', 'view', 'add');
	}
	
	private function DisplayEditForm(){
		// activated template
		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');
		$this->obj_tmpl->addVar('display', 'view', 'edit');
		// parse data	
		$result = $this->obj_files->GetDataAsSingleArray("GetKategoriById", array($this->arr_routes['params'][1]));
		$this->obj_tmpl->addVar('display', 'ID', $result['id_cat']);	
		$this->obj_tmpl->addVar('display', 'CAT', $result['judul']);
		$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['deskripsi']);
		$this->obj_tmpl->addVar('display', 'URUTAN', $result['urutan']);
	}
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>
