<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// init object 		

	private $obj_cpd;

	private $obj_notify;

	private $obj_upload;

	// init variable

	private $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		// example

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kegiatan');	

	}

	

	protected function BaseLoad(){ }

	

	protected function BaseView(){ }

	

	protected function PageLoad(){ 

		// load business

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'update':

				self::UpdateData();

				break;

			case 'rekomendasi':

				self::UpdateRekomendasi();

				break;

				

			case 'komisi_etik':

				self::UpdateKomisiEtik();

				break;	

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// operation

	private function UpdateData(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		// if(empty($this->arr_params['sitename'])){ $err[] = '<br /><strong>Site name</strong> must be filled'; }

		// processing --------------------------------------------------

		if(empty($err)){

			for($i=1;$i<=count($this->arr_params['ranah']);$i++){

				$params = array($this->arr_params['ranah'][$i]['bawah'], $this->arr_params['ranah'][$i]['atas'], $i);

				$this->obj_cpd->ProcessingData("UpdateRanah", ($params));

			}

			for($i=1;$i<=count($this->arr_params['kelompok']);$i++){

				$params = array($this->arr_params['kelompok'][$i]['bawah'], $this->arr_params['kelompok'][$i]['atas'], $i);

				$this->obj_cpd->ProcessingData("UpdateKelompok", ($params));

			}

			for($i=1;$i<=count($this->arr_params['kompetensi']);$i++){

				$params = array($this->arr_params['kompetensi'][$i]['bawah'], $this->arr_params['kompetensi'][$i]['atas'], $i);

				$this->obj_cpd->ProcessingData("UpdateKompetensi", ($params));

			}

			// notification message				

			self::SendNotification($err, $filled, 'Data has been saved.', 'success');

		}else{

			// filled field with last input

			// $filled = array("SITENAME" => $this->arr_params['sitename'], "SITEEMAIL" => $this->arr_params['siteemail']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

		}

	}

	

	private function UpdateRekomendasi(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['perihal'])){ $err[] = '<br /><strong>Perihal</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['lampiran'])){ $err[] = '<br /><strong>Lampiran</strong> tidak boleh kosong'; }		

		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> tidak boleh kosong'; }		

		if(empty($this->arr_params['ketua'])){ $err[] = '<br /><strong>Ketua</strong> tidak boleh kosong'; }		

		// processing --------------------------------------------------

		if(empty($err)){

			$file_name = self::UploadImage();

			$params = array($this->arr_params['perihal'], $this->arr_params['lampiran'], $this->arr_params['tempat'], $this->arr_params['ketua'], $file_name);

			if($this->obj_cpd->ProcessingData("UpdateRekomendasiSetting", $params)){

				// gambar

				/*$gambar = $_FILES['gambar'];

				if(!empty($gambar['tmp_name'])){ 

					// upload file 

					$err[] = self::UploadGambar($gambar);

				}*/

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array('PERIHAL' => $this->arr_params['perihal'], 'LAMPIRAN' => $this->arr_params['lampiran'], 'TEMPAT' => $this->arr_params['tempat'], 'KETUA' => $this->arr_params['ketua']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}	

		}else{

			$filled = array('PERIHAL' => $this->arr_params['perihal'], 'LAMPIRAN' => $this->arr_params['lampiran'], 'TEMPAT' => $this->arr_params['tempat'], 'KETUA' => $this->arr_params['ketua']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi');

	}

	

	private function UpdateKomisiEtik(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['perihal'])){ $err[] = '<br /><strong>Perihal</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['lampiran'])){ $err[] = '<br /><strong>Lampiran</strong> tidak boleh kosong'; }		

		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> tidak boleh kosong'; }		

		if(empty($this->arr_params['ketua'])){ $err[] = '<br /><strong>Ketua</strong> tidak boleh kosong'; }		

		// processing --------------------------------------------------

		if(empty($err)){

			$file_name = self::UploadGambarEtik();

			$params = array($this->arr_params['perihal'], $this->arr_params['lampiran'], $this->arr_params['tempat'], $this->arr_params['ketua'],$file_name );

			//print_r($params);exit;

			if($this->obj_cpd->ProcessingData("UpdateKomisiEtikSetting", $params)){

				// gambar

				/*$gambar = $_FILES['gambar'];

				if(!empty($gambar['tmp_name'])){ 

					// upload file 

					$err[] = self::UploadGambarEtik($gambar);

				}*/

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array('PERIHAL' => $this->arr_params['perihal'], 'LAMPIRAN' => $this->arr_params['lampiran'], 'TEMPAT' => $this->arr_params['tempat'], 'KETUA' => $this->arr_params['ketua']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}	

		}else{

			$filled = array('PERIHAL' => $this->arr_params['perihal'], 'LAMPIRAN' => $this->arr_params['lampiran'], 'TEMPAT' => $this->arr_params['tempat'], 'KETUA' => $this->arr_params['ketua']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'komisi_etik');

	}

	

	private function UploadImage(){

		// allowed type

		if(isset($this->arr_params['image_hid']))

			$file_name = $this->arr_params['image_hid'];

		else

			$file_name = '';

		// --			

		if(isset($_FILES['gambar']['tmp_name']) AND !empty($_FILES['gambar']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['gambar']['name']);

			$file_path = "doc/temp/signature/";

			//$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->ImageUpload($_FILES['gambar'], $file_path, 150, 80);

		}

		return $file_name;

	}

	

	

	private function UploadGambarEtik(){

		/*// allowed type

		$err = "";

		if(isset($gambar['tmp_name']) AND !empty($gambar['tmp_name'])){

			// name and path file

			$gambar['name'] = 'tanda_tangan.jpg';

			$file_path = "doc/temp/signatureetik/";			

			// processing

			if($this->obj_upload->ImageUpload($gambar, $file_path, 100, 100)){				

				$err = '<br /><strong>Images</strong> berhasil diupload'; 

			}else{

				$err = '<br />Images<strong>tidak berhasil</strong> diupload'; 

			}

		}

		return $err;*/

	// allowed type

		if(isset($this->arr_params['image_hid']))

			$file_name = $this->arr_params['image_hid'];

		else

			$file_name = '';

		// --			

		if(isset($_FILES['gambar']['tmp_name']) AND !empty($_FILES['gambar']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['gambar']['name']);

			$file_path = "doc/temp/signatureetik/";

			//$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->ImageUpload($_FILES['gambar'], $file_path, 150, 80);

		}

		return $file_name;





	}

}



?>