<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_cpd;

	protected $obj_notify;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();

		// Display Detail Kegiatan

		self::DisplayDetailKegiatan();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));

		$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list'));

		$this->obj_tmpl->addVar('content', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_FORM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_ELEMEN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_SKP', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function DisplayDetailKegiatan(){

		$params = array($this->arr_routes['params'][0]);

		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanById", ($params));

		// parse

		$this->obj_tmpl->addVar('content', 'ID', $rs['id_kegiatan']);

		$this->obj_tmpl->addVar('content', 'NAMA', $rs['nama']);

		$this->obj_tmpl->addVar('content', 'KEYWORD', $rs['kata_kunci']);

		$this->obj_tmpl->addVar('content', 'BATAS_BAWAH', $rs['batas_bawah']);

		$this->obj_tmpl->addVar('content', 'BATAS_ATAS', $rs['batas_atas']);

		// selected komponen

		switch($rs['id_ranah']){

			case 2:

				$this->obj_tmpl->addVar('content', 'RANAH_B', 'selected="selected"');

				break;

			case 3:

				$this->obj_tmpl->addVar('content', 'RANAH_C', 'selected="selected"');

				break;

			case 4:

				$this->obj_tmpl->addVar('content', 'RANAH_D', 'selected="selected"');

				break;

			case 5:

				$this->obj_tmpl->addVar('content', 'RANAH_E', 'selected="selected"');

				break;

			default:

				$this->obj_tmpl->addVar('content', 'RANAH_A', 'selected="selected"');

				break;

		}

		switch($rs['id_jenis']){

			case 2:

				$this->obj_tmpl->addVar('content', 'JENIS_INTERNAL', 'checked="checked"');

				break;

			case 3:

				$this->obj_tmpl->addVar('content', 'JENIS_EKSTERNAL', 'checked="checked"');

				break;

			default:

				$this->obj_tmpl->addVar('content', 'JENIS_PRIBADI', 'checked="checked"');

				break;

		}

		switch($rs['id_kompetensi']){

			case 2:

				$this->obj_tmpl->addVar('content', 'KOMPETENSI_A', 'checked="checked"');

				break;

			case 3:

				$this->obj_tmpl->addVar('content', 'KOMPETENSI_P', 'checked="checked"');

				break;

			case 4:

				$this->obj_tmpl->addVar('content', 'KOMPETENSI_N', 'checked="checked"');

				break;

			default:

				$this->obj_tmpl->addVar('content', 'KOMPETENSI_K', 'checked="checked"');

				break;

		}

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// khusus select dan radio

		if(isset($this->obj_notify->arr_message['field'])){

			switch($this->obj_notify->arr_message['field']['ranah']){

				case 1:					

					$this->obj_tmpl->addVar('content', 'RANAH_A', 'selected="selected"');

					break;

				case 2:

					$this->obj_tmpl->addVar('content', 'RANAH_B', 'selected="selected"');

					break;

				case 3:

					$this->obj_tmpl->addVar('content', 'RANAH_C', 'selected="selected"');

					break;

				case 4:

					$this->obj_tmpl->addVar('content', 'RANAH_D', 'selected="selected"');

					break;

				case 5:

					$this->obj_tmpl->addVar('content', 'RANAH_E', 'selected="selected"');

					break;

				default:

					break;

			}

			switch($this->obj_notify->arr_message['field']['kelompok']){

				case 2:

					$this->obj_tmpl->addVar('content', 'JENIS_INTERNAL', 'checked="checked"');

					break;

				case 3:

					$this->obj_tmpl->addVar('content', 'JENIS_EKSTERNAL', 'checked="checked"');

					break;

				default:

					break;

			}

			switch($this->obj_notify->arr_message['field']['kompetensi']){

				case 2:

					$this->obj_tmpl->addVar('content', 'KOMPETENSI_A', 'checked="checked"');

					break;

				case 3:

					$this->obj_tmpl->addVar('content', 'KOMPETENSI_P', 'checked="checked"');

					break;

				case 4:

					$this->obj_tmpl->addVar('content', 'KOMPETENSI_N', 'checked="checked"');

					break;

				default:

					break;

			}

		}

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>