<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_cpd;

	protected $obj_notify;

	protected $obj_date;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

	}

	

	public function PageView(){

		// check variable 

		self::CheckParameter();

		// display variable

		self::DisplayVariable();

		// Display Detail Kegiatan

		self::DisplayDetailKegiatan();

		// Display Elemen Kegiatan

		self::DisplayListElemen();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function CheckParameter(){

		if(!isset($this->arr_routes['params'][1]) AND !isset($this->arr_routes['params'][0])){

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list');

		}elseif(!isset($this->arr_routes['params'][1])){

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0]));

		}else{

			 $this->obj_tmpl->addVar('content', 'ID_KEGIATAN', $this->arr_routes['params'][0]);

			 $this->obj_tmpl->addVar('content', 'ID_FORM', $this->arr_routes['params'][1]);

		}

	}

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));

		$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list'));

		$this->obj_tmpl->addVar('content', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_FORM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_ELEMEN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_routes['params'][0], $this->arr_routes['params'][1])));

		$this->obj_tmpl->addVar('content', 'URL_SKP', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_routes['params'][0], $this->arr_routes['params'][1])));

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function DisplayDetailKegiatan(){

		// kegiatan

		$params = array($this->arr_routes['params'][0]);

		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanById", $params);

		// parse

		$this->obj_tmpl->addVar('content', 'NAMA', $rs['nama']);

		// form

		$params = array($this->arr_routes['params'][0], $this->arr_routes['params'][1]);

		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailFormById", $params);

		// parse

		$this->obj_tmpl->addVar('content', 'PERIODE_AWAL', $this->obj_date->GetFullDate($rs['periode_awal']));

		$this->obj_tmpl->addVar('content', 'PERIODE_AKHIR', $this->obj_date->GetFullDate($rs['periode_akhir']));

		$this->obj_tmpl->addVar('content', 'DATE_LABEL', $rs['date_label']);

		$this->obj_tmpl->addVar('content', 'DATE_LABEL_EN', $rs['date_label_en']);

		if(isset($this->arr_routes['params'][2]) AND !empty($this->arr_routes['params'][2])){

			// parse action

			$this->obj_tmpl->addVar('content', 'LABEL_ACTION', 'Edit');

			$this->obj_tmpl->addVar('content', 'ACTION', 'update_elemen');

			$this->obj_tmpl->addVar('content', 'ID_ELEMEN', $this->arr_routes['params'][2]);

			// display

			self::DisplayEditForm();

		}else{

			$this->obj_tmpl->setAttribute('list_elemen_list', 'visibility', 'hidden');

			// parse action

			$this->obj_tmpl->addVar('content', 'LABEL_ACTION', 'Tambah');

			$this->obj_tmpl->addVar('content', 'ACTION', 'insert_elemen');

		}

	}

	

	private function DisplayEditForm(){

		$params = array($this->arr_routes['params'][1], $this->arr_routes['params'][2]);

		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailElemenById", $params);

		$this->obj_tmpl->addVar('content', 'LABEL', $rs['label']);

		$this->obj_tmpl->addVar('content', 'LABEL_EN', $rs['label_en']);

		$this->obj_tmpl->addVar('content', 'ELEMEN_MINLENGTH', $rs['elemen_minlength']);

		$this->obj_tmpl->addVar('content', 'ELEMEN_MAXLENGTH', $rs['elemen_maxlength']);

		$this->obj_tmpl->addVar('content', 'ELEMEN_SIZE', $rs['elemen_size']);

		$this->obj_tmpl->addVar('content', 'ELEMEN_SORT', $rs['elemen_sort']);

		switch($rs['tipe']){

			case 'text':

				$this->obj_tmpl->addVar('content', 'TEXTBOX', 'selected="selected"');

				break;

			case 'textarea':

				$this->obj_tmpl->addVar('content', 'TEXTAREA', 'selected="selected"');

				break;

			case 'radio':

				$this->obj_tmpl->addVar('content', 'RADIO', 'selected="selected"');

				break;

			case 'selectbox':

				$this->obj_tmpl->addVar('content', 'SELECTBOX', 'selected="selected"');

				break;

			case 'filebrowse':

				$this->obj_tmpl->addVar('content', 'FILEBROWSE', 'selected="selected"');

				break;

			case 'date':

				$this->obj_tmpl->addVar('content', 'DATE', 'selected="selected"');

				break;

			case 'datetime':

				$this->obj_tmpl->addVar('content', 'DATETIME', 'selected="selected"');

				break;

			case 'spt_rumkit':

				$this->obj_tmpl->addVar('content', 'SPT_RUMKIT', 'selected="selected"');			

				break;	

			case 'spt_klinik':

				$this->obj_tmpl->addVar('content', 'SPT_KLINIK', 'selected="selected"');

				break;	

			case 'spt_cabang':

				$this->obj_tmpl->addVar('content', 'SPT_CABANG', 'selected="selected"');

				break;	

			case 'spt_wilayah':

				$this->obj_tmpl->addVar('content', 'SPT_WILAYAH', 'selected="selected"');	

				break;	

			case 'spt_studi':

				$this->obj_tmpl->addVar('content', 'SPT_STUDI', 'selected="selected"');

				break;

			case 'spt_kegiatan':

				$this->obj_tmpl->addVar('content', 'SPT_KEGIATAN', 'selected="selected"');

				break;

	

			default:

				break;

		}

		if($rs['is_parameter'] == 'yes')

			$this->obj_tmpl->addVar('content', 'PARAMETER_YES', 'checked="checked"');

		else

			$this->obj_tmpl->addVar('content', 'PARAMETER_NO', 'checked="checked"');

		if($rs['is_engine'] == 'yes')

			$this->obj_tmpl->addVar('content', 'ENGINE_YES', 'checked="checked"');

		else

			$this->obj_tmpl->addVar('content', 'ENGINE_NO', 'checked="checked"');

		if($rs['is_required'] == 'yes')

			$this->obj_tmpl->addVar('content', 'REQUIRED_YES', 'checked="checked"');

		else

			$this->obj_tmpl->addVar('content', 'REQUIRED_NO', 'checked="checked"');

		if($rs['is_displayed'] == 'yes')

			$this->obj_tmpl->addVar('content', 'DISPLAYED_YES', 'checked="checked"');

		else

			$this->obj_tmpl->addVar('content', 'DISPLAYED_NO', 'checked="checked"');

		$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", array($rs['id_elemen']));

		if($rs_id){

			$no = 0;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_elemen_list', 'ID_LIST', $rec['id_list']);

				$this->obj_tmpl->addVar('list_elemen_list', 'LABEL', $rec['list_name']);

				$this->obj_tmpl->addVar('list_elemen_list', 'VALUE', $rec['list_value']);

				$this->obj_tmpl->addVar('list_elemen_list', 'SORT', $rec['sort']);

				$this->obj_tmpl->ParseTemplate('list_elemen_list', 'a');

				$no++;

			}

		}else{

			$this->obj_tmpl->setAttribute('list_elemen_list', 'visibility', 'hidden');

		}

	}

	

	private function DisplayListElemen(){

		$params = array($this->arr_routes['params'][1]);

		$rs_id = $this->obj_cpd->GetResourceId("GetElemenByIdForm", $params);

		if($rs_id){

			$no = 0;

			while($rs = mysqli_fetch_assoc($rs_id)){

				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_routes['params'][0], $this->arr_routes['params'][1], $rs['id_elemen']));

				$this->obj_tmpl->addVar('list_elemen', 'INDEX', $no);

				$this->obj_tmpl->addVar('list_elemen', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_elemen', 'LABEL', $rs['label']);

				$this->obj_tmpl->addVar('list_elemen', 'LABEL_EN', $rs['label_en']);

				$this->obj_tmpl->addVar('list_elemen', 'SORT', $rs['elemen_sort']);

				if($rs['is_required'] == 'yes')

					$this->obj_tmpl->addVar('list_elemen', 'REQUIRED', 'green');

				else

					$this->obj_tmpl->addVar('list_elemen', 'REQUIRED', 'red');

				if($rs['is_engine'] == 'yes')

					$this->obj_tmpl->addVar('list_elemen', 'INDICATOR', 'green');

				else

					$this->obj_tmpl->addVar('list_elemen', 'INDICATOR', 'red');

				if($rs['is_parameter'] == 'yes')

					$this->obj_tmpl->addVar('list_elemen', 'PARAMETER', 'green');

				else

					$this->obj_tmpl->addVar('list_elemen', 'PARAMETER', 'red');

				if($rs['is_displayed'] == 'yes')

					$this->obj_tmpl->addVar('list_elemen', 'DISPLAYED', 'green');

				else

					$this->obj_tmpl->addVar('list_elemen', 'DISPLAYED', 'red');			

				$this->obj_tmpl->addVar('list_elemen', 'VIEW', self::GetElemenView($rs));

				$this->obj_tmpl->addVar('list_elemen', 'URL_EDIT', $url_edit);

				$this->obj_tmpl->ParseTemplate('list_elemen', 'a');

				$no++;

			}

			$this->obj_tmpl->addVar('content', 'TOTAL_DATA', $no);

		}

	}

	

	private function GetElemenView($rs){

		$str_view = "";

		switch($rs['tipe']){

			case 'text':

				$str_view='<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" />';

				break;

			case 'textarea':

				$str_view='<textarea rows="3" cols="40"></textarea>';

				break;

			case 'filebrowse':

				$str_view= '<input type="file">';

				break;

			case 'radio':

				$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", array($rs['id_elemen']));

				if($rs_id){

					while($rec = mysqli_fetch_assoc($rs_id)){

						$str_view .= '<label><input type="radio" name="sample">'.$rec['list_name'].'</label> &nbsp;&nbsp;';

					}

				}

				break;

			case 'selectbox':

				$str_view = '<select>';

				$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", array($rs['id_elemen']));

				if($rs_id){

					while($rec = mysqli_fetch_assoc($rs_id)){

						$str_view .= '<option>'.$rec['list_name'].'</option>';

					}

				}

				$str_view .= '</select>';

				break;

			case 'date':

				// javascript loaded

				$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');

				// dhtmlgoodies_calendar loaded

				$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');

				// dhtmlgoodies_calendar loaded body event

				$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");

				$str_view = self::CreateElemenDate($rs['id_elemen'], false);

				break;

			case 'datetime':

				// javascript loaded

				$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');

				// dhtmlgoodies_calendar loaded

				$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');

				// dhtmlgoodies_calendar loaded body event

				$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");

				$str_view = self::CreateElemenDate($rs['id_elemen'], true);

				break;

			case 'spt_cabang':

				// loaded javascript

				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

				// loaded style

				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');

				// load javascript template

				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');

				// parse input

				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'spt-cabang'));

				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" />';

				// append

				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');				

				break;	

			case 'spt_klinik':

				// loaded javascript

				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

				// loaded style

				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');

				// load javascript template

				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');

				// parse input

				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'spt-klinik'));

				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" />';

				// append

				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');	

				break;	

			case 'spt_rumkit':

				// loaded javascript

				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

				// loaded style

				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');

				// load javascript template

				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');

				// parse input

				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'spt-hospital'));

				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" />';

				// append

				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');	

				break;	

			case 'spt_studi':

				// loaded javascript

				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

				// loaded style

				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');

				// load javascript template

				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');

				// parse input

				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'spt-studi'));

				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" />';

				// append

				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');	

				break;	

			case 'spt_wilayah':

				// loaded javascript

				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

				// loaded style

				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');

				// load javascript template

				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');

				// parse input

				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'spt-wilayah'));

				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" />';

				// append

				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');	

				break;

			case 'spt_kegiatan':

				// loaded javascript

				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

				// loaded style

				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');

				// load javascript template

				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');

				// parse input

				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'spt-kegiatan'));

				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" />';

				// append

				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');	

				break;	

			default:

				$str_view = "No type selected";

				break;

		}

		return $str_view;

	}

	

	private function CreateElemenDate($id, $time = false){

		// button

		$button = '<input type="button" value="Cal" onclick="displayCalendarSelectBox(form_input.tahun_'.$id.',form_input.bulan_'.$id.',form_input.day_'.$id.',false,false,this)">'; 

		// tahun 

		$tahun = '<select name="tahun_'.$id.'">';

		for($i=2000;$i<=2017;$i++){

			$tahun .= "<option value=\"$i\">$i</option>";

		}

		$tahun .= '</select>';

		// bulan

		$arr_bln = array('01' => 'Jan', '02' => 'Feb', '03' => 'Mar', '04' => 'Apr', '05' => 'May', '06' => 'Jun', '07' => 'Jul', '08' => 'Ags', '09' => 'Sep', '10' => 'Oct', '11' => 'Nov', '12' => 'Dec');

		$bulan = '<select name="bulan_'.$id.'">';

		foreach($arr_bln as $key => $val){

			$bulan .= "<option value=\"$key\">$val</option>";

		}

		$bulan .= '</select>';

		// day

		$day = '<select name="day_'.$id.'">';

		for($i=1;$i<=31;$i++){

			if($i<10)

					$i = '0' . $i;

			$day .= "<option value=\"$i\">$i</option>";

		}

		$day .= '</select>';

		//---------------------

		$hour = "";

		$minute = "";

		if($time){

			// hour

			$hour = '<select name="hour_'.$id.'">';

			for($i=1;$i<=23;$i++){

				if($i<10)

					$i = '0' . $i;

				$hour .= "<option value=\"$i\">$i</option>";

			}

			$hour .= '</select>';

			// minute

			$minute = '<select name="minute_'.$id.'">';

			$i = 0;

			while($i<=55){

				if($i<10)

					$i = '0' . $i;

				$minute .= "<option value=\"$i\">$i</option>";

				$i = $i + 5;

			}

			$minute .= '</select>';

			// button

			$button = '<input type="button" value="Cal" onclick="displayCalendarSelectBox(form_input.tahun_'.$id.',form_input.bulan_'.$id.',form_input.day_'.$id.',form_input.hour_'.$id.',form_input.minute_'.$id.',this)">'; 

		}

		$str_return = $tahun . $bulan . $day . $hour . $minute;

		$str_return .= $button;

		return $str_return;

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>