<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_cpd;

	protected $obj_notify;

	protected $obj_date;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

	}

	

	public function PageView(){

		// check variable 

		self::CheckParameter();

		// display variable

		self::DisplayVariable();

		// Display Detail Kegiatan

		self::DisplayDetailKegiatan();

		// Display list parameter

		self::DisplayListParameter();

		// Display list engine

		self::DisplayListEngine();

		// Display list nilai

		self::DisplayListNilai();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function CheckParameter(){

		if(!isset($this->arr_routes['params'][1]) AND !isset($this->arr_routes['params'][0])){

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list');

		}elseif(!isset($this->arr_routes['params'][1])){

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0]));

		}else{

			 $this->obj_tmpl->addVar('content', 'ID_KEGIATAN', $this->arr_routes['params'][0]);

			 $this->obj_tmpl->addVar('content', 'ID_FORM', $this->arr_routes['params'][1]);

		}

	}

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));

		$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list'));

		$this->obj_tmpl->addVar('content', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_FORM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_ELEMEN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_routes['params'][0], $this->arr_routes['params'][1])));

		$this->obj_tmpl->addVar('content', 'URL_SKP', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_routes['params'][0], $this->arr_routes['params'][1])));

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function DisplayListParameter(){

		$params = array($this->arr_routes['params'][1]);

		$rs_id = $this->obj_cpd->GetResourceId("GetListParameterByIdForm", $params);

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_parameter', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_parameter', 'NAMA', $rs['label']);

				switch($rs['formulation']){	

					case 'direct':

						$this->obj_tmpl->addVar('list_parameter', 'DIRECT', 'selected="selected"');

						break;

					case 'range':

						$this->obj_tmpl->addVar('list_parameter', 'RANGE', 'selected="selected"');

						break;

					default:

						break;

				}

				$str_list = self::DisplayListIndikator($rs['id_elemen'], $rs['related_engine']);

				$this->obj_tmpl->addVar('list_parameter', 'INDIKATOR', $str_list);			

				$this->obj_tmpl->ParseTemplate('list_parameter', 'a');

			}

		}

	}

	

	private function DisplayListIndikator($id, $engine){

		$str_list = "<select name=\"indikator[$id]\">";

		$str_list .= '<option value="">--</option>';

		$params = array($this->arr_routes['params'][1]);

		$rs_id = $this->obj_cpd->GetResourceId("GetListIndikatorByIdForm", $params);

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				if($rs['id_elemen'] == $engine)

					$selected = 'selected="selected"';

				else

					$selected = '';

				$str_list .= '<option value="'.$rs['id_elemen'].'" '.$selected.'>'.$rs['label'].'</option>';

			}

		}

		$str_list .= "</select>";

		return $str_list;

	}

	

	private function DisplayDetailKegiatan(){

		// kegiatan

		$params = array($this->arr_routes['params'][0]);

		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanById", $params);

		// parse

		$this->obj_tmpl->addVar('content', 'NAMA', $rs['nama']);

		// form

		$params = array($this->arr_routes['params'][0], $this->arr_routes['params'][1]);

		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailFormById", $params);

		// parse

		$this->obj_tmpl->addVar('content', 'PERIODE_AWAL', $this->obj_date->GetFullDate($rs['periode_awal']));

		$this->obj_tmpl->addVar('content', 'PERIODE_AKHIR', $this->obj_date->GetFullDate($rs['periode_akhir']));

	}

	

	private function DisplayListEngine(){

		$params = array($this->arr_routes['params'][1]);

		$rs_id = $this->obj_cpd->GetResourceId("GetListIndikatorByIdForm", $params);

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_engine', 'ID', $rs['id_elemen']);

				$this->obj_tmpl->addVar('list_engine', 'ELEMEN', $rs['label']);

				$str_list = self::DisplayListElemenValue(array($rs['id_elemen']));

				$this->obj_tmpl->addVar('list_engine', 'ELEMEN_LIST', $str_list);			

				$this->obj_tmpl->ParseTemplate('list_engine', 'a');

			}

		}		

	}

	

	private function DisplayListElemenValue($params){

		$str_list = "";

		$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", $params);

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$str_list .= '<option value="'.$rs['id_list'].'">'.$rs['list_name'].'</option>';

			}

		}

		return $str_list;

	}

	

	private function DisplayListNilai(){

		$params = array($this->arr_routes['params'][1]);

		$rs_id = $this->obj_cpd->GetResourceId("GetListNilaiByIdForm", $params);

		if($rs_id){

			$no = 0;

			while($rs = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_nilai', 'ID', $rs['id_nilai']);

				$str_list = self::GetNameEngine($rs['group_elemen_list']);

				$this->obj_tmpl->addVar('list_nilai', 'GROUP', $str_list);

				$this->obj_tmpl->addVar('list_nilai', 'NILAI', $rs['nilai_skp']);

				$this->obj_tmpl->addVar('list_nilai', 'INDEX', $no);			

				$this->obj_tmpl->ParseTemplate('list_nilai', 'a');

				$no++;

			}

			$this->obj_tmpl->addVar('content', 'TOTAL_DATA', $no);

		}

	}

	

	private function GetNameEngine($group){

		$group = explode(',', $group);

		$str = "";

		$sp = 0;

		foreach($group as $val){

			$rs = $this->obj_cpd->GetDataAsSingleArray("GetElemenListNameById", array($val));

			$str .= "<td>". $rs['list_name'] . "</td>";

			$sp++;

		}

		$this->obj_tmpl->addVar('content', 'COLSPAN', 'colspan="'.$sp.'"');

		$this->obj_tmpl->addVar('content', 'COLSPAN_BOTTOM', 'colspan="'. intval($sp + 2) .'"');

		return $str;

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>