<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_cpd;

	protected $obj_notify;

	protected $obj_datetime;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_datetime = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_datetime->SetPatTemplates($this->obj_tmpl);

		// javascript loaded

		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');

		// dhtmlgoodies_calendar loaded

		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');

		// dhtmlgoodies_calendar loaded body event

		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();

		// Display Detail Kegiatan

		self::DisplayDetailKegiatan();

		// Display Form

		self::DisplayForm();

		// Display List

		self::DisplayList();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		if(isset($this->arr_routes['params'][0])){

			$this->obj_tmpl->addVar('content', 'ID_KEGIATAN', $this->arr_routes['params'][0]);

			// url

			$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));

			$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list'));

			$this->obj_tmpl->addVar('content', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_routes['params'][0])));

			$this->obj_tmpl->addVar('content', 'URL_FORM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0])));

			$this->obj_tmpl->addVar('content', 'URL_ELEMEN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_routes['params'][0])));

			$this->obj_tmpl->addVar('content', 'URL_SKP', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_routes['params'][0])));

		}else{

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list');

		}

		if(isset($this->arr_routes['params'][1]))

			$this->obj_tmpl->addVar('content', 'ID_FORM', $this->arr_routes['params'][1]);

	}

	

	private function DisplayDetailKegiatan(){

		$params = array($this->arr_routes['params'][0]);

		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanById", ($params));

		// parse

		$this->obj_tmpl->addVar('content', 'NAMA', $rs['nama']);

	}

	

	private function DisplayForm(){

		if(!isset($this->arr_routes['params'][1])){

			self::DisplayFormAdd();

		}else{

			// get data

			$params = array(intval($this->arr_routes['params'][0]), intval($this->arr_routes['params'][1]));

			$rec = $this->obj_cpd->GetDataAsSingleArray("GetDetailFormById", ($params));

			if($rec)

				self::DisplayFormEdit($rec);

			else

				self::DisplayFormAdd();

		}

		

	}

	

	private function DisplayFormAdd(){

		// display date

		$this->obj_datetime->DhtmlgoodiesStandardDate('list_year_start', 'list_month_start', 'list_day_start', date('Y') - 5, date('m'), date('d'), 2000, 2020);

		$this->obj_datetime->DhtmlgoodiesStandardDate('list_year_end', 'list_month_end', 'list_day_end', date('Y'), date('m'), date('d'), 2000, 2020);

		// parse action

		$this->obj_tmpl->addVar('content', 'ACTION_LABEL', 'Tambah');

		$this->obj_tmpl->addVar('content', 'ACTION_PROCESS', 'insert_form');

	}

	

	private function DisplayFormEdit($rec){

		// parse action

		$this->obj_tmpl->addVar('content', 'ACTION_LABEL', 'Edit');

		$this->obj_tmpl->addVar('content', 'ACTION_PROCESS', 'update_form');

		// parse data

		$this->obj_tmpl->addVar('content', 'DEFAULT_POINT', $rec['default_point']);

		$this->obj_tmpl->addVar('content', 'DATE_LABEL', $rec['date_label']);

		$this->obj_tmpl->addVar('content', 'DATE_LABEL_EN', $rec['date_label_en']);

		// display date

		$tgl_awal = explode('-', $rec['periode_awal']);

		$tgl_akhir = explode('-', $rec['periode_akhir']);

		$this->obj_datetime->DhtmlgoodiesStandardDate('list_year_start', 'list_month_start', 'list_day_start', $tgl_awal[0], $tgl_awal[1], $tgl_awal[2], 2000, 2020);

		$this->obj_datetime->DhtmlgoodiesStandardDate('list_year_end', 'list_month_end', 'list_day_end', $tgl_akhir[0], $tgl_akhir[1], $tgl_akhir[2], 2000, 2020);

		if($rec['tipe'] == 'rutin')

			$this->obj_tmpl->addVar('content', 'RUTIN', 'checked="checked"');

		else

			$this->obj_tmpl->addVar('content', 'NON-RUTIN', 'checked="checked"');

		if($rec['is_manual'] == 'yes')

			$this->obj_tmpl->addVar('content', 'YES', 'checked="checked"');

		else

			$this->obj_tmpl->addVar('content', 'NO', 'checked="checked"');

	}

	

	private function DisplayList(){		

		$params = array($this->arr_routes['params'][0]);

		$rs_id = $this->obj_cpd->GetResourceId("GetKegiatanFormByIdKegiatan", ($params));

		if($rs_id){

			$no = 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				// url

				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0], $rec['id_form']));

				$url_elemen = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_routes['params'][0], $rec['id_form']));

				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'hapus-form', array($this->arr_routes['params'][0], $rec['id_form']));

				// parse

				$this->obj_tmpl->addVar('list_form', 'NO', $no);

				$this->obj_tmpl->addVar('list_form', 'TIPE', ucwords($rec['tipe']));

				$this->obj_tmpl->addVar('list_form', 'MANUAL', strtoupper($rec['is_manual']));

				$this->obj_tmpl->addVar('list_form', 'BATAS_AWAL', $this->obj_datetime->GetFullDate($rec['periode_awal']));

				$this->obj_tmpl->addVar('list_form', 'BATAS_AKHIR', $this->obj_datetime->GetFullDate($rec['periode_akhir']));

				$this->obj_tmpl->addVar('list_form', 'URL_EDIT_FORM', $url_edit);

				$this->obj_tmpl->addVar('list_form', 'URL_ELEMEN_FORM', $url_elemen);

				$this->obj_tmpl->addVar('list_form', 'URL_DELETE_FORM', $url_hapus);

				$this->obj_tmpl->ParseTemplate('list_form', 'a');

				$no++;

			}

		}else{

			$this->obj_tmpl->SetAttribute('keterangan', 'visibility', 'show');

		}

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>