<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_cpd;

	protected $obj_notify;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_datetime = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();

		// Display Detail Kegiatan

		self::DisplayDetailKegiatan();		

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		if(isset($this->arr_routes['params'][0])){

			$this->obj_tmpl->addVar('content', 'ID_KEGIATAN', $this->arr_routes['params'][0]);

			// url

			$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));

			$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list'));

			$this->obj_tmpl->addVar('content', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_routes['params'][0])));

			$this->obj_tmpl->addVar('content', 'URL_FORM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_routes['params'][0])));

			$this->obj_tmpl->addVar('content', 'URL_ELEMEN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_routes['params'][0])));

			$this->obj_tmpl->addVar('content', 'URL_SKP', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_routes['params'][0])));

		}else{

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list');

		}

		if(isset($this->arr_routes['params'][1]))

			$this->obj_tmpl->addVar('content', 'ID_FORM', $this->arr_routes['params'][1]);

	}

	

	private function DisplayDetailKegiatan(){

		// kegiatan

		$params = array($this->arr_routes['params'][0]);

		$kegiatan = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanById", $params);

		// form

		$params = array($this->arr_routes['params'][0], $this->arr_routes['params'][1]);

		$form = $this->obj_cpd->GetDataAsSingleArray("GetDetailFormById", $params);

		// elemen

		$params = array($this->arr_routes['params'][1]);

		$elemen = $this->obj_cpd->GetResourceId("GetElemenByIdForm", $params);

		// kegiatan

		$params = array($this->arr_routes['params'][1]);

		$user = $this->obj_cpd->GetResourceId("GetBukuLogByIdKegiatan", $params);

		// parse

		$this->obj_tmpl->addVar('content', 'NAMA', $kegiatan['nama']);

		$this->obj_tmpl->addVar('content', 'TIPE', ucwords($form['tipe']));

		$this->obj_tmpl->addVar('content', 'BATAS_AWAL', $this->obj_datetime->GetFullDate($form['periode_awal']));

		$this->obj_tmpl->addVar('content', 'BATAS_AKHIR', $this->obj_datetime->GetFullDate($form['periode_akhir']));

		$this->obj_tmpl->addVar('content', 'SKP_MANUAL',  ucwords($form['is_manual']));

		if($user){

			$this->obj_tmpl->addVar('content', 'TOTAL_KEGIATAN',  mysqli_num_rows($user));

		}

		if($elemen){

			$this->obj_tmpl->addVar('content', 'TOTAL_ELEMEN',  mysqli_num_rows($elemen));

		}	

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>