<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	var $obj_cpd;

	var $obj_notify;

	// variable definition

	var $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){ }		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'list');	

	}

	

	protected function BaseLoad(){ }

	

	protected function BaseView(){ }

	

	protected function PageLoad(){ 

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'search':

				self::SearchData();

				break;

			case 'insert':

				self::InsertDataKegiatan();

				break;

			case 'update':

				self::UpdateDataKegiatan();

				break;

			case 'delete':

				self::DeleteDataKegiatan();

				break;

			case 'insert_form':

				self::InsertFormKegiatan();

				break;

			case 'update_form':

				self::UpdateFormKegiatan();

				break;

			case 'delete_form':

				self::DeleteFormKegiatan();

				break;

			case 'insert_elemen':

				self::InsertElemenForm();

				break;

			case 'update_elemen':

				self::UpdateElemenForm();

				break;

			case 'delete_elemen':

				self::DeleteElemenForm();

				break;

			case 'update_parameter':

				self::UpdateParameterRelation();

				break;

			case 'insert_engine':

				self::InsertFormEngine();

				break;

			case 'update_engine':

				self::UpdateFormEngine();

				break;

			case 'delete_engine':

				self::DeleteFormEngine();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// search method

	private function SearchData(){

		$_SESSION['search']['keyword'] = trim($this->arr_params['keyword']);

		$_SESSION['search']['ranah'] = $this->arr_params['ranah'];

	}

	

	// operation

	private function InsertDataKegiatan(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['keyword'])){ $err[] = '<br /><strong>Kata kunci</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['ranah'], $this->arr_params['kelompok'], $this->arr_params['kompetensi'], $this->arr_params['nama'], $this->arr_params['keyword'], intval($this->arr_params['batas_bawah']), intval($this->arr_params['batas_atas']), $this->str_userid);

			// execute process

			if($this->obj_cpd->ProcessingData("InsertDataKegiatan", $params)){

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

				$id = $this->obj_cpd->GetDataAsSingleArray("GetLatestID", array());

				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($id['id_kegiatan']));

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add');

			}	

		}else{

			// filled field with last input

			$filled = array("ranah" => $this->arr_params['ranah'], "kelompok" => $this->arr_params['kelompok'], 

					"kompetensi" => $this->arr_params['kompetensi'], "NAMA" => $this->arr_params['nama'], 

					"KEYWORD" => $this->arr_params['keyword'], "BATAS_BAWAH" => $this->arr_params['batas_bawah'], 

					"BATAS_ATAS" => $this->arr_params['batas_atas']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add');

		}

	}

	

	private function UpdateDataKegiatan(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID</strong> not selected'; }

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['keyword'])){ $err[] = '<br /><strong>Kata kunci</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['ranah'], $this->arr_params['kelompok'], $this->arr_params['kompetensi'], $this->arr_params['nama'], $this->arr_params['keyword'], intval($this->arr_params['batas_bawah']), intval($this->arr_params['batas_atas']), $this->str_userid, $this->arr_params['id_kegiatan']);

			// execute process

			if($this->obj_cpd->ProcessingData("UpdateDataKegiatan", $params)){

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

				

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

				

			}	

		}else{

			// filled field with last input

			$filled = array("ranah" => $this->arr_params['ranah'], "kelompok" => $this->arr_params['kelompok'], 

					"kompetensi" => $this->arr_params['kompetensi'], "NAMA" => $this->arr_params['nama'], 

					"KEYWORD" => $this->arr_params['keyword'], "BATAS_BAWAH" => $this->arr_params['batas_bawah'], 

					"BATAS_ATAS" => $this->arr_params['batas_atas']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_kegiatan']));

	}

	

	private function DeleteDataKegiatan(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			if(!empty($this->arr_params['id_kegiatan'])){

				$params = array($this->arr_params['id_kegiatan']);

				if($this->obj_cpd->ProcessingData("DeleteDataKegiatanById", $params)){

					// notification message				

					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

					// redirect to success page -----------------------------------

				}else{

					// notification message				

					self::SendNotification($err, $filled, 'Business process error.', 'error');

					// redirect to success page -----------------------------------

				}

			}else{

				// error message

				self::SendNotification($err, $filled, 'No ID selected.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ----------------------------------------			

		}	

		// last redirect to page error page ---------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'list');

	}

	

	private function InsertFormKegiatan(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['tipe'])){ $err[] = '<br /><strong>Tipe Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['is_manual'])){ $err[] = '<br /><strong>SKP Manual</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['date_label'])){ $err[] = '<br /><strong>Label Tanggal</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['date_label_en'])){ $err[] ='<br /><strong>Label Tanggal Asing</strong> tidak boleh kosong';}

		$tgl_awal = $this->arr_params['year_start'].'-'.$this->arr_params['month_start'].'-'.$this->arr_params['day_start'];

		$tgl_akhir = $this->arr_params['year_end'].'-'.$this->arr_params['month_end'].'-'.$this->arr_params['day_end'];

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['id_kegiatan'], $this->arr_params['tipe'], $this->arr_params['is_manual'], $tgl_awal, $tgl_akhir, $this->arr_params['default_point'], $this->arr_params['date_label'], $this->arr_params['date_label_en'], $this->str_userid);

			// execute process

			if($this->obj_cpd->ProcessingData("InsertFormKegiatan", $params)){

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

				

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ---------------------------------

				

			}	

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_params['id_kegiatan']));

	}

	

	private function UpdateFormKegiatan(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['tipe'])){ $err[] = '<br /><strong>Tipe Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['is_manual'])){ $err[] = '<br /><strong>SKP Manual</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['date_label'])){ $err[] = '<br /><strong>Label Tanggal</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['date_label_en'])){ $err[] ='<br /><strong>Label Tanggal Asing</strong> tidak boleh kosong';}

		$tgl_awal = $this->arr_params['year_start'].'-'.$this->arr_params['month_start'].'-'.$this->arr_params['day_start'];

		$tgl_akhir = $this->arr_params['year_end'].'-'.$this->arr_params['month_end'].'-'.$this->arr_params['day_end'];

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['tipe'], $this->arr_params['is_manual'], $tgl_awal, $tgl_akhir, $this->arr_params['default_point'], $this->arr_params['date_label'], $this->arr_params['date_label_en'], $this->str_userid, $this->arr_params['id_kegiatan'], $this->arr_params['id_form']);

			// execute process

			if($this->obj_cpd->ProcessingData("UpdateFormKegiatan", $params)){

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

				

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

				

			}	

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']));

	}

	

	private function DeleteFormKegiatan(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']);

			// execute process

			if($this->obj_cpd->ProcessingData("DeleteElemenForm", $params)){

				// notification message				

				self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

				// redirect to success page ------------------------------------

				

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

				

			}	

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'form', array($this->arr_params['id_kegiatan']));

	}

	

	private function InsertElemenForm(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['tipe'])){ $err[] = '<br /><strong>Tipe Kegiatan</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['label'])){ $err[] = '<br /><strong>Label</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['label_en'])){ $err[] = '<br /><strong>Label English</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['elemen_size'])){ $err[] = '<br /><strong>Size</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['elemen_maxlength'])){ $err[] = '<br /><strong>Maxlength</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_required'])){ $err[] = '<br /><strong>Required</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_engine'])){ $err[] = '<br /><strong>Engine</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_parameter'])){ $err[] = '<br /><strong>Parameter</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_displayed'])){ $err[] = '<br /><strong>Displayed</strong> tidak boleh kosong'; }	

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['id_form'], $this->arr_params['tipe'], $this->arr_params['label'], $this->arr_params['label_en'], $this->arr_params['elemen_size'], $this->arr_params['elemen_minlength'], $this->arr_params['elemen_maxlength'], $this->arr_params['elemen_sort'], $this->arr_params['is_required'], $this->arr_params['is_engine'], $this->arr_params['is_parameter'], $this->arr_params['is_displayed'], $this->str_userid);

			// execute process

			if($this->obj_cpd->ProcessingData("InsertElemenForm", $params)){

				// insert list elemen

				if(!empty($this->arr_params['elemen_list'])){

					$id_elemen = $this->obj_cpd->GetDataAsSingleArray("GetLastElemenListId", array());

					$no = 0;

					for($i=0;$i<count($this->arr_params['elemen_list']['label']);$i++){

						$params = array($id_elemen['id_elemen'], $this->arr_params['elemen_list']['label'][$no], $this->arr_params['elemen_list']['value'][$no], $this->arr_params['elemen_list']['sort'][$no]);

						$this->obj_cpd->ProcessingData("InsertElemenList", $params);						

						$no++;

					}

				}

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

				

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

				

			}	

		}else{

			// filled field with last input

			$filled = array("LABEL" => $this->arr_params['label'], "LABEL_EN" => $this->arr_params['label_en'], 

					"elemen_size" => $this->arr_params['elemen_size'], "elemen_sort" => $this->arr_params['elemen_sort'],

					"elemen_maxlength" => $this->arr_params['elemen_maxlength'], 

					"elemen_minlength" => $this->arr_params['elemen_minlength']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']));

	}

	

	private function UpdateElemenForm(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_elemen'])){ $err[] = '<br /><strong>ID Elemen</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['tipe'])){ $err[] = '<br /><strong>Tipe Kegiatan</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['label'])){ $err[] = '<br /><strong>Label</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['label_en'])){ $err[] = '<br /><strong>Label English</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['elemen_size'])){ $err[] = '<br /><strong>Size</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['elemen_maxlength'])){ $err[] = '<br /><strong>Maxlength</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_required'])){ $err[] = '<br /><strong>Required</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_engine'])){ $err[] = '<br /><strong>Engine</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_parameter'])){ $err[] = '<br /><strong>Parameter</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['is_displayed'])){ $err[] = '<br /><strong>Displayed</strong> tidak boleh kosong'; }	

		// processing --------------------------------------------------		

		if(empty($err)){

			$params = array($this->arr_params['tipe'], $this->arr_params['label'], $this->arr_params['label_en'], $this->arr_params['elemen_size'], $this->arr_params['elemen_minlength'], $this->arr_params['elemen_maxlength'], $this->arr_params['elemen_sort'], $this->arr_params['is_required'], $this->arr_params['is_engine'], $this->arr_params['is_parameter'], $this->arr_params['is_displayed'], $this->str_userid, $this->arr_params['id_form'], $this->arr_params['id_elemen']);

			// execute process

			if($this->obj_cpd->ProcessingData("UpdateElemenForm", $params)){

				// insert list elemen

				if(!empty($this->arr_params['elemen_list'])){

					$arr_not_deleted = array();		

					foreach($this->arr_params['elemen_list']['id'] as $id => $value){

						if(isset($this->arr_params['elemen_list']['label'][$id])){

							$arr_not_deleted[] = $id;

						}

					}	

					// --

					$str_not_deleted = implode(', ', $arr_not_deleted);

					if(empty($str_not_deleted)){ 	

						// max id

						$max = 0;

						$str_not_deleted = '0';

					}else{

						// max id

						$max = max($arr_not_deleted) + 1;

					}

					// delete

					$params_del = array($this->arr_params['id_elemen'], $str_not_deleted);

					$this->obj_cpd->ProcessingData("DeleteElemenListByElemenParams", $params_del);

					// update

					foreach($arr_not_deleted as $id){

						$params_update = array($this->arr_params['elemen_list']['label'][$id], $this->arr_params['elemen_list']['value'][$id], $this->arr_params['elemen_list']['sort'][$id], $id);

						$this->obj_cpd->ProcessingData("UpdateElemenListById", $params_update);

					}		

					// insert

					if(isset($this->arr_params['elemen_list']['label'][$max])){

						$count_max = $max + (count($this->arr_params['elemen_list']['label']) - count($arr_not_deleted));

						for($i=$max;$i<$count_max;$i++){

							$params_insert = array($this->arr_params['id_elemen'], $this->arr_params['elemen_list']['label'][$max], $this->arr_params['elemen_list']['value'][$max], $this->arr_params['elemen_list']['sort'][$max]);

							$this->obj_cpd->ProcessingData("InsertElemenList", $params_insert);

						}

					}

				}

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

				

			}	

		}else{

			// filled field with last input

			$filled = array("LABEL" => $this->arr_params['label'], "LABEL_EN" => $this->arr_params['label_en'], 

					"elemen_size" => $this->arr_params['elemen_size'], "elemen_sort" => $this->arr_params['elemen_sort'],

					"elemen_maxlength" => $this->arr_params['elemen_maxlength'], 

					"elemen_minlength" => $this->arr_params['elemen_minlength']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form'], $this->arr_params['id_elemen']));

	}

	

	private function DeleteElemenForm(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_elemen'])){ $err[] = '<br /><strong>ID Elemen</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			if(!empty($this->arr_params['id_elemen'])){

				foreach($this->arr_params['id_elemen'] as $val){

					$params = array($this->arr_params['id_form'], $val);

					$this->obj_cpd->ProcessingData("DeleteElemenById", $params);

				}

				// notification message				

				self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'No ID selected.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'elemen', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']));

	}

	

	private function UpdateParameterRelation(){		

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['parameter'])){ $err[] = '<br /><strong>Parameter</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['formulasi'])){ $err[] = '<br /><strong>Formulasi</strong> tidak boleh kosong'; }	

		if(empty($this->arr_params['indikator'])){ $err[] = '<br /><strong>Indikator</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			// execute process

			foreach($this->arr_params['parameter'] as $val){

				$params = array($this->arr_params['formulasi'][$val], $this->arr_params['indikator'][$val], $val);

				$this->obj_cpd->ProcessingData("UpdateParameterRelation", $params);

			}

			// notification message				

			self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			// redirect to success page ------------------------------------				

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------				

		}

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']));

	}

	

	private function InsertFormEngine(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['engine'])){ $err[] = '<br /><strong>Group Indikator</strong> tidak boleh kosong'; }	

		// if(empty($this->arr_params['nilai'])){ $err[] = '<br /><strong>Nilai</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$group = implode(',', $this->arr_params['engine']);	

			$params = array($this->arr_params['id_form'], $group, $this->arr_params['nilai']);

			// execute process

			if($this->obj_cpd->ProcessingData("InsertFormEngine", $params)){

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

				

			}	

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------				

		}

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']));

	}

	

	private function UpdateFormEngine(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_engine'])){ $err[] = '<br /><strong>ID Engine</strong> tidak boleh kosong'; }

		// print_r($this->arr_params['updated_value']);

		// processing --------------------------------------------------

		if(empty($err)){

			if(!empty($this->arr_params['updated_value'])){

				foreach($this->arr_params['updated_value'] as $id => $val){

					$params = array($val, $this->arr_params['id_form'], $id);

					$this->obj_cpd->ProcessingData("UpdateEngineById", $params);

				}

				// notification message				

				self::SendNotification($err, $filled, 'Data has been updated.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'No ID selected.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']));

	}

	

	private function DeleteFormEngine(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>ID Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_form'])){ $err[] = '<br /><strong>ID Form</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_engine'])){ $err[] = '<br /><strong>ID Engine</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			if(!empty($this->arr_params['id_engine'])){

				foreach($this->arr_params['id_engine'] as $val){

					$params = array($this->arr_params['id_form'], $val);

					$this->obj_cpd->ProcessingData("DeleteEngineById", $params);

				}

				// notification message				

				self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'No ID selected.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled field with last input

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

			

		}	

		// last redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'engine', array($this->arr_params['id_kegiatan'], $this->arr_params['id_form']));

	}

	

	

}



?>