<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{		

	protected $obj_cpd;

	protected $obj_date;

	// variable definition

	protected $int_periode = '';

	protected $int_tahun = '';

	protected $int_ranah = '';

	protected $str_tgl_mulai;

	protected $str_tgl_selesai;

	protected $arr_tahun_kegiatan = array();

	protected $arr_ranah_all = array();

	protected $total_nilai = 0;

	var $tablealign = '';

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('content');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);

		$loaded_query = array('evaluasi', 'kegiatan', 'str');

		$this->obj_cpd->SetUsesQuery($loaded_query);

		// load plugins

		$this->obj_ctrl->LoadFile('tcpdf/tcpdf.php', 'plugins');

		$this->obj_tcpdf = $this->obj_ctrl->LoadClass('TCPDF');

		// --

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		// load javascript

		$this->obj_ctrl->LoadJavascript('jquery.popin', 'jquery');	

		// load style :

		$this->obj_ctrl->LoadStyle('a-load-style', 'private/style');	

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();

		// display str

		self::DisplayDetailSTR();

		// display borang penilaian diri

		self::DisplayBorangPenilaian();

		// display report pdf

		//self::DisplayReport();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		// periode

		if(isset($this->arr_routes['params'][0])){

			$this->int_periode = $this->arr_routes['params'][0];

		}

		// tahun

		if(isset($this->arr_routes['params'][1])){

			$this->int_tahun = $this->arr_routes['params'][1];

		}

		// sub link

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian_pdf'));

		$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->int_periode)));

		$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian', array($this->int_periode)));

		$this->obj_tmpl->addVar('content', 'URL_P2KB', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->int_periode)));

		$this->obj_tmpl->addVar('content', 'URL_SURAT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->int_periode)));

	}

	

	private function DisplayDetailSTR(){

		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));

		

		if(!empty($result)){

			$tgl_periode = $this->obj_date->GetFullDate($result['tgl_mulai']) . ' s/d ' .$this->obj_date->GetFullDate($result['tgl_selesai']);

			$this->obj_tmpl->AddVar('content', 'STR_PERIODE', $tgl_periode);

		}else{

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'hasil', 'evaluasi');

		}

		// tahun kegiatan

		$rs_id =  $this->obj_cpd->GetResourceId("GetListTahunPeriodeById", array($this->str_userid, $this->int_periode));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_tahun', 'VALUE', $this->int_periode . '/' .$rec['id_tahun_periode'] . '/');

				$lbl = $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins').' s/d '.$this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins');

				// parse data

				if($this->int_tahun == $rec['id_tahun_periode']){

					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');

					$this->str_tgl_mulai = $rec['tgl_mulai'];

					$this->str_tgl_selesai = $rec['tgl_selesai'];

					// display data

					$this->obj_tmpl->addVar('display', 'view', 'data');

				}else{

					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');

				}

				$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $lbl);

				$this->obj_tmpl->ParseTemplate('list_tahun', 'a');

			}

		}

	}

	

	private function DisplayBorangPenilaian(){

		$rs_id = $this->obj_cpd->GetResourceId("GetListRanahByIdPerson", array($this->str_userid,$this->str_tgl_mulai, $this->str_tgl_selesai));

		//$this->obj_cpd->DebugQuery("GetListRanahByIdPerson", array($this->str_userid,$this->str_tgl_mulai, $this->str_tgl_selesai));

		$person = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->str_userid));

		$path = "doc/temp/blank.jpg";

		if(!empty($person)){

			// display foto

			$path = "doc/person/".$person['id_person']."/foto/".$person['photo'];

			if(!is_file($path))

				$path = "doc/temp/blank.jpg";

		}



		$this->tablealign = '<table border="none" width="100%" cellpadding="2">

							  <tr>

								<td width="70" align="left"><img src="doc/temp/p2kb-logo.png" width="50" height="50" /></td>

								<td align="center" width="400"><b>KOMISI PENGEMBANGAN PENDIDIKAN KEPROFESIAN BERKELANJUTAN (P2KB)<br />

								  PERHIMPUNAN DOKTER SPESIALIS KARDIOVASKULAR INDONESIA (PERKI)</b>

								  <br />Email:inaheart@indosat.net.id  <br /><font size="9">Sekretariat : Pengurus Pusat Perhimpunan Dokter Spesialis Kardiovaskular Indonesia ( PP PERKI )<br />

								   National Cardiovascular Center, Harapan Kita Hospital <br />

								   Jl. Letjen S. Parman Kav. 87, Jakarta 11420 <br />

								   Telp: 021 - 5681149 , 5684220 Fax : 021 - 5684220 <br />

								   E-mail: p2kb_perki@yahoo.com</font></td>

									<td width="70" align="right"><img src="doc/temp/logo-perki.jpg"  /></td>

							  </tr>

							  </table>

							<img src="doc/temp/hr.jpg" width="530" />

							<br>

							<table border="none" width="100%" cellpadding="2">

							

							<tr >

							<td width="60"  rowspan="4"><img src="'.HTTPPATH.$path.'" width="50" height="50" /></td>

							<td width="170">Nama</td>

							<td width="15">:</td>

							<td width="300">'.$person['prefix'].' '.$person['nama_lengkap'].' '.$person['suffix'].'</td>

						  </tr>

						 

												  <tr>

							<td width="170">Nomor anggota PERKI</td>

							<td width="15">:</td>

							<td>'.$person['no_anggota'].'</td>

						  </tr>

						  

						  <tr>

							<td width="170">Alamat</td>

							<td width="15">:</td>

							<td width="300">'.$person['alamat'].'</td>

						  </tr>

						  

						  </table>

							<br />';

							//<br>Periode : '.$this->str_tgl_mulai.' s/d '.$this->str_tgl_selesai.

		// get data

		$rs_id = $this->obj_cpd->GetResourceId("GetListKegiatanGroupByForm", $params);

		// parse data

		if($rs_id){

			$no = 1;

			$total = 0;

			while($rec = mysqli_fetch_assoc($rs_id)){

				// url

				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->int_periode, $this->int_tahun, $rec['id_kegiatan']));

				// parse

				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no . '.');

				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA', $rec['kegiatan']);

				$this->obj_tmpl->addVar('list_kegiatan', 'RANAH', $rec['ranah']);

				$this->obj_tmpl->addVar('list_kegiatan', 'JENIS', ucwords($rec['kelompok']));

				$this->obj_tmpl->addVar('list_kegiatan', 'KEGIATAN', $rec['kegiatan']);

				$this->obj_tmpl->addVar('list_kegiatan', 'JUMLAH', $rec['jumlah']);

				$this->obj_tmpl->addVar('list_kegiatan', 'ACCEPTED', $rec['accepted']);

				if($rec['tipe'] == 'rutin')

					$nilai = self::GetNilaiSkpRutin($rec['id_form']);

				else

					$nilai = $rec['nilai'];

				$this->obj_tmpl->addVar('list_kegiatan', 'NILAI', $nilai);

				$this->obj_tmpl->addVar('list_kegiatan', 'URL_INPUT', $url);

				$this->obj_tmpl->ParseTemplate('list_kegiatan', 'a');

				$total = $total + $nilai;

				$no++;	

			}

			$this->obj_tmpl->addVar('content', 'TOTAL_NILAI', $total);

		}		

	}

	

	private function DisplayListKegiatan($id_ranah){

		$this->total_nilai = 0;

		//$formulas = 250/150;

		$formulas = 250/200;

		$no = 1;

		// clear template

		$this->obj_tmpl->clearTemplate('list_kegiatan');

		// parse data

		$rs_id = $this->obj_cpd->GetResourceId("GetListKegiatanLogByRanah", array($id_ranah,$this->str_userid,$this->str_tgl_mulai, $this->str_tgl_selesai));

		$this->tablealign .= '<table  width="550px"  cellpadding="2" cellspacing="0" style="border-bottom:1px solid #333333;">

								  <tr  bgcolor="#000000" >

									<th width="450px" colspan="5"  valign="middle"><span style="color:#FFFFFF;vertical-align:middle">Jenis Kegiatan</span></th>

									<th width="50px"  valign="middle" align="center"><span style="color:#FFFFFF">SKP<br />

									  PERKI</span></th>

									<th width="50px"  valign="middle" align="center"><span style="color:#FFFFFF">SKP<br />

									  Konversi</span></th>

								  </tr>';

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no);

				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA_KEGIATAN', $rec['nama']);

				$this->tablealign .= '<tr class="blink-row">

										<td width="20px">'.$no.'.</td>

										<td colspan="6" width="430px">'.$rec['nama'].'</td>

										<td colspan="6" width="50px"></td>

										<td colspan="6" width="50px"></td>

									  </tr>';

				// get buku log

				self::DisplayBukuLog($no, $rec['id_kegiatan']);

				// --

				$this->obj_tmpl->parseTemplate('list_kegiatan', 'a');

				$no++;

			}

		}

		// --

		$skp_IFI = number_format($this->total_nilai, 2, ',', '');

		$this->obj_tmpl->addVar('list_ranah', 'SKP_IFI', $skp_IFI);

		$skp_konversi = number_format($this->total_nilai * $formulas, 2, ',', '');

		$this->obj_tmpl->addVar('list_ranah', 'SKP_KONVERSI', $skp_konversi);

		$this->tablealign .= '<tr bgcolor="#999999">

            <td colspan="5" width="450px" ><strong>Total SKP</strong></td>

            <td align="right" width="50px"><strong>'.$skp_IFI.'</strong></td>

            <td align="right" width="50px"><strong>'.$skp_konversi.'</strong></td>

          </tr>

        </table>';

		

	}

	

	private function DisplayBukuLog($no, $id_kegiatan){

		//$formulas = 250/150;

		$formulas = 250/200;

		// clear template

		$this->obj_tmpl->clearTemplate('list_buku_log');

		// show total rutin

		$this->obj_tmpl->setAttribute('row_rutin', 'visibility', 'hidden');

		// get data

		$params = array($this->str_userid, $id_kegiatan, $this->str_tgl_mulai, $this->str_tgl_selesai);

		

		$rs_id = $this->obj_cpd->GetResourceId("GetEvaluatedBukuLogByIdKegiatan", $params);

		//$this->obj_cpd->DebugQuery("GetEvaluatedBukuLogByIdKegiatan", $params);

		// parse data

		if($rs_id){

			$sub_no = 1;

			$total = 0;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_buku_log', 'NO', $no);

				$this->obj_tmpl->addVar('list_buku_log', 'SUB_NO', $sub_no);

				// tanggal kegiatan

				$this->obj_tmpl->addVar('list_buku_log', 'DATE_LABEL', $rec['date_label']);

				$this->obj_tmpl->addVar('list_buku_log', 'TANGGAL_KEGIATAN', $this->obj_date->GetFullDate($rec['tanggal_kegiatan']));

				// nilai skp

				if($rec['tipe'] == 'rutin'){

					// rutin = true

					$rutin = true;

					$this->obj_tmpl->addVar('list_buku_log', 'SKP_IFI', '-');

					$this->obj_tmpl->addVar('list_buku_log', 'SKP_KONVERSI', '-');

					$total = self::GetNilaiSkpRutin($rec['id_form']);

					// show total rutin

					$this->obj_tmpl->setAttribute('row_rutin', 'visibility', 'show');

					$skp_IFI = number_format($total, 2, ',', '');

					$this->obj_tmpl->addVar('row_rutin', 'SKP_IFI', $skp_IFI);

					$skp_konversi = number_format($total * $formulas, 2, ',', '');

					$this->obj_tmpl->addVar('row_rutin', 'SKP_KONVERSI', $skp_konversi);

					$this->tablealign .= '<tr>

										<td width="20px"></td>

										<td width="20px">'.$no.'.'.$sub_no.'</td>

										<td width="100px">'.$rec['date_label'].'</td>

										<td width="150px">: '.$this->obj_date->GetFullDate($rec['tanggal_kegiatan']).'</td>

										<td width="160px"><a href="{URL_DETAIL}" class="popin-open-01">Lihat detail kegiatan ...</a></td>

										<td align="right" width="50px">-</td>

										<td align="right" width="50px">-</td>

										</tr>

											<tr>

											<td width="20px"></td>

											<td colspan="4" width="430px">Rekapitulasi nilai skp</td>

											<td align="right" width="50px">'.$skp_IFI.'</td>

											<td align="right" width="50px">'.$skp_konversi.'</td>

											</tr>';

				}else{

					$total = $rec['nilai_skp'];

					$skp_IFI = number_format($total, 2, ',', '');

					$this->obj_tmpl->addVar('list_buku_log', 'SKP_IFI', $skp_IFI);

					$skp_konversi = number_format($total * $formulas, 2, ',', '');

					$this->obj_tmpl->addVar('list_buku_log', 'SKP_KONVERSI', $skp_konversi);

					// total nilai

					$this->total_nilai = $this->total_nilai + $total;

					$this->tablealign .= '<tr>

										<td width="20px"></td>

										<td width="20px">'.$no.'.'.$sub_no.'</td>

										<td width="100px">'.$rec['date_label'].'</td>

										<td width="150px">: '.$this->obj_date->GetFullDate($rec['tanggal_kegiatan']).'</td>

										<td width="160px"><a href="{URL_DETAIL}" class="popin-open-01">Lihat detail kegiatan ...</a></td>

										<td align="right" width="50px">'.$skp_IFI.'</td>

										<td align="right" width="50px">'.$skp_konversi.'</td>

									  	</tr>';

					

				}

				// url detail

				$this->obj_tmpl->addVar('list_buku_log', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian-detail', array($rec['id_log'])));

				// --

				$this->obj_tmpl->ParseTemplate('list_buku_log', 'a');

				$sub_no++;

			}

			// rutin = true

			if(isset($rutin)){

				$this->total_nilai = $this->total_nilai + $total;

			}

		}

	}

	

	private function GetNilaiSkpRutin($id_form){

		$nilai = 0;

		$jumlah = 0;

		// get parameter and indikator

		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));

		$id_parameter = $arr['parameter'];

		$id_engine = $arr['indikator'];

		// get nilai dalam range tahun kegiatannya

		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($this->str_userid, $id_form, $this->str_tgl_mulai, $this->str_tgl_selesai));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$arr_field = "";

				$xml = simplexml_load_string($rec["data_kegiatan"]);

				// echo does the casting for you

				$count = count($xml->item);

				for($i=0;$i<$count;$i++){

					$id = intval($xml->item[$i]->idt);

					$value = strval($xml->item[$i]->value);

					if($id == $id_parameter){

						$jumlah = $jumlah + $value;

						break;

					}

				}

			}

		}

		// get list elemen

		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));

		if($rs_id_list){

			$group_list = "FIND_IN_SET(0, group_elemen_list)";

			while($rec = mysqli_fetch_assoc($rs_id_list)){

				$range_value = explode('-', $rec['list_value'], 2);

				if(sizeof($range_value) >= 2){

					$batas_bawah = round($range_value[0], 2);

					$batas_atas = round($range_value[1], 2);

				}else{

					$batas_bawah = 0;

					$batas_atas = 0;

				}	

				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){

					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";

					break;

				}

			}

		}

		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	

		if(!empty($nilai))

			return $nilai['nilai_skp'];

		else

			return 0;

	}

	

	private function DisplayReport(){

		// print pdf

		$this->obj_tcpdf->setPrintHeader(false);

		$this->obj_tcpdf->setPrintFooter(false);

		$this->obj_tcpdf->SetDisplayMode('real');

		$this->obj_tcpdf->SetMargins(10, 10);		

		// add a page

		$this->obj_tcpdf->AddPage();	

		$this->obj_tcpdf->SetFont("arial", "BI", 10);	

		// create some HTML content

		//$this->tablealign = '';

   



		// output the HTML content

		$this->obj_tcpdf->writeHTML($this->tablealign, true, 0, true, 0);

		//Close and output PDF document

		$this->obj_tcpdf->Output("Surat-Rekomendasi-P2KB.pdf", "D");

	}

	

	

}



?>