<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	var $obj_cpd;

	var $obj_notify;

	// variable definition

	var $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	

	}

	

	protected function PageLoad(){ 

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);

		$loaded_query = array('str', 'evaluasi');

		$this->obj_cpd->SetUsesQuery($loaded_query);

		// --

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'search_dokumen':

				self::SearchDataDokumen();

				break;

			case 'search_str':

				self::SearchDataStr();

				break;

			case 'search_tim':

				self::SearchDataByTim();

				break;

			case 'search_p2kb':

				self::SearchDataByPerson();

				break;

			case 'setuju':

				self::PersetujuanStr();

				break;

			case 'verifikasi':

				self::VerifikasiKegiatan();

				break;

			case 'verifikasi_dokumen':

				self::VerifikasiDokumen();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// search method

	private function SearchDataDokumen(){

		$_SESSION['search']['dokumen']['cabang'] = $this->arr_params['id_cabang'];

		$_SESSION['search']['dokumen']['nama'] = $this->arr_params['keyword'];

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'dokumen-anggota');

	}

	

	private function SearchDataStr(){

		$_SESSION['search']['str']['wilayah'] = $this->arr_params['id_wilayah'];

		$_SESSION['search']['str']['nama'] = $this->arr_params['keyword'];

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'str');

	}

	

	private function SearchDataByTim(){

		$_SESSION['search']['verifikasi']['wilayah'] = $this->arr_params['id_wilayah'];

		$_SESSION['search']['verifikasi']['nama'] = $this->arr_params['keyword'];

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');

	}

	

	private function SearchDataByPerson(){

		$_SESSION['search']['verifikasi']['keyword'] = trim($this->arr_params['keyword']);

		$_SESSION['search']['verifikasi']['ranah'] = $this->arr_params['ranah'];

		// $_SESSION['search']['jenis'] = $this->arr_params['jenis'];

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log', array($this->arr_params['id_person'], $this->arr_params['periode'], $this->arr_params['tahun']));

	}

	

	private function VerifikasiKegiatan(){

		// check / validate parameter 

		$err = array();	

		$filled = array();	

		// required

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		if(empty($this->arr_params['periode'])){ $err[] = '<br /><strong>Id Periode</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['tahun'])){ $err[] = '<br /><strong>Id Tahun</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_kegiatan'])){ $err[] = '<br /><strong>Id Kegiatan</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id person</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id => $val){

				$tgl_ver = date('Y-m-d H:i:s');

				// check hanya yang berubah saja

				$arr_check = $this->obj_cpd->GetDataAsSingleArray("GetStatusEvaluasiKegiatanById", array($this->arr_params['id_person'], $id));

				if(!empty($arr_check['tgl_verifikasi'])){

					if($arr_check['evaluated'] == $val AND $arr_check['catatan'] == $this->arr_params['catatan'][$id]){

						$tgl_ver = $arr_check['tgl_verifikasi'];

					}

				}

				// execute

				$params = array($val, $this->arr_params['catatan'][$id], $this->str_userid, $tgl_ver, $this->arr_params['id_person'], $id);

				if($this->obj_cpd->ProcessingData("VerifikasiKegiatan", $params)){

					// notification message			

					self::SendNotification($err, $filled, 'Data telah disimpan.', 'success');

					// redirect to success page ------------------------------------

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'Business process failure.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->arr_params['id_person'], $this->arr_params['periode'], $this->arr_params['tahun'], $this->arr_params['id_kegiatan']));

	}

	

	private function VerifikasiDokumen(){

		// check / validate parameter 

		$err = array();	

		$filled = array();	

		// required

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		if(empty($this->arr_params['periode'])){ $err[] = '<br /><strong>Id Periode</strong> tidak boleh kosong'; }

		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id person</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id => $val){

				$tgl_ver = date('Y-m-d H:i:s');

				// check hanya yang berubah saja

				$arr_check = $this->obj_cpd->GetDataAsSingleArray("GetStatusEvaluasiDokumenById", array($this->arr_params['id_person'], $id));

				if(!empty($arr_check['tgl_verifikasi'])){

					if($arr_check['evaluated'] == $val AND $arr_check['catatan'] == $this->arr_params['catatan'][$id]){

						$tgl_ver = $arr_check['tgl_verifikasi'];

					}

				}

				// execute

				$params = array($val, $this->arr_params['catatan'][$id], $this->str_userid, $tgl_ver, $this->arr_params['id_person'], $id);

				if($this->obj_cpd->ProcessingData("VerifikasiDokumen", $params)){

					// notification message			

					self::SendNotification($err, $filled, 'Data telah disimpan.', 'success');

					// redirect to success page ------------------------------------

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'Business process failure.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'dokumen', array($this->arr_params['id_person'], $this->arr_params['periode']));

	}

	

	// persetujuan data STR anggota 

	

	private function PersetujuanStr(){

		// check / validate parameter 

		$err = array();	

		$filled = array();	

		// required

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				$params = array($id);

				if($this->obj_cpd->ProcessingData("PersetujuanStr", $params)){

					// notification message			

					self::SendNotification($err, $filled, 'Data telah disetujui.', 'success');

					// redirect to success page ------------------------------------

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'Business process failure.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'str');

	}

	

}



?>