<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	var $obj_cpd;

	var $obj_notify;

	// variable definition

	var $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		// example

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'], 'view');	

	}

	

	protected function PageLoad(){ 

		/* -- Other object loaded below */

		// business

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);

		// library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'search_calon':

				self::SearchCalon();

				break;

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			case 'register_related_member':

				self::RegisterRelatedMember();

				break;

			case 'delete_related_member':

				self::DeleteRelatedMember();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// operation

	

	// search calon dari anggota

	

	private function SearchCalon(){

		$_SESSION['search']['cabang'] = $this->arr_params['id_cabang'];

		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tim-add', array($this->arr_params['id_wilayah']));	

	}

	

	private function InsertData(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['kota'])){ $err[] = '<br /><strong>Kota</strong> harus diisi'; }

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama wilayah</strong> harus diisi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['nama'], $this->arr_params['deskripsi'], $this->str_userid);

			if($this->obj_cpd->ProcessingData('InsertWilayah', $params)){

				// get last id

				$max = $this->obj_cpd->GetDatasetAsArray('GetLastIdWilayah', array());

				// insert to kota

				foreach($this->arr_params['kota'] as $val){

					$params = array($max[0]['last'], $val);

					$this->obj_cpd->ProcessingData('InsertKotaByWilayah', $params);

				}

				// notification message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to page error page ------------------------------------	

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process error.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'], 'view', array('add'));	

	}

	

	private function UpdateData(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_wilayah'])){ $err[] = '<br /><strong>Id</strong> harus diisi'; }

		if(empty($this->arr_params['kota'])){ $err[] = '<br /><strong>Kota</strong> harus diisi'; }

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama wilayah</strong> harus diisi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['nama'], $this->arr_params['deskripsi'], $this->str_userid, $this->arr_params['id_wilayah']);

			$this->obj_cpd->ProcessingData('UpdateWilayahById', $params);

			// delete kota

			$params = array($this->arr_params['id_wilayah']);

			$this->obj_cpd->ProcessingData('DeleteKotaByWilayah', $params);

			// insert to kota

			foreach($this->arr_params['kota'] as $val){

				$params = array($this->arr_params['id_wilayah'], $val);

				$this->obj_cpd->ProcessingData('InsertKotaByWilayah', $params);

			}

			// notification message				

			self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			// redirect to page error page ------------------------------------	

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'], 'view', array('edit', $this->arr_params['id_wilayah']));	

	}

	

	private function DeleteData(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>Id</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			// insert to kota

			foreach($this->arr_params['downcheck'] as $val){

				$params = array($val);

				$this->obj_cpd->ProcessingData('DeleteWilayah', $params);

			}

			// notification message				

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

			// redirect to page error page ------------------------------------	

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'], 'view');	

	}

	

	private function RegisterRelatedMember(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_wilayah'])){ $err[] = '<br /><strong>Id</strong> harus diisi'; }

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>Data</strong> tidak terpilih'; }

		// processing --------------------------------------------------

		if(empty($err)){

			// insert to kota

			foreach($this->arr_params['downcheck'] as $val){

				// insert related member

				$params = array($val, $this->arr_params['id_wilayah'], $this->str_userid);

				$this->obj_cpd->ProcessingData('RegisterRelatedMemberByWilayah', $params);

				// insert related authority

				$id_auth = 15;

				$params = array($val, $id_auth);

				$this->obj_cpd->ProcessingData('InsertUserAuthorityByTimP2KB', $params);

			}

			// notification message				

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

			// redirect to page error page ------------------------------------	

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'], 'tim-add', array($this->arr_params['id_wilayah'], $this->arr_params['pages']));	

	}

	

	private function DeleteRelatedMember(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_wilayah'])){ $err[] = '<br /><strong>Id</strong> harus diisi'; }

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>Data</strong> tidak terpilih'; }

		// processing --------------------------------------------------

		if(empty($err)){

			// insert to kota

			foreach($this->arr_params['downcheck'] as $val){

				$params = array($this->arr_params['id_wilayah'], $val);

				$this->obj_cpd->ProcessingData('DeleteRelatedMemberByWilayah', $params);// insert related authority

				$id_auth = 15;

				$params = array($val, $id_auth);

				$this->obj_cpd->ProcessingData('DeleteUserAuthorityByTimP2KB', $params);

			}

			// notification message				

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

			// redirect to page error page ------------------------------------	

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page ------------------------------------		

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'], 'member', array($this->arr_params['id_wilayah']));	

	}

}



?>