<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object

	protected $obj_cpd;

	protected $obj_admin;

	protected $obj_support;

	protected $obj_paging;

	protected $obj_notify;

	// variable

	protected $int_wilayah;

	protected $str_cabang;

	protected $str_keyword;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		// load object business

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);

		$this->obj_support = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);	

		// load object pagination

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();	

		// display detail wilayah

		self::DisplayDetailWilayah();

		// display cabang

		self::DisplayCabangAuthority();

		// display data

		self::DisplayCalonTim();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariable(){

		// id wilayah

		if(isset($this->arr_routes['params'][0]))

			$this->int_wilayah = $this->arr_routes['params'][0];

		else

			$this->int_wilayah = 0;

		// link

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tim-add', array($this->int_wilayah)));	

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));	

		$this->obj_tmpl->addVar('content', 'URL_MEMBER', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'member', array($this->int_wilayah)));		

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));	

		// keyword

		if(isset($_SESSION['search']['keyword'])){

			$this->str_keyword = "%" . $_SESSION['search']['keyword'] . "%";

			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['keyword']);

		}else{

			$this->str_keyword = "%%";

		}

	}

	

	private function DisplayDetailWilayah(){

		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailWilayahById", array($this->int_wilayah));

		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'ID_WILAYAH', $result['id_wilayah']);

			$this->obj_tmpl->addVar('content', 'WILAYAH', $result['nama']);

		}

	}

	

	private function DisplayCabangAuthority(){

		// set parameter cabang

		if(isset($_SESSION['search']['cabang']) AND !empty($_SESSION['search']['cabang'])){ 

			$this->str_cabang =  "AND b.id_cabang =" . $_SESSION['search']['cabang'];

		}else{

			$this->str_cabang = '';

		}

		// parsing data

		$rs_id = $this->obj_support->GetDataCabang();		

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				if($rs['id_cabang'] == $this->str_cabang){

					$this->obj_tmpl->addVar('list_cabang', 'SELECTED', 'selected="selected"');

				}else{

					$this->obj_tmpl->addVar('list_cabang', 'SELECTED', '');

				}

				$this->obj_tmpl->addVar('list_cabang', 'VALUE', $rs['id_cabang']);

				$this->obj_tmpl->addVar('list_cabang', 'NAMA', $rs['nama']);

				$this->obj_tmpl->ParseTemplate('list_cabang', 'a');

			}

		}

	}

	

	private function DisplayCalonTim(){

		/* display paging template (bagian atas) */

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][1]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][1];

		$this->obj_tmpl->addVar('content', 'PAGES', $page);

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$params = array($this->str_cabang, $this->str_keyword);

		$this->obj_paging->SetTotalRecord($this->obj_admin->GetTotalCalonAdministrator($params));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->int_wilayah, '')));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get data

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$params = array($this->str_cabang, $this->str_keyword, $start, $max);

		$rs_id = $this->obj_admin->GetDataCalonAdministrator($params);	

		if($rs_id){

			$no = $start + 1;

			while($rs = mysqli_fetch_assoc($rs_id)){

				// parse data

				$this->obj_tmpl->addVar('list_data', 'NO', $no);

				$this->obj_tmpl->addVar('list_data', 'ID_PERSON', $rs['id_person']);

				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama_lengkap']);

				$this->obj_tmpl->addVar('list_data', 'PREFIX', $rs['prefix']);

				$this->obj_tmpl->addVar('list_data', 'SUFFIX', $rs['suffix']);

				$this->obj_tmpl->addVar('list_data', 'CABANG', $rs['cabang']);

				$this->obj_tmpl->addVar('list_data', 'NO_ANGGOTA', $rs['no_anggota']);

				$this->obj_tmpl->addVar('list_data', 'KOTA', $rs['kota']);

				$this->obj_tmpl->addVar('list_data', 'TELEPON', $rs['telepon']);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');

				$no++;

			}

		}

	}

}



?>