<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_cpd;

	protected $obj_notify;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// business object loaded

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);

		// --

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// variable link

		self::DisplayVariableUrl();

		// list data wilayah

		if(isset($this->arr_routes['params'][0]) AND !empty($this->arr_routes['params'][0])){

			switch($this->arr_routes['params'][0]){

				case 'add':

					self::DisplayAddForm();

					$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

					break;

				case 'edit':

					self::DisplayEditForm();

					$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit wilayah</a></li>');

					break;

				default :

					self::DisplayListWilayah();

					$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

					break;

			}

		}else{

			$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

			self::DisplayListWilayah();

		}

		// notifikasi

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariableUrl(){

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));

	}

	

	private function DisplayListWilayah(){

		$rs_id = $this->obj_cpd->GetResourceId("GetListWilayah", array());

		if($rs_id){

			$no = 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('edit', $rec['id_wilayah']));

				$url_member = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'member', array($rec['id_wilayah']));

				$this->obj_tmpl->addVar('list_data', 'NO', $no);	

				$this->obj_tmpl->addVar('list_data', 'INDEX', $no - 1);	

				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_wilayah']);	

				$this->obj_tmpl->addVar('list_data', 'NAMA', $rec['nama']);

				$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $rec['deskripsi']);	

				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $url_edit);	

				$this->obj_tmpl->addVar('list_data', 'URL_MEMBER', $url_member);	

				$this->obj_tmpl->ParseTemplate('list_data', 'a');	

				$no++;

			}

			$this->obj_tmpl->addVar('display', 'TOTAL_DATA', $no - 1);	

		}

	}

	

	private function DisplayEditForm(){

		// set template

		$this->obj_tmpl->addVar('display', 'view', 'edit');	

		// parse data	

		$result = $this->obj_cpd->GetDatasetAsArray("GetDetailWilayahById", array($this->arr_routes['params'][1]));

		if(!empty($result)){

			$this->obj_tmpl->addVar('display', 'ID_WILAYAH', $result[0]['id_wilayah']);	

			$this->obj_tmpl->addVar('display', 'NAMA', $result[0]['nama']);	

			$this->obj_tmpl->addVar('display', 'DESKRIPSI', $result[0]['deskripsi']);	

		}

		// selected kota

		$arr_selected = self::GetSelectedKotaByWilayah();

		// list province

		$rs_id = $this->obj_cpd->GetResourceId("GetListProvinceByCountry", array(360));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_province', 'NAMA', $rec['province_name']);

				// parse city

				$this->obj_tmpl->clearTemplate('list_city');

				$rs_id_city = $this->obj_cpd->GetResourceId("GetListKotaByProvince", array($rec['id_province']));

				if($rs_id_city){

					while($rec_city = mysqli_fetch_assoc($rs_id_city)){

						if(in_array($rec_city['id_city'], $arr_selected))

							$this->obj_tmpl->addVar('list_city', 'SELECTED', 'checked="checked"');

						else

							$this->obj_tmpl->addVar('list_city', 'SELECTED', '');

						$this->obj_tmpl->addVar('list_city', 'VALUE', $rec_city['id_city']);

						$this->obj_tmpl->addVar('list_city', 'NAMA', $rec_city['city_name']);								

						$this->obj_tmpl->ParseTemplate('list_city', 'a');

					}

				}		

				$this->obj_tmpl->ParseTemplate('list_province', 'a');

			}

		}

	}

	

	private function GetSelectedKotaByWilayah(){

		// selected kota

		// parse data	

		$rs_id = $this->obj_cpd->GetResourceId("GetListKotaByWilayah", array($this->arr_routes['params'][1]));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$arr_selected[] = $rec['id_city'];

			}

			return $arr_selected;

		}else{

			return array();

		}

	}

	

	private function DisplayAddForm(){

		// set template

		$this->obj_tmpl->addVar('display', 'view', 'add');	

		// list province

		$rs_id = $this->obj_cpd->GetResourceId("GetListProvinceByCountry", array(360,4));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_province', 'NAMA', $rec['province_name']);

				// parse city

				$this->obj_tmpl->clearTemplate('list_city');

				$rs_id_city = $this->obj_cpd->GetResourceId("GetListKotaByProvince", array($rec['id_province']));

				if($rs_id_city){

					while($rec_city = mysqli_fetch_assoc($rs_id_city)){

						$this->obj_tmpl->addVar('list_city', 'VALUE', $rec_city['id_city']);

						$this->obj_tmpl->addVar('list_city', 'NAMA', $rec_city['city_name']);								

						$this->obj_tmpl->ParseTemplate('list_city', 'a');

					}

				}		

				$this->obj_tmpl->ParseTemplate('list_province', 'a');

			}

		}

	}

}



?>