<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_dashboard;

	protected $obj_chart;

	protected $obj_date;

	protected $obj_paging;

	// var

	protected $color_counter;

	protected $arr_colors;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_dashboard = $this->obj_ctrl->LoadBusiness('dashboard', 'mysql', $this->arr_config['db']);

		$this->obj_dashboard->SetUsesQuery(array("overview"));

		// fusioncharts object loaded

		$param['type'] = '';

		$param['width'] = '';

		$param['height'] = '';

		$param['ID'] = '';

		$this->obj_chart = $this->obj_ctrl->LoadLibrary('FusionCharts', $param);

		// --

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation', $param);

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');	

		// load javascript

		$this->obj_ctrl->LoadJavascript('jquery.popin', 'jquery');	

	}

	

	public function PageView(){		

		// tabel statistik

		self::DisplayVariable();

		// selected display

		self::DisplayChartAndStatistik();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		// arr color

		$this->color_counter=0;

		$this->arr_colors[0] = "1941A5" ;//Dark Blue

		$this->arr_colors[1] = "AFD8F8";

		$this->arr_colors[2] = "F6BD0F";

		$this->arr_colors[3] = "8BBA00";

		$this->arr_colors[4] = "A66EDD";

		$this->arr_colors[5] = "F984A1" ;

		$this->arr_colors[6] = "CCCC00" ;//Chrome Yellow+Green

		$this->arr_colors[7] = "999999" ;//Grey

		$this->arr_colors[8] = "0099CC" ;//Blue Shade

		$this->arr_colors[9] = "FF0000" ;//Bright Red 

		$this->arr_colors[10] = "006F00" ;//Dark Green

		$this->arr_colors[11] = "0099FF"; //Blue (Light)

		$this->arr_colors[12] = "FF66CC" ;//Dark Pink

		$this->arr_colors[13] = "669966" ;//Dirty green

		$this->arr_colors[14] = "7C7CB4" ;//Violet shade of blue

		$this->arr_colors[15] = "FF9933" ;//Orange

		$this->arr_colors[16] = "9900FF" ;//Violet

		$this->arr_colors[17] = "99FFCC" ;//Blue+Green Light

		$this->arr_colors[18] = "CCCCFF" ;//Light violet

		$this->arr_colors[19] = "669900" ;//Shade of green

		// url

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		// sub nav

		$this->obj_tmpl->addVar('content', 'URL_KUNJUNGAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		$this->obj_tmpl->addVar('content', 'URL_CABANG', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('cabang')));

		$this->obj_tmpl->addVar('content', 'URL_WILAYAH', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('wilayah')));

		$this->obj_tmpl->addVar('content', 'URL_KELOMPOK', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('kelompok')));

	}

	

	private function DisplayChartAndStatistik(){

		// define selector

		$selector = '';

		if(isset($this->arr_routes['params'][0])){

			$selector = $this->arr_routes['params'][0];

		}

		// select data to display

		switch($selector){

			case 'cabang':

				$this->obj_tmpl->addVar('content', 'CABANG_ACTIVE', 'class="active"');

				$this->obj_tmpl->addVar('display', 'statistik', 'cabang');

				self::DisplayStatistikCabang();

				break;

			case 'wilayah':

				$this->obj_tmpl->addVar('content', 'WILAYAH_ACTIVE', 'class="active"');

				$this->obj_tmpl->addVar('display', 'statistik', 'wilayah');

				self::DisplayStatistikWilayah();

				break;

			case 'kelompok':

				$this->obj_tmpl->addVar('content', 'KELOMPOK_ACTIVE', 'class="active"');

				$this->obj_tmpl->addVar('display', 'statistik', 'kelompok');

				self::DisplayStatistikKelompok();

				break;

			default :				

				$this->obj_tmpl->addVar('content', 'KUNJUNGAN_ACTIVE', 'class="active"');

				self::DisplayStatistikKunjungan();

				self::DisplayChartKunjungan();

				self::DisplayListPengunjung();

				break;

		}

	}

	

	// kunjungan

	

	private function DisplayStatistikKunjungan(){

		$tahun = date('Y');

		if(isset($this->arr_routes['params'][1])){

			$tahun = $this->arr_routes['params'][1];

		}

		$total = 0;

		// total visit

		$result = $this->obj_dashboard->GetDataAsSingleArray("GetTotalKunjungan", array($tahun));

		$this->obj_tmpl->addVar('display', 'TOTAL', intval($result['total']));

		// forum diskusi

		$result = $this->obj_dashboard->GetDataAsSingleArray("GetTotalDiskusi", array($tahun, $tahun));

		$this->obj_tmpl->addVar('display', 'DISKUSI', intval($result['total']));

		$total = $total + intval($result['total']);

		// e-consultation

		$result = $this->obj_dashboard->GetDataAsSingleArray("GetTotalKonsultasi", array($tahun));

		$this->obj_tmpl->addVar('display', 'KONSULTASI', $result['total']);

		$total = $total + intval($result['total']);

		// mailbox

		$result = $this->obj_dashboard->GetDataAsSingleArray("GetTotalMailbox", array($tahun));

		$this->obj_tmpl->addVar('display', 'MAILBOX', $result['total']);

		$total = $total + intval($result['total']);

		// kritik dan saran

		$result = $this->obj_dashboard->GetDataAsSingleArray("GetTotalKomentar", array($tahun));

		$this->obj_tmpl->addVar('display', 'KOMENTAR', $result['total']);

		$total = $total + intval($result['total']);

		// p2kb

		$result = $this->obj_dashboard->GetDataAsSingleArray("GetTotalP2KB", array($tahun));

		$this->obj_tmpl->addVar('display', 'P2KB', $result['total']);

		$total = $total + intval($result['total']);

		// total keseluruhan

		$this->obj_tmpl->addVar('display', 'TOTAL_ACTION', $total);

	}

	

	private function DisplayChartKunjungan(){

		$this->obj_tmpl->addVar('display', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('kunjungan', '')));

		// start

		$tahun_selected = '';

		$tahun_start = date('Y');

		$tahun = date('Y');

		if(isset($this->arr_routes['params'][1])){

			$tahun = $this->arr_routes['params'][1];

		}

		$this->obj_tmpl->addVar('display', 'TAHUN', $tahun);

		for($i=$tahun_start;$i>=$tahun_start-4;$i--){

			if($i == $tahun){

				$tahun_selected = $i;

				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');

			}else{

				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');

			}

			$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $i);

			$this->obj_tmpl->parseTemplate('list_tahun', 'a');

		}

		// get data

		$rs_id = $this->obj_dashboard->GetResourceId("GetLoginAnggotaPerYear", array($tahun));

		$arr_bulan = array();

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$arr_bulan[$rec['bulan']] = $rec['jumlah'];

			}

		}

		// display chart

		$arr_lang = array('1' => 'Jan', '2' => 'Feb', '3' => 'Mar', '4' => 'Apr', '5' => 'Mei', '6' => 'Jun', '7' => 'Jul', '8' => 'Ags', '9' => 'Sep', '10' => 'Okt', '11' => 'Nov', '12' => 'Des');

		// set chart

		$str_set = "";

		$total = 0;

		foreach($arr_lang as $key => $val){

			// link

			$url_link = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('kunjungan', $tahun, $key));

			// value

			if(isset($arr_bulan[$key]))

				$value = $arr_bulan[$key];

			else

				$value = 0;

			$str_set .= "<set name='".$val."' value='".$value."' link='".$url_link."' />";

			$total = $total + $value;

		}

		// parse chart

		$strXML = "<graph caption='Statistik Tahun ".$tahun_selected."' subcaption='' xAxisName='Bulan' yAxisMinValue='0' yAxisMaxValue='25' yAxisName='Jumlah Kunjungan' decimalPrecision='0' formatNumberScale='0' numberSuffix='' showAlternateHGridColor='1' AlternateHGridColor='ff5904' divLineColor='ff5904' divLineAlpha='20' numdivlines='9' alternateHGridAlpha='4' showValues='0' rotateNames='0' canvasBgColor='faf3dc' hovercapborder='ff5904' hovercapbg='faf3dc' >

   			$str_set

</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_Line");

		$this->obj_tmpl->addVar('display', 'CHART_KUNJUNGAN', renderChartHTML($path_chart, "", $strXML, "ChartExample", 380, 300, false));

	}

	

	private function DisplayListPengunjung(){

		$arr_lang = array('1' => 'Januari', '2' => 'Februari', '3' => 'Maret', '4' => 'April', '5' => 'Mei', '6' => 'Juni', '7' => 'Juli', '8' => 'Agustus', '9' => 'September', '10' => 'Oktober', '11' => 'November', '12' => 'Desember');

		$tahun = date('Y');

		if(isset($this->arr_routes['params'][1])){

			$tahun = $this->arr_routes['params'][1];

			$this->obj_tmpl->addVar('display', 'TAHUN', $tahun);

		}

		$bulan = '-';

		if(isset($this->arr_routes['params'][2]) AND $this->arr_routes['params'][2] != '-'){

			$bulan = $this->arr_routes['params'][2];

			$this->obj_tmpl->addVar('display', 'BULAN', 'Bulan '.$arr_lang[$bulan]);

			$total = $this->obj_dashboard->GetDataAsSingleArray("GetTotalAnggotaByYearMonth", array($tahun, $bulan));

		}else{

			$this->obj_tmpl->addVar('display', 'BULAN', "Tahun");

			$total = $this->obj_dashboard->GetDataAsSingleArray("GetTotalAnggotaByYear", array($tahun));

		}

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][3]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][3];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		if(empty($total))

			$total = 0;

		else

			$total = $total['total'];

		$this->obj_paging->SetTotalRecord($total);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('kunjungan', $tahun, $bulan, '')));

		// set template pagination

		$this->obj_paging->SetTempatePaging('pagination');

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// total visit

		if(isset($this->arr_routes['params'][2]) AND $this->arr_routes['params'][2] != '-'){

			$rs_id = $this->obj_dashboard->GetResourceId("GetListAnggotaByYearMonth", array($tahun, $bulan, $start, $max));

		}else{

			$rs_id = $this->obj_dashboard->GetResourceId("GetListAnggotaByYear", array($tahun, $start, $max));

		}		

		if($rs_id){

			$no = $start + 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_anggota', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'overview', 'statistik', 'detail-anggota', array($rec['id_person'])));

				$this->obj_tmpl->addVar('list_anggota', 'NO', $no);

				$this->obj_tmpl->addVar('list_anggota', 'NAMA', $rec['nama']);

				$this->obj_tmpl->addVar('list_anggota', 'JUMLAH', $rec['jumlah']);

				$this->obj_tmpl->addVar('list_anggota', 'LAST_LOGIN', $this->obj_date->GetShortDate($rec['date_login'] . ' ' . $rec['time_login']));

				$this->obj_tmpl->parseTemplate('list_anggota', 'a');

				$no++;

			}

		}

	}

	

	// cabang

	

	private function DisplayStatistikCabang(){

		// chart

		$str_set = "";

		$result = $this->obj_dashboard->GetDatasetAsArray("GetListCabangMember", array());

		$no = 1;

		foreach($result as $rec){

			// link

			$url_link = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('cabang', $rec['id_cabang']));

			$color = self::getFCColor();

			$str_set .= "<set name='".$rec['nama']."' value='".$rec['jumlah']."' color='".$color."' link='".$url_link."' />";

			$no++;

		}

		$strXML = "<graph caption='' xAxisName='PPNI Cabang' yAxisMinValue='0' yAxisMaxValue='20' yAxisName='Jumlah anggota' decimalPrecision='0' formatNumberScale='0' numberSuffix='' showValues='0' rotateNames='1' >

   					$str_set

				</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_Column3D");

		$this->obj_tmpl->addVar('display', 'CHART_CABANG', renderChartHTML($path_chart, "", $strXML, "ChartExample", 760, 300, false));

		// display data

		$cabang = '';

		if(isset($this->arr_routes['params'][1])){

			$cabang = $this->arr_routes['params'][1];

		}

		// paging

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][2]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][2];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$total = $this->obj_dashboard->GetDataAsSingleArray("GetTotalListMemberByCabang", array($cabang));

		$this->obj_paging->SetTotalRecord($total['total']);

		$this->obj_tmpl->addGlobalVar('TOTAL_ANGGOTA', $total['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('cabang', $cabang, '')));

		// set template pagination

		$this->obj_paging->SetTempatePaging('pagination_cabang');

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$params = array($cabang, $start, $max);

		$rs_id = $this->obj_dashboard->GetResourceId("GetListMemberByCabang", $params);

		if($rs_id){

			$no = $start + 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('pagination_cabang', 'CABANG', $rec['cabang']);

				$this->obj_tmpl->addVar('list_anggota_cabang', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'overview', 'statistik', 'detail-anggota', array($rec['id_person'])));

				$this->obj_tmpl->addVar('list_anggota_cabang', 'NO', $no);

				$this->obj_tmpl->addVar('list_anggota_cabang', 'NO_ANGGOTA', $rec['no_anggota']);

				$this->obj_tmpl->addVar('list_anggota_cabang', 'NAMA', $rec['nama_lengkap']);

				$this->obj_tmpl->addVar('list_anggota_cabang', 'EMAIL', $rec['email']);

				$this->obj_tmpl->addVar('list_anggota_cabang', 'KOTA', $rec['kota']);

				$this->obj_tmpl->parseTemplate('list_anggota_cabang', 'a');

				$no++;

			}

		}

	}

	

	// wilayah

	

	private function DisplayStatistikWilayah(){

		// chart

		$str_set = "";

		$result = $this->obj_dashboard->GetDatasetAsArray("GetListWilayahMember", array());

		$no = 1;

		foreach($result as $rec){

			// link

			$url_link = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('wilayah', $rec['id_wilayah']));

			$color = self::getFCColor();

			$str_set .= "<set name='".$rec['nama']."' value='".$rec['jumlah']."' color='".$color."' link='".$url_link."' />";

			$no++;

		}

		$strXML = "<graph caption='' xAxisName='Wilayah' yAxisMinValue='0' yAxisMaxValue='20' yAxisName='Jumlah anggota' decimalPrecision='0' formatNumberScale='0' numberSuffix='' showValues='0' rotateNames='1' >

   					$str_set

				</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_Column3D");

		$this->obj_tmpl->addVar('display', 'CHART_WILAYAH', renderChartHTML($path_chart, "", $strXML, "ChartExample", 760, 300, false));

		// display data

		$wilayah = '';

		if(isset($this->arr_routes['params'][1])){

			$wilayah = $this->arr_routes['params'][1];

		}

		// paging

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][2]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][2];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$total = $this->obj_dashboard->GetDataAsSingleArray("GetTotalListMemberByWilayah", array($wilayah));

		$this->obj_paging->SetTotalRecord($total['total']);

		$this->obj_tmpl->addGlobalVar('TOTAL_ANGGOTA', $total['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('wilayah', $wilayah, '')));

		// set template pagination

		$this->obj_paging->SetTempatePaging('pagination_wilayah');

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$params = array($wilayah, $start, $max);

		$rs_id = $this->obj_dashboard->GetResourceId("GetListMemberByWilayah", $params);

		if($rs_id){

			$no = $start + 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('pagination_wilayah', 'WILAYAH', $rec['wilayah']);

				$this->obj_tmpl->addVar('list_anggota_wilayah', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'overview', 'statistik', 'detail-anggota', array($rec['id_person'])));

				$this->obj_tmpl->addVar('list_anggota_wilayah', 'NO', $no);

				$this->obj_tmpl->addVar('list_anggota_wilayah', 'NO_ANGGOTA', $rec['no_anggota']);

				$this->obj_tmpl->addVar('list_anggota_wilayah', 'NAMA', $rec['nama_lengkap']);

				$this->obj_tmpl->addVar('list_anggota_wilayah', 'EMAIL', $rec['email']);

				$this->obj_tmpl->addVar('list_anggota_wilayah', 'KOTA', $rec['kota']);

				$this->obj_tmpl->parseTemplate('list_anggota_wilayah', 'a');

				$no++;

			}

		}

	}

	

	// kelompok studi

	

	private function DisplayStatistikKelompok(){

		// chart

		$str_set = "";

		$result = $this->obj_dashboard->GetDatasetAsArray("GetListKelompokMember", array());

		$no = 1;

		foreach($result as $rec){

			// link

			$url_link = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('kelompok', $rec['id_kelompok_studi']));

			$color = self::getFCColor();

			$str_set .= "<set name='".$rec['nama']."' value='".$rec['jumlah']."' color='".$color."' link='".$url_link."' />";

			$no++;

		}

		$strXML = "<graph caption='' xAxisName='Kelompok Studi' yAxisMinValue='0' yAxisMaxValue='20' yAxisName='Jumlah anggota' decimalPrecision='0' formatNumberScale='0' numberSuffix='' showValues='0' rotateNames='1' >

   					$str_set

				</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_Column3D");

		$this->obj_tmpl->addVar('display', 'CHART_KELOMPOK', renderChartHTML($path_chart, "", $strXML, "ChartExample", 760, 300, false));

		// display data

		$kelompok = '';

		if(isset($this->arr_routes['params'][1])){

			$kelompok = $this->arr_routes['params'][1];

		}

		// paging

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][2]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][2];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$total = $this->obj_dashboard->GetDataAsSingleArray("GetTotalListMemberByKelompok", array($kelompok));

		$this->obj_paging->SetTotalRecord($total['total']);

		$this->obj_tmpl->addGlobalVar('TOTAL_ANGGOTA', $total['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('kelompok', $kelompok, '')));

		// set template pagination

		$this->obj_paging->SetTempatePaging('pagination_kelompok');

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$params = array($kelompok, $start, $max);

		$rs_id = $this->obj_dashboard->GetResourceId("GetListMemberByKelompok", $params);

		if($rs_id){

			$no = $start + 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('pagination_kelompok', 'KELOMPOK', $rec['kelompok']);

				$this->obj_tmpl->addVar('list_anggota_kelompok', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'overview', 'statistik', 'detail-anggota', array($rec['id_person'])));

				$this->obj_tmpl->addVar('list_anggota_kelompok', 'NO', $no);

				$this->obj_tmpl->addVar('list_anggota_kelompok', 'NO_ANGGOTA', $rec['no_anggota']);

				$this->obj_tmpl->addVar('list_anggota_kelompok', 'NAMA', $rec['nama_lengkap']);

				$this->obj_tmpl->addVar('list_anggota_kelompok', 'EMAIL', $rec['email']);

				$this->obj_tmpl->addVar('list_anggota_kelompok', 'KOTA', $rec['kota']);

				$this->obj_tmpl->parseTemplate('list_anggota_kelompok', 'a');

				$no++;

			}

		}		

	}

	

	// utility



	private function getFCColor() 

	{

		// Update index

		$this->color_counter++;

		//Return color

		return($this->arr_colors[$this->color_counter % count($this->arr_colors)]);

	}

	

}



?>