<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_dashboard;

	protected $obj_chart;

	protected $obj_paging;

	protected $obj_date;

	// var

	protected $color_counter;

	protected $arr_colors;

	protected $arr_bulan;

	protected $str_tahun_selected;

	protected $str_wilayah_selected = '-';

	protected $str_ranah_selected = '-';

	protected $str_nam_wilayah;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_dashboard = $this->obj_ctrl->LoadBusiness('dashboard', 'mysql', $this->arr_config['db']);

		$loaded_query = array('p2kb');

		$this->obj_dashboard->SetUsesQuery($loaded_query);

		// fusioncharts object loaded

		$param['type'] = '';

		$param['width'] = '';

		$param['height'] = '';

		$param['ID'] = '';

		$this->obj_chart = $this->obj_ctrl->LoadLibrary('FusionCharts', $param);

		// load object pagination

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');	

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// load javascript

		$this->obj_ctrl->LoadJavascript('jquery.popin', 'jquery');	

	}

	

	public function PageView(){

		// variable

		self::DisplayVariable();

		// tahun

		self::DisplayTahun();

		// wilayah

		self::DisplayWilayah();	

		// ranah

		self::DisplayRanah();		

		// statistik aktifitas pencatatan

		self::DisplayAktifitasPencatatan();

		// statistik perbandingan kegiatan dilakukan

		self::DisplayPerbandinganKegiatan();

		// display logo cpd

		self::DisplayLogoCPD();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function getFCColor() 

	{

		// Update index

		$this->color_counter++;

		//Return color

		return($this->arr_colors[$this->color_counter % count($this->arr_colors)]);

	}

	

	private function DisplayVariable(){

		// arr color

		$this->color_counter  = 0;

		$this->arr_colors[0]  = "1941A5"; //Dark Blue

		$this->arr_colors[1]  = "AFD8F8";

		$this->arr_colors[2]  = "F6BD0F";

		$this->arr_colors[3]  = "8BBA00";

		$this->arr_colors[4]  = "A66EDD";

		$this->arr_colors[5]  = "F984A1";

		$this->arr_colors[6]  = "CCCC00"; //Chrome Yellow+Green

		$this->arr_colors[7]  = "999999"; //Grey

		$this->arr_colors[8]  = "0099CC"; //Blue Shade

		$this->arr_colors[9]  = "FF0000"; //Bright Red 

		$this->arr_colors[10] = "006F00"; //Dark Green

		$this->arr_colors[11] = "0099FF"; //Blue (Light)

		$this->arr_colors[12] = "FF66CC"; //Dark Pink

		$this->arr_colors[13] = "669966"; //Dirty green

		$this->arr_colors[14] = "7C7CB4"; //Violet shade of blue

		$this->arr_colors[15] = "FF9933"; //Orange

		$this->arr_colors[16] = "9900FF"; //Violet

		$this->arr_colors[17] = "99FFCC"; //Blue+Green Light

		$this->arr_colors[18] = "CCCCFF"; //Light violet

		$this->arr_colors[19] = "669900"; //Shade of green

		// arr month

		$this->arr_month = array('1' => 'Jan', '2' => 'Feb', '3' => 'Mar', '4' => 'Apr', '5' => 'Mei', '6' => 'Jun', '7' => 'Jul', '8' => 'Ags', '9' => 'Sep', '10' => 'Okt', '11' => 'Nov', '12' => 'Des');

		// url

		$this->obj_tmpl->addVar('content', 'URL_KEGIATAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb'));

		$this->obj_tmpl->addVar('content', 'URL_HASIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb-hasil'));

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	// tahun

	private function DisplayTahun(){

		// display list tahun

		// get tahun

		$result = $this->obj_dashboard->GetDataAsSingleArray("GetTahunMinimalAktifitas", array());

		$tahun_min = $result['tahun'];

		$tahun_now = date('Y');

		// selected tahun 

		if(isset($this->arr_routes['params'][0])){

			$this->str_tahun_selected = $this->arr_routes['params'][0];

		}else{

			$this->str_tahun_selected = $tahun_now;

		}

		for($tahun=$tahun_now;$tahun>=$tahun_min;$tahun--){

			if($tahun == $this->str_tahun_selected)

				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');	

			else

				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');

			$this->obj_tmpl->addVar('list_tahun', 'VALUE', $tahun);

			$this->obj_tmpl->parseTemplate('list_tahun', 'a');

		}

	}

	

	// wilayah

	private function DisplayWilayah(){

		// selected tahun 

		if(isset($this->arr_routes['params'][1])){

			$this->str_wilayah_selected = $this->arr_routes['params'][1];

		}else{

			$this->str_wilayah_selected = '-';

		}

		// parse data

		$rs_id = $this->obj_dashboard->GetResourceId("GetListWilayah", array());

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				if($rec['id_wilayah'] == $this->str_wilayah_selected){

					$this->str_nam_wilayah = strtoupper($rec['nama']);

					$this->obj_tmpl->addVar('content', 'WILAYAH', strtoupper($rec['nama']));

					$this->obj_tmpl->addVar('list_wilayah', 'SELECTED', 'selected="selected"');

				}else{

					$this->obj_tmpl->addVar('list_wilayah', 'SELECTED', '');

				}

				$this->obj_tmpl->addVar('list_wilayah', 'ID', $rec['id_wilayah']);

				$this->obj_tmpl->addVar('list_wilayah', 'NAMA', $rec['nama']);

				$this->obj_tmpl->parseTemplate('list_wilayah', 'a');

			}

		}

	}

	

	// ranah

	private function DisplayRanah(){

		// selected tahun 

		if(isset($this->arr_routes['params'][2])){

			$str_ranah_selected = $this->arr_routes['params'][2];

		}else{

			$str_ranah_selected = '-';

		}

		// parse data

		$rs_id = $this->obj_dashboard->GetResourceId("GetListRanah", array());

		if($rs_id){

			$tmp = '';

			while($rec = mysqli_fetch_assoc($rs_id)){

				if($rec['id_ranah'] == $str_ranah_selected){

					$this->str_ranah_selected = $rec['id_ranah'];

					$this->obj_tmpl->addVar('list_ranah', 'SELECTED', 'selected="selected"');

				}else{

					if(empty($tmp) AND $this->str_ranah_selected == '-'){

						$tmp = $rec['id_ranah'];

						$this->str_ranah_selected = $tmp;

					}

					$this->obj_tmpl->addVar('list_ranah', 'SELECTED', '');

				}

				$this->obj_tmpl->addVar('list_ranah', 'ID', $rec['id_ranah']);

				$this->obj_tmpl->addVar('list_ranah', 'ALPHABET', $rec['alphabet']);

				$this->obj_tmpl->addVar('list_ranah', 'NAMA', $rec['nama']);

				$this->obj_tmpl->parseTemplate('list_ranah', 'a');

			}

		}

		$this->obj_tmpl->addVar('content', 'RANAH', $this->str_ranah_selected);

		// url ranah

		$this->obj_tmpl->addVar('content', 'URL_RANAH', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->str_tahun_selected, $this->str_wilayah_selected, '')));

	}

	

	// perbandingan str, persetujuan dan surat rekomendasi	

	private function DisplayPerbandinganKegiatan(){

		// get data

		if($this->str_wilayah_selected == '-')

			$rs_id = $this->obj_dashboard->GetResourceId("GetListKegiatanDilakukan", array($this->str_tahun_selected, $this->str_ranah_selected));

		else

			$rs_id = $this->obj_dashboard->GetResourceId("GetListKegiatanDilakukanByWilayah", array($this->str_tahun_selected, $this->str_wilayah_selected, $this->str_ranah_selected));

		// parse data

		if($rs_id){

			$no = 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_kegiatan', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'detail-p2kb-kegiatan', array($this->str_tahun_selected, $this->str_wilayah_selected, $rec['id_kegiatan'])));

				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no);

				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA_KEGIATAN', $rec['nama']);

				if(empty($rec['jumlah']))

					$jumlah = $rec['jumlah'];

				else

					$jumlah = "<b>".$rec['jumlah']."</b>";

				$this->obj_tmpl->addVar('list_kegiatan', 'JUMLAH', $jumlah);

				$this->obj_tmpl->parseTemplate('list_kegiatan', 'a');

				$no++;

			}

		}

	}

	

	// kegiatan setiap tahun	

	private function DisplayAktifitasPencatatan(){

		$str_set = '';

		// display chart

		if($this->str_wilayah_selected != '-'){

			$rs_id = $this->obj_dashboard->GetResourceId("GetTotalAktifitasPerBulanWilayah", array($this->str_tahun_selected, $this->str_wilayah_selected));

		}else{

			$rs_id = $this->obj_dashboard->GetResourceId("GetTotalAktifitasPerBulan", array($this->str_tahun_selected));

		}

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$arr_data[$rec['bulan']] = $rec['jumlah'];

			}

		}

		// parse str

		foreach($this->arr_month as $key => $val){

			if(isset($arr_data[$key]))

				$value = $arr_data[$key];

			else

				$value = '0';

			$color = self::getFCColor();

			$str_set .= "<set name='".$val."' value='".$value."' color='".$color."' />";

		}

		$strXML = "<graph caption='Kegiatan P2KB Anggota ".$this->str_nam_wilayah."' subcaption='Tahun ".$this->str_tahun_selected."' xAxisName='Bulan' yAxisMinValue='0' yAxisMaxValue='20' yAxisName='Jumlah Kegiatan' decimalPrecision='0' formatNumberScale='0' numberSuffix='' showValues='0' rotateNames='1'>

   					$str_set

				</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_Column3D");

		$this->obj_tmpl->addVar('content', 'CHART_AKTIFITAS', renderChartHTML($path_chart, "", $strXML, "", 380, 300, false));

	}

	

	// display logo p2kb	

	private function DisplayLogoCPD(){

		$this->obj_tmpl->addVar('layout', 'CPD_LOGO', 'P2KB Online');

	}

	

}



?>