<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_cpd;

	protected $obj_date;

	protected $obj_chart;	

	// variable definition

	protected $arr_search;

	protected $int_periode;

	protected $int_tahun;

	protected $str_tgl_mulai;

	protected $str_tgl_selesai;

	protected $str_periode_mulai;

	protected $str_periode_selesai;

	protected $arr_ranah = array();

	protected $arr_ranah_all = array();

	protected $arr_note = array();

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* -- Other object loaded below */

		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);

		$loaded_query = array('dashboard', 'kegiatan', 'evaluasi');

		$this->obj_cpd->SetUsesQuery($loaded_query);

		// --

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		// loaded javascript

		$this->obj_ctrl->LoadJavascript('fusioncharts');

		// fusioncharts object loaded

		$param['type'] = '';

		$param['width'] = '';

		$param['height'] = '';

		$param['ID'] = '';

		$this->obj_chart = $this->obj_ctrl->LoadLibrary('FusionCharts', $param);

	}

	

	public function PageView(){	

		// display default log

		self::GetVariableBukuLog();

		// display periode buku log

		self::DisplayPeriodeBukuLog();

		// display List Kegiatan

		self::DisplayListTableRanah();

		// ---------

		self::DisplayTableTotalNilai();

		self::DisplayVariableKeseluruhan();		

		// display chart Kegiatan

		self::DisplayChartKegiatan();

		// display chart Kegiatan

		self::DisplayChartTimeline();

		// Variable

		self::DisplayVariable();

		// display logo cpd

		self::DisplayLogoCPD();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		// variable

		$this->obj_tmpl->addVar('content', 'URL_STR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode'));

		$this->obj_tmpl->addVar('content', 'URL_BORANG', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'cpd', 'borang', 'isian'));

		$this->obj_tmpl->addVar('content', 'URL_LOG', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'cpd', 'buku', 'log', array($this->int_periode)));

		// --

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

	}

	

	private function GetVariableBukuLog(){

		// cari periode

		if(!isset($this->arr_routes['params'][0])){

			$str_default_periode = date('Y') . '-' . date('m') . '-' . date('d');

			$result = $this->obj_cpd->GetDataAsSingleArray("GetDefaultPeriodeByPerson", array($this->str_userid, $str_default_periode));

			if(!empty($result)){

				// int periode

				$this->int_periode = $result['id_periode'];

				// int tahun

				$this->int_tahun = $result['id_tahun_periode'];

				$this->str_tgl_mulai = $result['tgl_mulai'];

				$this->str_tgl_selesai = $result['tgl_selesai'];

			}

		}else{

			// int periode

			$this->int_periode = $this->arr_routes['params'][0];

			// tahun

			if(isset($this->arr_routes['params'][1])){

				$this->int_tahun = $this->arr_routes['params'][1];

				$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeKegiatanBySelected", array($this->str_userid, $this->int_tahun));		

				// set batasan tanggal

				$this->str_tgl_mulai = $result['tgl_mulai'];

				$this->str_tgl_selesai = $result['tgl_selesai'];

			}else{

				// cari tahun pertama dulu

				$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeKegiatanByPeriode", array($this->str_userid, $this->int_periode));

				$this->int_tahun = $result['id_tahun_periode'];

				// set batasan tanggal

				$this->str_tgl_mulai = $result['tgl_mulai'];

				$this->str_tgl_selesai = $result['tgl_selesai'];

			}

		}		

		// validated parameter anda redirected

		if(empty($this->int_periode) OR empty($this->int_tahun) OR empty($this->str_tgl_mulai) OR empty($this->str_tgl_selesai)){

			// redirect to buku log

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode');

		}

	}

	

	private function DisplayPeriodeBukuLog(){

		// display detail periode

		$rs_str = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));

		$this->str_periode_mulai = $rs_str['tgl_mulai'];

		$this->str_periode_selesai = $rs_str['tgl_selesai'];

		$this->obj_tmpl->addVar('content', 'TAHUN_STR', $rs_str['mulai'] . ' - ' . $rs_str['selesai']);

		// diaplay tahun kegiatan

		$rs_id =  $this->obj_cpd->GetResourceId("GetListTahunPeriodeById", array($this->str_userid, $this->int_periode));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				// --

				$this->obj_tmpl->addVar('list_tahun', 'VALUE', $this->int_periode . '/' .$rec['id_tahun_periode'] . '/');

				// parse data

				$lbl= $this->obj_date->GetFullDate($rec['tgl_mulai']).' s/d '.$this->obj_date->GetFullDate($rec['tgl_selesai']);

				if($this->int_tahun == $rec['id_tahun_periode']){

					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');

					// selected tahun kegiatan

					$this->obj_tmpl->addVar('content', 'TAHUN_PERIODE', $lbl);

					// get array ranah tahun

					$this->arr_ranah = self::GetNilaiByTanggal($this->str_userid, $rec['tgl_mulai'], $rec['tgl_selesai']);

					// end of selected

				}else{

					// get array ranah periode

					self::GetNilaiByTanggal($this->str_userid, $rec['tgl_mulai'], $rec['tgl_selesai']);

					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');

				}

				$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $rec['tahun'] . '/' . ($rec['tahun'] + 1));

				$this->obj_tmpl->ParseTemplate('list_tahun', 'a');

			}

		}

	}

	

	private function GetNilaiByTanggal($id_person, $str_tgl_mulai, $str_tgl_selesai){

		$total = 0;

		$arr_ranah_selected = array();

		// parameter

		$params = array($id_person, $str_tgl_mulai, $str_tgl_selesai);

		// get data

		$rs_id = $this->obj_cpd->GetResourceId("GetEvaluatedP2KBGroupByForm", $params);

		// parse data

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				// set ranah

				if(!isset($this->arr_ranah_all[$rec['ranah']])){$this->arr_ranah_all[$rec['ranah']] = 0;}

				if(!isset($arr_ranah_selected[$rec['ranah']])){$arr_ranah_selected[$rec['ranah']] = 0;}

				// get nilai skp

				if($rec['tipe'] == 'rutin')

					$nilai = self::GetNilaiSkpRutin($id_person, $rec['id_form'], $str_tgl_mulai, $str_tgl_selesai);

				else

					$nilai = $rec['nilai'];

				// tabel by ranah

				$this->arr_ranah_all[$rec['ranah']] = $this->arr_ranah_all[$rec['ranah']] + $nilai;	

				$arr_ranah_selected[$rec['ranah']] = $arr_ranah_selected[$rec['ranah']] + $nilai;	

			}

		}

		return $arr_ranah_selected;

	}

	

	private function GetNilaiSkpRutin($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai){

		$nilai = 0;

		$jumlah = 0;

		// get parameter and indikator

		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));

		$id_parameter = $arr['parameter'];

		$id_engine = $arr['indikator'];

		// get nilai dalam range tahun kegiatannya

		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$arr_field = "";

				$xml = simplexml_load_string($rec["data_kegiatan"]);

				// echo does the casting for you

				$count = count($xml->item);

				for($i=0;$i<$count;$i++){

					$id = intval($xml->item[$i]->idt);

					$value = strval($xml->item[$i]->value);

					if($id == $id_parameter){

						$jumlah = $jumlah + $value;

						break;

					}

				}

			}

		}

		// get list elemen

		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));

		if($rs_id_list){

			$group_list = "FIND_IN_SET(0, group_elemen_list)";

			while($rec = mysqli_fetch_assoc($rs_id_list)){

				$range_value = explode('-', $rec['list_value'], 2);

				if(sizeof($range_value) >= 2){

					$batas_bawah = round($range_value[0], 2);

					$batas_atas = round($range_value[1], 2);

				}else{

					$batas_bawah = 0;

					$batas_atas = 0;

				}	

				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){

					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";

					break;

				}

			}

		}

		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	

		if(!empty($nilai))

			return $nilai['nilai_skp'];

		else

			return 0;

	}

	

	private function DisplayIndicator($nilai, $min, $max){

		if(empty($max)){ $max = 999999;}

		if(empty($nilai)){ $nilai = 0.000001; }

		// set pre value

		$min_pre = $min - ($min * 15/100);

		$max_pre = $max + ($max * 15/100);		

		// switch nilai anda get indicator

		switch($nilai){

				case ($nilai >= $min) AND ($nilai <= $max):

				$this->arr_note[] = 1;

				$img = 'greedin-ico.jpg';

				break;	

			

			case ($nilai > $max) AND ($nilai <= $max_pre):

				$this->arr_note[] = 2;

				$img = 'greedin-ico.jpg';

				break;

			case ($nilai >= $min_pre) AND ($nilai < $max_pre):

				$this->arr_note[] = 2;

				$img = 'orangin-ico.jpg';

				break;

			case ($nilai <= 0):

				$this->arr_note[] = 3;

				$img = 'redin-ico.jpg';

				break;

			case ($nilai >= 1) AND ($nilai < $max_pre):

				$this->arr_note[] = 1;

				$img = 'orangin-ico.jpg';

				break;			

			case ($nilai > $max_pre):

				$this->arr_note[] = 2;

				$img = 'greedin-ico.jpg';

				break;

			default:

				$this->arr_note[] = 3;

				$img = 'redin-ico.jpg';

				break;

			/*case ($nilai >= $min) AND ($nilai <= $max):

				$this->arr_note[] = 1;

				$img = 'greedin-ico.jpg';

				break;				

			case ($nilai > $max) AND ($nilai <= $max_pre):

				$this->arr_note[] = 2;

				$img = 'orangin-ico.jpg';

				break;

			case ($nilai >= $min_pre) AND ($nilai < $min):

				$this->arr_note[] = 2;

				$img = 'orangin-ico.jpg';

				break;

			case ($nilai < $min_pre):

				$this->arr_note[] = 3;

				$img = 'redin-ico.jpg';

				break;

			case ($nilai > $max_pre):

				$this->arr_note[] = 2;

				$img = 'orangin-ico.jpg';

				break;

			default:

				$this->arr_note[] = 3;

				$img = 'redin-ico.jpg';

				break;*/

		}

		return $img;

	}

	

	private function DisplayListTableRanah(){

		$rs_id = $this->obj_cpd->GetResourceId("GetListRanah", array());

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				if(!isset($this->arr_ranah[$rec['alphabet']])){$this->arr_ranah[$rec['alphabet']] = 0;}

				$this->obj_tmpl->addVar('list_ranah', 'ALPHABET', $rec['alphabet']);

				$this->obj_tmpl->addVar('list_ranah', 'NAMA', $rec['nama']);

				if(empty($rec['batas_bawah']))

					$this->obj_tmpl->addVar('list_ranah', 'BAWAH', '-');

				else

					$this->obj_tmpl->addVar('list_ranah', 'BAWAH', $rec['batas_bawah'] / 5);

				if(empty($rec['batas_atas']))

					$this->obj_tmpl->addVar('list_ranah', 'ATAS', '-');

				else

					$this->obj_tmpl->addVar('list_ranah', 'ATAS', $rec['batas_atas'] / 5);

				$this->obj_tmpl->addVar('list_ranah', 'TOTAL', $this->arr_ranah[$rec['alphabet']]);

				$this->obj_tmpl->addVar('list_ranah', 'ICON', self::DisplayIndicator(round($this->arr_ranah[$rec['alphabet']], 2), $rec['batas_bawah'] / 5, $rec['batas_atas'] / 5));			





				$this->obj_tmpl->ParseTemplate('list_ranah', 'a');

			}

		}			

		$this->obj_tmpl->addVar('content', 'TOTAL_NILAI', array_sum($this->arr_ranah));

		// parse auto note

		

		//$note = array_sum($this->arr_note);//defult Aplikasi

		

		$note = array_sum($this->arr_ranah);

		//print_r($this->arr_ranah);

		//echo $note;

		if ($note < 21) {

		$this->obj_tmpl->addVar('content', 'AUTO_NOTE', 'Nilai yang dicapai <strong>belum</strong> memenuhi porsi yang diharapkan.');

		}elseif ($note >=21){

		$this->obj_tmpl->addVar('content', 'AUTO_NOTE', 'Nilai yang dicapai <strong>telah memenuhi</strong> porsi yang diharapkan.');

		}

		/*switch($note){

			case $note <= 5:

				$this->obj_tmpl->addVar('content', 'AUTO_NOTE', 'Nilai yang dicapai <strong>telah memenuhi</strong> porsi yang diharapkan.');

				break;

			default:

				$this->obj_tmpl->addVar('content', 'AUTO_NOTE', 'Nilai yang dicapai <strong>belum</strong> memenuhi porsi yang diharapkan.');

				break;

		}*/

	}

	

	private function DisplayTableTotalNilai(){

		// parse data	

		$rs_id = $this->obj_cpd->GetResourceId("GetListRanah", array());

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				if(!isset($this->arr_ranah_all[$rec['alphabet']])){$this->arr_ranah_all[$rec['alphabet']] = 0;}

				$this->obj_tmpl->addVar('list_ranah_all', 'ALPHABET', $rec['alphabet']);

				$this->obj_tmpl->addVar('list_ranah_all', 'NAMA', $rec['nama']);

				if(empty($rec['batas_bawah']))

					$this->obj_tmpl->addVar('list_ranah_all', 'BAWAH', '-');

				else

					$this->obj_tmpl->addVar('list_ranah_all', 'BAWAH', $rec['batas_bawah']);

				if(empty($rec['batas_atas']))

					$this->obj_tmpl->addVar('list_ranah_all', 'ATAS', '-');

				else

					$this->obj_tmpl->addVar('list_ranah_all', 'ATAS', $rec['batas_atas']);

				$this->obj_tmpl->addVar('list_ranah_all', 'TOTAL', $this->arr_ranah_all[$rec['alphabet']]);

				$this->obj_tmpl->addVar('list_ranah_all', 'ICON', self::DisplayIndicator(round($this->arr_ranah_all[$rec['alphabet']], 2), $rec['batas_bawah'], $rec['batas_atas']));

				$this->obj_tmpl->ParseTemplate('list_ranah_all', 'a');

			}

		}		

		$this->obj_tmpl->addVar('content', 'TOTAL_NILAI_ALL', array_sum($this->arr_ranah_all));

		// parse auto note

		//$note = array_sum($this->arr_note); //defult Aplikasi

		$note = array_sum($this->arr_ranah_all);

		if($note < 150) {

						$this->obj_tmpl->addVar('content', 'AUTO_NOTE_ALL', 'Nilai yang dicapai <strong>belum</strong> memenuhi porsi yang diharapkan.');

		} elseif($note>=150) {					

						$this->obj_tmpl->addVar('content', 'AUTO_NOTE_ALL', 'Nilai yang dicapai <strong>telah memenuhi</strong> porsi yang diharapkan.');

				}

							

		/*switch($note){

			case $note <= 5:

				$this->obj_tmpl->addVar('content', 'AUTO_NOTE_ALL', 'Nilai yang dicapai <strong>telah memenuhi</strong> porsi yang diharapkan.');

				break;

			default:

				$this->obj_tmpl->addVar('content', 'AUTO_NOTE_ALL', 'Nilai yang dicapai <strong>belum</strong> memenuhi porsi yang diharapkan.');

				break;

		}*/

	}

	

	private function DisplayChartKegiatan(){

		$params = array($this->str_userid, $this->str_tgl_mulai, $this->str_tgl_selesai);

		// get data

		$rs_id = $this->obj_cpd->GetResourceId("GetEvaluatedBukuLogChartBySearchIdPerson", $params);

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$arr_result[$rec['ranah']][$rec['evaluated']] = $rec['total'];

			}

		}

		$str_cat = "";

		$str_accept = "";

		$str_reject = "";

		$str_wait = "";

		$total_kegiatan = 0;

		$url_log = $this->obj_ctrl->GetUrl('private', 'cpd', 'buku', 'log', array($this->int_periode));

		foreach($this->arr_ranah as $ranah => $val){

			$str_cat .= "<category name='".$ranah."' />";

			if(isset($arr_result[$ranah]['yes'])){

				$total_kegiatan = $total_kegiatan + $arr_result[$ranah]['yes'];

				$str_accept .= "<set value='".$arr_result[$ranah]['yes']."' link='".$url_log."' /> ";

			}else{

				$str_accept .= "<set value='0' link='".$url_log."' /> ";

			}

			if(isset($arr_result[$ranah]['no'])){

				$total_kegiatan = $total_kegiatan + $arr_result[$ranah]['no'];

				$str_reject .= "<set value='".$arr_result[$ranah]['no']."' link='".$url_log."' /> ";

			}else{

				$str_reject .= "<set value='0' link='".$url_log."' /> ";

			}

			if(isset($arr_result[$ranah]['wait'])){

				$total_kegiatan = $total_kegiatan + $arr_result[$ranah]['wait'];

				$str_wait .= "<set value='".$arr_result[$ranah]['wait']."' link='".$url_log."' /> ";

			}else{

				$str_wait .= "<set value='0' link='".$url_log."' /> ";

			}

		}

		// total_kegiatan

		$this->obj_tmpl->addVar('content', 'TOTAL_KEGIATAN', $total_kegiatan);

		// --

		$caption = $this->obj_date->GetFullDate($this->str_tgl_mulai, "ins");

		$caption .= " s/d ";

		$caption .= $this->obj_date->GetFullDate($this->str_tgl_selesai, "ins");

		$strXML = "<graph caption='Periode tahun kegiatan' subcaption='".$caption."' xAxisName='Ranah kegiatan' yAxisMinValue='0' yAxisMaxValue='15' yAxisName='Jumlah kegiatan' decimalPrecision='0' formatNumberScale='0' numberSuffix='' showAlternateHGridColor='1' AlternateHGridColor='ff5904' divLineColor='ff5904' divLineAlpha='20' alternateHGridAlpha='5' showValues='0' rotateNames='0' canvasBgColor='faf3dc' hovercapborder='ff5904' hovercapbg='faf3dc' >

   <categories>

      $str_cat

   </categories>

   <dataset seriesname='Accepted' color='89C47D' showValues='0' areaAlpha='50' showAreaBorder='1' areaBorderThickness='2' areaBorderColor='FF0000'>

      $str_accept 

   </dataset>

   <dataset seriesname='Rejected' color='FA5656' showValues='0' areaAlpha='50' showAreaBorder='1' areaBorderThickness='2' areaBorderColor='006600'>

      $str_reject

   </dataset>

   <dataset seriesname='Waiting' color='F1CE41' showValues='0' areaAlpha='50' showAreaBorder='1' areaBorderThickness='2' areaBorderColor='006600'>

      $str_wait

   </dataset>

</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_StackedColumn2D");

		$this->obj_tmpl->addVar('content', 'RANAH_CHART', renderChartHTML($path_chart, "", $strXML, "ChartExample", 380, 230, false));

	}	

	

	private function DisplayChartTimeline(){

		// parameter

		$params = array($this->str_userid, $this->str_tgl_mulai, $this->str_tgl_selesai);

		// get data

		$rs_id = $this->obj_cpd->GetResourceId("GetPeriodeBukuLogBySearchIdPerson", $params);

		// parse data

		$total = 0;

		$nilai_rutin = 0;

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$nilai= 0;

				// get nilai skp

				if($rec['tipe'] != 'rutin'){

					$nilai = $rec['nilai_skp'];

				}else{

					// get form

					$form[$rec['id_form']] = true;

				}

				if(isset($val_bulan[$rec['tahun']][$rec['bulan']]))

					$val_bulan[$rec['tahun']][$rec['bulan']] = $val_bulan[$rec['tahun']][$rec['bulan']] + $nilai;

				else

					$val_bulan[$rec['tahun']][$rec['bulan']] = $nilai;			

			}

		}

		// get value rutin

		if(isset($form)){

			foreach($form as $key => $val){

				$nilai_rutin = $nilai_rutin + self::GetNilaiSkpRutin($this->str_userid, $key, $this->str_tgl_mulai, $this->str_tgl_selesai);

			}

		}

		$arr_lang = array('1' => 'Jan', '2' => 'Feb', '3' => 'Mar', '4' => 'Apr', '5' => 'Mei', '6' => 'Jun', '7' => 'Jul', '8' => 'Ags', '9' => 'Sep', '10' => 'Okt', '11' => 'Nov', '12' => 'Des');

		$caption = $this->obj_date->GetFullDate($this->str_tgl_mulai, "ins");

		$caption .= " s/d ";

		$caption .= $this->obj_date->GetFullDate($this->str_tgl_selesai, "ins");

		// get data

		$str_set = "";

		$start = explode('-', $this->str_tgl_mulai);

		if(sizeof($start) > 2){

			$bulan = intval($start[1]);

			$tahun = intval($start[0]);

		}else{

			$bulan = date('m');

			$tahun = date('Y');

		}

		for($i=intval($bulan);$i<=intval($bulan)+12;$i++){

			if($i > 12){

				$tahun = intval($start[0]) + 1;

				$month = $i - 12;

			}else{

				$month = $i;

			}			

			if(isset($val_bulan[$tahun][$month]))

				$value = $val_bulan[$tahun][$month];

			else

				$value = 0;

			$last_score = $value + $nilai_rutin;

			if($i == ($bulan + 12))

				$str_set .= "<set name='".$arr_lang[$month]."' value='".$last_score."' />";

			else

				$str_set .= "<set name='".$arr_lang[$month]."' value='".$value."' />";

		}

		// parse chart

		$strXML = "<graph caption='Periode tahun kegiatan' subcaption='".$caption."' xAxisName='Bulan' yAxisMinValue='0' yAxisMaxValue='15' yAxisName='Nilai SKP' decimalPrecision='2' formatNumberScale='0' numberSuffix='' showAlternateHGridColor='1' AlternateHGridColor='ff5904' divLineColor='ff5904' divLineAlpha='20' alternateHGridAlpha='5' showValues='0' rotateNames='1' canvasBgColor='faf3dc' hovercapborder='ff5904' hovercapbg='faf3dc' >

   			$str_set

</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_Line");

		$this->obj_tmpl->addVar('content', 'TIMELINE_CHART', renderChartHTML($path_chart, "", $strXML, "ChartExample", 380, 230, false));

	}

	

	private function DisplayVariableKeseluruhan(){

		$result = $this->obj_cpd->GetDatasetAsArray("GetTotalKegiatanP2KBByPerson", array($this->str_userid, $this->str_periode_mulai, $this->str_periode_selesai));

		$this->obj_tmpl->addVar('content', 'TOTAL_SELURUH_KEGIATAN', $result[0]['total']);

		$result = $this->obj_cpd->GetDatasetAsArray("GetTotalLampiranDokumenByPerson", array($this->str_userid, $this->int_periode));

		$this->obj_tmpl->addVar('content', 'TOTAL_DOKUMEN', $result[0]['total']);

		$result = $this->obj_cpd->GetDatasetAsArray("GetTotalCatatanByPerson", array($this->str_userid, $this->int_periode));

		$this->obj_tmpl->addVar('content', 'TOTAL_CATATAN', $result[0]['total']);

	}

	

	// display logo cpd

	private function DisplayLogoCPD(){

		$this->obj_tmpl->addVar('layout', 'CPD_LOGO', 'P2KB Online');

	}

	

}



?>