<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object

	protected $obj_dashboard;

	protected $obj_chart;

	// variable

	protected $str_selected;

	protected $arr_month;

	protected $int_total_inbox;

	protected $int_total_sent;

	protected $int_total_history;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_dashboard = $this->obj_ctrl->LoadBusiness('dashboard', 'mysql', $this->arr_config['db']);

		$this->obj_dashboard->SetUsesQuery(array("personal"));

		// fusioncharts object loaded

		$param['type'] = '';

		$param['width'] = '';

		$param['height'] = '';

		$param['ID'] = '';

		$this->obj_chart = $this->obj_ctrl->LoadLibrary('FusionCharts', $param);

	}

	

	public function PageView(){

		// tabel statistik

		self::DisplayVariable();

		// tabel statistik

		self::DisplayTableStatistik();

		// grafik login

		self::DisplayChartLogin();

		// grafik login

		self::DisplayChartAll();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		$this->arr_month = array('1' => 'Jan', '2' => 'Feb', '3' => 'Mar', '4' => 'Apr', '5' => 'Mei', '6' => 'Jun', '7' => 'Jul', '8' => 'Ags', '9' => 'Sep', '10' => 'Okt', '11' => 'Nov', '12' => 'Des');

		// --

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));	

	}

	

	// login activities

	private function DisplayChartLogin(){

		$arr_data = array();

		// --

		$rs_id=$this->obj_dashboard->GetResourceId("GetListTotalLoginByPerson", array($this->str_userid, $this->str_selected));

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$arr_data[$rs['bulan']] = $rs['total'];

			}			

		}

		$str_set = "";

		foreach($this->arr_month as $key => $val){

			if(isset($arr_data[$key]))

				$value = $arr_data[$key];

			else

				$value = '';

			$str_set .= "<set name='".$val."' value='".$value."' />";

		}

		$strXML = "<graph caption='Tahun ".$this->str_selected."' xAxisName='Bulan' yAxisMinValue='0' yAxisMaxValue='30' yAxisName='Jumlah' decimalPrecision='0' formatNumberScale='0' numberSuffix='' showAlternateHGridColor='1' AlternateHGridColor='CCCCCC' numdivlines='5' divLineColor='CCCCCC' divLineAlpha='80' alternateHGridAlpha='30' showValues='1' rotateNames='0' hovercapborder='889E6D' hovercapbg='DEDEBE' >

   					$str_set

				</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_Line");

		$this->obj_tmpl->addVar('content', 'CHART_LOGIN', renderChartHTML($path_chart, "", $strXML, "", 380, 205, false));

	}

	

	private function DisplayTableStatistik(){

		// parse tahun

		if(isset($this->arr_routes['params'][0])) 

			$this->str_selected = $this->arr_routes['params'][0];

		else

			$this->str_selected = date('Y');

		$arr_data = $this->obj_dashboard->GetDatasetAsArray("GetYearLoginByPerson", array($this->str_userid));

		foreach($arr_data as $rec){

			if($this->str_selected == $rec['tahun'])

				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');	

			else

				$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'tahun');	

			$this->obj_tmpl->addVar('list_tahun', 'VALUE', $rec['tahun']);	

			$this->obj_tmpl->addVar('list_tahun', 'LABEL', $rec['tahun']);	

			$this->obj_tmpl->parseTemplate('list_tahun', 'a');	

		}		

		// rangkuman

		$rs_id = $this->obj_dashboard->GetResourceId("GetStatistikDataByPerson", array($this->str_userid, $this->str_userid, $this->str_userid, $this->str_userid, $this->str_userid, $this->str_userid, $this->str_userid));

		if($rs_id){

			while($rec = mysql_fetch_row($rs_id)){

				$this->obj_tmpl->addVar('list_statistik', 'NAME', $rec[0]);

				$this->obj_tmpl->addVar('list_statistik', 'COUNT', $rec[1]);

				$this->obj_tmpl->ParseTemplate('list_statistik', 'a');

			}			

		}

	}



	private function DisplayChartAll(){

		// dashboard rangkuman per tahun

		$arr_data = array();

		// comment

		$rs_id = $this->obj_dashboard->GetResourceId("GetListCommentByPersonYear", array($this->str_userid, $this->str_selected));

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$arr_data[$rs['bulan']] = $rs['total'];

			}			

		}

		$str_comment = "";

		foreach($this->arr_month as $key => $val){

			if(isset($arr_data[$key]))

				$value = $arr_data[$key];

			else

				$value = '';

			$str_comment .= "<set value='".$value."' />";

		}

		// mailbox

		$arr_data = array();

		$rs_id = $this->obj_dashboard->GetResourceId("GetListMailboxByPersonYear", array($this->str_userid, $this->str_selected, $this->str_userid, $this->str_selected));

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$arr_data[$rs['bulan']] = $rs['total'];

			}			

		}

		$str_mailbox = "";

		foreach($this->arr_month as $key => $val){

			if(isset($arr_data[$key]))

				$value = $arr_data[$key];

			else

				$value = '';

			$str_mailbox .= "<set value='".$value."' />";

		}

		// konsultasi

		$arr_data = array();

		$rs_id = $this->obj_dashboard->GetResourceId("GetListKonsultasiByPersonYear", array($this->str_userid, $this->str_selected));

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$arr_data[$rs['bulan']] = $rs['total'];

			}			

		}

		$str_konsultasi = "";

		foreach($this->arr_month as $key => $val){

			if(isset($arr_data[$key]))

				$value = $arr_data[$key];

			else

				$value = '';

			$str_konsultasi .= "<set value='".$value."' />";

		}

		// diskusi

		$arr_data = array();

		$rs_id = $this->obj_dashboard->GetResourceId("GetListDiskusiByPersonYear", array($this->str_userid, $this->str_selected, $this->str_userid, $this->str_selected));

		if($rs_id){

			while($rs = mysqli_fetch_assoc($rs_id)){

				$arr_data[$rs['bulan']] = $rs['total'];

			}			

		}

		$str_diskusi = "";

		foreach($this->arr_month as $key => $val){

			if(isset($arr_data[$key]))

				$value = $arr_data[$key];

			else

				$value = '';

			$str_diskusi .= "<set value='".$value."' />";

		}		

		$strXML = "<graph xaxisname='Fasilitas' yaxisname='Jumlah' hovercapbg='DEDEBE' hovercapborder='889E6D' rotateNames='0' yAxisMaxValue='30' numdivlines='5' divLineColor='CCCCCC' divLineAlpha='80' decimalPrecision='0' showAlternateHGridColor='1' AlternateHGridAlpha='30' AlternateHGridColor='CCCCCC' caption='Rangkuman aktifitas pribadi' subcaption='Tahun 2009' >

   <categories font='Arial' fontSize='11' fontColor='000000'>

      <category name='Jan'/>

      <category name='Feb' />

      <category name='Mar' />

      <category name='Apr' />

      <category name='Mei' />

      <category name='Jun'/>

      <category name='Jul' />

      <category name='Ags' />

      <category name='Sep' />

      <category name='Okt' />

      <category name='Nov' />

      <category name='Des' />

   </categories>

   <dataset seriesname='Komentar / asupan' color='E55454'>

      $str_comment

   </dataset>

    <dataset seriesname='Mailbox' color='F3CF3E'>

      $str_mailbox

   </dataset>

   <dataset seriesname='E-Consultation' color='3E7EF3'>

      $str_konsultasi

   </dataset>

   <dataset seriesname='Forum Diskusi' color='54CF5A'>

      $str_diskusi

   </dataset>

</graph>";

		$path_chart = $this->obj_chart->UseChart("FCF_MSColumn2D");

		$this->obj_tmpl->addVar('content', 'CHART_ALL', renderChartHTML($path_chart, "", $strXML, "", 760, 270, false));

	}

}



?>