<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object

	protected $obj_forum;

	protected $obj_notify;

	// post

	protected $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	

	}

	

	protected function PageLoad(){ 

		/* -- Other object loaded below */

		// load business

		$this->obj_forum = $this->obj_ctrl->LoadBusiness('forum', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_forum->SetUsesBusinessQuery($loaded_query);

		// --

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert_kategori':

				self::InsertNewKategori();

				break;

			case 'update_kategori':

				self::UpdateKategori();

				break;

			case 'delete_kategori':

				self::DeleteKategori();

				break;

			case 'delete_topik':

				self::DeleteTopik();

				break;

			case 'delete_reply':

				self::DeleteReply();

				break;

			case 'insert':

				self::InsertNewTopik();

				break;

			case 'reply':

				self::ReplyMessage();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	private function InsertNewKategori(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// ----------------------------------------------------------------	

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><b>Judul</b> harus diisi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><b>Deskripsi</b> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){			

			// pendidikan

			$params = array($this->arr_params['judul'], $this->arr_params['deskripsi'], $this->str_userid);

			// processing data

			if($this->obj_forum->ProcessingData("InsertNewKategori", $params)){

				// sukses message			

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			}else{

				$filled = array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

			}

		}else{

			$filled = array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori-add');	

	}

	

	private function UpdateKategori(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// ----------------------------------------------------------------	

		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><b>ID</b> tidak terpilih'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><b>Judul</b> harus diisi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><b>Deskripsi</b> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){			

			// pendidikan

			$params = array($this->arr_params['judul'], $this->arr_params['deskripsi'], $this->str_userid, $this->arr_params['id_cat']);

			// processing data

			if($this->obj_forum->ProcessingData("UpdateKategori", $params)){

				// sukses message			

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			}else{

				$filled = array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

			}

		}else{

			$filled = array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori-edit', array($this->arr_params['id_cat']));	

	}

	

	private function DeleteKategori(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// ----------------------------------------------------------------	

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Kategori</b> tidak terpilih'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				// processing data

				$this->obj_forum->ProcessingData("DeleteKategori", array($id));

			}

			// sukses message	

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');			

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori');

	}

	

	private function DeleteTopik(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// ----------------------------------------------------------------	

		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><b>Kategori</b> tidak terpilih'; }

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Topik</b> tidak terpilih'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				// processing data

				$this->obj_forum->ProcessingData("DeleteTopik", array($this->arr_params['id_cat'], $id));

			}

			// sukses message	

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');			

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'topik', array($this->arr_params['id_cat']));	

	}

	

	private function DeleteReply(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// ----------------------------------------------------------------	

		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><b>Kategori</b> tidak terpilih'; }

		if(empty($this->arr_params['id_topik'])){ $err[] = '<br /><b>Topik</b> tidak terpilih'; }

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Balasan</b> tidak terpilih'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				// processing data

				$this->obj_forum->ProcessingData("DeleteReply", array($this->arr_params['id_topik'], $id));

			}

			// sukses message	

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');			

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'reply', array($this->arr_params['id_cat'], $this->arr_params['id_topik']));	

	}

	

	private function InsertNewTopik(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// ----------------------------------------------------------------	

		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><b>Kategori</b> tidak terpilih'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><b>Judul</b> harus diisi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><b>Deskripsi</b> harus diisi'; }

		// kode validasi

		if($this->arr_params['valid_code'] != $_SESSION['captcha']){ 

			$err[] = '<br /><b>Kode validasi</b> yang dimasukkan tidak valid';

		}

		// processing --------------------------------------------------

		if(empty($err)){			

			// pendidikan

			$params = array($this->arr_params['id_cat'], $this->str_userid, $this->arr_params['judul'], $this->arr_params['deskripsi']);

			// processing data

			if($this->obj_forum->ProcessingData("InsertNewTopik", $params)){

				// sukses message			

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			}else{

				$filled = array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

			}

		}else{

			$filled = array("JUDUL" => $this->arr_params['judul'], "DESKRIPSI" => $this->arr_params['deskripsi']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'topik-new', array($this->arr_params['id_cat']));	

	}

	

	private function ReplyMessage(){

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// ----------------------------------------------------------------	

		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><b>Kategori</b> tidak terpilih'; }

		if(empty($this->arr_params['id_topik'])){ $err[] = '<br /><b>Topik</b> tidak terpilih'; }

		if(empty($this->arr_params['reply'])){ $err[] = '<br /><b>Balasan</b> harus diisi'; }

		// kode validasi

		if($this->arr_params['valid_code'] != $_SESSION['captcha']){ 

			$err[] = '<br /><b>Kode validasi</b> yang dimasukkan tidak valid';

		}

		// processing --------------------------------------------------

		if(empty($err)){			

			// pendidikan

			$params = array($this->arr_params['id_topik'], $this->arr_params['id_before'], $this->arr_params['reply'], $this->str_userid);

			// processing data

			if($this->obj_forum->ProcessingData("ReplyMessage", $params)){

				// sukses message			

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			}else{

				$filled = array("REPLY" => $this->arr_params['reply']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

			}

		}else{

			$filled = array("REPLY" => $this->arr_params['reply']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'reply-form', array($this->arr_params['id_cat'], $this->arr_params['id_topik'], $this->arr_params['id_before']));	

	}

}



?>