<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_forum;

	protected $obj_date;

	protected $obj_notify;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_forum = $this->obj_ctrl->LoadBusiness('forum', 'mysql', $this->arr_config['db']);

		$loaded_query = array('konsultasi');

		$this->obj_forum->SetUsesBusinessQuery($loaded_query);

		// --

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();

		// display kategori

		self::DisplayDetailKategori();

		// display topik

		self::DisplayListTopik();

		// display notification

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariable(){

		// url

		$this->obj_tmpl->addVar('content', 'URL_KATEGORI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori'));

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function DisplayDetailKategori(){

		$id_cat = 0;

		if(isset($this->arr_routes['params'][0])){ $id_cat = $this->arr_routes['params'][0];}

		// parameter

		$params = array($id_cat);

		// get data

		$result = $this->obj_forum->GetDataAsSingleArray("GetDetailKategoriKonsultasiById", $params);

		// parse data

		$no = 1;

		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'KATEGORI', $result['nama']);

			$this->obj_tmpl->addVar('content', 'ID_CAT', $result['id_cat']);

		}

	}

	

	private function DisplayListTopik(){

		$id_cat = 0;

		if(isset($this->arr_routes['params'][0])){ $id_cat = $this->arr_routes['params'][0];}

		// parameter

		$params = array($id_cat);

		// get data

		$rs_id = $this->obj_forum->GetResourceId("GetListTopikKonsultasiByKategori", $params);

		// parse data

		$no = 1;

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				// url

				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'reply', array($id_cat, $rec['id_topik']));

				// parse

				$this->obj_tmpl->addVar('list_kategori', 'NO', $no);

				$this->obj_tmpl->addVar('list_kategori', 'ID', $rec['id_topik']);

				$this->obj_tmpl->addVar('list_kategori', 'JUDUL', $rec['judul']);

				$this->obj_tmpl->addVar('list_kategori', 'TANGGAL_KIRIM', $this->obj_date->GetFullDate($rec['post_date']));

				$this->obj_tmpl->addVar('list_kategori', 'PENGIRIM', $rec['pengirim']);

				$this->obj_tmpl->addVar('list_kategori', 'GENDER', ucwords($rec['gender']));

				$this->obj_tmpl->addVar('list_kategori', 'TINGGI', $rec['tinggi']);

				$this->obj_tmpl->addVar('list_kategori', 'BERAT', $rec['berat']);

				$this->obj_tmpl->addVar('list_kategori', 'TOTAL_REPLY', intval($rec['total_answer']));

				$this->obj_tmpl->addVar('list_kategori', 'ALLOWED', ucwords($rec['allowed']));

				if(!empty($rec['konsultan'])){

					$this->obj_tmpl->addVar('list_kategori', 'KONSULTAN', "By : " . $rec['konsultan']);

					$this->obj_tmpl->addVar('list_kategori', 'LAST_DATE_ANSWER', $this->obj_date->GetFullDate($rec['last_date_answer']));

				}

				$this->obj_tmpl->addVar('list_kategori', 'URL_REPLY', $url);

				$this->obj_tmpl->ParseTemplate('list_kategori', 'a');

				$no++;

			}

		}

	}

}



?>