<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// init object

	private $obj_info;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_info = $this->obj_ctrl->LoadBusiness('info', 'mysql', $this->arr_config['db']);

		$this->obj_info->UseQuery(array('download'));

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_date = $this->obj_ctrl->LoadLibrary("DateTimeManipulation");

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

		// loaded style

	}

	

	public function PageView(){

		// display page link navigation

		self::DisplayPageLink();

		// display template (add, view, edit)

		self::TemplateToDisplay();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori', array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori'));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function TemplateToDisplay(){

		// display list data

		$view = (isset($this->arr_routes['params'][0])?$this->arr_routes['params'][0]:'-');

		switch($view){

			case 'add':

				// add form

				self::DisplayAddForm();

				break;

			case 'edit':

				// edit form

				self::DisplayEditForm();

				break;

			default:

				// list data

				self::DisplayListData();

				break;

		}

		

	}

	

	private function DisplayListData(){

		// activated template

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		// get record data

		$rs_id = $this->obj_info->GetResourceId("GetListKategoriByName", array());

		$no = 0;

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				// url edit

				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori', array('edit', $rec['id_cat']));	

				$url_file = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($rec['id_cat']));			

				$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

				$this->obj_tmpl->addVar('list_data', 'NO', $no + 1);

				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_cat']);	

				$this->obj_tmpl->addVar('list_data', 'NAMA_KATEGORI', $rec['nama']);

				$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $rec['deskripsi']);

				$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url);

				$this->obj_tmpl->addVar('list_data', 'URL_FILE', $url_file);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');	

				$no++;

			}

		}

		$this->obj_tmpl->addVar('display', 'TOTAL_DATA', $no);	

	}

	

	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

		$this->obj_tmpl->addVar('display', 'COUNTRY', 'Indonesia');	

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$id_cat = (isset($this->arr_routes['params'][1])?$this->arr_routes['params'][1]:0);

		$result = $this->obj_info->GetDataAsSingleArray('GetDetailKategoriById', array($id_cat));

		$this->obj_tmpl->addVar('display', 'ID_CAT', $result['id_cat']);	

		$this->obj_tmpl->addVar('display', 'NAMA_KATEGORI', $result['nama']);

		$this->obj_tmpl->addVar('display', 'DESKRIPSI', $result['deskripsi']);

		$this->obj_tmpl->addVar('display', 'MOD_DATE',  $this->obj_date->GetFullDate($result['mdd'], "en"));

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>

