<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// init object

	private $obj_person;

	private $obj_info;

	private $obj_date;

	private $obj_notify;

	private $obj_paging;

	// init variable

	private $id_cat;

	private $id_page;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_info = $this->obj_ctrl->LoadBusiness('info', 'mysql', $this->arr_config['db']);

		$this->obj_info->UseQuery(array("download"));

		$this->obj_person= $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date = $this->obj_ctrl->LoadLibrary("DateTimeManipulation");

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

	}

	

	public function PageView(){

		// display page link navigation

		self::DisplayPageLink();

		// display detail kategori

		self::DisplayDetailKategori();

		// display template (add, view, edit)

		self::TemplateToDisplay();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayPageLink(){

		// page

		$this->id_page = (isset($this->arr_routes['params'][3])?$this->arr_routes['params'][3]:1);

		$this->obj_tmpl->addVar('display', 'PAGE', $this->id_page);

		// kategori

		$this->id_cat = (isset($this->arr_routes['params'][0])?$this->arr_routes['params'][0]:0);

		$this->obj_tmpl->addVar('display', 'KATEGORI', $this->id_cat);

		// url

		$this->obj_tmpl->addVar('content', 'URL_KATEGORI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori'));

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->id_cat, 'add', '-', $this->id_page)));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->id_cat, '-', '-', $this->id_page)));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function DisplayDetailKategori(){

		$result = $this->obj_info->GetDataAsSingleArray('GetDetailKategoriById', array($this->id_cat));

		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'KATEGORI', $result['nama']);

		}

	}

	

	private function TemplateToDisplay(){

		$view = (isset($this->arr_routes['params'][1])?$this->arr_routes['params'][1]:'-');

		switch($view){

			case 'add':

				// add form

				self::DisplayAddForm();

				break;

			case 'edit':

				// edit form

				self::DisplayEditForm();

				break;

			default:

				// list data

				self::DisplayListData();

				break;

		}

	}

	

	private function DisplayListData(){

		// activated template

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		// set active page number

		$this->obj_paging->SetPagesNumber($this->id_page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$result = $this->obj_info->GetDataAsSingleArray("GetTotalFileByKategori", array($this->id_cat));

		$this->obj_paging->SetTotalRecord($result['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->id_cat, '-', '-', '')));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$rs_id = $this->obj_info->GetResourceId("GetListFileByKategoriWithLimit", array($this->id_cat, $start, $max));

		$no = $start + 0;

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				// url link

				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->id_cat, 'edit', $rec['id_download'], $this->id_page));

				$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

				$this->obj_tmpl->addVar('list_data', 'NO', $no + 1);

				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_download']);	

				$this->obj_tmpl->addVar('list_data', 'NAMA_FILE', $rec['judul']);

				$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $rec['deskripsi']);

				$this->obj_tmpl->addVar('list_data', 'HITS', $rec['hits']);

				$this->obj_tmpl->addVar('list_data', 'TYPE_FILE', '');

				$file = $rec['filepath'].$rec['filename'];

				if(is_file($file)){

					$url_down = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'file', array(md5($rec['id_download'])));

				}else{

					$url_down = "#";

				}

				$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url);

				$this->obj_tmpl->addVar('list_data', 'URL_DOWNLOAD', $url_down);

				// type file

				$type = explode(".", $rec['filename']);

				$tipe = end($type);

				$this->obj_tmpl->addVar('list_data', 'TYPE', $tipe);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');	

				$no++;

			}

		}

		$this->obj_tmpl->addVar('display', 'TOTAL_DATA', $no);	

	}

	

	private function DisplayAddForm(){

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data

		$id_file = (isset($this->arr_routes['params'][2])?$this->arr_routes['params'][2]:0);

		$result = $this->obj_info->GetDataAsSingleArray('GetDetailFileById', array($id_file));

		if(!empty($result)){

			$this->obj_tmpl->addVar('display', 'ID_DOWNLOAD', $result['id_download']);	

			$this->obj_tmpl->addVar('display', 'JUDUL', $result['judul']);	

			$this->obj_tmpl->addVar('display', 'DESKRIPSI', $result['deskripsi']);	

			$this->obj_tmpl->addVar('display', 'KATA_KUNCI', $result['kata_kunci']);	

			$file = $result['filepath'].$result['filename'];

			if(is_file($file)){

				$url_down = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'file', array(md5($result['id_download'])));

			}else{

				$url_down = "#";

			}

			$this->obj_tmpl->addVar('display', 'URL_DOWNLOAD', $url_down);	

			$this->obj_tmpl->addVar('display', 'NAMA_FILE', $result['filename']);	

			$this->obj_tmpl->addVar('display', 'MOD_DATE',  $this->obj_date->GetFullDate($result['mdd'], "en"));

			$res = $this->obj_person->GetDataAsSingleArray("GetNameById", array($result['mdb']));

			if(!empty($res)){

				$this->obj_tmpl->addVar('display', 'MOD_BY', $res['fullname']);

			}

		}

	}

}



?>

