<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// init object 	

	private $obj_info;

	private $obj_notify;	

	private $obj_upload;

	// init variable

	private $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kategori');

	}

	

	protected function PageLoad(){ 

		// load business

		$this->obj_info = $this->obj_ctrl->LoadBusiness('info', 'mysql', $this->arr_config['db']);

		$this->obj_info->UseQuery(array("download"));

		// load library 

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

		

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'save_file':

				self::SaveFile();

				break;

			case 'update_file':

				self::UpdateFile();

				break;

			case 'delete_file':

				self::DeleteFile();

				break;

			case 'save_kategori':

				self::SaveKategori();

				break;

			case 'update_kategori':

				self::UpdateKategori();

				break;

			case 'delete_kategori':

				self::DeleteKategori();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// download operation

	

	private function SaveFile(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kategori'])){ $err[] = '<br /><strong>Kategori</strong> tidak terpilih'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus di isi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> harus di isi'; }

		// gambar

		// berkas

		$berkas = $_FILES['file_attach'];

		if(empty($berkas['tmp_name'])){ $err[] = '<br /><strong>Berkas</strong> must be filled'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['id_kategori'], $this->arr_params['judul'],$this->arr_params['deskripsi'], $this->arr_params['kata_kunci'], $this->str_userid);

			if($this->obj_info->ProcessingData("InsertFile", $params)){

				// get last id

				$id = $this->obj_info->GetLastInsertedId();

				// upload file 

				self::UploadBerkas($berkas, $id);

				// sukses message				

				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');

			}else{

				$filled = array('JUDUL' => $this->arr_params['judul'], 'DESKRIPSI' => $this->arr_params['deskripsi'], 'KATA_KUNCI' => $this->arr_params['kata_kunci']);

				// error message

				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');

			}	

		}else{

			$filled = array('JUDUL' => $this->arr_params['judul'], 'DESKRIPSI' => $this->arr_params['deskripsi'], 'KATA_KUNCI' => $this->arr_params['kata_kunci']);

			// error message

			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');

		}

		// Redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list',array($this->arr_params['id_kategori'], 'add', '-', $this->arr_params['page']));

	}

	

	private function UpdateFile(){		

		$err = array();	

		$filled = array();	

		// check / validate parameter 		

		if(empty($this->arr_params['id_kategori'])){ $err[] = '<br /><strong>Kategori</strong> tidak terpilih'; }	

		if(empty($this->arr_params['id_download'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus di isi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> harus di isi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['judul'], $this->arr_params['deskripsi'], $this->arr_params['kata_kunci'], $this->str_userid, $this->arr_params['id_download']);

			if($this->obj_info->ProcessingData("UpdateFile", $params)){

				// upload file 

				self::UploadBerkas($_FILES['file_attach'], $this->arr_params['id_download']);

				// sukses message				

				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');

			}else{

				$filled = array('JUDUL' => $this->arr_params['judul'], 'DESKRIPSI' => $this->arr_params['deskripsi'], 'KATA_KUNCI' => $this->arr_params['kata_kunci']);

				// error message

				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');

			}	

		}else{

			$filled = array('JUDUL' => $this->arr_params['judul'], 'DESKRIPSI' => $this->arr_params['deskripsi'], 'KATA_KUNCI' => $this->arr_params['kata_kunci']);

			// error message

			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');

		}

		// Redirect  page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'list',array($this->arr_params['id_kategori'], 'edit', $this->arr_params['id_download'], $this->arr_params['page']));

	}	

	

	private function DeleteFile(){

		$err = array();	

		$filled = array();

		// check parameter

		if(empty($this->arr_params['id_kategori'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_info->ProcessingData("DeleteFile", array($id))){

					$file_path = 'doc/informasi/download/'.$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					// notification message	

	         		self::SendNotification($err, array(), "Data berhasil dihapus.", "success");

				}else{

					// error message

					self::SendNotification($err, array(), "Business process failure.", "error");

				}

			}				

		}else{

			// error message

			self::SendNotification($err, array(), "See input requirement.", "error");

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list',array($this->arr_params['id_kategori'], '-', '-', $this->arr_params['page']));

	}

	

	private function UploadBerkas($berkas, $id){

		$err = array();

		// allowed type

		$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');

		// --

		if(!empty($berkas['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $berkas['name']);

			$file_path = "doc/informasi/download/".$id."/";

			// processing

			if($this->obj_upload->FileUpload($berkas, $file_path)){

				// insert to database

				$params = array($file_name, $file_path, $id);

				$this->obj_info->ProcessingData("UpdateFilePath", $params);

				// --

				$err[] = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 

			}else{

				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}		

		}else{

			$err[] = '<br />Berkas <strong>tidak berhasil</strong> diupload'; 

		}		

		// return

		return $err;

	}

	

	// download kategori operation

	

	private function SaveKategori(){

		$err = array();	

		$filled = array();	

		// check / validate parameter

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama</strong> tidak boleh kosong'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['nama'], $this->arr_params['deskripsi'], $this->str_userid);

			if($this->obj_info->ProcessingData("InsertKategori", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');

			}else{

				$filled = array('NAMA_KATEGORI' => $this->arr_params['nama'], 'DESKRIPSI' => $this->arr_params['deskripsi']);

				// error message

				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');

			}	

		}else{

			$filled = array('NAMA_KATEGORI' => $this->arr_params['nama'], 'DESKRIPSI' => $this->arr_params['deskripsi']);

			// error message

			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');

		}

		// Redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'kategori', array('add'));		

	}

	

	private function UpdateKategori(){		

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama Kategori Harus di isi</strong> harus di isi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['nama'], $this->arr_params['deskripsi'], $this->str_userid,$this->arr_params['id_cat']);

			if($this->obj_info->ProcessingData("UpdateKategori", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');

			}else{

				$filled = array('NAMA_KATEGORI' => $this->arr_params['nama'], 'DESKRIPSI' => $this->arr_params['deskripsi']);

				// error message

				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');

			}	

		}else{

			$filled = array('NAMA_KATEGORI' => $this->arr_params['nama'], 'DESKRIPSI' => $this->arr_params['deskripsi']);

			// error message

			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');

		}

		// Redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'kategori', array('edit', $this->arr_params['id_cat']));

	}

	

	private function DeleteKategori(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_info->ProcessingData("DeleteKategori", array($id))){

					$dir = "doc/informasi/download/".$id."/";

					$this->obj_upload->RemoveDir($dir);

					// notification message	

	         		self::SendNotification($err, array(), "Data berhasil dihapus.", "success");

				}else{

					// error message

					self::SendNotification($err, array(), "Business process failure.", "error");

				}

			}				

		}else{

			// error message

			self::SendNotification($err, array(), "See input requirement.", "error");

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'kategori');

	}

	

}



?>