<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_event;

	private $obj_person;

	private $obj_negara;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		$this->obj_event = $this->obj_ctrl->LoadBusiness('agenda', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_negara = $this->obj_ctrl->LoadBusiness('negara', 'mysql', $this->arr_config['db']);

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		// javascript loaded

		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');

		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

		$this->obj_ctrl->LoadJavascript('tiny_mce');

		// dhtmlgoodies_calendar loaded

		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');

		// dhtmlgoodies_calendar loaded body event

		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");

		// loaded style

		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');		

	}

	

	public function PageView(){

		/* 

		-- display view content

		*/

		self::DisplayNotification();

		self::DisplayPageLink();

		self::DisplayRedirect();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0'], 'add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0'])));

		$this->obj_tmpl->addVar('content', 'URL_CATEGORY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category'));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process', array($this->arr_routes['params']['0'])));

		// parse kategori

		$this->obj_tmpl->addVar('display', 'KATEGORI', $this->arr_routes['params']['0']);

	}



   private function DisplayRedirect() {

      if (isset($this->arr_routes['params']['1']) && $this->arr_routes['params']['1'] == "add") {

         self::DisplayAddForm();

      } else if (isset($this->arr_routes['params']['1']) && $this->arr_routes['params']['1'] == "edit") {

         self::DisplayEditForm();

      } else {

         self::DisplayListArchive();

      }

   }

   

	private function DisplayListArchive(){

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		if(!isset($this->arr_routes['params']['1'])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params']['1'];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_event->CountAgendaByCategoryId(array($this->arr_routes['params']['0'])));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0']))."/");

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$event = $this->obj_event->GetAgendaByCategoryId(array($this->arr_routes['params']['0'], $start, $max));

		$no = 0;

		$num = $start+1;

		foreach($event as $key=>$value) {

			$href = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_routes['params']['0']));

			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0'], "edit", $value['id_agenda']));

			// display last update

			$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($value['mdb']));

			$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($value['mdd']));

			$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

			// --

			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

			$this->obj_tmpl->addVar('list_data', 'NO', $num);

			$this->obj_tmpl->addVar('list_data', 'ID', $value['id_agenda']);	

			$this->obj_tmpl->addVar('list_data', 'CATEGORY', $value['nama']);

			$this->obj_tmpl->addVar('list_data', 'TITLE', $value['judul']);

			$this->obj_tmpl->addVar('list_data', 'PLACE', $value['tempat']);

			$this->obj_tmpl->addVar('list_data', 'DATE', $this->obj_date->GetFullDate($value['tgl_mulai']) . ' s/d ' . $this->obj_date->GetFullDate($value['tgl_selesai']));

			$this->obj_tmpl->addVar('list_data', 'SCALE', $value['tingkat']);

			$this->obj_tmpl->addVar('list_data', 'SPEACHER', $value['pembicara']);

			$this->obj_tmpl->addVar('list_data', 'SOURCE', $value['penyelenggara']);

			$this->obj_tmpl->addVar('list_data', 'HIT', $value['hits']);

			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');

			$no++;

			$num++;

		}

	}	



	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

		if(isset($this->obj_notify->arr_message['field'])){

			$result = array($this->obj_notify->arr_message['field']);

			$this->obj_tmpl->addVar('display', 'TITLE', $result['0']['judul']);

			$this->obj_tmpl->addVar('display', 'PLACE', $result['0']['tempat']);

         

			if ($result['0']['tingkat'] == 'lokal') {

				$this->obj_tmpl->addVar('display', 'LOCAL', 'selected');

				$this->obj_tmpl->addVar('display', 'NASIONAL', '');

				$this->obj_tmpl->addVar('display', 'INTERNASIONAL', '');

			} else if ($result['0']['tingkat'] == 'nasional') {

				$this->obj_tmpl->addVar('display', 'LOCAL', '');

				$this->obj_tmpl->addVar('display', 'NASIONAL', 'selected');

				$this->obj_tmpl->addVar('display', 'INTERNASIONAL', '');

			} else {

				$this->obj_tmpl->addVar('display', 'LOCAL', '');

				$this->obj_tmpl->addVar('display', 'NASIONAL', '');

				$this->obj_tmpl->addVar('display', 'INTERNASIONAL', 'selected');

			}

			$this->obj_tmpl->addVar('display', 'SPECHER', $result['0']['pembicara']);

			$this->obj_tmpl->addVar('display', 'PENYELENGGARA', $result['0']['penyelenggara']);

			$this->obj_tmpl->addVar('display', 'SK', $result['0']['sk_event']);

			$this->obj_tmpl->addVar('display', 'CONTENT', $result['0']['content']);

			$this->obj_tmpl->addVar('display', 'SOURCE', $result['0']['sumber']);

			//id_negara

			$this->obj_tmpl->addVar('display', 'IMAGE_NOTE', $result['0']['img_note']);

			$this->obj_tmpl->addVar('display', 'FILE_NOTE', $result['0']['file_title']);

			$this->obj_tmpl->addVar('display', 'HIT', $result['0']['hits']);

		}

      

		$cat = $this->obj_event->GetAgendaCategory(array(0, 1000));

		foreach($cat as $key=>$value ) {

			$this->obj_tmpl->addVar('cat_add', 'CAT_VALUE', $value['id_cat']);

			$this->obj_tmpl->addVar('cat_add', 'CAT_NAME', $value['nama']);

			if (isset($result['0']['id_cat'])) {

				if ($value['id_cat'] == $result['0']['id_cat']) {

					$this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', 'selected');

				} else {

					$this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');

				}

			} else {

				$this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');

			}

			$this->obj_tmpl->ParseTemplate('cat_add', 'a');

		}

		$negara = $this->obj_negara->GetNegara(array(0, 1000));

		foreach($negara as $key=>$value) {

			$this->obj_tmpl->addVar('country_a', 'COUNTRY_VALUE', $value['id_country']);

			$this->obj_tmpl->addVar('country_a', 'COUNTRY_NAME', $value['country_name']);

			if (isset($result['0']['id_country'])) {

				if ($value['id_country'] == $result['0']['id_country']) {

					$this->obj_tmpl->addVar('country_a', 'COUNTRY_SELECTED', 'selected');

				} else {

					$this->obj_tmpl->addVar('country_a', 'COUNTRY_SELECTED', '');

				}

			} else {

				$this->obj_tmpl->addVar('country_a', 'COUNTRY_SELECTED', '');

			}

			$this->obj_tmpl->ParseTemplate('country_a', 'a');

		}

		if (isset($result['0']['tgl_mulai'])) {

			$tgl_mulai = explode('-', $result['0']['tgl_mulai']);

		} else {

			$tgl_mulai = explode('-', date("Y-m-d"));

		}

		$tm = $tgl_mulai[0];

		$bm = $tgl_mulai[1];

		$hm = $tgl_mulai[2];

		$this->obj_date->SetPatTemplates($this->obj_tmpl);

		$this->obj_date->DhtmlgoodiesStandardDate('list_year_start_a', 'list_month_start_a', 'list_day_start_a', $tm + 5 , $bm, $hm, $tm - 75, $tm + 5);

      

		if (isset($result['0']['tgl_selesai'])) {

			$tgl_akhir = explode('-', $result['0']['tgl_selesai']);

		} else {

			$tgl_akhir = explode('-', date("Y-m-d"));

		}

		$ta = $tgl_akhir[0];

		$ba = $tgl_akhir[1];

		$ha = $tgl_akhir[2];

      	$this->obj_date->SetPatTemplates($this->obj_tmpl);

		$this->obj_date->DhtmlgoodiesStandardDate('list_year_end_a', 'list_month_end_a', 'list_day_end_a', $ta + 5 , $ba, $ha, $ta - 75, $ta + 5);

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$result = $this->obj_event->GetAgendaById(array($this->arr_routes['params']['2']));

      	// cek notification 

		if(isset($this->obj_notify->arr_message['field'])){

			$result = array($this->obj_notify->arr_message['field']);

		}

		$this->obj_tmpl->addVar('display', 'ID', $result['0']['id_agenda']);	

		$this->obj_tmpl->addVar('display', 'TITLE', $result['0']['judul']);

		$this->obj_tmpl->addVar('display', 'PLACE', $result['0']['tempat']);

      

		if ($result['0']['tingkat'] == 'lokal') {

			$this->obj_tmpl->addVar('display', 'LOCAL', 'selected');

			$this->obj_tmpl->addVar('display', 'NASIONAL', '');

			$this->obj_tmpl->addVar('display', 'INTERNASIONAL', '');

		} else if ($result['0']['tingkat'] == 'nasional') {

			$this->obj_tmpl->addVar('display', 'LOCAL', '');

			$this->obj_tmpl->addVar('display', 'NASIONAL', 'selected');

			$this->obj_tmpl->addVar('display', 'INTERNASIONAL', '');

		} else {

			$this->obj_tmpl->addVar('display', 'LOCAL', '');

			$this->obj_tmpl->addVar('display', 'NASIONAL', '');

			$this->obj_tmpl->addVar('display', 'INTERNASIONAL', 'selected');

		}

		$this->obj_tmpl->addVar('display', 'SPECHER', $result['0']['pembicara']);

		$this->obj_tmpl->addVar('display', 'PENYELENGGARA', $result['0']['penyelenggara']);

		$this->obj_tmpl->addVar('display', 'SK', $result['0']['sk_event']);

		$this->obj_tmpl->addVar('display', 'CONTENT', $result['0']['content']);

		$this->obj_tmpl->addVar('display', 'SOURCE', $result['0']['sumber']);

		//id_negara

		$urlImg = "";

		if (!empty($result['0']['img_name'])) {

			$urlImg = HTTPPATH . "doc/event/images/" . $result['0']['id_agenda'] . '/' . $result['0']['img_name'];

		}

		$this->obj_tmpl->addVar('display', 'URL_IMAGE', $urlImg);

		$this->obj_tmpl->addVar('display', 'IMAGE_NOTE', $result['0']['img_note']);

		$this->obj_tmpl->addVar('display', 'IMAGE_NAME', $result['0']['img_name']);

		$urlFile = "";

		if (!empty($result['0']['file_name'])) {

			$urlFile = HTTPPATH . "doc/event/file/". $result['0']['id_agenda'] . '/' . $result['0']['file_name'];

		}

		$this->obj_tmpl->addVar('display', 'URL_FILE', $urlFile);

		$this->obj_tmpl->addVar('display', 'FILE_NAME', $result['0']['file_name']);

		$this->obj_tmpl->addVar('display', 'FILE_NOTE', $result['0']['file_title']);

		$this->obj_tmpl->addVar('display', 'HIT', $result['0']['hits']);

      

		$cat = $this->obj_event->GetAgendaCategory(array(0, 1000));

		foreach($cat as $key=>$value ) {

			$this->obj_tmpl->addVar('cat_edit', 'CAT_VALUE', $value['id_cat']);

			$this->obj_tmpl->addVar('cat_edit', 'CAT_NAME', $value['nama']);

			if ($value['id_cat'] == $result['0']['id_cat']) {

				$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', 'selected');

			} else {

				$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', '');

			}

			$this->obj_tmpl->ParseTemplate('cat_edit', 'a');

		}

		$negara = $this->obj_negara->GetNegara(array(0, 1000));

		foreach($negara as $key=>$value) {

			$this->obj_tmpl->addVar('country', 'COUNTRY_VALUE', $value['id_country']);

			$this->obj_tmpl->addVar('country', 'COUNTRY_NAME', $value['country_name']);

			if ($value['id_country'] == $result['0']['id_country']) {

				$this->obj_tmpl->addVar('country', 'COUNTRY_SELECTED', 'selected');

			} else {

				$this->obj_tmpl->addVar('country', 'COUNTRY_SELECTED', '');

			}

			$this->obj_tmpl->ParseTemplate('country', 'a');

		}

		$tgl_mulai = explode('-', $result['0']['tgl_mulai']);

		if (sizeof($tgl_mulai) > 2) {

			$tm = $tgl_mulai[0];

			$bm = $tgl_mulai[1];

			$hm = $tgl_mulai[2];

		} else {

			$tgl_mulai = explode('-', date("Y-m-d"));

			$tm = $tgl_mulai[0];

			$bm = $tgl_mulai[1];

			$hm = $tgl_mulai[2];

		}

      	$this->obj_date->SetPatTemplates($this->obj_tmpl);

		$this->obj_date->DhtmlgoodiesStandardDate('list_year_start', 'list_month_start', 'list_day_start', $tm, $bm, $hm, $tm - 75, $tm + 5);

		$tgl_akhir = explode('-', $result['0']['tgl_selesai']);

		if (sizeof($tgl_akhir)>2) {

			$ta = $tgl_akhir[0];

			$ba = $tgl_akhir[1];

			$ha = $tgl_akhir[2];

		} else {

			$tgl_akhir = explode('-', date("Y-m-d"));

			$ta = $tgl_akhir[0];

			$ba = $tgl_akhir[1];

			$ha = $tgl_akhir[2];

		}

		$this->obj_date->SetPatTemplates($this->obj_tmpl);

		$this->obj_date->DhtmlgoodiesStandardDate('list_year_end', 'list_month_end', 'list_day_end',  $ta, $ba, $ha, $ta - 75, $ta + 5);

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>