<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_galery;

	private $obj_date;

	private $obj_notify;

	private $arr_params;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category');

	}

	

	protected function PageLoad(){ 

		// load business

		$this->obj_galery = $this->obj_ctrl->LoadBusiness('gallery', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		

	}

	

	public function PageView(){

		// important to prevent bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	private function InsertData(){

		$err = array();	

		$filled = array();	

		// check / validate parameter 

		if(empty($this->arr_params['cat'])){ $err[] = '<br /><strong>Nama kategori</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array("judul" => $this->arr_params['cat'], "deskripsi" => $this->arr_params['description'], 

							"urutan" => $this->arr_params['urutan'], "mdb" => $this->str_userid);

			if($this->obj_galery->ProcessingData("InsertKategori", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array('CAT' => $this->arr_params['cat'], 'DESCRIPTION' => $this->arr_params['description'], 

								'URUTAN' => $this->arr_params['urutan']);

				// error message

				self::SendNotification($err, $filled, 'Business Process Error', 'error');

				// redirect to page error page --------------------------------	

			}	

		}else{

			$filled = array('CAT' => $this->arr_params['cat'], 'DESCRIPTION' => $this->arr_params['description'], 

							'URUTAN' => $this->arr_params['urutan']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		// redirect to page error page ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category', array('add'));

	}

	

	private function UpdateData(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><strong>Id kategori</strong> tidak terpilih'; }

		if(empty($this->arr_params['cat'])){ $err[] = '<br /><strong>Nama kategori</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array("nama" => $this->arr_params['cat'], "deskripsi" => $this->arr_params['description'], 

							"urutan" => $this->arr_params['urutan'], "mdb" => $this->str_userid, 

							"id_cat" => $this->arr_params['id_cat']);

			if($this->obj_galery->ProcessingData("UpdateKategori", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array('CAT' => $this->arr_params['cat'], 'DESCRIPTION' => $this->arr_params['description'], 

								'URUTAN' => $this->arr_params['urutan']);

				// error message

				self::SendNotification($err, $filled, 'Business Process Error', 'error');

				// redirect to page error page --------------------------------	

			}	

		}else{

			$filled = array('CAT' => $this->arr_params['cat'], 'DESCRIPTION' => $this->arr_params['description'], 

							'URUTAN' => $this->arr_params['urutan']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

   		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category', array('edit', $this->arr_params['id_cat']));

	}

	

	private function DeleteData(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_galery->ProcessingData("DeleteKategori", array($id))){

					// sukses message				

					self::SendNotification($err, $filled, 'Data has been saved.', 'success');

					// redirect to success page ------------------------------------

				}else{

					// error message

					self::SendNotification($err, $filled, 'Business Process Error', 'error');

					// redirect to page error page --------------------------------	

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

	}

}



?>