<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_galery;

	private $obj_date;

	private $obj_notify;

	private $arr_params;

	private $obj_upload;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori']));

	}

	

	protected function PageLoad(){ 

		// load business

		$this->obj_galery = $this->obj_ctrl->LoadBusiness('gallery', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		$err = array();

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		if(empty($_FILES['image']['tmp_name'])){ $err[] = '<br /><strong>Gambar</strong> harus diisi'; }

		$id_galeri = $this->obj_galery->GetLastIdGaleri(array());

		// processing --------------------------------------------------

		if(empty($err)){

         	$filename = self::UploadImage($id_galeri);

			$params = array("id_gal" => $id_galeri, "id_cat" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "images_name" => $filename,

							"images_path" => "doc/galery/".$id_galeri.'/', "urutan" => $this->arr_params['urutan'], 

							"mdb" => $this->str_userid);

			if($this->obj_galery->SetGallery($params, true)){

				// notification message				

				self::SendNotification($err, $filled, "Data has been saved.", "success");

			}else{

				// error message

         		$filled = array("TITLE" => $this->arr_params['title'], "DESCRIPTION" => $this->arr_params['description'], 

								"URUTAN" => $this->arr_params['urutan']);

				// error message

				self::SendNotification($err, $filled, "Business process failure.", "error");

			}	

		}else{

			// error message

         	$filled = array("TITLE" => $this->arr_params['title'], "DESCRIPTION" => $this->arr_params['description'], 

							"URUTAN" => $this->arr_params['urutan']);

			self::SendNotification($err, $filled, "See input requirement.", "error");

		}

		// redirect to page error page ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori'], 'add'));

	}

	

  	private function UploadImage($id_galeri){

		// allowed type

		$file_name = "";

		if(isset($_FILES['image']['tmp_name']) AND !empty($_FILES['image']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['image']['name']);

			$file_path = "doc/galery/thumb/".$id_galeri.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			//$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 101, 71);

			$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 101);			

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['image']['name']);

			$file_path = "doc/galery/".$id_galeri.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			//$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 500, 331);

			$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 500);			

		}

		return $file_name;

	}



	private function UpdateData(){

		$err = array();

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		// processing --------------------------------------------------

      	$a = $this->obj_galery->GetGalleryById(array($this->arr_params['id_galery']));

		if(empty($err)){

			$filename = self::UploadImage($this->arr_params['id_galery']);

			if($filename == "") {

				$filename = $a[0]['images_name'];

			}

			$params = array("id_cat" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "images_name" => $filename,

							"images_path" => "doc/galery/".$this->arr_params['id_galery'].'/', 

							"urutan" => $this->arr_params['urutan'], "mdb" => $this->str_userid,

							"id_galery" => $this->arr_params['id_galery']);

			if($this->obj_galery->SetGallery($params, false)){

				// notification message	

	         	self::SendNotification($err, $filled, "Data has been saved.", "success");

			}else{

				// error message

         		$filled = array("TITLE" => $this->arr_params['title'], "DESCRIPTION" => $this->arr_params['description'], 

								"URUTAN" => $this->arr_params['urutan']);

				// error message

				self::SendNotification($err, $filled, "Business process failure.", "error");

			}	

		}else{

			// error message

         	$filled = array("TITLE" => $this->arr_params['title'], "DESCRIPTION" => $this->arr_params['description'], 

							"URUTAN" => $this->arr_params['urutan']);

			self::SendNotification($err, $filled, "See input requirement.", "error");

		}

   		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori'], 'edit', $this->arr_params['id_galery']));	

	}

	

	private function DeleteData(){

		$err = array();	

		// check / validate parameter 

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_galery->DeleteGallery(array($id))){

					$file_path = "doc/galery/thumb/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					$file_path = "doc/galery/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					// notification message	

	         		self::SendNotification($err, array(), "Data has been deleted.", "success");

				}else{

					// error message

					self::SendNotification($err, $params, "Business process failure.", "error");

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $params, "See input requirement.", "error");

		}

	}

   

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		foreach($filled as $key=>$value){

			$this->obj_notify->SetField($key, $value);

		}

		$this->obj_notify->SentMessage();

	}

}



?>