<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_galery;

	private $obj_person;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_galery = $this->obj_ctrl->LoadBusiness('gallery', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// display page link

		self::DisplayPageLink();

		// display form

		self::DisplayRedirect();

		// display notification

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayPageLink(){

		if(!isset($this->arr_routes['params'][0])){

			$this->arr_routes['params'][0] = 'list';

		}

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params'][0], 'add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params'][0])));

		$this->obj_tmpl->addVar('content', 'URL_CATEGORY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category'));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process', array($this->arr_routes['params'][0])));

		// parse kategori

		$this->obj_tmpl->addVar('display', 'KATEGORI', $this->arr_routes['params'][0]);

	}



   private function DisplayRedirect() {

		if(isset($this->arr_routes['params'][1]) && $this->arr_routes['params'][1] == "add") {

			self::DisplayAddForm();

		}elseif(isset($this->arr_routes['params'][1]) && $this->arr_routes['params'][1] == "edit") {

			self::DisplayEditForm();

		}else{

			self::DisplayListArchive();

		}

   }

   

	private function DisplayListArchive(){

  		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		if(!isset($this->arr_routes['params'][1])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params'][1];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(10);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_galery->CountGalleryByCategoryId(array($this->arr_routes['params'][0])));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params'][0]))."/");

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$galery = $this->obj_galery->GetGalleryByCategoryId(array($this->arr_routes['params'][0], $start, $max));

		$no = 0;

		$num = $start + 1;

		foreach($galery as $key=>$value) {

			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0'], "edit", $value['id_galery']));

			// display last update

			$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($value['mdb']));

			$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($value['mdd'], 'ins'));

			$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

			// --

			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

			$this->obj_tmpl->addVar('list_data', 'NO', $num);

			$this->obj_tmpl->addVar('list_data', 'ID', $value['id_galery']);	

			$this->obj_tmpl->addVar('list_data', 'CATEGORY', $value['judul_cat']);

			$this->obj_tmpl->addVar('list_data', 'TITLE', $value['judul']);

			$this->obj_tmpl->addVar('list_data', 'DESCRIPTION', $value['deskripsi']);

			$this->obj_tmpl->addVar('list_data', 'IMG_NAME', $value['images_name']);

			$this->obj_tmpl->addVar('list_data', 'URL_IMAGE', HTTPPATH . 'doc/galery/thumb/'. $value['id_galery'] .'/' . $value['images_name']);

			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');

			$no++;

			$num++;

		}

	}	



	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

		// get data

		$rs_id = $this->obj_galery->GetResourceId("GetListKategori", array(0, 100));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('cat_add', 'CAT_VALUE', $rec['id_cat']);

				$this->obj_tmpl->addVar('cat_add', 'CAT_NAME', $rec['judul']);

				if ($rec['id_cat'] == $this->arr_routes['params'][0]) {

					$this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', 'selected="selected"');

				} else {

					$this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');

				}

				$this->obj_tmpl->ParseTemplate('cat_add', 'a');

			}

		}

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$result = $this->obj_galery->GetGalleryById(array($this->arr_routes['params'][2]));

		$this->obj_tmpl->addVar('display', 'ID', $result[0]['id_galery']);	

		$this->obj_tmpl->addVar('display', 'TITLE', $result[0]['judul']);

		$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result[0]['deskripsi']);

		$this->obj_tmpl->addVar('display', 'URUTAN', $result[0]['urutan']);

		$urlImg = "";

		if(!empty($result[0]['images_name'])) {

			$urlImg = HTTPPATH . 'doc/galery/thumb/'. $result[0]['id_galery'] .'/' .$result[0]['images_name'];

		}

		$this->obj_tmpl->addVar('display', 'URL_IMAGE', $urlImg);      

		// get data kategori

		$rs_id = $this->obj_galery->GetResourceId("GetListKategori", array(0, 100));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('cat_edit', 'CAT_VALUE', $rec['id_cat']);

				$this->obj_tmpl->addVar('cat_edit', 'CAT_NAME', $rec['judul']);

				if($rec['id_cat'] == $this->arr_routes['params'][0]) {

					$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', 'selected="selected"');

				}else{

					$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', '');

				}

				$this->obj_tmpl->ParseTemplate('cat_edit', 'a');

			}

		}

	}

}



?>