<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// init object

	private $obj_info;

	private $obj_person;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;

	// init variable

	private $int_page;

	

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_info = $this->obj_ctrl->LoadBusiness('info', 'mysql', $this->arr_config['db']);

		$this->obj_info->UseQuery(array("faq"));

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_date = $this->obj_ctrl->LoadLibrary("DateTimeManipulation");

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

		

	}

	

	public function PageView(){

		// display page link navigation

		self::DisplayPageLink();

		// display template (add, view, edit)

		self::TemplateToDisplay();

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){		

		// page

		$this->id_page = (isset($this->arr_routes['params'][2])?$this->arr_routes['params'][2]:1);

		$this->obj_tmpl->addVar('display', 'PAGE', $this->id_page);

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array('-', '-', $this->id_page)));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function TemplateToDisplay(){

		$view = (isset($this->arr_routes['params'][0])?$this->arr_routes['params'][0]:'-');

		switch($view){

			case 'detail':

				// detail form

				self::DisplayDetailForm();

				break;

			default:

				// list data

				self::DisplayListData();

				break;

		}

	}

	

	private function DisplayListData(){

		// activated template

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		// set active page number

		$this->obj_paging->SetPagesNumber($this->id_page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$result = $this->obj_info->GetDataAsSingleArray("GetTotalBukuTamu", array());

		$this->obj_paging->SetTotalRecord($result['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'],array('-', '-', '')));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// -------------------------------------------

		// display record data 

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$rs_id = $this->obj_info->GetResourceId("GetListBukuTamuWithLimit", array($start, $max));

		$no = $start + 0;

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				// url link

				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array('detail', $rec['id_thread'], $this->id_page));

				// parse data

				$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

				$this->obj_tmpl->addVar('list_data', 'NO', $no + 1);

				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_thread']);	

				$this->obj_tmpl->addVar('list_data', 'TANGGAL', $this->obj_date->GetFullDate($rec['mdd']));

				$this->obj_tmpl->addVar('list_data', 'NAMA', $rec['nama']);

				$this->obj_tmpl->addVar('list_data', 'EMAIL', $rec['email']);

				$this->obj_tmpl->addVar('list_data', 'PROFESI', $rec['profesi']);

				$this->obj_tmpl->addVar('list_data', 'PERIHAL', $rec['perihal']);

				$this->obj_tmpl->addVar('list_data', 'KONTEN', $rec['konten']);

				$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');	

				$no++;

			}

		}

		$this->obj_tmpl->addVar('display', 'TOTAL_DATA', $no);	

	}

	

	private function DisplayDetailForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Detail</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'detail');

		// parse data	

		$id = (isset($this->arr_routes['params'][1])?$this->arr_routes['params'][1]:0);

		$result = $this->obj_info->GetDataAsSingleArray('GetDetailBukuTamuById', array($id));

		if(!empty($result)){

			$this->obj_tmpl->addVar('display', 'NAMA', $result['nama']);

			$this->obj_tmpl->addVar('display', 'EMAIL', $result['email']);

			$this->obj_tmpl->addVar('display', 'PROFESI', $result['profesi']);

			$this->obj_tmpl->addVar('display', 'PERIHAL', $result['perihal']);

			$this->obj_tmpl->addVar('display', 'KONTEN', $result['konten']);

			$this->obj_tmpl->addVar('display', 'TANGGAL', $this->obj_date->GetFullDate($result['mdd'], "en"));

		}

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>

