<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_mdvi;

	protected $obj_notify;

	protected $obj_upload;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view-volume');	

	}

	

	protected function PageLoad(){ 

		// load business

		$this->obj_mdvi = $this->obj_ctrl->LoadBusiness('mdvi', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert_konten':

				self::InsertKonten();

				break;

			case 'update_konten':

				self::UpdateKonten();

				break;

			case 'delete_konten':

				self::DeleteKonten();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// operation

	

	private function InsertKonten(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['id_vol'])){ $err[] = '<br /><strong>Volume</strong> tidak terpilih'; }

		if(empty($this->arr_params['tipe'])){ $err[] = '<br /><strong>Tipe</strong> harus diisi'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['abstrak'])){ $err[] = '<br /><strong>Abstrak Indonesia</strong> harus diisi'; }

		if(empty($this->arr_params['abstrak_en'])){ $err[] = '<br /><strong>Abstrak Inggris</strong> harus diisi'; }

		$filename = '';

		if(isset($_FILES['file_name']['name'])){

			$filename = str_replace(' ', '_', $_FILES['file_name']['name']);

		}

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array($this->arr_params['id_vol'], $this->arr_params['tipe'], $this->arr_params['judul'], $this->arr_params['pengirim'], $this->arr_params['alamat'], $this->arr_params['abstrak'], $this->arr_params['abstrak_en'], $this->arr_params['urutan'], $filename, $this->str_userid);

			// --

			if($this->obj_mdvi->ProcessingRawData("InsertKonten", $params)){

				// get last id

				$result = $this->obj_mdvi->GetDataAsSingleArray("GetLastIdKonten", array());

				$id_konten = $result['last_id'];

				// uploadfile		

				$err[] = self::UploadFulltext($this->arr_params['id_vol'], $id_konten);

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array("JUDUL" => $this->arr_params['judul'], $this->arr_params['tipe'] => 'selected="selected"', "PENGIRIM" => $this->arr_params['pengirim'], "ALAMAT" => $this->arr_params['alamat'], "ABSTRAK" => $this->arr_params['abstrak'], "ABSTRAK_EN" => $this->arr_params['abstrak'], "URUTAN" => $this->arr_params['urutan']);

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			$filled = array("JUDUL" => $this->arr_params['judul'], $this->arr_params['tipe'] => 'selected="selected"', "PENGIRIM" => $this->arr_params['pengirim'], "ALAMAT" => $this->arr_params['alamat'], "ABSTRAK" => $this->arr_params['abstrak'], "ABSTRAK_EN" => $this->arr_params['abstrak'], "URUTAN" => $this->arr_params['urutan']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'add-content', array($this->arr_params['id_vol']));

	}

	

	private function UpdateKonten(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['id'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_vol'])){ $err[] = '<br /><strong>Volume</strong> tidak terpilih'; }

		if(empty($this->arr_params['tipe'])){ $err[] = '<br /><strong>Tipe</strong> harus diisi'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['abstrak'])){ $err[] = '<br /><strong>Abstrak Indonesia</strong> harus diisi'; }

		if(empty($this->arr_params['abstrak_en'])){ $err[] = '<br /><strong>Abstrak Inggris</strong> harus diisi'; }

		$filename = $this->arr_params['file_old'];

		if(!empty($_FILES['file_name']['name'])){

			$filename = str_replace(' ', '_', $_FILES['file_name']['name']);

		}

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array($this->arr_params['tipe'], $this->arr_params['judul'], $this->arr_params['pengirim'], $this->arr_params['alamat'], $this->arr_params['abstrak'], $this->arr_params['abstrak_en'], $this->arr_params['urutan'], $filename, $this->str_userid, $this->arr_params['id']);

			// --

			if($this->obj_mdvi->ProcessingRawData("UpdateKonten", $params)){

				// uploadfile		

				$err[] = self::UploadFulltext($this->arr_params['id_vol'], $this->arr_params['id']);

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array("JUDUL" => $this->arr_params['judul'], $this->arr_params['tipe'] => 'selected="selected"', "PENGIRIM" => $this->arr_params['pengirim'], "ALAMAT" => $this->arr_params['alamat'], "ABSTRAK" => $this->arr_params['abstrak'], "ABSTRAK_EN" => $this->arr_params['abstrak'], "URUTAN" => $this->arr_params['urutan']);

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			$filled = array("JUDUL" => $this->arr_params['judul'], $this->arr_params['tipe'] => 'selected="selected"', "PENGIRIM" => $this->arr_params['pengirim'], "ALAMAT" => $this->arr_params['alamat'], "ABSTRAK" => $this->arr_params['abstrak'], "ABSTRAK_EN" => $this->arr_params['abstrak'], "URUTAN" => $this->arr_params['urutan']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'edit-content', array($this->arr_params['id_vol'], $this->arr_params['id']));

	}

	

	private function DeleteKonten(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['id_vol'])){ $err[] = '<br /><strong>Volume tidak terpilih</strong>'; }

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>Tidak ada yang terpilih</strong>'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// delete

			foreach($this->arr_params['downcheck'] as $id){

				// delete data

				$params = array($id);

				$this->obj_mdvi->ProcessingData("DeleteKonten", $params);

				// delete file

				$file_path = "doc/mdvi/".$this->arr_params['id_vol']."/".$id."/";

				// delete last 

				if(is_dir($file_path))

					$this->obj_upload->RemoveDir($file_path);

			}

			// sukses message				

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

			// redirect to success page ------------------------------------

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view-content', array($this->arr_params['id_vol']));

	}	

	

	private function UploadFulltext($id_vol, $id_konten){

		// allowed type

		$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl');

		$err = "";

		if(isset($_FILES['file_name']['tmp_name']) AND !empty($_FILES['file_name']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['file_name']['name']);

			$file_path = "doc/mdvi/fulltext/".$id_vol."/".$id_konten."/";

			// processing

			if($this->obj_upload->FileUpload($_FILES['file_name'], $file_path)){

				$err = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 

			}else{

				$err = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}

		}

		return $err;

	}

}



?>