<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_mdvi;

	protected $obj_notify;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view');	

	}

	

	protected function PageLoad(){ 

		// load business

		$this->obj_mdvi = $this->obj_ctrl->LoadBusiness('mdvi', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'pedoman':

				self::UpdatePedoman();

				break;

			case 'pedoman_en':

				self::UpdatePedomanEn();

				break;

			case 'susunan_redaksi':

				self::SusunanRedaksi();

				break;

			case 'informasi':

				self::InformasiMajalah();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// operation

	

	private function SusunanRedaksi(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Full text</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array('susunan_redaksi', $this->arr_params['content'], $this->str_userid);

			if($this->obj_mdvi->ProcessingRawData("UpdateMdvi", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view');

	}

	

	private function UpdatePedoman(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Full text</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array('pedoman', $this->arr_params['content'], $this->str_userid);

			if($this->obj_mdvi->ProcessingRawData("UpdateMdvi", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view', array('pedoman'));

	}

	

	private function UpdatePedomanEn(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Full text</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array('pedoman_en', $this->arr_params['content'], $this->str_userid);

			if($this->obj_mdvi->ProcessingRawData("UpdateMdvi", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view', array('pedoman-en'));

	}

	

	private function InformasiMajalah(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Full text</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array('informasi', $this->arr_params['content'], $this->str_userid);

			if($this->obj_mdvi->ProcessingRawData("UpdateMdvi", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view', array('informasi'));

	}

}



?>