<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_mdvi;

	protected $obj_notify;

	protected $obj_upload;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view-volume');	

	}

	

	protected function PageLoad(){ 

		// load business

		$this->obj_mdvi = $this->obj_ctrl->LoadBusiness('mdvi', 'mysql', $this->arr_config['db']);

		// load library

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert_volume':

				self::InsertVolume();

				break;

			case 'delete_volume':

				self::DeleteVolume();

				break;

			case 'update_volume':

				self::UpdateVolume();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// operation

	

	private function InsertVolume(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['volume'])){ $err[] = '<br /><strong>Volume</strong> harus diisi'; }

		if(empty($this->arr_params['nomor'])){ $err[] = '<br /><strong>Nomor</strong> harus diisi'; }

		if(empty($this->arr_params['tahun'])){ $err[] = '<br /><strong>Tahun</strong> harus diisi'; }

		if(empty($this->arr_params['bulan'])){ $err[] = '<br /><strong>Bulan</strong> harus diisi'; }

		if(empty($this->arr_params['judul_editorial'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['pengirim_editorial'])){ $err[] = '<br /><strong>Pengirim</strong> harus diisi'; }

		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }

		if(empty($this->arr_params['fulltext_editorial'])){ $err[] = '<br /><strong>Full Text</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array($this->arr_params['volume'], $this->arr_params['nomor'], $this->arr_params['tahun'], $this->arr_params['bulan'], $this->arr_params['judul_editorial'], $this->arr_params['fulltext_editorial'], $this->arr_params['pengirim_editorial'], $this->arr_params['address'], $this->str_userid);

			if($this->obj_mdvi->ProcessingRawData("InsertVolume", $params)){

				// get last id

				$int_last_id = $this->obj_mdvi->GetDataAsSingleArray("GetLastIdVolume", array());

				// upload images

				$err[] = self::UploadGambar($int_last_id['last_id']);

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array("VOLUME" => $this->arr_params['volume'], "NOMOR" => $this->arr_params['nomor'], "TAHUN" => $this->arr_params['tahun'], "BULAN_".$this->arr_params['bulan'] => 'selected="selected"', "JUDUL_EDITORIAL" => $this->arr_params['judul_editorial'], "PENGIRIM_EDITORIAL" => $this->arr_params['pengirim_editorial'], "ADDRESS" => $this->arr_params['address'], "FULLTEXT_EDITORIAL" => $this->arr_params['fulltext_editorial']);

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			$filled = array("VOLUME" => $this->arr_params['volume'], "NOMOR" => $this->arr_params['nomor'], "TAHUN" => $this->arr_params['tahun'], "BULAN_".$this->arr_params['bulan'] => 'selected="selected"', "JUDUL_EDITORIAL" => $this->arr_params['judul_editorial'], "PENGIRIM_EDITORIAL" => $this->arr_params['pengirim_editorial'], "ADDRESS" => $this->arr_params['address'], "FULLTEXT_EDITORIAL" => $this->arr_params['fulltext_editorial']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'add-volume');

	}

	

	private function UpdateVolume(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['id_vol'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }

		if(empty($this->arr_params['volume'])){ $err[] = '<br /><strong>Volume</strong> harus diisi'; }

		if(empty($this->arr_params['nomor'])){ $err[] = '<br /><strong>Nomor</strong> harus diisi'; }

		if(empty($this->arr_params['tahun'])){ $err[] = '<br /><strong>Tahun</strong> harus diisi'; }

		if(empty($this->arr_params['bulan'])){ $err[] = '<br /><strong>Bulan</strong> harus diisi'; }

		if(empty($this->arr_params['judul_editorial'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['pengirim_editorial'])){ $err[] = '<br /><strong>Pengirim</strong> harus diisi'; }

		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }

		if(empty($this->arr_params['fulltext_editorial'])){ $err[] = '<br /><strong>Full Text</strong> harus diisi'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// insert

			$params = array($this->arr_params['volume'], $this->arr_params['nomor'], $this->arr_params['tahun'], $this->arr_params['bulan'], $this->arr_params['judul_editorial'], $this->arr_params['fulltext_editorial'], $this->arr_params['pengirim_editorial'], $this->arr_params['address'], $this->str_userid, $this->arr_params['id_vol']);

			if($this->obj_mdvi->ProcessingRawData("UpdateVolume", $params)){

				// upload images

				$err[] = self::UploadGambar($this->arr_params['id_vol']);

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array("VOLUME" => $this->arr_params['volume'], "NOMOR" => $this->arr_params['nomor'], "TAHUN" => $this->arr_params['tahun'], "BULAN_".$this->arr_params['bulan'] => 'selected="selected"', "JUDUL_EDITORIAL" => $this->arr_params['judul_editorial'], "PENGIRIM_EDITORIAL" => $this->arr_params['pengirim_editorial'], "ADDRESS" => $this->arr_params['address'], "FULLTEXT_EDITORIAL" => $this->arr_params['fulltext_editorial']);

				// error message

				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');

				// redirect to page error page --------------------------------

			}

		}else{

			$filled = array("VOLUME" => $this->arr_params['volume'], "NOMOR" => $this->arr_params['nomor'], "TAHUN" => $this->arr_params['tahun'], "BULAN_".$this->arr_params['bulan'] => 'selected="selected"', "JUDUL_EDITORIAL" => $this->arr_params['judul_editorial'], "PENGIRIM_EDITORIAL" => $this->arr_params['pengirim_editorial'], "ADDRESS" => $this->arr_params['address'], "FULLTEXT_EDITORIAL" => $this->arr_params['fulltext_editorial']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'edit-volume', array($this->arr_params['id_vol']));

	}

	

	private function DeleteVolume(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>Tidak ada yang terpilih</strong>'; }

		// processing -----------------------------------------------------

		if(empty($err)){			

			// delete

			foreach($this->arr_params['downcheck'] as $id){

				$params = array($id);

				$this->obj_mdvi->ProcessingData("DeleteVolume", $params);

			}

			// sukses message				

			self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

			// redirect to success page ------------------------------------

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view-volume');

	}

	

	private function UploadGambar($id_vol){		

		$err = "";

		if(!empty($id_vol)){

			// allowed type

			$err = "";

			if(isset($_FILES['images']['tmp_name']) AND !empty($_FILES['images']['tmp_name'])){

				// name and path file

				$file_name = str_replace(' ', '_', $_FILES['images']['name']);

				$file_path = "doc/mdvi/images/".$id_vol."/";

				// delete last

				if(is_dir($file_path))

					$this->obj_upload->RemoveDir($file_path);

				// processing

				if($this->obj_upload->ImageUpload($_FILES['images'], $file_path, 300)){

					// insert to database

					$params = array($file_name, $id_vol);

					$this->obj_mdvi->ProcessingData("UpdateVolumeImages", $params);

					$err = '<br /><strong>Gambar</strong> berhasil diupload'; 

				}else{

					$err = '<br /><strong>Gambar</strong> tidak berhasil diupload'; 

				}

			}

		}

		return $err;

	}

}



?>