<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_mdvi;

	private $obj_person;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load object

		$this->obj_mdvi = $this->obj_ctrl->LoadBusiness('mdvi', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		// load javascript

		$this->obj_ctrl->LoadJavascript('tiny_mce');

	}

	

	public function PageView(){

		// display notification

		self::DisplayNotification();

		// page link

		self::DisplayPageLink();

		// detail volume

		self::DisplayDetailVolume();

		// list konten

		self::DisplayListKonten();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayPageLink(){		

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add-content', array($this->arr_routes['params'][0])));

		// sub nav

		$this->obj_tmpl->addVar('content', 'URL_MDVI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));

		$this->obj_tmpl->addVar('content', 'URL_VOLUME', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-volume'));

		$this->obj_tmpl->addVar('content', 'URL_KONTEN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-content', array($this->arr_routes['params'][0])));

		// process

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process-content'));

	}

	

	private function DisplayDetailVolume(){

		$id_vol = 0;

		if(isset($this->arr_routes['params'][0])){

			$id_vol = $this->arr_routes['params'][0];

		}

		$result = $this->obj_mdvi->GetDataAsSingleArray("GetDetailVolumeById", array($id_vol));

		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'ID_VOL', $result['id_vol']);

			$this->obj_tmpl->addVar('content', 'VOLUME', $result['volume']);

			$this->obj_tmpl->addVar('content', 'NOMOR', $result['nomor']);

		}

	}

	

	private function DisplayListKonten(){

		if(!isset($this->arr_routes['params'][1])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params'][1];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$total = $this->obj_mdvi->GetDataAsSingleArray("GetTotalContentByVolume", array($this->arr_routes['params'][0]));

		$this->obj_paging->SetTotalRecord($total['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params'][0])));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$rs_id = $this->obj_mdvi->GetResourceId("GetListContentByVolume", array($this->arr_routes['params'][0], $start, $max));

		$no = 0;

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit-content', array($rec['id_vol'], $rec['id']));

				// display last update

				$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($rec['mdb']));

				$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($rec['mdd']));

				$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

				// --

				$this->obj_tmpl->addVar('list_data', 'NO', ($no + 1));

				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id']);	

				$this->obj_tmpl->addVar('list_data', 'TIPE',ucwords($rec['tipe']));

				$this->obj_tmpl->addVar('list_data', 'JUDUL', $rec['judul']);

				$this->obj_tmpl->addVar('list_data', 'URUTAN', $rec['urutan']);

				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $edit);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');

				$no++;

			}

		}

	}

	

}



?>