<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_mdvi;

	private $obj_person;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_mdvi = $this->obj_ctrl->LoadBusiness('mdvi', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		// javascript

		$this->obj_ctrl->LoadJavascript('tiny_mce');

	}

	

	public function PageView(){

		// notification

		self::DisplayNotification();

		// page link

		self::DisplayPageLink();

		// display list volume

		self::DisplayListArchive();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/		

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayPageLink(){		

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add-volume'));

		// sub nav

		$this->obj_tmpl->addVar('content', 'URL_MDVI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));

		$this->obj_tmpl->addVar('content', 'URL_VOLUME', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-volume'));

		// process

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process-volume'));

	}

	

	private function DisplayListArchive(){

		if(!isset($this->arr_routes['params'][0])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params'][0];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$total = $this->obj_mdvi->GetDataAsSingleArray("GetTotalVolume", array());

		$this->obj_paging->SetTotalRecord($total['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$rs_id = $this->obj_mdvi->GetResourceId("GetListVolume", array($start, $max));

		$no = 0;

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit-volume', array($rec['id_vol']));

				$konten = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-content', array($rec['id_vol']));

				// display last update

				$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($rec['mdb']));

				$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($rec['mdd']));

				$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

				// --

				$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

				$this->obj_tmpl->addVar('list_data', 'NO', ($no + 1));

				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_vol']);	

				$this->obj_tmpl->addVar('list_data', 'VOLUME', $rec['volume']);

				$this->obj_tmpl->addVar('list_data', 'NOMOR', $rec['nomor']);

				$this->obj_tmpl->addVar('list_data', 'TAHUN', $rec['tahun']);

				$this->obj_tmpl->addVar('list_data', 'BULAN', $rec['bulan']);

				$this->obj_tmpl->addVar('list_data', 'JUDUL', $rec['judul_editorial']);

				$this->obj_tmpl->addVar('list_data', 'TANGGAL', $rec['mdd']);

				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $edit);

				$this->obj_tmpl->addVar('list_data', 'URL_CONTENT', $konten);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');

				$no++;

			}

		}

	}

}



?>