<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_mdvi;

	private $obj_person;

	private $obj_notify;

	private $obj_date;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_mdvi = $this->obj_ctrl->LoadBusiness('mdvi', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

      	$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// load javascript

      	$this->obj_ctrl->LoadJavascript('tiny_mce');

	}

	

	public function PageView(){

		// page link

		self::DisplayPageLink();

		// display page

		self::DisplayPage();

		// display notification

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayPageLink(){

		// sub nav

		$this->obj_tmpl->addVar('content', 'URL_REDAKSI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		$this->obj_tmpl->addVar('content', 'URL_PEDOMAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('pedoman')));

		$this->obj_tmpl->addVar('content', 'URL_PEDOMAN_EN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('pedoman-en')));

		$this->obj_tmpl->addVar('content', 'URL_INFORMATION', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('informasi')));

		// volume

		$this->obj_tmpl->addVar('content', 'URL_VOLUME', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-volume'));

		// process

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process-mdvi'));

	}



   private function DisplayPage(){		

		if(isset($this->arr_routes['params'][0])){

			switch($this->arr_routes['params'][0]){

				case 'pedoman':

					$this->obj_tmpl->addVar('content', 'TITLE', 'Pedoman Untuk Penulis');

					$this->obj_tmpl->addVar('content', 'PEDOMAN_ACTIVE', 'class="active"');

					$this->obj_tmpl->addVar('content', 'SAVE', "pedoman");

					$result = $this->obj_mdvi->GetDataAsSingleArray("GetMdviByField", array("pedoman"));

					$this->obj_tmpl->addVar('content', 'CONTENT', $result['pedoman']);

					break;

				case 'pedoman-en':

					$this->obj_tmpl->addVar('content', 'TITLE', 'Guidlines For Author');

					$this->obj_tmpl->addVar('content', 'PEDOMAN_EN_ACTIVE', 'class="active"');

					$this->obj_tmpl->addVar('content', 'SAVE', "pedoman_en");

					$result = $this->obj_mdvi->GetDataAsSingleArray("GetMdviByField", array("pedoman_en"));

					$this->obj_tmpl->addVar('content', 'CONTENT', $result['pedoman_en']);

					break;

				case 'informasi':

					$this->obj_tmpl->addVar('content', 'TITLE', 'Informasi Majalah');

					$this->obj_tmpl->addVar('content', 'INFORMATION_ACTIVE', 'class="active"');

					$this->obj_tmpl->addVar('content', 'SAVE', "informasi");

					$result = $this->obj_mdvi->GetDataAsSingleArray("GetMdviByField", array("informasi"));

					$this->obj_tmpl->addVar('content', 'CONTENT', $result['informasi']);

					break;

				default:

					$this->obj_tmpl->addVar('content', 'TITLE', 'Susunan Redaksi');

					$this->obj_tmpl->addVar('content', 'REDAKSI_ACTIVE', 'class="active"');

					$this->obj_tmpl->addVar('content', 'SAVE', 'susunan_redaksi');

					$result = $this->obj_mdvi->GetDataAsSingleArray("GetMdviByField", array("susunan_redaksi"));

					$this->obj_tmpl->addVar('content', 'CONTENT', $result['susunan_redaksi']);

					break;

			}

		}else{

			$this->obj_tmpl->addVar('content', 'TITLE', 'Susunan Redaksi');

			$this->obj_tmpl->addVar('content', 'REDAKSI_ACTIVE', 'class="active"');

			$this->obj_tmpl->addVar('content', 'SAVE', 'susunan_redaksi');

			$result = $this->obj_mdvi->GetDataAsSingleArray("GetMdviByField", array("susunan_redaksi"));

			$this->obj_tmpl->addVar('content', 'CONTENT', $result['susunan_redaksi']);

		}

		// display last update

		$data = $this->obj_mdvi->GetDataAsSingleArray("GetMdvi", array());

		$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($data['mdb']));

		$this->obj_tmpl->addVar('content', 'MDD', $this->obj_date->GetFullDate($data['mdd']));

		$this->obj_tmpl->addVar('content', 'MDB', $person['nama']);

   }

}



?>