<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_news;

	private $obj_date;

	private $obj_notify;

	private $arr_params;

	private $obj_upload;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori']));

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_news = $this->obj_ctrl->LoadBusiness('news', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		$err = array();

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['kategori'])){ $err[] = '<br /><strong>Kategori</strong> tidak terpilih'; }

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsidescription</strong> harus diisi'; }

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Konten</strong> harus diisi'; }

		$id_news = $this->obj_news->GetLastIdNews(array());

		// processing --------------------------------------------------

		if(empty($err)){

			$filename = self::UploadImage($id_news);

			$params = array("id_news" => $id_news, "id_cat" => $this->arr_params['cat'], "bahasa" => $this->arr_params['bahasa'],"judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => $filename, "img_note" => $this->arr_params['image_note'], "hit" => 0,

							"mdb" => $this->str_userid, "headline" => $this->arr_params['headline'],"sort_head" => $this->arr_params['sort_head']);
							
							
				//$this->obj_news->DebugQuery("SetNews",$params);exit;			

			if($this->obj_news->SetNews($params, true)){

				// notification message				

				self::SendNotification($err, array(), "Data has been saved.", "success");

			}else{

				// error message

				self::SendNotification($err, $params, "Business process failure.", "error");

			}	

		}else{

			// error message

			$params = array("id_cat" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => "", "img_note" => $this->arr_params['image_note'],

							"headline" => $this->arr_params['headline'],"sort_head" => $this->arr_params['sort_head']);

			self::SendNotification($err, $params, "See input requirement.", "error");

		}

		// redirect to page error page ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori'], 'add'));

	}

	

  	private function UploadImage($id_news){

		// allowed type

		$file_name = "";

		if(isset($_FILES['image']['tmp_name']) AND !empty($_FILES['image']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['image']['name']);

			$file_path = "doc/news/public/".$id_news.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->ImageUpload($_FILES['image'], $file_path,350);

		}

		return $file_name;

	}



	private function UpdateData(){

		// check / validate parameter 

		$err = array();	

		$filled = array();

		if(empty($this->arr_params['kategori'])){ $err[] = '<br /><strong>Kategori</strong> tidak terpilih'; }

		if(empty($this->arr_params['id_berita'])){ $err[] = '<br /><strong>Berita</strong> tidak terpilih'; }

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsidescription</strong> harus diisi'; }

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Konten</strong> harus diisi'; }

		// processing --------------------------------------------------

      	$a = $this->obj_news->GetNewsById(array($this->arr_params['id_berita']));

		if(empty($err)){

         	$filename = self::UploadImage($this->arr_params['id_berita']);

			if ($filename=="") {

				$filename = $a['0']['img_name'];

			}

			$params = array("id_cat" => $this->arr_params['cat'],"bahasa" => $this->arr_params['bahasa'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => $filename, "img_note" => $this->arr_params['image_note'],

							"hit" => $this->arr_params['hit'], "mdb" => $this->str_userid, "headline" => $this->arr_params['headline'],

							"sort_head" => $this->arr_params['sort_head'], "id_berita" => $this->arr_params['id_berita']);

			if($this->obj_news->SetNews($params, false)){

				// notification message	

	         	self::SendNotification($err, array(), "Data has been saved.", "success");

			}else{

				// error message

				self::SendNotification($err, $params, "Business process failure.", "error");

			}	

		}else{

			// error message

         	$params = array("id_cat" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => $a['0']['img_name'], "img_note" => $this->arr_params['image_note'],

							"hit" => $this->arr_params['hit'],"headline" => $this->arr_params['headline'],

							"sort_head" => $this->arr_params['sort_head']);

			self::SendNotification($err, $params, "See input requirement.", "error");

   		

		}

		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori'], 'edit', $this->arr_params['id_berita']));	

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		$filled = array();

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_news->DeleteNewsById(array($id))){

					$file_path = "doc/news/public/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					// notification message	

	         		self::SendNotification($err, array(), "Data has been deleted.", "success");

				}else{

					// error message

					self::SendNotification($err, array(), "Business process failure.", "error");

				}

			}				

		}else{

			// error message

			self::SendNotification($err, array(), "See input requirement.", "error");

		}

	}

   

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		foreach($filled as $key=>$value){

			$this->obj_notify->SetField($key, $value);

		}

		$this->obj_notify->SentMessage();

	}

}



?>