<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_news;

	private $obj_person;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		$this->obj_news = $this->obj_ctrl->LoadBusiness('news', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		/* 

		-- display view content

		*/

      self::DisplayPageLink();

      self::DisplayRedirect();

      self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		$this->obj_tmpl->addVar('content', 'URL_HEAD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'],array('head')));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process-category'));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS_HEAD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));		

	}



   private function DisplayRedirect() {

      if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "add") {

         self::DisplayAddForm();

      } else if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "edit") {

         self::DisplayEditForm();

	  } else if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "head") { 	 

		 self::DisplayListHeadLineNews();

      } else {

         self::DisplayListArchive();

      }

   }

   

	private function DisplayListArchive(){

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		// --

		if(!isset($this->arr_routes['params']['0'])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params']['0'];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(10);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_news->CountNewsCategory(array()));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$newsCat = $this->obj_news->GetCategory(array($start, $max));

		if (sizeof($newsCat) > 0) {

			$this->obj_tmpl->addVar('cat', 'cat', 'have');

		}

		$no = 0;

		$num = $start+1;

		foreach($newsCat as $key=>$value) {

			$href = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($value['id_cat']));

			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array("edit", $value['id_cat']));

			// display last update

			$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($value['mdb']));

			$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($value['mdd']));

			$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

			// --

			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

			$this->obj_tmpl->addVar('list_data', 'NO', $num);

			$this->obj_tmpl->addVar('list_data', 'ID', $value['id_cat']);	

			$this->obj_tmpl->addVar('list_data', 'NAME', $value['nama']);

			$this->obj_tmpl->addVar('list_data', 'DESCRIPTION', $value['deskripsi']);

			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);

			$this->obj_tmpl->addVar('list_data', 'URL_NEWS', $href);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');

			$no++;

			$num++;

		}

	}	

	

	private function DisplayListHeadLineNews(){

  		$this->obj_tmpl->addVar('content', 'VIEW_HEAD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'head');

		if(!isset($this->arr_routes['params']['1'])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params']['1'];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(10);

		// set total record

		$total = $this->obj_news->GetDataAsSingleArray('CountNewsHeadByCategoryId',array());

		$this->obj_paging->SetTotalRecord($total['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0']))."/");

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$news = $this->obj_news->GetDatasetAsArray('GetNewsHeadByCategoryId',array($start, $max));

//		print_r($news);

		//$this->obj_news->DebugQuery('GetNewsHeadByCategoryId',array($start, $max));

		$no = 0;

		$num = $start+1;

		foreach($news as $key=>$value) {

			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($value['id_cat'], "edit", $value['id_berita']));

			// display last update

			$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($value['mdb']));

			$this->obj_tmpl->addVar('list_data_head', 'MDD', $this->obj_date->GetFullDate($value['mdd']));

			$this->obj_tmpl->addVar('list_data_head', 'MDB', $person['nama']);

			// --

			

			$this->obj_tmpl->addVar('list_data_head', 'INDEX', $no);

			$this->obj_tmpl->addVar('list_data_head', 'NO', $num);

			$this->obj_tmpl->addVar('list_data_head', 'ID', $value['id_berita']);	

			$this->obj_tmpl->addVar('list_data_head', 'CATEGORY', $value['nama']);

			$this->obj_tmpl->addVar('list_data_head', 'TITLE', $value['judul']);

			$this->obj_tmpl->addVar('list_data_head', 'DESCRIPTION', $value['deskripsi']);

			$this->obj_tmpl->addVar('list_data_head', 'CONTENT', $value['content']);

			$this->obj_tmpl->addVar('list_data_head', 'URL_IMAGE', HTTPPATH . 'doc/news/public/' . $value['id_berita'] . '/' . $value['img_name']);

			$this->obj_tmpl->addVar('list_data_head', 'IMG_NAME', $value['img_name']);

			$this->obj_tmpl->addVar('list_data_head', 'IMG_NOTE', $value['img_note']);

			$this->obj_tmpl->addVar('list_data_head', 'HIT', $value['hit']);

			$this->obj_tmpl->addVar('list_data_head', 'URL_EDIT', $href1);

			$this->obj_tmpl->ParseTemplate('list_data_head', 'a');

			$no++;

			$num++;

		}

	}	





	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$result = $this->obj_news->GetCategoryById(array($this->arr_routes['params']['1']));

		$this->obj_tmpl->addVar('display', 'ID', $result['0']['id_cat']);	

		$this->obj_tmpl->addVar('display', 'CAT', $result['0']['nama']);

		$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['deskripsi']);

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>