<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_otherlink;

	private $obj_notify;

	private $arr_params;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'view');

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_otherlink = $this->obj_ctrl->LoadBusiness('otherlink', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert_otherlink':

				self::InsertOtherlink();

				break;

			case 'update_otherlink':

				self::UpdateOtherlink();

				break;			

			case 'delete_otherlink':

				self::DeleteOtherlink();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	private function InsertOtherlink(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		if(empty($this->arr_params['url'])){ $err[] = '<br /><strong>URL Link</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['nama'], $this->arr_params['deskripsi'], $this->arr_params['url'], $this->str_userid);

			if($this->obj_otherlink->ProcessingData("InsertOtherlink", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array("NAMA" => $this->arr_params['nama'], "DESKRIPSI" => $this->arr_params['deskripsi'], "URL" => $this->arr_params['url']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------				

			}	

		}else{

			$filled = array("NAMA" => $this->arr_params['nama'], "DESKRIPSI" => $this->arr_params['deskripsi'], "URL" => $this->arr_params['url']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		// redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

	}



	private function UpdateOtherlink(){ 

		$err = array();	

		$filled = array();

		// check / validate parameter

		if(empty($this->arr_params['id'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }

		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['deskripsi'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		if(empty($this->arr_params['url'])){ $err[] = '<br /><strong>URL Link</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['nama'], $this->arr_params['deskripsi'], $this->arr_params['url'], $this->str_userid, $this->arr_params['id']);

			if($this->obj_otherlink->ProcessingData("UpdateOtherlink", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				$filled = array("NAMA" => $this->arr_params['nama'], "DESKRIPSI" => $this->arr_params['deskripsi'], "URL" => $this->arr_params['url']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------				

			}	

		}else{

			$filled = array("NAMA" => $this->arr_params['nama'], "DESKRIPSI" => $this->arr_params['deskripsi'], "URL" => $this->arr_params['url']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('edit', $this->arr_params['id']));	

	}

	

	private function DeleteOtherlink(){

		// check / validate parameter 

		$err = array();	

		$filled = array();

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_otherlink->ProcessingData("DeleteOtherlinkById", array($id))){

					// sukses message				

					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

				}else{

					// error message

					self::SendNotification($err, $filled, 'Business process failure.', 'error');

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

	}

}



?>