<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_sponsor;

	private $obj_banner;

	private $obj_date;

	private $obj_notify;

	private $arr_params;

	private $obj_upload;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'view');

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_sponsor = $this->obj_ctrl->LoadBusiness('sponsor', 'mysql', $this->arr_config['db']);

		$this->obj_banner = $this->obj_ctrl->LoadBusiness('banner', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			case 'update_welcome_banner':

				self::UpdateWelcomeBanner();

				break;

			case 'delete_banner':

				self::DeleteBanner();

				break;

			case 'insert_banner':

				self::InsertBanner();

				break;

			case 'update_banner':

				self::UpdateBanner();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	private function InsertData(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Title</strong> harus diisi'; }

		if(empty($this->arr_params['link'])){ $err[] = '<br /><strong>URL Link</strong> harus diisi'; }

		$id_sponsor = $this->obj_sponsor->GetLastIdSponsor(array());

		// processing --------------------------------------------------

		if(empty($err)){

         	$filename = self::UploadImage($id_sponsor);

			$params = array($id_sponsor, "judul" => $this->arr_params['title'], "img_name" => $filename, 

							"img_path" => 'doc/sponsor/'.$id_sponsor.'/', "url_link" => $this->arr_params['link'], 

							"sort" => intval($this->arr_params['sort']), "mdb" => $this->str_userid);

			if($this->obj_sponsor->SetSponsor($params, true)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------				

			}	

		}else{

			$filled = array("TITLE" => $this->arr_params['title'], "LINK" => $this->arr_params['link'], "SORT" => $this->arr_params['sort']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		// redirect to page error page ------------------------------------	

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

	}

	

  	private function UploadImage($id_sponsor){

		// allowed type

      	$file_name = "";

		if(isset($_FILES['image']['tmp_name']) AND !empty($_FILES['image']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['image']['name']);

			$file_path = "doc/sponsor/".$id_sponsor.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 180);

		}

		return $file_name;

	}



	private function UpdateData(){ 

		$err = array();	

		$filled = array();

		// check / validate parameter

		if(empty($this->arr_params['id_sponsor'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Title</strong> harus diisi'; }

		if(empty($this->arr_params['link'])){ $err[] = '<br /><strong>URL Link</strong> harus diisi'; }

      	$sponsor = $this->obj_sponsor->GetSponsorById(array($this->arr_params['id_sponsor']));

		// processing --------------------------------------------------

		if(empty($err)){

			$filename = self::UploadImage($this->arr_params['id_sponsor']);

			if($filename == "") {

				$filename = $sponsor['0']['img_name'];

			}

			$params = array("judul" => $this->arr_params['title'], "img_name" => $filename,

							"img_path" => 'doc/sponsor/'.$this->arr_params['id_sponsor'].'/', 

							"url_link" => $this->arr_params['link'], "sort" => $this->arr_params['sort'], 

							"mdb" => $this->str_userid, "id_sponsor" => $this->arr_params['id_sponsor']);

			if($this->obj_sponsor->SetSponsor($params, false)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

			}	

		}else{

			$filled = array("TITLE" => $this->arr_params['title'], "LINK" => $this->arr_params['link'], "SORT" => $this->arr_params['sort']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('edit', $this->arr_params['id_sponsor']));	

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		$filled = array();

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_sponsor->DeleteSponsorById(array($id))){

					$file_path = "doc/sponsor/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					// sukses message				

					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

				}else{

					// error message

					self::SendNotification($err, $filled, 'Business process failure.', 'error');

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

	}

	

	private function DeleteBanner(){

		// check / validate parameter 

		$err = array();	

		$filled = array();

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_banner->ProcessingData("DeleteBannerById", array($id))){

					$file_path = "doc/banner/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					// sukses message				

					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');

				}else{

					// error message

					self::SendNotification($err, $filled, 'Business process failure.', 'error');

				}

			}				

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

		}

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'welcome-banner');

	}

	

	private function InsertBanner(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($_FILES['banner']['tmp_name'])){ $err[] = '<br /><strong>Banner</strong>harus diisi'; }

		if(empty($this->arr_params['img_url'])){ $err[] = '<br /><strong>URL</strong>harus diisi'; }

		// get id

		$id = $this->obj_banner->GetDataAsSingleArray("GetBannerLastId", array());	

		// upoaded

		if(isset($_FILES['banner']['tmp_name']) AND !empty($_FILES['banner']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['banner']['name']);

			$file_path = "doc/banner/".$id['last'].'/';

			// processing

			//if(!$this->obj_upload->ImageUpload($_FILES['banner'], $file_path, 590)){

			if(!$this->obj_upload->ImageUpload($_FILES['banner'], $file_path, 970)){

				$err = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($id['last'], $file_name, $file_path, $this->arr_params['img_url'], $this->str_userid);

			// execute process

			if($this->obj_banner->ProcessingData("InsertBannerData", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'welcome-banner', array('add'));

	}

	

	private function UpdateBanner(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['img_url'])){ $err[] = '<br /><strong>URL</strong>harus diisi'; }

		// get id

		$id = $this->obj_banner->GetDataAsSingleArray("GetBannerLastId", array());	

		// upoaded

		if(isset($_FILES['banner']['tmp_name']) AND !empty($_FILES['banner']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['banner']['name']);

			$file_path = "doc/banner/".$this->arr_params['id'].'/';

			// processing

			//if(!$this->obj_upload->ImageUpload($_FILES['banner'], $file_path, 590)){

			if(!$this->obj_upload->ImageUpload($_FILES['banner'], $file_path, 970)){

				$err = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}

		}else{

			$file_name = $this->arr_params['img_name'];

			$file_path = "doc/banner/".$this->arr_params['id'].'/';

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($file_name, $file_path, $this->arr_params['img_url'], $this->str_userid, $this->arr_params['id']);

			// execute process

			if($this->obj_banner->ProcessingData("UpdateBannerData", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'welcome-banner', array('edit', $this->arr_params['id']));

	}

}



?>