<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_sponsor;

	private $obj_person;

	private $obj_paging;

	private $obj_date;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		$this->obj_sponsor = $this->obj_ctrl->LoadBusiness('sponsor', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		/* 

		-- display view content

		*/

      self::DisplayNotification();

      self::DisplayPageLink();

      self::DisplayRedirect();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}



   private function DisplayRedirect() {

      if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "add") {

         self::DisplayAddForm();

      } else if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "edit") {

         self::DisplayEditForm();

      } else {

         self::DisplayListArchive();

      }

   }

   

	private function DisplayListArchive(){

  		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');



		if(!isset($this->arr_routes['params']['0'])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params']['0'];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(10);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_sponsor->CountSponsor(array()));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$sponsor = $this->obj_sponsor->GetSponsor(array($start, $max));

      	$no = 0;

		foreach($sponsor as $key=>$value) {

			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array("edit", $value['id_sponsor']));

			$href = HTTPPATH . $value['img_path']."/".$value['img_name'];

			// display last update

			$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($value['mdb']));

			$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($value['mdd']));

			$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

			// --

			$this->obj_tmpl->addVar('list_data', 'NO', $no + 1);

			$this->obj_tmpl->addVar('list_data', 'ID', $value['id_sponsor']);	

			$this->obj_tmpl->addVar('list_data', 'TITLE', $value['judul']);

			$this->obj_tmpl->addVar('list_data', 'URL_IMAGE', $href);

			$this->obj_tmpl->addVar('list_data', 'LINK', $value['url_link']);

			$this->obj_tmpl->addVar('list_data', 'SORT', $value['sort']);

			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');

			$no++;

		}

	}	



	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$result = $this->obj_sponsor->GetSponsorById(array($this->arr_routes['params']['1']));

		$href = HTTPPATH . $result['0']['img_path']."/".$result['0']['img_name'];

		$this->obj_tmpl->addVar('display', 'ID', $result['0']['id_sponsor']);	

		$this->obj_tmpl->addVar('display', 'TITLE', $result['0']['judul']);

		$this->obj_tmpl->addVar('display', 'URL_IMAGE', $href);

		$this->obj_tmpl->addVar('display', 'LINK', $result['0']['url_link']);

		$this->obj_tmpl->addVar('display', 'SORT', $result['0']['sort']);

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>