<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_banner;

	protected $obj_person;

	protected $obj_notify;

	protected $obj_date;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		$this->obj_banner = $this->obj_ctrl->LoadBusiness('banner', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

	}

	

	public function PageView(){

		// display page link

		self::DisplayPageLink();

		// display banner

		self::DisplayBanner();

		// display notification

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'welcome-banner', array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'welcome-banner'));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function DisplayBanner() {

		if(isset($this->arr_routes['params'][0]) and $this->arr_routes['params'][0] == "add") {

			self::DisplayAddForm();

		}elseif (isset($this->arr_routes['params']['0']) and $this->arr_routes['params']['0'] == "edit") {

			self::DisplayEditForm();

		}else{

			self::DisplayListBanner();

		}

   }

	

	private function DisplayListBanner(){		

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		$rs_id = $this->obj_banner->GetResourceId("GetListBanner", array(0, 20));

		if($rs_id){

			$no = 1;

			while($rec = mysqli_fetch_assoc($rs_id)){			

				$this->obj_tmpl->addVar('list_banner', 'ID', $rec['id']);	

				$this->obj_tmpl->addVar('list_banner', 'IMG_PATH', $rec['img_path']);

				$this->obj_tmpl->addVar('list_banner', 'IMG_NAME', $rec['img_name']);

				$this->obj_tmpl->addVar('list_banner', 'NO', $no . '.');

				$this->obj_tmpl->addVar('list_banner', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'welcome-banner', array('edit', $rec['id'])));

				$this->obj_tmpl->ParseTemplate('list_banner', 'a');

				$no++;

			}

		}

	}

	

	private function DisplayAddForm(){		

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'data', 'add');

	}

	

	private function DisplayEditForm(){		

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'data', 'edit');

		// parse data	

		$result = $this->obj_banner->GetDataAsSingleArray("GetBannerById", array($this->arr_routes['params'][1]));

		$href = HTTPPATH.$result['img_path'].$result['img_name'];

		$this->obj_tmpl->addVar('display', 'ID', $result['id']);

		$this->obj_tmpl->addVar('display', 'IMG_NAME', $result['img_name']);

		$this->obj_tmpl->addVar('display', 'URL_IMAGE', $href);

		$this->obj_tmpl->addVar('display', 'IMG_URL', $result['img_link']);

		// display last update

		$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($result['mdb']));

		$this->obj_tmpl->addVar('display', 'MDD', $this->obj_date->GetFullDate($result['mdd']));

		$this->obj_tmpl->addVar('display', 'MDB', $person['nama']);

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>