<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_iuran;

	protected $obj_date;

	// variable definition

	protected $int_cabang;

	protected $int_tahun;

	protected $int_smt;

	protected $str_person;

	protected $str_status_anggota;

	protected $int_pp_value;

	protected $int_p2kb_value;

	protected $int_cabang_value;

	protected $int_start_bln;

	protected $arr_value;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('content');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_iuran = $this->obj_ctrl->LoadBusiness('iuran', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_iuran->SetUsesBusinessQuery($loaded_query);		

		// library loaded

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

	}

	

	public function PageView(){

		// display variable link

		self::DisplayVariableLink();

		// display laporan pembayaran

		self::DisplayDetailPerson();

		// display laporan pembayaran

		self::DisplayKontribusiPembayaran();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariableLink(){

		// cabang

		if(isset($this->arr_routes['params'][0])){

			$this->int_cabang = $this->arr_routes['params'][0];

		}

		// tahun

		if(isset($this->arr_routes['params'][1])){

			$this->int_tahun = $this->arr_routes['params'][1];

		}

		// semester

		if(isset($this->arr_routes['params'][2])){

			$this->int_smt = $this->arr_routes['params'][2];

		}

		// person

		if(isset($this->arr_routes['params'][3])){

			$this->str_person = $this->arr_routes['params'][3];

		}

	}

	

	private function DisplayDetailPerson(){

		$result = $this->obj_iuran->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->str_person));

		if(!empty($result)){			

			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);

			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);

			$this->obj_tmpl->addVar('content', 'NAMA', $result['nama_lengkap']);

			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);

			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);

			$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);

			$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);

			$this->str_status_anggota = $result['status_anggota'];

			// display foto

			$path = "doc/foto/".$result['photo'];

			if(is_file($path))

				$this->obj_tmpl->addVar('content', 'FOTO', $path);

			else

				$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");

		}

	}

	

	private function DisplayKontribusiPembayaran(){

		// get detail member

		$status_pembayaran = 'no';

		$status_anggota = $this->str_status_anggota;

		// parse data

		$rs_id = $this->obj_iuran->GetResourceId("GetDataIuranByAnggota", array($this->int_cabang, $this->int_tahun, $this->int_smt, $this->str_person));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$status_pembayaran = $rec['status_pelunasan'];

				$status_anggota = $rec['status_anggota'];

				if($status_pembayaran == 'yes'){

					$this->arr_value[$rec['bulan']] = $rec['p2kb'].'-'.$rec['pp'].'-'.$rec['cabang'];

				}

			}

		}

		// tahun

		$this->obj_tmpl->addVar("content", "TAHUN", $this->int_tahun);

		// parse bulan

		$arr_bln = array('Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember');

		$total['p2kb'] = 0;

		$total['pp'] = 0;

		$total['cabang'] = 0;

		switch($this->int_smt){

			case 'I':

				$this->int_start_bln = 1;

				$this->obj_tmpl->addVar("content", "SEMESTER", 'I (Januari - Juni)');

				for($i=0;$i<6;$i++){

					$data = array();

					$this->obj_tmpl->addVar("list_bulan", "BULAN", $arr_bln[$i]);

					if(isset($this->arr_value[$i + 1])){

						$data = explode('-', $this->arr_value[$i + 1]);

						$this->obj_tmpl->addVar("list_bulan", "P2KB", $data[0]);

						$this->obj_tmpl->addVar("list_bulan", "PP", $data[1]);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", $data[2]);

						$total['p2kb'] = $total['p2kb'] + $data[0];

						$total['pp'] = $total['pp'] + $data[1];

						$total['cabang'] = $total['cabang'] + $data[2];

						$this->obj_tmpl->addVar("list_bulan", "JUMLAH", array_sum($data));

					}else{

						$this->obj_tmpl->addVar("list_bulan", "P2KB", 0);

						$this->obj_tmpl->addVar("list_bulan", "PP", 0);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", 0);

						$this->obj_tmpl->addVar("list_bulan", "JUMLAH", 0);

					}					

					$this->obj_tmpl->ParseTemplate("list_bulan", "a");

				}

				break;

			case 'II':

				$this->int_start_bln = 7;

				$this->obj_tmpl->addVar("content", "SEMESTER", 'II (Juli - Desember)');

				for($i=6;$i<12;$i++){

					$data = array();

					$this->obj_tmpl->addVar("list_bulan", "BULAN", $arr_bln[$i]);

					if(isset($this->arr_value[$i + 1])){

						$data = explode('-', $this->arr_value[$i + 1]);

						$this->obj_tmpl->addVar("list_bulan", "P2KB", $data[0]);

						$this->obj_tmpl->addVar("list_bulan", "PP", $data[1]);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", $data[2]);

						$total['p2kb'] = $total['p2kb'] + $data[0];

						$total['pp'] = $total['pp'] + $data[1];

						$total['cabang'] = $total['cabang'] + $data[2];

						$this->obj_tmpl->addVar("list_bulan", "JUMLAH", array_sum($data));

					}else{

						$this->obj_tmpl->addVar("list_bulan", "P2KB", 0);

						$this->obj_tmpl->addVar("list_bulan", "PP", 0);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", 0);

						$this->obj_tmpl->addVar("list_bulan", "JUMLAH", 0);

					}					

					$this->obj_tmpl->ParseTemplate("list_bulan", "a");

				}

				break;

			default:

				break;

		}

		// parse total

		$this->obj_tmpl->addVar("content", "TOTAL_P2KB", $total['p2kb']);

		$this->obj_tmpl->addVar("content", "TOTAL_PP", $total['pp']);

		$this->obj_tmpl->addVar("content", "TOTAL_CABANG", $total['cabang']);

		$this->obj_tmpl->addVar("content", "TOTAL_JUMLAH", array_sum($total));

		// status

		if($status_pembayaran == 'yes'){$lunas = "LUNAS";}else{$lunas = "<b>BELUM LUNAS</b>";};

		$this->obj_tmpl->addVar("content", "STATUS_ANGGOTA", $status_anggota);

		$this->obj_tmpl->addVar("content", "PELUNASAN", $lunas);

	}

	

}



?>