<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_iuran;

	protected $obj_date;

	protected $obj_notify;

	// variable definition

	protected $int_cabang;

	protected $int_tahun;

	protected $int_smt;

	protected $str_person;

	protected $int_pp_value;

	protected $int_p2kb_value;

	protected $int_cabang_value;

	protected $int_start_bln;

	protected $arr_value;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_iuran = $this->obj_ctrl->LoadBusiness('iuran', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_iuran->SetUsesBusinessQuery($loaded_query);		

		// library loaded

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// display notification

		self::DisplayNotification();

		// display variable link

		self::DisplayVariableLink();

		// display laporan pembayaran

		self::DisplayDetailPerson();

		// display laporan pembayaran

		self::DisplayIuranAnggota();

		// display laporan pembayaran

		self::DisplayKontribusiPembayaran();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariableLink(){

		// cabang

		if(isset($this->arr_routes['params'][0])){

			$this->int_cabang = $this->arr_routes['params'][0];

			$this->obj_tmpl->addVar("content", "ID_CABANG", $this->int_cabang);

		}

		// tahun

		if(isset($this->arr_routes['params'][1])){

			$this->int_tahun = $this->arr_routes['params'][1];

			$this->obj_tmpl->addVar("content", "ID_TAHUN", $this->int_tahun);

		}

		// semester

		if(isset($this->arr_routes['params'][2])){

			$this->int_smt = $this->arr_routes['params'][2];

			$this->obj_tmpl->addVar("content", "ID_SMT", $this->int_smt);

		}

		// person

		if(isset($this->arr_routes['params'][3])){

			$this->str_person = $this->arr_routes['params'][3];

			$this->obj_tmpl->addVar("content", "ID_PERSON", $this->str_person);

		}

		// page

		if(isset($this->arr_routes['params'][4])){

			$page = $this->arr_routes['params'][4];

			$this->obj_tmpl->addVar("content", "ID_PAGE", $page);

		}

		$this->obj_tmpl->addVar("content", "URL_BACK", $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'iuran-cabang', array($this->int_cabang, $this->int_tahun, $this->int_smt, $page)));

		$this->obj_tmpl->addVar("content", "URL_PROCESS", $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'iuran', 'process'));

	}

	

	private function DisplayDetailPerson(){

		$result = $this->obj_iuran->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->str_person));

		if(!empty($result)){			

			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);

			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);

			$this->obj_tmpl->addVar('content', 'NAMA', $result['nama_lengkap']);

			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);

			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);

			$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);

			$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);

			// display foto

			$path = "doc/foto/".$result['photo'];

			if(is_file($path))

				$this->obj_tmpl->addVar('content', 'FOTO', $path);

			else

				$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");

		}

	}

	

	private function DisplayIuranAnggota(){

		// parse data

		$rs_id = $this->obj_iuran->GetResourceId("GetIuranAnggota", array(1));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->int_dpp_value = $rec['dpp'];

				$this->int_dpw_value = $rec['dpw'];

				$this->int_dpd_value = $rec['dpw'];

				$this->int_dpk_value = $rec['dpk'];

				$this->obj_tmpl->addVar("list_iuran", "ID_IURAN", $rec['id']);

				$this->obj_tmpl->addVar("list_iuran", "NAMA", $rec['nama']);

				$this->obj_tmpl->addVar("list_iuran", "BESARAN", $rec['besaran']);

				$this->obj_tmpl->addVar("list_iuran", "DPP", $rec['dpp']);

				$this->obj_tmpl->addVar("list_iuran", "DPW", $rec['dpw']);

				$this->obj_tmpl->addVar("list_iuran", "DPD", $rec['dpw']);

				$this->obj_tmpl->addVar("list_iuran", "DPK", $rec['dpk']);

				$this->obj_tmpl->ParseTemplate("list_iuran", "a");

			}

		}

	}

	

	private function DisplayKontribusiPembayaran(){

		// parse data

		$rs_id = $this->obj_iuran->GetResourceId("GetDataIuranByAnggota", array($this->int_cabang, $this->int_tahun, $this->int_smt, $this->str_person));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$status_pembayaran = $rec['status_pelunasan'];

				$this->obj_tmpl->addVar("content", $status_pembayaran, 'selected="selected"');

				$status_anggota = $rec['status_anggota'];

				$this->obj_tmpl->addVar("content", $status_anggota, 'selected="selected"');

				$this->arr_value[$rec['bulan']] = $rec['dpp'].'-'.$rec['dpw'].'-'.$rec['dpd'].'-'.$rec['dpk'];

			}

		}

		// print_r($this->arr_value);

		// tahun

		$this->obj_tmpl->addVar("content", "TAHUN", $this->int_tahun);

		// parse bulan

		/*$arr_bln = array('Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember');

		switch($this->int_smt){

			case 'I':

				$this->int_start_bln = 1;

				$total['p2kb'] = 0;

				$total['pp'] = 0;

				$total['cabang'] = 0;

				$this->obj_tmpl->addVar("content", "SEMESTER", 'I (Januari - Juni)');

				for($i=0;$i<6;$i++){

					$data = array();

					$this->obj_tmpl->addVar("list_bulan", "BULAN", $arr_bln[$i]);

					$this->obj_tmpl->addVar("list_bulan", "VALUE", $i + 1);

					if(isset($this->arr_value[$i + 1])){

						$data = explode('-', $this->arr_value[$i + 1]);

						$this->obj_tmpl->addVar("list_bulan", "PP", $data[0]);

						$this->obj_tmpl->addVar("list_bulan", "PW", $data[1]);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", $data[2]);

					}else{

						$this->obj_tmpl->addVar("list_bulan", "PP", 0);

						$this->obj_tmpl->addVar("list_bulan", "PW", 0);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", 0);

						$this->obj_tmpl->addVar("list_bulan", "JUMLAH", 0);

					}					

					$this->obj_tmpl->ParseTemplate("list_bulan", "a");

				}

				break;

			case 'II':

				$this->int_start_bln = 7;

				$this->obj_tmpl->addVar("content", "SEMESTER", 'II (Juli - Desember)');

				for($i=6;$i<12;$i++){

					$data = array();

					$this->obj_tmpl->addVar("list_bulan", "BULAN", $arr_bln[$i]);

					$this->obj_tmpl->addVar("list_bulan", "VALUE", $i + 1);

					if(isset($this->arr_value[$i + 1])){

						$data = explode('-', $this->arr_value[$i + 1]);

						$this->obj_tmpl->addVar("list_bulan", "PP", $data[0]);

						$this->obj_tmpl->addVar("list_bulan", "PW", $data[1]);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", $data[2]);

					}else{

						$this->obj_tmpl->addVar("list_bulan", "PP", 0);

						$this->obj_tmpl->addVar("list_bulan", "PW", 0);

						$this->obj_tmpl->addVar("list_bulan", "CABANG", 0);

						$this->obj_tmpl->addVar("list_bulan", "JUMLAH", 0);

					}					

					$this->obj_tmpl->ParseTemplate("list_bulan", "a");

				}

				break;

			default:

				break;

		}*/

	}

	

}



?>