<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_iuran;

	protected $obj_paging;

	protected $obj_date;

	protected $obj_notify;

	// variable definition

	protected $int_cabang = 0;

	protected $int_tahun;

	protected $int_smt;

	protected $str_bayar;

	protected $str_nama;

	protected $int_pp_value;

	protected $int_p2kb_value;

	protected $int_cabang_value;	

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_iuran = $this->obj_ctrl->LoadBusiness('iuran', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_iuran->SetUsesBusinessQuery($loaded_query);		

		// library loaded

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		// -javascript		

		$this->obj_ctrl->LoadJavascript('jquery');

		$this->obj_ctrl->LoadJavascript('jquery.popin', 'jquery');	

	}

	

	public function PageView(){

		// display notification

		self::DisplayNotification();

		// display variable link

		self::DisplayVariableLink();

		// display iuran settings

		//self::DisplayIuranAnggota();

		// display list cabang

		self::DisplayListCabang();

		// display list tahun

		self::DisplayListTahun();

		// display list semester

		self::DisplayListSemester();

		// display keyword name

		self::DisplayKeywordName();

		// display laporan pembayaran

		self::DisplayKontribusiPembayaran();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariableLink(){

		// parse variable

		$this->obj_tmpl->addVar("content", "URL_PROCESS", $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'iuran', 'process'));

	}

	

	private function DisplayIuranAnggota(){

		// parse data

		$rs_id = $this->obj_iuran->GetResourceId("GetIuranSettings", array());

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->int_pp_value = $rec['pp'];

				$this->int_p2kb_value = $rec['pw'];

				$this->int_cabang_value = $rec['cabang'];

				$this->obj_tmpl->addVar("list_iuran", "NAMA", $rec['status_anggota']);

				$this->obj_tmpl->addVar("list_iuran", "DESKRIPSI", $rec['keterangan']);

				$this->obj_tmpl->addVar("list_iuran", "PP", number_format($rec['pp'], 2, ',', '.'));

				$this->obj_tmpl->addVar("list_iuran", "PW", number_format($rec['pw'], 2, ',', '.'));

				$this->obj_tmpl->addVar("list_iuran", "PC", number_format($rec['cabang'], 2, ',', '.'));

				$this->obj_tmpl->ParseTemplate("list_iuran", "a");

			}

		}

	}

	

		private function DisplayListCabang(){

		if(isset($this->arr_routes['params'][0])){

			$this->int_cabang = $this->arr_routes['params'][0];

		}

		$rs_id = $this->obj_iuran->GetResourceId("GetListCabangByAdmin", array($this->str_userid));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$arr_cabang[] = $rec['id_cabang'];

				if($this->int_cabang == $rec['id_cabang']){

					$this->obj_tmpl->addVar("content", "CABANG", $rec['id_cabang']);

					$this->obj_tmpl->addVar("list_cabang", "SELECTED", 'selected="selected"');

				}else{

					$this->obj_tmpl->addVar("list_cabang", "SELECTED", '');

				}			

				$this->obj_tmpl->addVar("list_cabang", "VALUE", $rec['id_cabang']);

				$this->obj_tmpl->addVar("list_cabang", "NAMA", $rec['nama']);

				$this->obj_tmpl->ParseTemplate("list_cabang", "a");

			}

		}

		// check authority

		if(!empty($this->int_cabang)){

			if(!in_array($this->int_cabang, $arr_cabang)){

				// redirect page

				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'cabang');

			}

		}

	}

	

	private function DisplayListTahun(){

		if(isset($this->arr_routes['params'][1])){

			$this->int_tahun = $this->arr_routes['params'][1];

		}

		// parse tahun

		$tahun = date('Y') + 5;		

		for($i=$tahun;$i>=$tahun-9;$i--){

			if($this->int_tahun == $i)

				$this->obj_tmpl->addVar("list_tahun", "SELECTED", 'selected="selected"');

			else

				$this->obj_tmpl->addVar("list_tahun", "SELECTED", '');

			$this->obj_tmpl->addVar("list_tahun", "TAHUN", $i);

			$this->obj_tmpl->ParseTemplate("list_tahun", "a");

		}

		// parse variable

		$this->obj_tmpl->addVar("content", "TAHUN", $this->int_tahun);

	}

	

	private function DisplayListSemester(){

		if(isset($this->arr_routes['params'][2])){

			$this->int_smt = $this->arr_routes['params'][2];

		}

		// parse semester

		$arr_bln = array('Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember');

		switch($this->int_smt){

			case 'I':

				$this->int_start_bln = 1;

				$this->obj_tmpl->addVar("content", "SMT_I", 'selected="selected"');

				break;

			case 'II':

				$this->int_start_bln = 7;

				$this->obj_tmpl->addVar("content", "SMT_II", 'selected="selected"');

				break;

			default:

				break;

		}

		// parse variable

		$this->obj_tmpl->addVar("content", "SMT", $this->int_smt);

	}

	

	private function DisplayKeywordName(){

		if(isset($this->arr_routes['params'][4])){

			$this->str_nama = str_replace('-', ' ', $this->arr_routes['params'][4]);

		}

		// parse variable

		$this->obj_tmpl->addVar("content", "KEYWORD", $this->str_nama);

	}

	

	private function DisplayKontribusiPembayaran(){

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][3]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][3];

		// parse paging variable

		$this->obj_tmpl->addVar("content", "PAGING", $page);

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$total = $this->obj_iuran->GetDataAsSingleArray("GetTotalAnggotaByCabang", array($this->int_cabang, $this->int_tahun, $this->int_smt, $this->int_cabang, $this->int_cabang, $this->int_tahun, $this->int_smt));

		$this->obj_paging->SetTotalRecord($total['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->int_cabang, $this->int_tahun, $this->int_smt, '')));

		// set template pagination

		$this->obj_paging->SetTempatePaging('pagination');

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$no = 1;

		$no = $no + $start;

		// display list anggota

		$rs_id = $this->obj_iuran->GetResourceId("GetDataAnggotaByCabang", array($this->int_cabang, $this->int_tahun, $this->int_smt, $this->int_cabang, $this->int_cabang, $this->int_tahun, $this->int_smt, $start, $max));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar("list_anggota", "NO", $no);

				$this->obj_tmpl->addVar("list_anggota", "ID_PERSON", $rec['id_person']);

				$this->obj_tmpl->addVar("list_anggota", "NO_ANGGOTA", $rec['no_anggota']);

				$jumlah = $this->obj_iuran->GetDataAsSingleArray("GetJumlahIuranByAnggota", array($this->int_cabang, $this->int_tahun, $this->int_smt, $rec['id_person']));

				if(!empty($jumlah)){

					$this->obj_tmpl->addVar("list_anggota", "JUMLAH", $jumlah['jumlah']);

					if($jumlah['status_pelunasan'] == 'yes'){

						$this->obj_tmpl->addVar("list_anggota", "CHECKED", 'checked="checked"');

						$this->obj_tmpl->addVar("list_anggota", "STATUS_PEMBAYARAN", 'LUNAS');

					}else{

						$this->obj_tmpl->addVar("list_anggota", "JUMLAH", 0);

						$this->obj_tmpl->addVar("list_anggota", "CHECKED", '');

						$this->obj_tmpl->addVar("list_anggota", "STATUS_PEMBAYARAN", '<b>BELUM</b>');

					}

					$this->obj_tmpl->addVar("list_anggota", "STATUS_ANGGOTA", $jumlah['status_anggota']);

				}else{

					$this->obj_tmpl->addVar("list_anggota", "STATUS_ANGGOTA", $rec['status_anggota']);

					$this->obj_tmpl->addVar("list_anggota", "JUMLAH", 0);

					$this->obj_tmpl->addVar("list_anggota", "STATUS_PEMBAYARAN", '<b>BELUM</b>');

				}

				$this->obj_tmpl->addVar("list_anggota", "NAMA", $rec['nama']);

				// link

				$this->obj_tmpl->addVar("list_anggota", "URL_DETAIL", $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'detail-iuran', array($this->int_cabang, $this->int_tahun, $this->int_smt, $rec['id_person'])));

				$this->obj_tmpl->addVar("list_anggota", "URL_EDIT", $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit-iuran', array($this->int_cabang, $this->int_tahun, $this->int_smt, $rec['id_person'], $page)));

				// --

				$this->obj_tmpl->ParseTemplate("list_anggota", "a");

				$no++;

			}

		}

		// parse variable info anggota yang telah membayar

		$lunas = $this->obj_iuran->GetDataAsSingleArray("GetTotalIuranLunasByParams", array($this->int_cabang, $this->int_tahun, $this->int_smt));

		$belum_lunas = $total['total'] - $lunas['lunas'];

		$this->obj_tmpl->addVar("pagination", "TOTAL_ANGGOTA", $belum_lunas);

		// print out

		if(!empty($this->int_cabang) AND !empty($this->int_tahun) AND !empty($this->int_smt)){

			$this->obj_tmpl->addVar("content", "URL_PRINT", $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'print-out', array($this->int_cabang, $this->int_tahun, $this->int_smt)));

		}else{

			$this->obj_tmpl->addVar("content", "URL_PRINT", '#');

		}

	}

	

	// utility

	

	private function GetAktifSemester($month){		

		if($month <= 6){

			$this->int_smt = 'I';

			$str = "I (Januari s/d Juni)";			

		}else{

			$this->int_smt = 'II';

			$str = "II (Juli s/d Desember)";			

		}

		return $str;

	}

	

	private function GetJumlahDibayarkan($month){		

		if($month <= 6){

			$this->int_smt = 'I';

			$str = "I (Januari s/d Juni)";			

		}else{

			$this->int_smt = 'II';

			$str = "II (Juli s/d Desember)";			

		}

		return $str;

	}

	

}



?>