<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_iuran;

	protected $obj_date;

	protected $obj_workbook;

	protected $obj_worksheet;

	// variable definition

	protected $str_excel_name;

	protected $int_cabang = 0;

	protected $int_tahun;

	protected $int_smt;

	protected $int_pp_value;

	protected $int_p2kb_value;

	protected $int_cabang_value;

	protected $int_start_bln = 1;

	protected $arr_value;

	// variable definition

	protected $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		// excel	

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		$this->obj_iuran = $this->obj_ctrl->LoadBusiness('iuran', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_iuran->SetUsesBusinessQuery($loaded_query);

		// -- 

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// load plugins

		$this->obj_ctrl->LoadFile('excel/class.writeexcel_workbook.inc.php', 'plugins');

		$this->obj_ctrl->LoadFile('excel/class.writeexcel_worksheet.inc.php', 'plugins');

		$this->str_excel_name = tempnam("doc/temp/excel/", "excel_file.xls");

		// load class excel

		$this->obj_workbook = new writeexcel_workbook($this->str_excel_name);

	}

	

	public function PageView(){

		// get variable

		self::GetVariable();

		// display pdf download

		self::DownloadLaporan();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function GetVariable(){

		// cabang

		if(isset($this->arr_routes['params'][0])){

			$this->int_cabang = $this->arr_routes['params'][0];

		}

		// tahun

		if(isset($this->arr_routes['params'][1])){

			$this->int_tahun = $this->arr_routes['params'][1];

		}

		// semester

		if(isset($this->arr_routes['params'][2])){

			$this->int_smt = $this->arr_routes['params'][2];

		}

	}

		

	// operation

	private function DownloadLaporan(){

		// data

		$cabang = $this->obj_iuran->GetDataAsSingleArray("GetDetailCabang", array($this->int_cabang));

		$file_name = $cabang['nama'] . "-" . $this->int_tahun . '-' . $this->int_smt;			

		// header bulan

		$arr_bln = array('uang pangkal', 'iuran keanggotaan', 'iuran ICN');

		$arr_column = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S');

		switch($this->int_smt){

			case 'I':

				$this->int_start_bln = 1;

				$semester = "JANUARI - JUNI";

				break;

			case 'II':

				$this->int_start_bln = 7;

				$semester = "JULI - DESEMBER";

				break;

			default:

				break;

		}	

		// disable error warning

		error_reporting(E_ERROR);

		// create worksheet

		$this->obj_worksheet = $this->obj_workbook->addworksheet('Laporan Iuran Anggota');

		$this->obj_worksheet->set_margins(0.4);

		// set column width

		$this->obj_worksheet->set_column('A:A', 3);

		$this->obj_worksheet->set_column('B:B', 8);

		$this->obj_worksheet->set_column('C:C', 5);

		$this->obj_worksheet->set_column('D:D', 30);

		$this->obj_worksheet->set_column('E:P', 6);

		$this->obj_worksheet->set_column('Q:Q', 8);

		// create format

		// title

		$title = $this->obj_workbook->addformat();

		$title->set_size(10);

		$title->set_font('arial');

		$title->set_border(0);

		$title->set_bold();

		// border 

		$border = $this->obj_workbook->addformat();

		$border->set_color('black');

		$border->set_size(8);

		$border->set_fg_color('white');

		$border->set_border_color('black');

		$border->set_border(1);

		$border->set_align('left');

		$border->set_align('top');

		// border center

		$border_center = $this->obj_workbook->addformat();

		$border_center->set_color('black');

		$border_center->set_size(8);

		$border_center->set_fg_color('white');

		$border_center->set_border_color('black');

		$border_center->set_border(1);

		$border_center->set_align('center');

		$border_center->set_align('top');

		// border right

		$border_right = $this->obj_workbook->addformat();

		$border_right->set_color('black');

		$border_right->set_size(8);

		$border_right->set_fg_color('white');

		$border_right->set_border_color('black');

		$border_right->set_border(1);

		$border_right->set_align('right');

		$border_right->set_align('top');

		// merge

		// just top left right

		$merge_top = $this->obj_workbook->addformat();

		$merge_top->set_color('black');

		$merge_top->set_size(8);

		$merge_top->set_fg_color('white');

		$merge_top->set_border_color('black');

		$merge_top->set_top(1);

		$merge_top->set_right(1);

		$merge_top->set_left(1);

		$merge_top->set_align('center');

		$merge_top->set_align('vcenter');

		$merge_top->set_merge();

		// just bottom left right

		$merge_bottom = $this->obj_workbook->addformat();

		$merge_bottom->set_color('black');

		$merge_bottom->set_size(8);

		$merge_bottom->set_fg_color('white');

		$merge_bottom->set_border_color('black');

		$merge_bottom->set_bottom(1);

		$merge_bottom->set_right(1);

		$merge_bottom->set_left(1);

		$merge_bottom->set_align('center');

		$merge_bottom->set_align('vcenter');

		$merge_bottom->set_merge();

		// just left right

		$merge_top_bottom = $this->obj_workbook->addformat();

		$merge_top_bottom->set_color('black');

		$merge_top_bottom->set_size(8);

		$merge_top_bottom->set_fg_color('white');

		$merge_top_bottom->set_border_color('black');

		$merge_top_bottom->set_right(1);

		$merge_top_bottom->set_left(1);

		$merge_top_bottom->set_align('center');

		$merge_top_bottom->set_align('vcenter');

		$merge_top_bottom->set_merge();

		// just left

		$merge_left = $this->obj_workbook->addformat();

		$merge_left->set_color('black');

		$merge_left->set_size(8);

		$merge_left->set_fg_color('white');

		$merge_left->set_border_color('black');

		$merge_left->set_left(1);

		$merge_left->set_top(1);

		$merge_left->set_bottom(1);

		$merge_left->set_align('center');

		$merge_left->set_align('vcenter');

		$merge_left->set_merge();

		// just right

		$merge_right = $this->obj_workbook->addformat();

		$merge_right->set_color('black');

		$merge_right->set_size(8);

		$merge_right->set_fg_color('white');

		$merge_right->set_border_color('black');

		$merge_right->set_right(1);

		$merge_right->set_top(1);

		$merge_right->set_bottom(1);

		$merge_right->set_align('center');

		$merge_right->set_align('vcenter');

		$merge_right->set_merge();

		// just left right

		$merge_left_right = $this->obj_workbook->addformat();

		$merge_left_right->set_color('black');

		$merge_left_right->set_size(8);

		$merge_left_right->set_fg_color('white');

		$merge_left_right->set_border_color('black');

		$merge_left_right->set_top(1);

		$merge_left_right->set_bottom(1);

		$merge_left_right->set_align('center');

		$merge_left_right->set_align('vcenter');

		$merge_left_right->set_merge();

		// --

		$this->obj_worksheet->repeat_rows(3, 5);

		// judul

		$this->obj_worksheet->write('A1', "Laporan KONTRIBUSI Iuran Anggota PPNI dan P2KB", $title);

		$this->obj_worksheet->write('A2', "CABANG " . $cabang['nama'], $title);

		// table header

		$this->obj_worksheet->write_blank('A4', $merge_top);

		$this->obj_worksheet->write('A5', "No.", $merge_top_bottom);

		$this->obj_worksheet->write_blank('A6', $merge_bottom);

		// --

		$this->obj_worksheet->write_blank('B4', $merge_top);

		$this->obj_worksheet->write('B5', "No Anggota", $merge_top_bottom);

		$this->obj_worksheet->write_blank('B6', $merge_bottom);

		// --

		$this->obj_worksheet->write_blank('C4', $merge_top);

		$this->obj_worksheet->write('C5', "Status", $merge_top_bottom);

		$this->obj_worksheet->write_blank('C6', $merge_bottom);

		// --

		$this->obj_worksheet->write_blank('D4', $merge_top);

		$this->obj_worksheet->write('D5', "Nama", $merge_top_bottom);

		$this->obj_worksheet->write_blank('D6', $merge_bottom);

		// --

		$this->obj_worksheet->write('E4',"Pembayaran Periode ".$semester." Tahun ".$this->int_tahun, $merge_left);

		$this->obj_worksheet->write_blank('F4', $merge_left_right);

		$this->obj_worksheet->write_blank('G4', $merge_left_right);

		$this->obj_worksheet->write_blank('H4', $merge_left_right);

		$this->obj_worksheet->write_blank('I4', $merge_left_right);

		$this->obj_worksheet->write_blank('J4', $merge_left_right);

		$this->obj_worksheet->write_blank('K4', $merge_left_right);

		$this->obj_worksheet->write_blank('L4', $merge_left_right);

		$this->obj_worksheet->write_blank('M4', $merge_left_right);

		$this->obj_worksheet->write_blank('N4', $merge_left_right);

		$this->obj_worksheet->write_blank('O4', $merge_left_right);

		$this->obj_worksheet->write_blank('P4', $merge_right);

		// --

		$this->obj_worksheet->write('Q4', "Jumlah", $border_center);

		$this->obj_worksheet->write_blank('Q5', $border_center);

		$this->obj_worksheet->write_blank('Q6', $border_center);

		$int_column = 4;

		for($i=$this->int_start_bln - 1;$i<$this->int_start_bln + 5;$i++){

			$column_left = $arr_column[$int_column] . '5';

			$column_right = $arr_column[$int_column + 1] . '5';

			$this->obj_worksheet->write($column_left, $arr_bln[$i], $merge_left);

			$this->obj_worksheet->write_blank($column_right, $merge_right);

			$int_column = $int_column + 2;

		}

		// header status iuran

		$int_column = 4;

		

		for($i=0;$i<=11;$i++){

			if(($i % 4) == 0){

				$this->obj_worksheet->write($arr_column[$int_column] . "6", "DPP", $border_center);

				$this->obj_worksheet->write($arr_column[$int_column + 1] . "6", "DPW", $border_center);

				$this->obj_worksheet->write($arr_column[$int_column + 2] . "6", "DPD", $border_center);

				

			}else{

				$this->obj_worksheet->write($arr_column[$int_column] . "6", "DPK", $border_center);

				}

			$int_column++;

		}

		// parse data

		$total = $this->obj_iuran->GetDataAsSingleArray("GetTotalAnggotaByCabang", array($this->int_cabang, $this->int_tahun, $this->int_smt, $this->int_cabang, $this->int_cabang, $this->int_tahun, $this->int_smt));

		$rs_id = $this->obj_iuran->GetResourceId("GetDataAnggotaByCabang", array($this->int_cabang, $this->int_tahun, $this->int_smt, $this->int_cabang, $this->int_cabang, $this->int_tahun, $this->int_smt, 0, $total['total']));

		if($rs_id){

			$no = 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$total_right = 0;

				// --

				$this->obj_worksheet->write("A" . ($no + 6), $no, $border);

				$this->obj_worksheet->write("B" . ($no + 6), $rec['no_anggota'], $border_center);

				$this->obj_worksheet->write("D" . ($no + 6), $rec['nama'], $border);

				$status_anggota = $rec['status_anggota'];

				$status_pembayaran = 'no';

				$arr_value = array();

				// get detail pembayaran by person

				$rs_detail = $this->obj_iuran->GetResourceId("GetDataIuranByAnggota", array($this->int_cabang, $this->int_tahun, $this->int_smt, $rec['id_person']));

				if($rs_detail){

					while($rec = mysqli_fetch_assoc($rs_detail)){

						$status_pembayaran = $rec['status_pelunasan'];

						$status_anggota = $rec['status_anggota'];

						if($status_pembayaran == 'yes'){

							$arr_value[$rec['bulan']]['pp'] = $rec['pp'];

							$arr_value[$rec['bulan']]['p2kb'] = $rec['p2kb'];

						}else{

							$arr_value[$rec['bulan']]['pp'] = 0;

							$arr_value[$rec['bulan']]['p2kb'] = 0;

						}

					}

				}

				$this->obj_worksheet->write("C" . ($no + 6), $status_anggota, $border_center);

				// pp dan p2kb

				$int_column = 4;

				for($i=$this->int_start_bln - 1;$i<$this->int_start_bln + 5;$i++){

					$column_left = $arr_column[$int_column] . ($no + 6);

					$column_right = $arr_column[$int_column + 1] . ($no + 6);

					if(isset($arr_value[$i+1])){

						$this->obj_worksheet->write($column_left, $arr_value[$i+1]['pp'], $border_right);

						$this->obj_worksheet->write($column_right, $arr_value[$i+1]['p2kb'], $border_right);

					}else{

						$this->obj_worksheet->write($column_left, 0, $border_right);

						$this->obj_worksheet->write($column_right, 0, $border_right);

					}

					$int_column = $int_column + 2;

				}				

				// jumlah right

				$this->obj_worksheet->write("Q".($no + 6), "=SUM(E".($no + 6).":P".($no + 6).")", $border_right);

				$no++;

			}

		}

		// parse jumlah

		$this->obj_worksheet->write_blank('A' . ($no + 6), $border);

		$this->obj_worksheet->write_blank('B' . ($no + 6), $border);

		$this->obj_worksheet->write_blank('C' . ($no + 6), $border);

		$this->obj_worksheet->write('D' . ($no + 6), "JUMLAH", $border);

		// jumlah bottom

		for($i=4;$i<=16;$i++){

			$column_jumlah = $arr_column[$i] . ($no + 6);

			$this->obj_worksheet->write($column_jumlah, "=SUM(".$arr_column[$i]."7:".$arr_column[$i].($total['total']+6).")", $border_right);

		}

		// close work book

		$this->obj_worksheet->set_landscape();

		$this->obj_workbook->close();

		// header download

		header("Content-Type: application/x-msexcel; name=\"".$file_name."xls\"");

		header("Content-Disposition: inline; filename=\"".$file_name.".xls\"");

		$fh = fopen($this->str_excel_name, "rb");

		fpassthru($fh);

		// remove temporari file

		self::RemoveTemporaryFile();

	}

	

	private function RemoveTemporaryFile(){

		$dir = "doc/temp/excel/";

		if(is_dir($dir)){

			$folder = opendir($dir);

			while($file = readdir($folder))

			{

				if ($file == '.' || $file == '..') {

					continue;

				}				

				if(is_file($dir.'/'.$file))

				{

					unlink($dir.'/'.$file);

				}

				  

			}

			closedir($folder);

		}

	}

	

}



?>