<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object
	private $obj_cv;
	private $obj_date;
	
	private $obj_notify;
	// init variable
	private $int_page;
	
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load business
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		
		// load library
		$this->obj_date = $this->obj_ctrl->LoadLibrary("DateTimeManipulation");
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		// load javascript
		$this->obj_ctrl->LoadJavascript('form_event');
		
	}
	
	public function PageView(){
		// display template (add, view, edit)
		self::TemplateToDisplay();
		// display test cookies
		self::DisplayNotification();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	
	private function TemplateToDisplay(){
		//$this->obj_cv->DebugQuery("GetVirtualAcountAnggota", array($this->str_userid));
		$result = $this->obj_cv->GetDataAsSingleArray("GetVirtualAcountAnggota", array($this->str_userid));
		//print_r($result);
		if(empty($result)){
			$view='kosong';
			}else{
			$view='isi';
			}
		switch($view){
			case 'kosong':
				// detail form
				self::DisplayEditForm();
				break;
			default:
				// list data
				self::DisplayInfoRekening();
				break;
		}
	}
	
	private function DisplayInfoRekening(){
		// activated template
		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');
		$this->obj_tmpl->addVar('display', 'URL_UPDATE', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekening', array('edit')));
		// get start record
		
		// parsing data
		//$this->obj_info->DebugQuery("GetRekeningPesertaByIdPerson", array($this->str_userid));
		$result = $this->obj_cv->GetDataAsSingleArray("GetVirtualAcountAnggota", array($this->str_userid));
		//$no = $start + 0;
		if(!empty($result)){
 		 
			$this->obj_tmpl->addVar('display', 'NAMA', $result['nama']);
			$this->obj_tmpl->addVar('display', 'EMAIL', $result['email']);
			$this->obj_tmpl->addVar('display', 'PHONE', $result['phone']);
			$this->obj_tmpl->addVar('display', 'VIRTUAL_ACOUNT', $result['virtual_account']);
			$this->obj_tmpl->addVar('display', 'EXPIRED', $result['expired_until']);
			
		}	
	}
	
	// update 22-03-2013
	private function DisplayEditForm(){
		// activated template
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekening', array()));
		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Update Rekening</a></li>');
		$this->obj_tmpl->addVar('display', 'view', 'edit');
		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('display', 'USER_ID', $this->str_userid);
                $img_va = HTTPPATH.'doc/temp/create-va.png';
                $this->obj_tmpl->addVar('display', 'VA_IMAGE', $img_va);
		// parse data	
		
	}
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>
