<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_admin;
	protected $obj_anggota;
	protected $obj_paging;
	protected $obj_date;
	protected $obj_workbook;
	protected $obj_worksheet;
	// variable definition
	protected $str_keyword;
	protected $str_cabang;
	protected $str_nama_cabang;
	protected $arr_cabang = array();	
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		// excel	
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		// load object business
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	
		$this->obj_anggota = $this->obj_ctrl->LoadBusiness('anggota', 'mysql', $this->arr_config['db']);	
		// load object pagination
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');	
		// load plugins
		$this->obj_ctrl->LoadFile('excel/class.writeexcel_workbook.inc.php', 'plugins');
		$this->obj_ctrl->LoadFile('excel/class.writeexcel_worksheet.inc.php', 'plugins');
		$this->str_excel_name = tempnam("doc/temp/excel/", "excel_file.xls");
		// load class excel
		$this->obj_workbook = new writeexcel_workbook($this->str_excel_name);
	}
	
	public function PageView(){
		// authority
		self::DisplayCabangAuthority();	
		// display pdf download
		self::DownloadLaporan();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
		
	// operation
	
	private function DisplayCabangAuthority(){
		// cabang
		$this->str_cabang = "";
		if(isset($_SESSION['search']['cabang'])){ $this->str_cabang = $_SESSION['search']['cabang'];}
		// parsing data
		//$this->obj_admin->DebugQuery("GetListCabangByCabangVa",array($this->arr_routes['params'][1]));exit;
		$rs_id = $this->obj_admin->GetListCabangByCabangVa(array($this->arr_routes['params'][1]));
				
		while($rs = mysqli_fetch_assoc($rs_id)){	
		//print_r($rs['nama']);exit;
		$this->str_nama_cabang = $rs['nama'];
			/*if($rs['id_cabang'] == $this->str_cabang){
				$this->str_nama_cabang = $rs['nama'];
			}
			$this->arr_cabang[] = $rs['id_cabang'];*/
		}
		/*if(!in_array($this->str_cabang, $this->arr_cabang)){
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');
		}*/
	}
	
	private function DownloadLaporan(){
		// disable error warning
		error_reporting(E_ERROR);
		// create worksheet
		$this->obj_worksheet = $this->obj_workbook->addworksheet('Virtual Acount Anggota');
		$this->obj_worksheet->set_margins(0.4);
		// set column width
		$this->obj_worksheet->set_column('A:A', 5);
		$this->obj_worksheet->set_column('B:B', 25);
		$this->obj_worksheet->set_column('C:C', 25);
		$this->obj_worksheet->set_column('D:D', 35);
		$this->obj_worksheet->set_column('E:E', 30);
		$this->obj_worksheet->set_column('F:F', 20);
		$this->obj_worksheet->set_column('G:G', 30);
		$this->obj_worksheet->set_column('H:H', 20);
		// create format
		// title
		$title = $this->obj_workbook->addformat();
		$title->set_size(10);
		$title->set_font('arial');
		$title->set_border(0);
		$title->set_bold();
		// border 
		$text = $this->obj_workbook->addformat();
		$text->set_color('black');
		$text->set_size(9);
		$text->set_fg_color('white');
		$text->set_border_color('black');
		$text->set_border(0);
		$text->set_align('left');
		$text->set_align('top');
		// border center
		$text_center = $this->obj_workbook->addformat();
		$text_center->set_color('black');
		$text_center->set_size(9);
		$text_center->set_fg_color('white');
		$text_center->set_border_color('black');
		$text_center->set_border(0);
		$text_center->set_align('center');
		$text_center->set_align('top');
		// border center
		$text_title= $this->obj_workbook->addformat();
		$text_title->set_color('black');
		$text_title->set_size(10);
		$text_title->set_fg_color('white');
		$text_title->set_border_color('black');
		$text_title->set_border(0);
		$text_title->set_align('left');
		$text_title->set_align('top');
		$text_title->set_bold();
		// --
		$this->obj_worksheet->repeat_rows(4, 5);
		// judul
		$this->obj_worksheet->write('A1', "Billing Virtual Acount Anggota PPNI", $title);
		$this->obj_worksheet->write('A2', "Komisariat " .$this->str_nama_cabang, $title);
		// table header
		$this->obj_worksheet->write('A5', "No.", $text_title);
		// --
		$this->obj_worksheet->write('B5', "Tgl Pengajuan", $text_title);
		// --
		$this->obj_worksheet->write('C5', "Nama Anggota", $text_title);
		// --
		$this->obj_worksheet->write('D5', "Virtual Acount", $text_title);
		// --
		$this->obj_worksheet->write('E5', "JML Pembayaran", $text_title);
		// --
		$this->obj_worksheet->write('F5', "Periode Pembayaran", $text_title);
		// --
		$this->obj_worksheet->write('G5', "Email", $text_title);
		// --
		$this->obj_worksheet->write('H5', "Telepon", $text_title);
		// parse data
		// set total record
		//$int_total = $this->obj_anggota->GetTotalAnggotaByAdmin(array($this->str_cabang, '%%'));
		//$this->obj_anggota->DebugQuery("GetListVaAnggotaByCabangVa",array($this->arr_routes['params'][0], $this->arr_routes['params'][1]));	exit;
		$rs_id = $this->obj_anggota->GetListVaAnggotaByCabangVa(array($this->arr_routes['params'][0], $this->arr_routes['params'][1]));	
		if($rs_id){
			$no = 1;
			while($rec = mysqli_fetch_assoc($rs_id)){
				$this->obj_worksheet->write('A' . ($no + 6), $no . ".", $text);
				$this->obj_worksheet->write('B' . ($no + 6), $rec['mdd'], $text);
				$this->obj_worksheet->write('C' . ($no + 6), $rec['nama'], $text);
			$this->obj_worksheet->write('D' . ($no + 6), "'".$rec['virtual_account'], $text);
				$this->obj_worksheet->write('E' . ($no + 6), $rec['jlh_tagihan'], $text);
				$this->obj_worksheet->write('F' . ($no + 6), $rec['thn_tagihan'], $text);
				$this->obj_worksheet->write('G' . ($no + 6), $rec['email'], $text);
				$this->obj_worksheet->write('H' . ($no + 6), "'".$rec['phone'], $text);
				$no++;
			}
		}
		// close work book
		$this->obj_worksheet->set_landscape();
		$this->obj_workbook->close();
		// header download
		$file_name = "Biling_Va_".$this->str_nama_cabang;
		header("Content-Type: application/x-msexcel; name=\"".$file_name."xls\"");
		header("Content-Disposition: inline; filename=\"".$file_name.".xls\"");
		$fh = fopen($this->str_excel_name, "rb");
		echo stream_get_contents($fh);
		//fpassthru($fh);
		// remove temporari file
		self::RemoveTemporaryFile();
	}
	
	private function RemoveTemporaryFile(){
		$dir = "doc/temp/excel/";
		if(is_dir($dir)){
			$folder = opendir($dir);
			while($file = readdir($folder))
			{
				if ($file == '.' || $file == '..') {
					continue;
				}				
				if(is_file($dir.'/'.$file))
				{
					unlink($dir.'/'.$file);
				}
				  
			}
			closedir($folder);
		}
	}
	
}

?>