<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	private $obj_data;
	private $obj_notify;
	// init variable
	private $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'list');	
	}
	
	protected function PageLoad(){ 
		// load business
		$this->obj_data = $this->obj_ctrl->LoadBusiness('data', 'mysql', $this->arr_config['db']);
		$this->obj_data->UseQuery(array("kota"));
		// load library
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'search':
				self::SearchByPropinsi();
				break;
			case 'insert':
				self::InsertData();
				break;
			case 'update':
				self::UpdateData();
				break;
			case 'delete':
				self::DeleteData();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	private function SearchByPropinsi(){
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->arr_params['id_propinsi']));
	}
	
	private function InsertData(){
		$err = array();	
		$filled = array();	
		// check / validate parameter 
		if(empty($this->arr_params['id_propinsi'])){ $err[] = '<br /><strong>Propinsi </strong> harus diisi'; }
		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama </strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){	
			$params = array($this->arr_params['id_propinsi'], $this->arr_params['nama'], '', '', $this->str_userid);
			
			//$this->obj_data->DebugQuery("InsertKota", $params);exit;
			if($this->obj_data->ProcessingData("InsertKota", $params)){
				// sukses message				
				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');
			}else{
				$filled = array('NAMA' => $this->arr_params['nama']);
				// error message
				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');
			}	
		}else{
			$filled = array('NAMA' => $this->arr_params['nama']);
			// error message
			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');
		}
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['id_propinsi'], 'add'));
	}
	
	private function UpdateData(){
		$err = array();	
		$filled = array();	
		// check / validate parameter 
		if(empty($this->arr_params['id_propinsi'])){ $err[] = '<br /><strong>Propinsi </strong> harus diisi'; }
		if(empty($this->arr_params['id_kota'])){ $err[] = '<br /><strong>Id kota </strong> harus diisi'; }
		if(empty($this->arr_params['nama'])){ $err[] = '<br /><strong>Nama </strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){	
			$params = array($this->arr_params['id_propinsi'], $this->arr_params['nama'], '', '', $this->str_userid, $this->arr_params['id_kota']);
			if($this->obj_data->ProcessingData("UpdateKota", $params)){
				// sukses message				
				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');
			}else{
				$filled = array('NAMA' => $this->arr_params['nama']);
				// error message
				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');
			}	
		}else{
			$filled = array('NAMA' => $this->arr_params['nama']);
			// error message
			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');
		}
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->arr_params['id_propinsi'], 'edit', $this->arr_params['id_kota']));
	}
	
	private function DeleteData(){
		$err = array();	
		$filled = array();
		if(empty($this->arr_params['id_propinsi'])){ $err[] = '<br /><strong>Propinsi </strong> harus diisi'; }
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID tidak terpilih</strong>'; }
		// processing --------------------------------------------------
		if(empty($err)){
			foreach($this->arr_params['downcheck'] as $id){
				if($this->obj_data->ProcessingData("DeleteKota", array($id))){
					// notification message	
	         		self::SendNotification($err, array(), "Data berhasil dihapus.", "success");
				}else{
					// error message
					self::SendNotification($err, array(), "Data gagal dihapus.", "error");
				}
			}				
		}else{
			// error message
			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');
		}
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list',array($this->arr_params['id_propinsi'], '-', '-'));
	}
}

?>