<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	var $obj_system;

	var $obj_city;

	var $obj_notify;

	var $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');	

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		

		$this->obj_city = $this->obj_ctrl->LoadBusiness('kota', 'mysql', $this->arr_config['db']);

		

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		// check / validate parameter 

		

		$err = array();	

		

		if(empty($this->arr_params['country'])){ $err[] = '<br /><strong>Country Name</strong> must be filled'; }

		if(empty($this->arr_params['province'])){ $err[] = '<br /><strong>Province name</strong> must be filled'; }

		

		

		// processing --------------------------------------------------

		$param=strtolower(trim($this->arr_params['province']));

		$result = $this->obj_city->GetProvinceDataByNameCity($param);

		$cekvalue=$result['total'];

		

		if(empty($err) and $cekvalue==0){

		$result = $this->obj_city->GetDetailData('spt_country_m',array("country_name" => "str:".$this->arr_params['country']));

		

			$params = array("province_name" => "str:" . $this->arr_params['province'],

							"id_country" => "int:" . $result['id_country']);

			if($this->obj_system->InsertData('spt_provincy_m', $params)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

				// redirect to page error page ------------------------------------	

				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			

			$this->obj_notify->SetField('COUNTRY', $this->arr_params['country']);

			$this->obj_notify->SetField('PROVINCE', $this->arr_params['province']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

		}

	}

	

	private function UpdateData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['country'])){ $err[] = '<br /><strong>Country Name</strong> must be filled'; }

		if(empty($this->arr_params['province'])){ $err[] = '<br /><strong>Province name</strong> must be filled'; }

		// processing --------------------------------------------------

		$param=strtolower(trim($this->arr_params['province']));

		$result = $this->obj_city->GetProvinceDataByNameCity($param);

		$cekvalue=$result['total'];

		if(empty($err) and $cekvalue==0){

		

		$result = $this->obj_city->GetDetailData('spt_country_m',array("country_name" => "str:".$this->arr_params['country']));

						

			$values = array("id_province:int" 	=> "" . $this->arr_params['id_province'],

							"province_name:str" 	=> "" . $this->arr_params['province'],

							"id_country:int" 	=> "" . $result['id_country']);

							

			$params = array("id_province:AND" => "int:" . $this->arr_params['id_province']);

			if($this->obj_system->UpdateData('spt_provincy_m', $values, $params)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

				//

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

				// redirect to page error page ------------------------------------	

				//

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			

			$this->obj_notify->SetField('COUNTRY', $this->arr_params['country']);

			$this->obj_notify->SetField('PROVINCE', $this->arr_params['province']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			//

		}

		// redirect page

		

		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array( $this->arr_params['page'],'edit',$this->arr_params['id_province']));

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_system->DeleteData('spt_provincy_m', 'int', 'id_province', $id)){

					// notification message				

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("success", "Data has been deleted.");

					$this->obj_notify->SentMessage();

					// redirect to success page ------------------------------------

					//

				}else{

					// error message

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

					$this->obj_notify->SentMessage();

					// redirect to page error page ------------------------------------	

					//

				}

			}				

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			//

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			//

		}

	}

}



?>