<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_paging;

	var $obj_notify;

	var $obj_system;

	var $obj_hospital;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		// load business object]

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		$this->obj_kota = $this->obj_ctrl->LoadBusiness('kota', 'mysql', $this->arr_config['db']);

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');

		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');

		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');

		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');

		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');

		// loaded style

		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');	

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		

	}

	

	public function PageView(){

		/* 

		-- display view content

		*/

		parent::DisplayWebTitle('Access Authority');

		// display page link navigation

		self::DisplayPageLink();

		// display template (add, view, edit)

		self::TemplateToDisplay();

		

		// display test cookies

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}

	

	private function TemplateToDisplay(){

		// display list data

		if(isset($this->arr_routes['params'][0]) AND $this->arr_routes['params'][0] == 'add'){

			// add form

			self::DisplayAddForm();

		}elseif(isset($this->arr_routes['params'][1]) AND $this->arr_routes['params'][1] == 'edit'){

			// edit form

			self::DisplayEditForm();

		}else{

			// list data

			self::DisplayTableData();

		}

	}

	

	private function DisplayTableData(){

		// activated template

		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		

		if(!isset($this->arr_routes['params'][0]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][0];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(10);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_kota->GetTotalDataProvince());

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// -------------------------------------------

		// display record data 

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$rs_id = $this->obj_kota->GetProvinceAsResource($start,$max);

		$no = $start + 0;

		while($rec = mysqli_fetch_assoc($rs_id)){

			// url link

			$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($page,'edit', $rec['id_province']));

			// get name group

			

			

			// parse data

			//id_province,province_name,id_country

			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

			$this->obj_tmpl->addVar('list_data', 'NO', $no + 1);

			$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_province']);	

			$this->obj_tmpl->addVar('list_data', 'PROVINCE', $rec['province_name']);

			$this->obj_tmpl->addVar('list_data', 'COUNTRY', $rec['country_name']);

			$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');	

			$no++;

		}

		$this->obj_tmpl->addVar('display', 'TOTAL_DATA', $no);	

	}

	

	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('display', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'country'));

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

		$this->obj_tmpl->addVar('display', 'COUNTRY', 'Indonesia');	

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('display', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'country'));

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$params = array($this->arr_routes['params'][2]);

		$page = array($this->arr_routes['params'][0]);	

		$result = $this->obj_kota->GetProvinceDataByIdProvince($params);

		$this->obj_tmpl->addVar('display', 'PAGE', $page);

		$this->obj_tmpl->addVar('display', 'COUNTRY', $result['country_name']);	

		$this->obj_tmpl->addVar('display', 'ID_PROVINCE', $result['id_province']);	

		$this->obj_tmpl->addVar('display', 'PROVINCE', $result['province_name']);

		

		

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>

