<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	var $obj_system;

	var $obj_hospital;

	var $obj_notify;

	var $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');	

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		

		$this->obj_hospital = $this->obj_ctrl->LoadBusiness('hospital', 'mysql', $this->arr_config['db']);

		

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		// check / validate parameter 		

		$err = array();	

		// --

		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama Rumah Sakit</strong> must be filled'; }

		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Alamat Rumah Sakit</strong> must be filled'; }

		if(empty($this->arr_params['phone'])){ $err[] = '<br /><strong>No Telephon</strong> must be filled'; }

		if(empty($this->arr_params['fax'])){ $err[] = '<br /><strong>No Fax</strong> must be filled'; }

		if(!empty($this->arr_params['kota'])){

			$kota = $this->obj_hospital->GetDetailData('spt_city_m',array("city_name" => "str:".$this->arr_params['kota']));

			if(!isset($kota['id_city'])){

				$err[] = '<br /><strong>Nama Kota</strong> must be filled';

			}

		}else{

			$err[] = '<br /><strong>Nama Kota</strong> must be filled';

		}

		// processing --------------------------------------------------		

		if(empty($err)){

			$params = array("nama" => "str:" . $this->arr_params['name'],

							"alamat" => "str:" . $this->arr_params['alamat'],

							"telepon" => "str:" . $this->arr_params['phone'],

							"fax" => "str:" . $this->arr_params['fax'],

							"id_city" => "int:" . $kota['id_city']);

			if($this->obj_system->InsertData('spt_hospital_m', $params)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

				// redirect to page error page ------------------------------------	

				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			

			$this->obj_notify->SetField('KOTA', $this->arr_params['kota']);

			$this->obj_notify->SetField('NAME', $this->arr_params['name']);

			$this->obj_notify->SetField('ALAMAT', $this->arr_params['alamat']);

			$this->obj_notify->SetField('PHONE', $this->arr_params['phone']);

			$this->obj_notify->SetField('FAX', $this->arr_params['fax']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

		}

	}

	

	private function UpdateData(){

		// check / validate parameter 

		$err = array();	

		// --

		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Authority name</strong> must be filled'; }

		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Authority description</strong> must be filled'; }

		if(empty($this->arr_params['phone'])){ $err[] = '<br /><strong>Authority description</strong> must be filled'; }

		if(empty($this->arr_params['fax'])){ $err[] = '<br /><strong>Authority description</strong> must be filled'; }

		if(!empty($this->arr_params['kota'])){

			$kota = $this->obj_hospital->GetDetailData('spt_city_m',array("city_name" => "str:".$this->arr_params['kota']));

			if(!isset($kota['id_city'])){

				$err[] = '<br /><strong>Nama Kota</strong> must be filled';

			}

		}else{

			$err[] = '<br /><strong>Nama Kota</strong> must be filled';

		}	

		// processing --------------------------------------------------

		if(empty($err)){						

			$values = array("id_hospital:int" 	=> "" . $this->arr_params['id_hospital'],

							"nama:str" 	=> "" . $this->arr_params['name'],

							"alamat:str" 	=> "" . $this->arr_params['alamat'],

							"telepon:str" 	=> "" . $this->arr_params['phone'],

							"fax:str" 	=> "" . $this->arr_params['fax'],

							"id_city:int" 	=> "" . $kota['id_city']);							

			$params = array("id_hospital:AND" => "int:" . $this->arr_params['id_hospital']);

			if($this->obj_system->UpdateData('spt_hospital_m', $values, $params)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

				//

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

				// redirect to page error page ------------------------------------	

				//

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			$this->obj_notify->SetField('KOTA', $this->arr_params['kota']);

			$this->obj_notify->SetField('NAME', $this->arr_params['name']);

			$this->obj_notify->SetField('ALAMAT', $this->arr_params['alamat']);

			$this->obj_notify->SetField('PHONE', $this->arr_params['phone']);

			$this->obj_notify->SetField('FAX', $this->arr_params['fax']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			//

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array( $this->arr_params['page'],'edit',$this->arr_params['id_hospital']));

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_system->DeleteData('spt_hospital_m', 'int', 'id_hospital', $id)){

					// notification message				

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("success", "Data has been deleted.");

					$this->obj_notify->SentMessage();

					// redirect to success page ------------------------------------

					//

				}else{

					// error message

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

					$this->obj_notify->SentMessage();

					// redirect to page error page ------------------------------------	

					//

				}

			}				

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			//

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			//

		}

	}

}



?>