<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_dpp;

	private $obj_person;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		$this->obj_dpp = $this->obj_ctrl->LoadBusiness('dpp', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_ctrl->LoadJavascript('tiny_mce');

	}

	

	public function PageView(){

		// page link

		self::DisplayPageLink();

		// form

		self::DisplayForm();

		// notifikasi

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		// sub nav

		$this->obj_tmpl->addVar('content', 'URL_PENGURUS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view'));

		$this->obj_tmpl->addVar('content', 'URL_PERWAKILAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('perwakilan-per-cabang')));

		$this->obj_tmpl->addVar('content', 'URL_PENGADUAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('tatalaksana')));

		// buku

		$this->obj_tmpl->addVar('content', 'URL_BUKU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'buku'));

		// --

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}



   private function DisplayForm() {

		if(isset($this->arr_routes['params'][0]) && $this->arr_routes['params'][0] == "add") {

			self::DisplayAddForm();

		}elseif(isset($this->arr_routes['params'][0]) && $this->arr_routes['params'][0] == "edit") {

			self::DisplayEditForm();

		}else{

			self::DisplayListArchive();

		}

   }

   

	private function DisplayListArchive(){

  		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		if(!isset($this->arr_routes['params'][0])) {

			$page = 1;

		}else{

			$page = $this->arr_routes['params'][0];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$result = $this->obj_dpp->GetDataAsSingleArray("GetTotalBuku", array());

		$this->obj_paging->SetTotalRecord($result['total']);

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// get data

		$rs_id = $this->obj_dpp->GetResourceId("GetListBuku", array($start, $max));

		if($rs_id){

			$no = 1;

			while($rec = mysqli_fetch_assoc($rs_id)){

				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array("edit", $rec['id']));

				$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download', array(md5(sha1($rec['id']))));

				// --

				$this->obj_tmpl->addVar('list_data', 'NO', $no);

				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $url_edit);

				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id']);	

				$this->obj_tmpl->addVar('list_data', 'JUDUL', $rec['judul']);

				$this->obj_tmpl->addVar('list_data', 'FILE', $rec['filepath']);

				$files = "doc/dpp/".$rec['id'].'/'.$rec['filepath'];	

				if(is_file($files)){

					$this->obj_tmpl->addVar('list_data', 'URL_DOWNLOAD', $url_download);

				}else{

					$this->obj_tmpl->addVar('list_data', 'URL_DOWNLOAD', '#');

				}				

				// display last update

				$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($rec['mdb']));

				$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($rec['mdd']));

				$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');

				$no++;

			}

		}

	}	



	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$result = $this->obj_dpp->GetDataAsSingleArray("GetDetailBukuById", array($this->arr_routes['params'][1]));

		$this->obj_tmpl->addVar('display', 'ID', $result['id']);	

		$this->obj_tmpl->addVar('display', 'JUDUL', $result['judul']);

		$this->obj_tmpl->addVar('display', 'FILENAME', $result['filepath']);

		$this->obj_tmpl->addVar('display', 'URUTAN', $result['urutan']);

		$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download', array(md5(sha1($result['id']))));

		$files = "doc/dpp/".$result['id'].'/'.$result['filepath'];	

		if(is_file($files)){

			$this->obj_tmpl->addVar('display', 'URL_DOWNLOAD', $url_download);

		}else{

			$this->obj_tmpl->addVar('display', 'URL_DOWNLOAD', '#');

		}	

		// display last update

		$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($result['mdb']));

		$this->obj_tmpl->addVar('display', 'MDD', $this->obj_date->GetFullDate($result['mdd']));

		$this->obj_tmpl->addVar('display', 'MDB', $person['nama']);

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>