<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_dpp;
	protected $obj_upload;
	protected $obj_notify;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view');	
	}
	
	protected function PageLoad(){ 
		// load business
		$this->obj_dpp = $this->obj_ctrl->LoadBusiness('dpp', 'mysql', $this->arr_config['db']);
		// load library
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'pengurus':
				self::UpdatePengurus();
				break;
			case 'perwakilan':
				self::UpdatePerwakilanCabang();
				break;
			case 'pengaduan':
				self::UpdatePengaduan();
				break;
			case 'insert_buku':
				self::InsertBuku();
				break;
			case 'update_buku':
				self::UpdateBuku();
				break;
			case 'delete_buku':
				self::DeleteBuku();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// operation
	
	private function UpdatePengurus(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Full text</strong> harus diisi'; }
		// processing -----------------------------------------------------
		if(empty($err)){			
			// insert
			$params = array($this->arr_params['content'], $this->str_userid);
			if($this->obj_dpp->ProcessingRawData("UpdatePengurus", $params)){
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
				// redirect to page error page --------------------------------
			}
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'view');
	}
	
	private function UpdatePerwakilanCabang(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Full text</strong> harus diisi'; }
		// processing -----------------------------------------------------
		if(empty($err)){			
			// insert
			$params = array($this->arr_params['content'], $this->str_userid);
			if($this->obj_dpp->ProcessingRawData("UpdatePerwakilan", $params)){
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
				// redirect to page error page --------------------------------
			}
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view', array('perwakilan-per-cabang'));
	}
	
	private function UpdatePengaduan(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Full text</strong> harus diisi'; }
		// processing -----------------------------------------------------
		if(empty($err)){			
			// insert
			$params = array($this->arr_params['content'], $this->str_userid);
			if($this->obj_dpp->ProcessingRawData("UpdatePengaduan", $params)){
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
				// redirect to page error page --------------------------------
			}
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view', array('tatalaksana'));
	}
	
	// operation buku
	
	private function UploadBuku($id, $file_data){
		$err = array();		
		//if(!empty($file_data['tmp_name']) AND $file_data['size'] <= 300000000000)
		if(!empty($file_data['tmp_name']))
		{
			// allowed type
			$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');	
			// name and path file
			$file_name = str_replace(' ', '_', $file_data['name']);
			$file_path = "doc/dpp/".$id."/";
			if(is_dir($file_path)){
				$this->obj_upload->RemoveDir($file_path);
			}
			// processing
			if($this->obj_upload->FileUpload($file_data, $file_path)){
				$err[] = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 
			}else{
				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
			}		
		}else{
			$err[] = '<br />File <strong>tidak berhasil</strong> diupload'; 
		}
		// return
		return $err;
	}
	
	private function InsertBuku(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }
		if(empty($_FILES['buku']['tmp_name'])){ $err[] = '<br /><strong>File</strong> belum terpilih'; }
		$file_name = str_replace(' ', '_', $_FILES['buku']['name']);
		// processing -----------------------------------------------------
		if(empty($err)){		
			// insert (judul, filepath, urutan, mdb)
			$params = array($this->arr_params['judul'], $file_name, $this->arr_params['urutan'], $this->str_userid);
			if($this->obj_dpp->ProcessingData("InsertBuku", $params)){
				// get last id
				$result = $this->obj_dpp->GetDataAsSingleArray("GetBukuLastId", array());
				// upload file
				$err = self::UploadBuku($result['last'], $_FILES['buku']);
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				$filled = array("JUDUL" => $this->arr_params['judul'], "URUTAN" => $this->arr_params['urutan']);
				// error message
				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
				// redirect to page error page --------------------------------
			}
		}else{
			$filled = array("JUDUL" => $this->arr_params['judul'], "URUTAN" => $this->arr_params['urutan']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'buku', array('add'));
	}
	
	private function UpdateBuku(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['id'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }
		//
		if(!empty($_FILES['buku']['tmp_name'])){ 
			$file_name = str_replace(' ', '_', $_FILES['buku']['name']);
		}else{
			$file_name = $this->arr_params['last_file'];
		}
		// processing -----------------------------------------------------
		if(empty($err)){		
			// insert (judul, filepath, urutan, mdb)
			$params = array($this->arr_params['judul'], $file_name, $this->arr_params['urutan'], $this->str_userid, $this->arr_params['id']);
			if($this->obj_dpp->ProcessingData("UpdateBuku", $params)){
				// upload file
				$err = self::UploadBuku($this->arr_params['id'], $_FILES['buku']);
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				$filled = array("JUDUL" => $this->arr_params['judul'], "URUTAN" => $this->arr_params['urutan']);
				// error message
				self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
				// redirect to page error page --------------------------------
			}
		}else{
			$filled = array("JUDUL" => $this->arr_params['judul'], "URUTAN" => $this->arr_params['urutan']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'buku', array('edit', $this->arr_params['id']));
	}
	
	private function DeleteBuku(){
		$err = array();		
		$filled = array();
		// check / validate parameter 
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }
		// processing --------------------------------------------------
		if(empty($err)){
			foreach($this->arr_params['downcheck'] as $id){
				if($this->obj_dpp->ProcessingData("DeleteBuku", array($id))){
					// unlink source
					$file_path = "doc/dpp/".$id."/";
					if(is_dir($file_path)){
						$this->obj_upload->RemoveDir($file_path);
					}
					// sukses message				
					self::SendNotification($err, $filled, 'Data has been deleted.', 'success');
					// redirect to success page ------------------------------------
				}else{
					// error message
					self::SendNotification($err, $filled, 'Business Process Failure.', 'error');
					// redirect to page error page --------------------------------
				}
			}				
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'], $this->arr_routes['module'], 'buku');
	}
}

?>