<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_dpp;

	private $obj_person;

	private $obj_notify;

	private $obj_date;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_dpp = $this->obj_ctrl->LoadBusiness('dpp', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

      	$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// load javascript

      	$this->obj_ctrl->LoadJavascript('tiny_mce');

	}

	

	public function PageView(){

		// page link

		self::DisplayPageLink();

		// display page

		self::DisplayPage();

		// display notification

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayPageLink(){

		// sub nav

		$this->obj_tmpl->addVar('content', 'URL_PENGURUS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		$this->obj_tmpl->addVar('content', 'URL_PERWAKILAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('perwakilan-per-cabang')));

		$this->obj_tmpl->addVar('content', 'URL_PENGADUAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('tatalaksana')));

		// buku

		$this->obj_tmpl->addVar('content', 'URL_BUKU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'buku'));

		// process

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}



   private function DisplayPage(){		

		if(isset($this->arr_routes['params'][0])){

			switch($this->arr_routes['params'][0]){

				case 'perwakilan-per-cabang':

					$this->obj_tmpl->addVar('content', 'TITLE', 'Perwakilan Per Komisariat');

					$this->obj_tmpl->addVar('content', 'PERWAKILAN_ACTIVE', 'class="active"');

					$this->obj_tmpl->addVar('content', 'SAVE', "perwakilan");

					$result = $this->obj_dpp->GetDataAsSingleArray("GetPerwakilanCabang", array());

					$this->obj_tmpl->addVar('content', 'CONTENT', $result['perwakilan_per_cabang']);

					break;

				case 'tatalaksana':

					$this->obj_tmpl->addVar('content', 'TITLE', 'Tatalaksana Pengaduan');

					$this->obj_tmpl->addVar('content', 'PENGADUAN_ACTIVE', 'class="active"');

					$this->obj_tmpl->addVar('content', 'SAVE', "pengaduan");

					$result = $this->obj_dpp->GetDataAsSingleArray("GetTatalaksanaPengaduan", array());

					$this->obj_tmpl->addVar('content', 'CONTENT', $result['alur_pengaduan']);

					break;

				default:

					$this->obj_tmpl->addVar('content', 'TITLE', 'Pengurus Pusat');

					$this->obj_tmpl->addVar('content', 'PENGURUS_ACTIVE', 'class="active"');

					$this->obj_tmpl->addVar('content', 'SAVE', 'pengurus');

					$result = $this->obj_dpp->GetDataAsSingleArray("GetPengurusDPP", array());

					$this->obj_tmpl->addVar('content', 'CONTENT', $result['pengurus_pusat']);

					break;

			}

		}else{

			$this->obj_tmpl->addVar('content', 'TITLE', 'Pengurus Pusat');

			$this->obj_tmpl->addVar('content', 'PENGURUS_ACTIVE', 'class="active"');

			$this->obj_tmpl->addVar('content', 'SAVE', 'pengurus');

			$result = $this->obj_dpp->GetDataAsSingleArray("GetPengurusDPP", array());

			$this->obj_tmpl->addVar('content', 'CONTENT', $result['pengurus_pusat']);

		}

		// display last update

		$data = $this->obj_dpp->GetDataAsSingleArray("GetLastUpdate", array());

		$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($data['mdb']));

		$this->obj_tmpl->addVar('content', 'MDD', $this->obj_date->GetFullDate($data['mdd']));

		$this->obj_tmpl->addVar('content', 'MDB', $person['nama']);

   }

}



?>