<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	private $obj_branch;
	private $obj_person;
	private $obj_date;
	private $obj_notify;
	private $obj_upload;
	private $arr_params;

	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'],'view');
	}
	
	protected function PageLoad(){ 
		/*
		-- Other object loaded below 
		*/
		$this->obj_branch = $this->obj_ctrl->LoadBusiness('cabang', 'mysql', $this->arr_config['db']);
	$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);		
	$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');		
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'insert':
				self::InsertData();
				break;
			case 'update':
				self::UpdateData();
				break;
			case 'delete':
				self::DeleteData();
				break;
			case 'insert_pengurus':
				self::InsertDataPengurus();
				break;
			case 'pengurus_pp':
				self::InsertDataPengurusPusat();
				break;
			case 'pengurus_pw':
				self::InsertDataPengurusWilayah();
				break;
			case 'pengurus_pw_adm':
				self::InsertDataPengurusWilayahAdm();
				break;		
			case 'pengurus_pd':
				self::InsertDataPengurusDaerah();
				break;	
			case 'pengurus_pd_adm':
				self::InsertDataPengurusDaerahAdm();
				break;		
			case 'pengurus_adm_pd':
				self::InsertDataPengurusAdmDaerah();
				break;
			case 'pengurus_pk':
				self::InsertDataPengurusKomisariat();
				break;	
			case 'add_komisariat':
				self::InsertDataKomisariat();
			default:
			case 'aset_dpw':
				self::InsertDataAsetDpw();
			default:
			
			case 'aset_dpd':
				self::InsertDataAsetDpd();
			default:
			case 'aset_dpk':
				self::InsertDataAsetDpk();
			default:
			case 'add_komisariat_pusat':
				self::InsertDataKomisariatPusat();
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function InsertData(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		$id_cabang = $this->obj_branch->GetLastIdCabang(array());
		// processing --------------------------------------------------
		if(empty($err)){
			$filename = self::UploadImage($id_cabang);
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'], "alamat" => $this->arr_params['address'], 
							"city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'], "fax" => $this->arr_params['fax'], 
							"profil" => $this->arr_params['profile'], "pengurus" => $this->arr_params['pengurus'], 
							"logo" => $filename, "mdb" => $this->str_userid);
			if($this->obj_branch->SetCabang($params, true)){
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	
	}
	
	private function UpdateData(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Komisariat</strong> tidak terpilih'; }
		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		// processing --------------------------------------------------
		if(empty($err)){
			$last_img = $this->arr_params['last_img'];
			$filename = self::UploadImage($this->arr_params['id_cabang'], $last_img);
			$params = array("nama" => $this->arr_params['name'], "kode" => $this->arr_params['kode'], "alamat" => $this->arr_params['address'], 
							"city" => $this->arr_params['city'], "telephone" => $this->arr_params['telephone'], "fax" => $this->arr_params['fax'], 
							"profil" => $this->arr_params['profile'], "pengurus" => $this->arr_params['pengurus'], 
							"logo" => $filename, "mdb" => $this->str_userid, "id_cabang"=>$this->arr_params['id_cabang']);
			if($this->obj_branch->SetCabang($params, false)){
				// notification message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'], "kode" => $this->arr_params['kode'], "alamat" => $this->arr_params['address'], 
							"city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'], "fax" => $this->arr_params['fax'], 
							"profil" => $this->arr_params['profile'], "pengurus" => $this->arr_params['pengurus'], 
							"mdb" => $this->str_userid);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('edit', $this->arr_params['id_cabang']));	
	}
	
	private function DeleteData(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }
		// processing --------------------------------------------------
		if(empty($err)){
			foreach($this->arr_params['downcheck'] as $id){
				if($this->obj_branch->DeleteCabang(array($id))){
					// notification message				
					$this->obj_notify->ClearSession();
					$this->obj_notify->SetHeaderMessage("success", "Data has been deleted.");
					$this->obj_notify->SentMessage();
				}else{
					// error message
					$this->obj_notify->ClearSession();
					$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
					$this->obj_notify->SentMessage();
				}
			}				
		}else{
			// error message
			$this->obj_notify->ClearSession();
			$this->obj_notify->SetHeaderMessage("error", "Pilih PPNI Komisariat yang akan dihapus.");
			$this->obj_notify->SentMessage();
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_daerah', array( $this->arr_params['id_daerah']));
	}
	
	// utility
	
	private function UploadImage($id_cabang, $file_name = ""){
		// allowed type
		if(isset($_FILES['logo']['tmp_name']) AND !empty($_FILES['logo']['tmp_name'])){
			// name and path file
			$file_name = str_replace(' ', '_', $_FILES['logo']['name']);
			$file_path = "doc/logo/cabang/".$id_cabang.'/';
			$this->obj_upload->RemoveDir($file_path);
			// processing
			$this->obj_upload->ImageUpload($_FILES['logo'], $file_path, 180);
		}
		return $file_name;
	}
   
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		foreach($filled as $key=>$value){
			$this->obj_notify->SetField($key, $value);
		}
		$this->obj_notify->SentMessage();
	}
	
private function InsertDataPengurus(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		$id_pengurus = $this->obj_branch->GetLastIdPengurus(array());
		// processing --------------------------------------------------
		if(empty($err)){
			$filename = self::UploadFotoPengurus($id_pengurus);
			$params = array("nama" => $this->arr_params['name'],"jabatan" => $this->arr_params['jabatan'],
							"foto" => $filename, "mdb" => $this->str_userid);
			if($this->obj_branch->SetPengurus($params, true)){
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	
	}
	
private function UploadFotoPengurus($id_pengurus, $file_name = ""){
		// allowed type
		if(isset($_FILES['foto']['tmp_name']) AND !empty($_FILES['foto']['tmp_name'])){
			// name and path file
			$file_name = str_replace(' ', '_', $_FILES['foto']['name']);
			$file_path = "doc/logo/cabang/pengurus/".$id_pengurus.'/';
			$this->obj_upload->RemoveDir($file_path);
			// processing
			$this->obj_upload->ImageUpload($_FILES['foto'], $file_path, 180);
		}
		return $file_name;
	}	
	

private function InsertDataPengurusPusat(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
		$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
		$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($$no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			//print_r($person_ketua['0']['id_person']);exit;
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			 $this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->str_userid,'1');
			//print_r($params);exit;
				//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;			
			if($this->obj_branch->SetPengurusPusat($params, false)){
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_pusat', array());	
	}	
		
		
// pengurus Wilayah

private function InsertDataPengurusWilayah(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
		$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
		$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
		
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			//print_r($person_ketua['0']['id_person']);exit;
			
			$result = $this->obj_branch->GetPengurusWilayahById(array($this->arr_params['id_wilayah']));
		//print_r($result);exit;
		//$this->obj_tmpl->addVar('display', 'ID', $result['0']['id']);	
		if(!empty($result['0']['id_province'])){
			//print_r($params);exit;
				//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			$param_aut_ketua=array($person_ketua['0']['id_person'],'27');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'27');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_wilayah']);
			$param_masukan=false;
			
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'27');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'27');
			$params = array( $this->arr_params['id_wilayah'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}
				
			// Delete Autoritas
			
			//$this->obj_branch->DeleteAdminWilayah(array($this->arr_params['id_wilayah']));	
			//$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'27'));		
		//$this->obj_branch->DebugQuery("SetAutSekertaris",$param_aut_sekertaris);exit;			
			if($this->obj_branch->SetPengurusWilayah($params, $param_masukan)){
				
				$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
				$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_wilayah', array( $this->arr_params['id_wilayah']));	
	}	
	
private function InsertDataPengurusWilayahAdm(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
		$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
		$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
		
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			//print_r($person_ketua['0']['id_person']);exit;
			
			$result = $this->obj_branch->GetPengurusWilayahById(array($this->arr_params['id_wilayah']));
		//print_r($result);exit;
		//$this->obj_tmpl->addVar('display', 'ID', $result['0']['id']);	
		if(!empty($result['0']['id_province'])){
			//print_r($params);exit;
				//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			$param_aut_ketua=array($person_ketua['0']['id_person'],'27');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'27');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_wilayah']);
			$param_masukan=false;
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'27');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'27');
			$params = array( $this->arr_params['id_wilayah'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}
				
			// Delete Autoritas
			
			//$this->obj_branch->DeleteAdminWilayah(array($this->arr_params['id_wilayah']));	
			//$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'27'));		
		//$this->obj_branch->DebugQuery("SetAutSekertaris",$param_aut_sekertaris);exit;			
			if($this->obj_branch->SetPengurusWilayah($params, $param_masukan)){
				$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
				$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_adm_wilayah', array( $this->arr_params['id_wilayah']));	
	}		
	
	
private function InsertDataPengurusDaerah(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
			$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			//print_r($person_ketua['0']['id_person']);exit;
			
			$result = $this->obj_branch->GetPengurusDaerahById(array($this->arr_params['id_daerah']));
		//print_r($result);exit;		
		//$this->obj_tmpl->addVar('display', 'ID', $result['0']['id']);	
		if(!empty($result[0]['id_city'])){
			//print_r($result);exit;
			//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_daerah']);
			$param_masukan=false;
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');
			$params = array( $this->arr_params['id_daerah'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}	
				
			// Delete Autoritas
			//$this->obj_branch->DebugQuery("DeleteAutKetuaWilayah",array($result[0]['id_person_ketua'],'26'));exit;
			//$this->obj_branch->DeleteAutKetuaWilayah(array($result[0]['id_person_ketua'],'26'));	
			//$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'26'));			
			//$this->obj_branch->DebugQuery("SetAutKetua",$param_aut_ketua);exit;	
			//$this->obj_branch->DeleteAdminDaerah(array($this->arr_params['id_daerah']));			
			if($this->obj_branch->SetPengurusDaerah($params, $param_masukan)){
			$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_daerah', array( $this->arr_params['id_daerah']));	
	}


private function InsertDataPengurusDaerahAdm(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
			$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			//print_r($person_ketua['0']['id_person']);exit;
			
			$result = $this->obj_branch->GetPengurusDaerahById(array($this->arr_params['id_daerah']));
		//print_r($result);exit;		
		//$this->obj_tmpl->addVar('display', 'ID', $result['0']['id']);	
		if(!empty($result[0]['id_city'])){
			//print_r($result);exit;
			//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_daerah']);
			$param_masukan=false;
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');
			$params = array( $this->arr_params['id_daerah'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}	
				
			// Delete Autoritas
			//$this->obj_branch->DebugQuery("DeleteAutKetuaWilayah",array($result[0]['id_person_ketua'],'26'));exit;
			//$this->obj_branch->DeleteAutKetuaWilayah(array($result[0]['id_person_ketua'],'26'));	
			//$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'26'));			
			//$this->obj_branch->DebugQuery("SetAutKetua",$param_aut_ketua);exit;	
			//$this->obj_branch->DeleteAdminDaerah(array($this->arr_params['id_daerah']));			
			if($this->obj_branch->SetPengurusDaerah($params, $param_masukan)){
			$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_detail_daerah', array( $this->arr_params['id_daerah']));	
	}


private function InsertDataPengurusAdmDaerah(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
			$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			//print_r($person_ketua['0']['id_person']);exit;
			
			$result = $this->obj_branch->GetPengurusDaerahById(array($this->arr_params['id_daerah']));
		//print_r($result);exit;		
		//$this->obj_tmpl->addVar('display', 'ID', $result['0']['id']);	
		if(!empty($result[0]['id_city'])){
			//print_r($result);exit;
			//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_daerah']);
			$param_masukan=false;
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');
			$params = array( $this->arr_params['id_daerah'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}	
				
			// Delete Autoritas
			//$this->obj_branch->DebugQuery("DeleteAutKetuaWilayah",array($result[0]['id_person_ketua'],'26'));exit;
			//$this->obj_branch->DeleteAutKetuaWilayah(array($result[0]['id_person_ketua'],'26'));	
			//$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'26'));			
			//$this->obj_branch->DebugQuery("SetAutKetua",$param_aut_ketua);exit;	
			//$this->obj_branch->DeleteAdminDaerah(array($this->arr_params['id_daerah']));			
			if($this->obj_branch->SetPengurusDaerah($params, $param_masukan)){
			$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_adm_daerah', array( $this->arr_params['id_daerah']));	
	}


	
// pengurus Komisarait	
  private function InsertDataPengurusKomisariat(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
			if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama DPK </strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
			$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
			$no_anggota_bendahara=substr($this->arr_params['bendahara'],-11);
			$no_anggota_infokom=substr($this->arr_params['infokom'],-11);
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			$person_bendahara = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_bendahara));
			$person_infokom = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_infokom));
			
			//$this->obj_person->DebugQuery("GetIdPersonByName",array($no_anggota_bendahara));exit;
			//print_r($person_bendahara);exit;
			$result = $this->obj_branch->GetPengurusKomisariathById(array($this->arr_params['id_cabang']));
			//print_r($result);exit;		
		if(!empty($result[0]['id_cabang'])){
			
		//	$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			
			$param_aut_ketua=array($person_ketua['0']['id_person'],'10');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'10');	
			$param_aut_bendahara=array($person_bendahara['0']['id_person'],'10');
			$param_aut_infokom=array($person_infokom['0']['id_person'],'10');
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'],
			$person_bendahara['0']['id_person'],$person_infokom['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['rekening'],
			$this->arr_params['email'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_cabang']);
			$param_masukan=false;
			$param_cabang=array($this->arr_params['name'],$this->arr_params['id_daerah'],$this->str_userid,$this->arr_params['id_cabang']);
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'10');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'10');
			$params = array( $this->arr_params['id_cabang'],
			$this->arr_params['rekening'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['email'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$person_bendahara['0']['id_person'],
			$person_infokom['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}
				//print_r($params);exit;
				//$this->obj_branch->DebugQuery(UpdateCabang,$param_cabang, $param_masukan);exit;
			// Delete Autoritas
			//$this->obj_branch->DebugQuery("DeleteAutKetuaWilayah",array($result[0]['id_person_ketua'],'10'));exit;
			//$this->obj_branch->DeleteAutKetuaWilayah(array($result[0]['id_person_ketua'],'10'));
			//$this->obj_branch->DebugQuery("DeleteAutSekertarisWilayah",array($result[0]['id_person_sekertaris'],'10'));exit;
			//$this->obj_branch->DeleteAutKetuaWilayah($param_aut_ketua);	
			//$this->obj_branch->DeleteAutSekertarisWilayah($param_aut_sekertaris);	
			//$this->obj_branch->SetPengurusKomisariat($params, $param_masukan);exit;
			//$this->obj_branch->DeleteAdminKomisariat(array($this->arr_params['id_cabang']));	
			//$this->obj_branch->DebugQuery("SetPengurusKomisariat",$params);exit;	
			if($this->obj_branch->SetPengurusKomisariat($params, $param_masukan)){
			$this->obj_branch->SetCabang($param_cabang, $param_masukan);
			$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
			$this->obj_branch->SetAutBendara($param_aut_bendahara, true);
			$this->obj_branch->SetAutInfokom($param_aut_infokom, true);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_komisariat', array( $this->arr_params['id_daerah'],$this->arr_params['id_cabang']));	
	}	
	
	
	// pengurus Komisarait	
  private function InsertDataKomisariat(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
			$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
			$no_anggota_bendahara=substr($this->arr_params['bendahara'],-11);
			$no_anggota_infokom=substr($this->arr_params['infokom'],-11);
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			//print_r($no_anggota_ketua);exit;
			 //$this->obj_person->DebugQuery("GetIdPersonByName",array($no_anggota_ketua));exit;
			
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			$person_bendahara = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_bendahara));
			$person_infokom = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_infokom));
			$params=array($this->arr_params['id_daerah']);
			$MaxId = $this->obj_branch->GetMaxIdCabang($params);
			$no_max = $MaxId['last']+ 1;
			//print_r($result);exit;
			$angka = self::tambah_nol($no_max ,3);
			$kode_cabang= $this->arr_params['id_daerah'].$angka;
			//print_r($kode_cabang);exit;
			$params = array("nama" => $this->arr_params['name'],$kode_cabang, 
							"id_daerah" => $this->arr_params['id_daerah'], "mdb" => $this->str_userid);
			if($this->obj_branch->SetCabang($params, true)){
			$params = array();
			$id_cabang=$this->obj_branch->GetLastIdCabang2($params);
			$param_aut_ketua=array($person_ketua['0']['id_person'],'10');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'10');
			$param_aut_bendahara=array($person_bendahara['0']['id_person'],'10');
			$param_aut_infokom=array($person_infokom['0']['id_person'],'10');
			$params = array( $id_cabang,
			$this->arr_params['rekening'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['email'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'],
			$person_bendahara['0']['id_person'],
			$person_infokom['0']['id_person'],
			 $this->str_userid);
			 //print_r($params );exit;
			//$this->obj_branch->DebugQuery("SetAutInfokom",$param_aut_infokom, true);exit;
			$this->obj_branch->SetPengurusKomisariat($params, true);
			$this->obj_branch->SetAutKetua($param_aut_ketua, true);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, true);
			$this->obj_branch->SetAutBendara($param_aut_bendahara, true);
			$this->obj_branch->SetAutInfokom($param_aut_infokom, true);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_adm_daerah', array( ));	
	}		
		
		
		
			// pengurus Komisarait	
  private function InsertDataKomisariatPusat(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$no_anggota_ketua=substr($this->arr_params['ketua'],-11);
			$no_anggota_sekertaris=substr($this->arr_params['sekertaris'],-11);
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_ketua));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($no_anggota_sekertaris));
			$params=array($this->arr_params['id_daerah']);
			$MaxId = $this->obj_branch->GetMaxIdCabang($params);
			$no_max = $MaxId['last']+ 1;
			//print_r($result);exit;
			$angka = self::tambah_nol($no_max ,3);
			$kode_cabang= $this->arr_params['id_daerah'].$angka;
			//print_r($kode_cabang);exit;
			$params = array("nama" => $this->arr_params['name'],$kode_cabang, 
							"id_daerah" => $this->arr_params['id_daerah'], "mdb" => $this->str_userid);
			if($this->obj_branch->SetCabang($params, true)){
			$params = array();
			$id_cabang=$this->obj_branch->GetLastIdCabang2($params);
			$param_aut_ketua=array($person_ketua['0']['id_person'],'10');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'10');
			$params = array( $id_cabang,
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$this->obj_branch->SetPengurusKomisariat($params, true);
			$this->obj_branch->SetAutKetua($param_aut_ketua, true);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, true);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_daerah', array($this->arr_params['id_daerah']));	
	}	
	
	
	// Aset Dpw	
  private function InsertDataAsetDpw(){
			$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		$tgl_aset = $this->arr_params['tahun'].'-'.$this->arr_params['bulan'].'-'.$this->arr_params['hari'];		
		
		//if(empty($this->arr_params['foto'])){ $err[] = '<br /><b>Foto</b> harus di Upload'; }
		if(empty($this->arr_params['register'])){ $err[] = '<br /><b>Register</b> harus diisi'; }
		if(empty($this->arr_params['nama'])){ $err[] = '<br /><b>Nama</b> harus diisi'; }
		
		//if($this->arr_params['valid_code'] != $_SESSION['captcha']){ 
			//$err[] = '<br /><b>Kode validasi</b> yang dimasukkan tidak valid';
		//}
		
		// processing -----------------------------------------------------
		if(empty($err)){
			// validasi nomor anggota yang sudah terdaftar (diambil dari table member_m)
			$MaxId = $this->obj_branch->GetRecordIdasetDpwMax($params2);
			$id = strval(intval($MaxId['id'])+ 1);
			$file_name = str_replace(' ', '_', $_FILES['image']['name']);
			$file_path = 'doc/aset_dpw/'.$id.'/';
			
			// insert into calon_anggota_m
			$params = array($this->arr_params['id_wilayah'],$this->arr_params['nama'],$this->arr_params['kode_barang'],  $this->arr_params['register'],  $this->arr_params['asal'], $tgl_aset,$this->arr_params['harga'], $this->arr_params['kondisi'],$this->arr_params['keterangan'],$this->arr_params['penyusutan'],$file_name,$file_path,$this->str_userid);
			
			
			// execute process
			//print_r($params);exit;
			//$this->obj_branch->DebugQuery('InsertAsetAdmDpw',($params));exit;
			if($this->obj_branch->InsertAsetAdmDpw($params)){
				// send email		
				//tambahan
				 //$this->arr_params['file_name'] = self::UploadImageAsetDpw($id);	
				 //$this->arr_params['file_path'] = 'doc/aset_dpw/'.$id.'/';
				 
				//self::SendEmail();				
				// redirect to success page ------------------------------------
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpw',array());
			// notification message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
			}else{
				// filled last field
				$filled = array("nama" => $this->arr_params['nama'],"kode_barang" => $this->arr_params['kode_barang'], "register" => $this->arr_params['register'], "asal" => $this->arr_params['asal'], "hari" => $this->arr_params['hari'], "harga" => $this->arr_params['harga'],  "keterangan" => $this->arr_params['keterangan'], "penyusutan" => $this->arr_params['penyusutan']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpw',array($id_person));
			}	
		}else{
			// filled last field
			$filled = array("nama" => $this->arr_params['nama'],"kode_barang" => $this->arr_params['kode_barang'], "register" => $this->arr_params['register'], "asal" => $this->arr_params['asal'], "hari" => $this->arr_params['hari'], "harga" => $this->arr_params['harga'],  "keterangan" => $this->arr_params['keterangan'], "penyusutan" => $this->arr_params['penyusutan']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpw',array());
		}	
	}	
	
	// Aset DpD	
  private function InsertDataAsetDpd(){
			$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		$tgl_aset = $this->arr_params['tahun'].'-'.$this->arr_params['bulan'].'-'.$this->arr_params['hari'];		
		
		//if(empty($this->arr_params['foto'])){ $err[] = '<br /><b>Foto</b> harus di Upload'; }
		if(empty($this->arr_params['register'])){ $err[] = '<br /><b>Register</b> harus diisi'; }
		if(empty($this->arr_params['nama'])){ $err[] = '<br /><b>Nama</b> harus diisi'; }
		
		//if($this->arr_params['valid_code'] != $_SESSION['captcha']){ 
			//$err[] = '<br /><b>Kode validasi</b> yang dimasukkan tidak valid';
		//}
		
		// processing -----------------------------------------------------
		if(empty($err)){
			// validasi nomor anggota yang sudah terdaftar (diambil dari table member_m)
			$MaxId = $this->obj_branch->GetRecordIdasetDpdMax($params2);
			$id = strval(intval($MaxId['id'])+ 1);
			$file_name = str_replace(' ', '_', $_FILES['image']['name']);
			$file_path = 'doc/aset_dpw/'.$id.'/';
			
			// insert into calon_anggota_m
			$params = array($this->arr_params['id_daerah'],$this->arr_params['nama'],$this->arr_params['kode_barang'],  $this->arr_params['register'],  $this->arr_params['asal'], $tgl_aset,$this->arr_params['harga'], $this->arr_params['kondisi'],$this->arr_params['keterangan'],$this->arr_params['penyusutan'],$file_name,$file_path,$this->str_userid);
			
			
			// execute process
			//print_r($params);exit;
			//$this->obj_branch->DebugQuery('InsertAsetAdmDpd',($params));exit;
			if($this->obj_branch->InsertAsetAdmDpd($params)){
				// send email		
				//tambahan
				 //$this->arr_params['file_name'] = self::UploadImageAsetDpw($id);	
				 //$this->arr_params['file_path'] = 'doc/aset_dpw/'.$id.'/';
				 
				//self::SendEmail();				
				// redirect to success page ------------------------------------
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpd',array());
			// notification message
				self::SendNotification($err, $filled, 'Data berhasil di kirim.', 'sukses');
			}else{
				// filled last field
				$filled = array("nama" => $this->arr_params['nama'],"kode_barang" => $this->arr_params['kode_barang'], "register" => $this->arr_params['register'], "asal" => $this->arr_params['asal'], "hari" => $this->arr_params['hari'], "harga" => $this->arr_params['harga'],  "keterangan" => $this->arr_params['keterangan'], "penyusutan" => $this->arr_params['penyusutan']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpd',array($id_person));
			}	
		}else{
			// filled last field
			$filled = array("nama" => $this->arr_params['nama'],"kode_barang" => $this->arr_params['kode_barang'], "register" => $this->arr_params['register'], "asal" => $this->arr_params['asal'], "hari" => $this->arr_params['hari'], "harga" => $this->arr_params['harga'],  "keterangan" => $this->arr_params['keterangan'], "penyusutan" => $this->arr_params['penyusutan']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpd',array());
		}	
	}	
	
	
		// Aset Dpk	
  private function InsertDataAsetDpk(){
			$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		$tgl_aset = $this->arr_params['tahun'].'-'.$this->arr_params['bulan'].'-'.$this->arr_params['hari'];		
		
		//if(empty($this->arr_params['foto'])){ $err[] = '<br /><b>Foto</b> harus di Upload'; }
		if(empty($this->arr_params['register'])){ $err[] = '<br /><b>Register</b> harus diisi'; }
		if(empty($this->arr_params['nama'])){ $err[] = '<br /><b>Nama</b> harus diisi'; }
		
		//if($this->arr_params['valid_code'] != $_SESSION['captcha']){ 
			//$err[] = '<br /><b>Kode validasi</b> yang dimasukkan tidak valid';
		//}
		
		// processing -----------------------------------------------------
		if(empty($err)){
			// validasi nomor anggota yang sudah terdaftar (diambil dari table member_m)
			$MaxId = $this->obj_branch->GetRecordIdasetDpkMax($params2);
			$id = strval(intval($MaxId['id'])+ 1);
			$file_name = str_replace(' ', '_', $_FILES['image']['name']);
			$file_path = 'doc/aset_dpw/'.$id.'/';
			
			// insert into calon_anggota_m
			$params = array($this->arr_params['id_cabang'],$this->arr_params['nama'],$this->arr_params['kode_barang'],  $this->arr_params['register'],  $this->arr_params['asal'], $tgl_aset,$this->arr_params['harga'], $this->arr_params['kondisi'],$this->arr_params['keterangan'],$this->arr_params['penyusutan'],$file_name,$file_path,$this->str_userid);
			
			
			// execute process
			//print_r($params);exit;
			//$this->obj_branch->DebugQuery('InsertAsetAdmDpw',($params));exit;
			if($this->obj_branch->InsertAsetAdmDpk($params)){
				// send email		
				//tambahan
				 //$this->arr_params['file_name'] = self::UploadImageAsetDpw($id);	
				 //$this->arr_params['file_path'] = 'doc/aset_dpw/'.$id.'/';
				 
				//self::SendEmail();				
				// redirect to success page ------------------------------------
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpk',array());
			// notification message
				self::SendNotification($err, $filled, 'Data berhasil di kirim.', 'sukses');
			}else{
				// filled last field
				$filled = array("nama" => $this->arr_params['nama'],"kode_barang" => $this->arr_params['kode_barang'], "register" => $this->arr_params['register'], "asal" => $this->arr_params['asal'], "hari" => $this->arr_params['hari'], "harga" => $this->arr_params['harga'],  "keterangan" => $this->arr_params['keterangan'], "penyusutan" => $this->arr_params['penyusutan']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpk',array());
			}	
		}else{
			// filled last field
			$filled = array("nama" => $this->arr_params['nama'],"kode_barang" => $this->arr_params['kode_barang'], "register" => $this->arr_params['register'], "asal" => $this->arr_params['asal'], "hari" => $this->arr_params['hari'], "harga" => $this->arr_params['harga'],  "keterangan" => $this->arr_params['keterangan'], "penyusutan" => $this->arr_params['penyusutan']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'view_aset_dpk',array());
		}	
	}	
	
	
	private function UploadImageAsetDpw($id){
		// allowed type
		if(isset($_FILES['logo']['tmp_name']) AND !empty($_FILES['logo']['tmp_name'])){
			// name and path file
			$file_name = str_replace(' ', '_', $_FILES['image']['name']);
			$file_path = "doc/aset_dpw/".$id.'/';
			$this->obj_upload->RemoveDir($file_path);
			// processing
			$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 200);
		}
		return $file_name;
	}
	
	
		private  function tambah_nol($angka,$jumlah){	
		   $jumlah_nol = strlen($angka);
		   $angka_nol = $jumlah - $jumlah_nol;
		   $nol = "";
		   for($i=1;$i<=$angka_nol;$i++)
		   {
			  $nol .= '0';
		   }
		   return $nol.$angka;
	}			
}

?>
