<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_branch;

	protected $obj_date;

	protected $obj_notify;

	protected $arr_params;

	protected $obj_upload;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-news', array($this->arr_routes['params']['0']));

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_branch = $this->obj_ctrl->LoadBusiness('cabang', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['cabang'])){ $err[] = '<br /><strong>Komisariat </strong> tidak terpilih'; }

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Intro</strong> harus diisi'; }

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Konten</strong> harus diisi'; }

		$id_news = $this->obj_branch->GetLastIdNews(array());

		// processing --------------------------------------------------

		if(empty($err)){

         	$filename = self::UploadImage($id_news);

			$params = array("id_nw" => $id_news, "id_cabang" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => $filename, "img_note" => $this->arr_params['image_note'], "hit" => 0, 

							"mdb" => $this->str_userid);

			if($this->obj_branch->SetNewsCabang($params, true)){

				// notification message				

				self::SendNotification($err, array(), "Data has been saved.", "success");

			}else{

				// error message

				self::SendNotification($err, $params, "Business process failure.", "error");

			}	

		}else{

			// error message

         	$params = array("id_cabang" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => "", "img_note" => $this->arr_params['image_note'],

							"hit" => 0, "mdb" => $this->str_userid);

			self::SendNotification($err, $params, "See input requirement.", "error");

		}

		// redirect to page error page ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-news', array($this->arr_params['cabang'], 'add'));	

	}

	

  	private function UploadImage($id_news){

		// allowed type

		$file_name = "";

		if(isset($_FILES['image']['tmp_name']) AND !empty($_FILES['image']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['image']['name']);

			$file_path = "doc/news/cabang/".$id_news.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 180);

		}

		return $file_name;

	}



	private function UpdateData(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		if(empty($this->arr_params['id_berita'])){ $err[] = '<br /><strong>Komisariat </strong> tidak terpilih'; }

		if(empty($this->arr_params['cabang'])){ $err[] = '<br /><strong>Komisariat </strong> tidak terpilih'; }

		if(empty($this->arr_params['title'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Intro</strong> harus diisi'; }

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Konten</strong> harus diisi'; }

		// processing --------------------------------------------------

      	$a = $this->obj_branch->GetNewsCabangById(array($this->arr_params['id_berita']));

		if(empty($err)){

			$filename = self::UploadImage($this->arr_params['id_berita']);

			if($filename == ""){

				$filename = $a['0']['img_name'];

			}

			$params = array("id_cabang" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => $filename, "img_note" => $this->arr_params['image_note'],

							"hit" => $this->arr_params['hit'], "mdb" => $this->str_userid,

							"id_berita" => $this->arr_params['id_berita']);

			if($this->obj_branch->SetNewsCabang($params, false)){

				// notification message	

	         	self::SendNotification($err, array(), "Data has been saved.", "success");

			}else{

				// error message

				self::SendNotification($err, $params, "Business process failure.", "error");

			}	

		}else{

			// error message

			$params = array("id_cabang" => $this->arr_params['cat'], "judul" => $this->arr_params['title'],

							"deskripsi" => $this->arr_params['description'], "content" => $this->arr_params['content'],

							"img_name" => $a['0']['img_name'], "img_note" => $this->arr_params['image_note'],

							"hit" => $this->arr_params['hit'], "mdb" => $this->str_userid,

							"id_berita" => $this->arr_params['id_berita']);

			self::SendNotification($err, $params, "See input requirement.", "error");

		}

		// redirect page

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-news', array($this->arr_params['cabang'], 'edit', $this->arr_params['id_berita']));	

	}

	

	private function DeleteData(){ 

		$err = array();	

		// check / validate parameter

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_branch->DeleteNewsCabang(array($id))){

					$file_path = "doc/news/cabang/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					// notification message	

	         		self::SendNotification($err, array(), "Data has been deleted.", "success");

				}else{

					// error message

					self::SendNotification($err, array(), "Business process failure.", "error");

				}

			}				

		}else{

			// error message

			self::SendNotification($err, array(), "See input requirement.", "error");

		}

	}

   

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		foreach($filled as $key=>$value){

			$this->obj_notify->SetField($key, $value);

		}

		$this->obj_notify->SentMessage();

	}

}



?>