<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	private $obj_branch;
	private $obj_person;
	private $obj_date;
	private $obj_notify;
	private $obj_upload;
	private $arr_params;

	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'],$this->arr_routes['module'],'view');
	}
	
	protected function PageLoad(){ 
		/*
		-- Other object loaded below 
		*/
		$this->obj_branch = $this->obj_ctrl->LoadBusiness('cabang', 'mysql', $this->arr_config['db']);
	$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);		
	$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');		
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'insert':
				self::InsertData();
				break;
			case 'update':
				self::UpdateData();
				break;
			case 'delete':
				self::DeleteData();
				break;
			case 'insert_pengurus':
				self::InsertDataPengurus();
				break;
			case 'pengurus_pp':
				self::InsertDataPengurusPusat();
				break;
			case 'pengurus_pw':
				self::InsertDataPengurusWilayah();
				break;	
			case 'pengurus_pd':
				self::InsertDataPengurusDaerah();
				break;	
			case 'pengurus_pk':
				self::InsertDataPengurusKomisariat();
				break;	
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function InsertData(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		$id_cabang = $this->obj_branch->GetLastIdCabang(array());
		// processing --------------------------------------------------
		if(empty($err)){
			$filename = self::UploadImage($id_cabang);
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'], "alamat" => $this->arr_params['address'], 
							"city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'], "fax" => $this->arr_params['fax'], 
							"profil" => $this->arr_params['profile'], "pengurus" => $this->arr_params['pengurus'], 
							"logo" => $filename, "mdb" => $this->str_userid);
			if($this->obj_branch->SetCabang($params, true)){
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	
	}
	
	private function UpdateData(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['id_cabang'])){ $err[] = '<br /><strong>Komisariat</strong> tidak terpilih'; }
		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		// processing --------------------------------------------------
		if(empty($err)){
			$last_img = $this->arr_params['last_img'];
			$filename = self::UploadImage($this->arr_params['id_cabang'], $last_img);
			$params = array("nama" => $this->arr_params['name'], "kode" => $this->arr_params['kode'], "alamat" => $this->arr_params['address'], 
							"city" => $this->arr_params['city'], "telephone" => $this->arr_params['telephone'], "fax" => $this->arr_params['fax'], 
							"profil" => $this->arr_params['profile'], "pengurus" => $this->arr_params['pengurus'], 
							"logo" => $filename, "mdb" => $this->str_userid, "id_cabang"=>$this->arr_params['id_cabang']);
			if($this->obj_branch->SetCabang($params, false)){
				// notification message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'], "kode" => $this->arr_params['kode'], "alamat" => $this->arr_params['address'], 
							"city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'], "fax" => $this->arr_params['fax'], 
							"profil" => $this->arr_params['profile'], "pengurus" => $this->arr_params['pengurus'], 
							"mdb" => $this->str_userid);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('edit', $this->arr_params['id_cabang']));	
	}
	
	private function DeleteData(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }
		// processing --------------------------------------------------
		if(empty($err)){
			foreach($this->arr_params['downcheck'] as $id){
				if($this->obj_branch->DeleteCabang(array($id))){
					// notification message				
					$this->obj_notify->ClearSession();
					$this->obj_notify->SetHeaderMessage("success", "Data has been deleted.");
					$this->obj_notify->SentMessage();
				}else{
					// error message
					$this->obj_notify->ClearSession();
					$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
					$this->obj_notify->SentMessage();
				}
			}				
		}else{
			// error message
			$this->obj_notify->ClearSession();
			$this->obj_notify->SetHeaderMessage("error", "Pilih PPNI Komisariat yang akan dihapus.");
			$this->obj_notify->SentMessage();
		}
	}
	
	// utility
	
	private function UploadImage($id_cabang, $file_name = ""){
		// allowed type
		if(isset($_FILES['logo']['tmp_name']) AND !empty($_FILES['logo']['tmp_name'])){
			// name and path file
			$file_name = str_replace(' ', '_', $_FILES['logo']['name']);
			$file_path = "doc/logo/cabang/".$id_cabang.'/';
			$this->obj_upload->RemoveDir($file_path);
			// processing
			$this->obj_upload->ImageUpload($_FILES['logo'], $file_path, 180);
		}
		return $file_name;
	}
   
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		foreach($filled as $key=>$value){
			$this->obj_notify->SetField($key, $value);
		}
		$this->obj_notify->SentMessage();
	}
	
private function InsertDataPengurus(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		$id_pengurus = $this->obj_branch->GetLastIdPengurus(array());
		// processing --------------------------------------------------
		if(empty($err)){
			$filename = self::UploadFotoPengurus($id_pengurus);
			$params = array("nama" => $this->arr_params['name'],"jabatan" => $this->arr_params['jabatan'],
							"foto" => $filename, "mdb" => $this->str_userid);
			if($this->obj_branch->SetPengurus($params, true)){
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	
	}
	
private function UploadFotoPengurus($id_pengurus, $file_name = ""){
		// allowed type
		if(isset($_FILES['foto']['tmp_name']) AND !empty($_FILES['foto']['tmp_name'])){
			// name and path file
			$file_name = str_replace(' ', '_', $_FILES['foto']['name']);
			$file_path = "doc/logo/cabang/pengurus/".$id_pengurus.'/';
			$this->obj_upload->RemoveDir($file_path);
			// processing
			$this->obj_upload->ImageUpload($_FILES['foto'], $file_path, 180);
		}
		return $file_name;
	}	
	

private function InsertDataPengurusPusat(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['ketua']));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['sekertaris']));
			//print_r($person_ketua['0']['id_person']);exit;
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			 $this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->str_userid,'1');
			//print_r($params);exit;
				//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;			
			if($this->obj_branch->SetPengurusPusat($params, false)){
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_pusat', array());	
	}	
		
		
// pengurus Wilayah

private function InsertDataPengurusWilayah(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['ketua']));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['sekertaris']));
			//print_r($person_ketua['0']['id_person']);exit;
			
			$result = $this->obj_branch->GetPengurusWilayahById(array($this->arr_params['id_wilayah']));
		//print_r($result);exit;
		//$this->obj_tmpl->addVar('display', 'ID', $result['0']['id']);	
		if(!empty($result['0']['id_province'])){
			//print_r($params);exit;
				//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			$param_aut_ketua=array($person_ketua['0']['id_person'],'27');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'27');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_wilayah']);
			$param_masukan=false;
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'27');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'27');
			$params = array( $this->arr_params['id_wilayah'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}
				
			// Delete Autoritas
			
			$this->obj_branch->DeleteAutKetuaWilayah(array($result[0]['id_person_ketua'],'27'));	
			$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'27'));		
		//$this->obj_branch->DebugQuery("SetAutKetua",$param_aut_ketua);exit;			
			if($this->obj_branch->SetPengurusWilayah($params, $param_masukan)){
				$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
				$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_wilayah', array( $this->arr_params['id_wilayah']));	
	}	
	
	
// pengurus Wilayah
	private function InsertDataPengurusDaerah(){
		// check / validate parameter 
		$err = array();	
		//if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama cabang</strong> harus diisi'; }
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['ketua']));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['sekertaris']));
			//print_r($person_ketua['0']['id_person']);exit;
			
			$result = $this->obj_branch->GetPengurusDaerahById(array($this->arr_params['id_daerah']));
		//print_r($result);exit;		
		//$this->obj_tmpl->addVar('display', 'ID', $result['0']['id']);	
		if(!empty($result[0]['id_city'])){
			//print_r($result);exit;
			//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_daerah']);
			$param_masukan=false;
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'26');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'26');
			$params = array( $this->arr_params['id_daerah'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}	
				
			// Delete Autoritas
			//$this->obj_branch->DebugQuery("DeleteAutKetuaWilayah",array($result[0]['id_person_ketua'],'26'));exit;
			$this->obj_branch->DeleteAutKetuaWilayah(array($result[0]['id_person_ketua'],'26'));	
			$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'26'));			
			//$this->obj_branch->DebugQuery("SetAutKetua",$param_aut_ketua);exit;			
			if($this->obj_branch->SetPengurusDaerah($params, $param_masukan)){
			$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_daerah', array( $this->arr_params['id_daerah']));	
	}	


	
// pengurus Komisarait	
private function InsertDataPengurusKomisariat(){
		// check / validate parameter 
		$err = array();	
		if(empty($this->arr_params['address'])){ $err[] = '<br /><strong>Alamat sekretariat</strong> harus diisi'; }
		
		// processing --------------------------------------------------
		if(empty($err)){
			$person_ketua = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['ketua']));
			$person_sekertaris = $this->obj_person->GetDatasetAsArray("GetIdPersonByName",array($this->arr_params['sekertaris']));
			$result = $this->obj_branch->GetPengurusKomisariathById(array($this->arr_params['id_cabang']));
			//print_r($result);exit;		
		if(!empty($result[0]['id_cabang'])){
			
			//$this->obj_branch->DebugQuery("UpdatePengurusPusat",$params);exit;
			$param_aut_ketua=array($person_ketua['0']['id_person'],'10');
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'10');	
			$params = array($person_ketua['0']['id_person'],$person_sekertaris['0']['id_person'], 
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$this->str_userid, $this->arr_params['id_cabang']);
			$param_masukan=false;
			}else{
			$param_aut_ketua=array($person_ketua['0']['id_person'],'10');	
			$param_aut_sekertaris=array($person_sekertaris['0']['id_person'],'10');
			$params = array( $this->arr_params['id_cabang'],
			$this->arr_params['address'],
			$this->arr_params['telephone'],
			$this->arr_params['fax'],
			$this->arr_params['website'],
			$person_ketua['0']['id_person'],
			$person_sekertaris['0']['id_person'], 
			$this->str_userid);
			$param_masukan=true;
				}	
				
			// Delete Autoritas
			$this->obj_branch->DeleteAutKetuaWilayah(array($result[0]['id_person_ketua'],'10'));	
			$this->obj_branch->DeleteAutSekertarisWilayah(array($result[0]['id_person_sekertaris'],'10'));	
			//$this->obj_branch->SetPengurusKomisariat($params, $param_masukan);exit;		
			if($this->obj_branch->SetPengurusKomisariat($params, $param_masukan)){
			$this->obj_branch->SetAutKetua($param_aut_ketua, $param_masukan);
			$this->obj_branch->SetAutSekertaris($param_aut_sekertaris, $param_masukan);
				// notification message				
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");
				$this->obj_notify->SentMessage();
				// redirect to success page ------------------------------------
			}else{
				// error message
				$this->obj_notify->ClearSession();
				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");
				$this->obj_notify->SentMessage();
			}	
		}else{
			// error message
			$params = array("nama" => $this->arr_params['name'],"kode" => $this->arr_params['kode'],
							"alamat" => $this->arr_params['address'], "city" => $this->arr_params['city'],"telephone" => $this->arr_params['telephone'],
							"fax" => $this->arr_params['fax'], "profil" => $this->arr_params['profile'],
							"pengurus" => $this->arr_params['pengurus']);
			self::SendNotification($err, $params, "See input requirement.", "error");	
		}
		// redirect to page error page ------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view_komisariat', array( $this->arr_params['id_daerah'],$this->arr_params['id_cabang']));	
	}		
		
				
}

?>
