<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_profile;

	private $obj_person;

	private $obj_notify;

	private $obj_date;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_profile = $this->obj_ctrl->LoadBusiness('profile_organisasi', 'mysql', $this->arr_config['db']);

		// load utility

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		// load javascript

		$this->obj_ctrl->LoadJavascript('tiny_mce');

	}

	

	public function PageView(){

		self::DisplayPageLink();

		self::DisplayRedirect();

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

	}



   private function DisplayRedirect() {

		if(isset($this->arr_routes['params'][0])) {

			$this->obj_tmpl->addVar('display', 'NAME', $this->arr_routes['params'][0]);

			self::DisplayEditForm();

		}else{

			self::DisplayListArchive();

		}

   }

   

	private function DisplayListArchive(){

  		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');

		$profile = $this->obj_profile->GetInfoAll();

        $no = 0;

		foreach($profile[0] as $key => $value) {

			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($key));

			$this->obj_tmpl->addVar('list_data', 'NO', $no+1);

			$this->obj_tmpl->addVar('list_data', 'NAME', strtoupper(str_replace('_',' ',$key)));

			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');

			$no++;

		}

		// display last update

		$data = $this->obj_profile->GetProfilOrganisasi(array());

		$result = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($data['mdb']));

		$this->obj_tmpl->addVar('display', 'MDD', $this->obj_date->GetFullDate($data['mdd']));

		$this->obj_tmpl->addVar('display', 'MDB', $result['nama']);

	}	

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

      	$result['0'] = array();

		if($this->arr_routes['params']['0'] == "visi") {

			$result = $this->obj_profile->GetInfoVisi();

			$this->obj_tmpl->addVar('display', 'TITLE', "Visi");

			$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['visi']);

		}elseif($this->arr_routes['params']['0'] == "misi") {

			$result = $this->obj_profile->GetInfoMisi();

			$this->obj_tmpl->addVar('display', 'TITLE', "Misi");

			$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['misi']);

		}elseif($this->arr_routes['params']['0'] == "sejarah") {

			$result = $this->obj_profile->GetInfoSejarah();

			$this->obj_tmpl->addVar('display', 'TITLE', "Sejarah");

			$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['sejarah']);

		}elseif($this->arr_routes['params']['0'] == "anggaran_dasar") {

			$result = $this->obj_profile->GetInfoAnggaranDasar();

			$this->obj_tmpl->addVar('display', 'TITLE', "Anggaran Dasar");

			$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['anggaran_dasar']);

		}elseif($this->arr_routes['params']['0'] == "anggaran_rumah_tangga") {

			$result = $this->obj_profile->GetInfoAnggaranRumahTangga();

			$this->obj_tmpl->addVar('display', 'TITLE', "Anggaran Rumah Tangga");

			$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['anggaran_rumah_tangga']);

		}elseif($this->arr_routes['params']['0'] == "struktur_organisasi") {

			$result = $this->obj_profile->GetInfoStrukturOrganisasi();

			$this->obj_tmpl->addVar('display', 'TITLE', "Struktur Organisasi");

			$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['struktur_organisasi']);

		}elseif($this->arr_routes['params']['0'] == "contact_us") {

			$result = $this->obj_profile->GetInfoContactUs();

			$this->obj_tmpl->addVar('display', 'TITLE', "Kontak");

			$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['contact_us']);

		}

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>