<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_studygroup;

	private $obj_date;

	private $obj_notify;

	private $obj_upload;

    private $arr_params;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view');

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_studygroup = $this->obj_ctrl->LoadBusiness('kelompok_studi', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	

		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');	

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		$err = array();	

		// check / validate parameter 

		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama</strong> harus diisi'; }

		$id_kelompok = $this->obj_studygroup->GetLastIdKelompok(array());

		// processing --------------------------------------------------

		if(empty($err)){

			$filename = self::UploadImage($id_kelompok);

			$params = array("nama" => $this->arr_params['name'], "contact_person" => $this->arr_params['contact'],

							"telephone" => $this->arr_params['telephone'], "profil" => $this->arr_params['profile'],

							"pengurus" => $this->arr_params['pengurus'], "logo" => $filename, "mdb" => $this->str_userid);

			if($this->obj_studygroup->SetStudyGroup($params, true)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			$this->obj_notify->SetField('NAME', $this->arr_params['name']);

			$this->obj_notify->SetField('CONTACT', $this->arr_params['contact']);

			$this->obj_notify->SetField('TELEPHONE', $this->arr_params['telephone']);

			$this->obj_notify->SetField('PROFILE', $this->arr_params['profile']);

			$this->obj_notify->SetField('PENGURUS', $this->arr_params['pengurus']);

			// sent message to view page	

			$this->obj_notify->SentMessage();			

		}

		// redirect to page error page ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('add'));	

	}

	

	private function UpdateData(){

		$err = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_kelompok_studi'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }

		if(empty($this->arr_params['name'])){ $err[] = '<br /><strong>Nama</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$last_img = $this->arr_params['last_img'];

			$filename = self::UploadImage($this->arr_params['id_kelompok_studi'], $last_img);

			$params = array("nama" => $this->arr_params['name'], "contact_person" => $this->arr_params['contact'],

							"telephone" => $this->arr_params['telephone'], "profil" => $this->arr_params['profile'],

							"pengurus" => $this->arr_params['pengurus'], "logo" => $filename, "mdb" => $this->str_userid, 

							"id_kelompok_studi" => $this->arr_params['id_kelompok_studi']);

			if($this->obj_studygroup->SetStudyGroup($params, false)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

				// redirect to success page ------------------------------------

				//

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			$this->obj_notify->SetField('NAME', $this->arr_params['name']);

			$this->obj_notify->SetField('CONTACT', $this->arr_params['contact']);

			$this->obj_notify->SetField('TELEPHONE', $this->arr_params['telephone']);

			$this->obj_notify->SetField('PROFILE', $this->arr_params['profile']);

			$this->obj_notify->SetField('PENGURUS', $this->arr_params['pengurus']);

			// sent message to view page	

			$this->obj_notify->SentMessage();   		

		}

		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('edit', $this->arr_params['id_kelompok_studi']));	

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_studygroup->DeleteStudyGroup(array($id))){

					// notification message				

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("success", "Data has been deleted.");

					$this->obj_notify->SentMessage();

					// redirect to success page ------------------------------------

					//

				}else{

					// error message

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

					$this->obj_notify->SentMessage();

					// redirect to page error page ------------------------------------	

					//

				}

			}				

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			//

			// sent message to view page	

			$this->obj_notify->SentMessage();

			// redirect to page error page ------------------------------------		

			//

		}

	}

	

	// utility

	

	private function UploadImage($id_kelompok, $file_name = ""){

		// allowed type

		if(isset($_FILES['logo']['tmp_name']) AND !empty($_FILES['logo']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['logo']['name']);

			$file_path = "doc/logo/kelompok_studi/".$id_kelompok.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->ImageUpload($_FILES['logo'], $file_path, 180);

		}

		return $file_name;

	}

	

}



?>