<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_studygroup;

	private $obj_person;

	private $obj_date;

	private $obj_paging;

	private $obj_notify;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/*

		-- Other object loaded below 

		*/

		$this->obj_studygroup = $this->obj_ctrl->LoadBusiness('kelompok_studi', 'mysql', $this->arr_config['db']);

		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');

        $this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

      	$this->obj_ctrl->LoadJavascript('tiny_mce');

	}

	

	public function PageView(){

		/* 

		-- display view content

		*/

		self::DisplayPageLink();

		self::DisplayRedirect();

		self::DisplayNotification();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	private function DisplayPageLink(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array('add')));

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	}



   private function DisplayRedirect() {

      if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "add") {

         self::DisplayAddForm();

      } else if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "edit") {

         self::DisplayEditForm();

      } else {

         self::DisplayListArchive();

      }

   }

   

	private function DisplayListArchive(){

  		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');



		if(!isset($this->arr_routes['params']['0'])) {

			$page = 1;

		} else {

			$page = $this->arr_routes['params']['0'];

		}

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(20);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_studygroup->CountStudyGroup(array()));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		$studygroup = $this->obj_studygroup->GetStudyGroup(array($start, $max));

		if (sizeof($studygroup) > 0) {

			$this->obj_tmpl->addVar('cat', 'cat', 'have');

		}

		$no = 0;

		$num = $start+1;

		foreach($studygroup as $key=>$value) {

			$href = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-news', array($value['id_kelompok_studi']));

			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array("edit", $value['id_kelompok_studi']));

			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);

			$this->obj_tmpl->addVar('list_data', 'NO', $num);

			$this->obj_tmpl->addVar('list_data', 'ID', $value['id_kelompok_studi']);	

			$this->obj_tmpl->addVar('list_data', 'NAME', $value['nama']);

			$this->obj_tmpl->addVar('list_data', 'CONTACT', $value['contact_person']);

			$this->obj_tmpl->addVar('list_data', 'TELEPHONE', $value['telephone']);

			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);

			$this->obj_tmpl->addVar('list_data', 'URL_NEWS', $href);

			$this->obj_tmpl->ParseTemplate('list_data', 'a');

			$no++;

			$num++;

		}

	}	



	private function DisplayAddForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');

		$this->obj_tmpl->addVar('display', 'view', 'add');

	}

	

	private function DisplayEditForm(){

		// activated template

		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');

		$this->obj_tmpl->addVar('display', 'view', 'edit');

		// parse data	

		$result = $this->obj_studygroup->GetStudyGroupById(array($this->arr_routes['params']['1']));

		$this->obj_tmpl->addVar('display', 'ID', $result['0']['id_kelompok_studi']);	

		$this->obj_tmpl->addVar('display', 'NAME', $result['0']['nama']);

		$this->obj_tmpl->addVar('display', 'CONTACT', $result['0']['contact_person']);

		$this->obj_tmpl->addVar('display', 'TELEPHONE', $result['0']['telephone']);

		$this->obj_tmpl->addVar('display', 'PROFILE', $result['0']['profil']);

		$this->obj_tmpl->addVar('display', 'PENGURUS', $result['0']['pengurus']);

		$this->obj_tmpl->addVar('display', 'LOGO', $result['0']['logo']);

		// display foto

		$imgpath = "doc/logo/kelompok_studi/".$result['0']['id_kelompok_studi']."/".$result['0']['logo'];

		if(is_file($imgpath)){

			$str_img = '<img class="photo-view" src="'.HTTPPATH.$imgpath.'" />';

			$this->obj_tmpl->addVar('display', 'IMGVIEW', $str_img);

		}

		// display last update

		$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($result[0]['mdb']));

		$this->obj_tmpl->addVar('display', 'MDD', $this->obj_date->GetFullDate($result[0]['mdd']));

		$this->obj_tmpl->addVar('display', 'MDB', $person['nama']);

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

}



?>