<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_account;

	protected $obj_notify;

	protected $obj_mail;

	protected $obj_crypt;

	// variable definition

	protected $arr_params;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		

	}		

	

	protected function ParseDocumentOutput(){

		/** Redirect result to default page */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'settings');	

	}

	

	protected function PageLoad(){ 

		/* -- Other object loaded below */

		$this->obj_account = $this->obj_ctrl->LoadBusiness('account', 'mysql', $this->arr_config['db']);

		$loaded_query = array('business');

		$this->obj_account->SetUsesBusinessQuery($loaded_query);

		// --

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');

		// plugins 

		$this->obj_ctrl->LoadFile('class.phpmailer.php', 'plugins/phpmailer');

		$this->obj_mail = new PHPMailer;

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'email':

				self::UpdateEmail();

				break;

			case 'userid':

				self::UpdateUserId();

				break;

			case 'password':

				self::UpdatePassword();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	// notification method

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		for($i=0;$i<count($filled);$i++){

			$name = array_keys($filled);

			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);

		}

		$this->obj_notify->SentMessage();

	}

	

	// operation

	private function UpdateEmail(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		if(empty($this->arr_params['email'])){ 

			$err[] = '<br /><strong>Email baru</strong> harus diisi'; 

		}else{

			// eregi email

			$normal = "^[a-z0-9_\+-]+(\.[a-z0-9_\+-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*\.([a-z]{2,4})$";

			if(!eregi($normal, $this->arr_params['email'])){

			  $err[] = '<br /><b>Format Email</b> tidak diperkenankan';

			}else{

				// try to send mail

				if(!self::SendEmailUpdate()){

					$err[] = '<br /><b>Email</b> tidak dapat terkirim, pastikan alamat email anda valid';

				}

			}

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['email'], $this->str_userid);

			// execute process

			if($this->obj_account->ProcessingData("UpdateEmail", $params)){

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("EMAIL_NOTIFIKASI" => $this->arr_params['email']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("EMAIL_NOTIFIKASI" => $this->arr_params['email']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

	}

	

	private function UpdateUserId(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		$userid = trim($this->arr_params['userid']);

		if(empty($userid)){ 

			$err[] = '<br /><strong>User Id baru</strong> harus diisi'; 

		}else{

			if(strlen($userid) < 6 OR strlen($userid) > 30){

				$err[] = '<br /><strong>User Id baru</strong> melebihi atau kurang dari karakter yang diharuskan'; 

			}else{

				$rs = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->str_userid));

				if($rs['userid'] == $this->arr_params['userid']){

					$err[] = '<br /><strong>User Id baru</strong> tidak bisa digunakan (gunakan User Id yang lebih unik)'; 

				}

			}

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			$params = array($this->arr_params['userid'], $this->str_userid);

			// execute process

			if($this->obj_account->ProcessingData("UpdateUserId", $params)){

				// try to send mail

				if(!self::SendEmailUserid()){

					$err[] = '<br /><b>Email</b> tidak dapat terkirim';

				}

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array("USERID_NEW" => $this->arr_params['userid']);

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array("USERID_NEW" => $this->arr_params['userid']);

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}	

		// redirect page --------------------------------------------------		

	}

	

	private function UpdatePassword(){	

		// inisialize variable --------------------------------------------

		$err = array();		

		$filled = array();

		// required -------------------------------------------

		$pass_old = trim($this->arr_params['pass_old']);

		$pass_new = trim($this->arr_params['pass_new']);

		$pass_confirm = trim($this->arr_params['pass_confirm']);

		if(empty($pass_old)){ $err[] = '<br /><strong>Kata kunci lama</strong> harus diisi'; }

		if(empty($pass_new)){ $err[] = '<br /><strong>Kata kunci baru</strong> harus diisi'; }

		if(strlen($pass_new) < 6 OR strlen($pass_new) > 30){

			$err[] = '<br /><strong>Kata kunci baru</strong> melebihi atau kurang dari karakter yang diharuskan'; 

		}

		if(strcmp($pass_new, $pass_confirm)){

			$err[] = '<br /><strong>Kata kunci baru</strong> tidak valid, pastikan kembali kata kunci anda'; 

		}

		// check old password

		$rs = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->str_userid));

		$pass_valid = $this->obj_crypt->StandardDecrypt($rs['pass'], $rs['hash_key']);

		if($pass_valid != $pass_old){

			$err[] = '<br /><strong>Password lama</strong> tidak cocok (tidak dapat ditemukan)'; 

		}

		// processing -----------------------------------------------------

		if(empty($err)){

			// encrypt password

			$pass_new = $this->obj_crypt->StandardEncrypt($pass_new, $rs['hash_key']);

			$params = array($pass_new, $this->str_userid);

			// execute process

			if($this->obj_account->ProcessingData("UpdatePassword", $params)){

				// try to send mail

				if(!self::SendEmailPassword($pass_confirm)){

					$err[] = '<br /><b>Email</b> tidak dapat terkirim';

				}

				// sukses message				

				self::SendNotification($err, $filled, 'Data has been saved.', 'success');

				// redirect to success page ------------------------------------

			}else{

				// filled last field

				$filled = array();

				// error message

				self::SendNotification($err, $filled, 'Business process failure.', 'error');

				// redirect to page error page ------------------------------------	

			}

		}else{

			// filled last field

			$filled = array();

			// error message

			self::SendNotification($err, $filled, 'See input requirement.', 'error');

			// redirect to page error page --------------------------------	

		}

		// redirect page --------------------------------------------------		

	}

	

	private function SendEmailUpdate(){

		// get detail member

		$params = array($this->str_userid);

		$rs = $this->obj_account->GetDataAsSingleArray("GetDetailMember", $params);

		// body

		$body	= "<body bgcolor=\"#CCCCCC\">

					<style>

					.page {

						margin: auto;

						padding: 5px 5px 5px 5px;

						width: 400px;

						background-color: #FFFFFF;

						border: 1px solid #999999;

						font-family: Verdana, Arial, Helvetica, sans-serif;

					}

					.page p {

						margin: 0px 0px 10px 0px;

						font-size: 11px;

						line-height: 16px;

					}

					.page H3 {

						margin: 0px 0px 10px 0px;

						font-size: 12px;

					}

					</style>

					<div class=\"page\">

						<h3>Persatuan Perawat Nasional Indonesia</h3>

						<h3>Control Panel</h3>

						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>

						Kami melakukan konfirmasi bahwa alamat email anda telah diperbaharui. Untuk konfirmasi lain yang terkait dengan kegiatan anda dalam web organisasi akan ditujukan disini.<br></p>

						<p>Terima kasih.</p>

					</div>

					</body>";	

		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');

		$body             = eregi_replace("[\]",'',$body);

		// this script will auto generate setting

		$this->obj_mail->IsSMTP();

		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication

		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier

		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server

		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		

		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username

		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		

		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		

		$this->obj_mail->From       = $this->arr_system_default['siteemail'];

		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		

		$this->obj_mail->Subject    = "Perubahan alamat email";		

		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      

		//HTML Body

		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 

		// optional, comment out and test

		$this->obj_mail->WordWrap   = 50; // set word wrap		

		$this->obj_mail->MsgHTML($body);		

		$this->obj_mail->AddAddress($this->arr_params['email'], $rs['nama_lengkap']);		

		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment

		$this->obj_mail->IsHTML(true); // send as HTML		

		if(!$this->obj_mail->Send())

			return false;

		else

			return true;

	}

	

	private function SendEmailUserid(){

		// get detail member

		$params = array($this->str_userid);

		$rs = $this->obj_account->GetDataAsSingleArray("GetDetailMember", $params);

		// body

		$body	= "<body bgcolor=\"#CCCCCC\">

					<style>

					.page {

						margin: auto;

						padding: 5px 5px 5px 5px;

						width: 400px;

						background-color: #FFFFFF;

						border: 1px solid #999999;

						font-family: Verdana, Arial, Helvetica, sans-serif;

					}

					.page p {

						margin: 0px 0px 10px 0px;

						font-size: 11px;

						line-height: 16px;

					}

					.page H3 {

						margin: 0px 0px 10px 0px;

						font-size: 12px;

					}

					</style>

					<div class=\"page\">

						<h3>Persatuan Perawat Nasional Indonesia</h3>

						<h3>Control Panel</h3>

						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>

						Email ini memberikan konfirmasi kepada anda bahwa User Id dalam web organisasi telah berhasil diubah sebagai berikut : <strong>".$this->arr_params['userid']."</strong>.<br></p>

						<p>Terima kasih.</p>

					</div>

					</body>";	

		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');

		$body             = eregi_replace("[\]",'',$body);

		// this script will auto generate setting

		$this->obj_mail->IsSMTP();

		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication

		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier

		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server

		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		

		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username

		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		

		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		

		$this->obj_mail->From       = $this->arr_system_default['siteemail'];

		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		

		$this->obj_mail->Subject    = "Perubahan User Id";		

		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      

		//HTML Body

		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 

		// optional, comment out and test

		$this->obj_mail->WordWrap   = 50; // set word wrap		

		$this->obj_mail->MsgHTML($body);		

		$this->obj_mail->AddAddress($rs['email'], $rs['nama_lengkap']);		

		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment

		$this->obj_mail->IsHTML(true); // send as HTML		

		if(!$this->obj_mail->Send())

			return false;

		else

			return true;

	}

	

	private function SendEmailPassword($pass_confirm){

		// get detail member

		$params = array($this->str_userid);

		$rs = $this->obj_account->GetDataAsSingleArray("GetDetailMember", $params);

		// body

		$body	= "<body bgcolor=\"#CCCCCC\">

					<style>

					.page {

						margin: auto;

						padding: 5px 5px 5px 5px;

						width: 400px;

						background-color: #FFFFFF;

						border: 1px solid #999999;

						font-family: Verdana, Arial, Helvetica, sans-serif;

					}

					.page p {

						margin: 0px 0px 10px 0px;

						font-size: 11px;

						line-height: 16px;

					}

					.page H3 {

						margin: 0px 0px 10px 0px;

						font-size: 12px;

					}

					</style>

					<div class=\"page\">

						<h3>Persatuan Perawat Nasional Indonesia</h3>

						<h3>Control Panel</h3>

						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>

						Email ini memberikan konfirmasi kepada anda bahwa Password dalam web organisasi telah berhasil diubah sebagai berikut : <strong>".$pass_confirm."</strong>.<br></p>

						<p>Terima kasih.</p>

					</div>

					</body>";	

		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');

		$body             = eregi_replace("[\]",'',$body);

		// this script will auto generate setting

		$this->obj_mail->IsSMTP();

		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication

		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier

		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server

		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		

		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username

		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		

		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		

		$this->obj_mail->From       = $this->arr_system_default['siteemail'];

		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		

		$this->obj_mail->Subject    = "Perubahan kata kunci (password)";		

		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      

		//HTML Body

		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 

		// optional, comment out and test

		$this->obj_mail->WordWrap   = 50; // set word wrap		

		$this->obj_mail->MsgHTML($body);		

		$this->obj_mail->AddAddress($rs['email'], $rs['nama_lengkap']);		

		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment

		$this->obj_mail->IsHTML(true); // send as HTML		

		if(!$this->obj_mail->Send())

			return false;

		else

			return true;

	}

	

}



?>