<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{		

	// object definition

	protected $obj_admin;

	protected $obj_date;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');	

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load business

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	

		// load library

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation', 'mysql', $this->arr_config['db']);	

	}

	

	public function PageView(){		

		// display detail administrator

		self::DisplayAdministrator();

		// display authority administrator

		self::DisplayAuthority();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayAdministrator(){

		$result = $this->obj_admin->GetAdministratorStatusById(array($this->str_userid, $this->str_userid));

		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);

			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);

			$this->obj_tmpl->addVar('content', 'NAMA', $result['nama_lengkap']);

			$this->obj_tmpl->addVar('content', 'TGL_LAHIR', $this->obj_date->GetFullDate($result['tanggal_lahir']));

			$this->obj_tmpl->addVar('content', 'TMP_LAHIR', $result['tempat_lahir']);

			$this->obj_tmpl->addVar('content', 'TELEPON', $result['telepon']);

			$this->obj_tmpl->addVar('content', 'HP', $result['no_hp']);

			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);

			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);

			$last_login = $result['date_login'] . ' ' . $result['time_login'];

			$this->obj_tmpl->addVar('content', 'LAST_LOGIN', $this->obj_date->GetFullDate($last_login));

			

			// display foto

			$path = "doc/person/".$result['id_person']."/foto/".$result['photo'];

			if(is_file($path))

				$this->obj_tmpl->addVar('content', 'FOTO', $path);

			else

				$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");

		}

	}

	

	private function DisplayAuthority(){

		$rs_id = $this->obj_admin->GetListAuthorityByAdmin(array($this->str_userid, $this->arr_config['app_group']['cpanel']));

		if($rs_id){

			while($rec = mysqli_fetch_assoc($rs_id)){

				$this->obj_tmpl->addVar('list_akses', 'HAK_AKSES', $rec['auth_name']);

				$this->obj_tmpl->addVar('list_akses', 'DESKRIPSI', $rec['deskripsi']);

				$this->obj_tmpl->parseTemplate('list_akses', 'a');

			}

		}

	}

}



?>