<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object definition

	protected $obj_admin;

	protected $obj_data;

	protected $obj_date;

	protected $obj_crypt;

	protected $obj_notify;

	// variable

	protected $int_page;

	protected $str_id_person;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		// load business

		$this->obj_data = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);

		// library loaded

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	

		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');

	}

	

	public function PageView(){

		// display test cookies

		self::DisplayNotification();

		// variable display

		self::DisplayVariable();

		// display content registrasi

		self::DisplayContent();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariable(){

		// head nav

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));	

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'sistem'));	

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota'));

		// global var

		$this->int_page = $this->arr_routes['params'][0];

		$this->str_id_person = $this->arr_routes['params'][1];

		$this->obj_tmpl->addVar('content', 'ID_PAGE', $this->int_page);

		$this->obj_tmpl->addVar('content', 'ID_PERSON', $this->str_id_person);

		// sub nav

		$this->obj_tmpl->addVar('content', 'URL_PRIBADI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->int_page, $this->str_id_person)));	

		$this->obj_tmpl->addVar('content', 'URL_ACCOUNT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->int_page, $this->str_id_person, 'account')));	

		$this->obj_tmpl->addVar('content', 'URL_ACCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->int_page, $this->str_id_person, 'access')));	

	}

	

	private function DisplayContent(){

		// account

		self::DisplayAccountContent();

		// access

		self::DisplayAccessContent();

		// identitas

		self::DisplayIdentitasContent();

	}

	

	private function DisplayIdentitasContent(){

		// load specific object

		$obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);

		// id person

		$id_person = $this->arr_routes['params'][1];

		$this->obj_tmpl->addVar('content', 'ID_PERSON', $id_person);	

		// parse data

		$params = array($id_person);

		$result = $obj_cv->GetIdentitasPribadiByIdPerson($params);

		if(!empty($result)){

			// photo

			$file_photo = "doc/person/".$id_person."/foto/".$result['photo'];

			if(is_file($file_photo))

				$this->obj_tmpl->addVar('content', 'PHOTOPATH', HTTPPATH.$file_photo);

			else

				$this->obj_tmpl->addVar('content', 'PHOTOPATH', HTTPPATH."doc/temp/blank.jpg");

			// cek notification 

			if(isset($this->obj_notify->arr_message['field'])){

				$result = $this->obj_notify->arr_message['field'];

			}

			// parse data

			$this->obj_tmpl->addVar('content', 'NAMA_LENGKAP', $result['nama_lengkap']);	

			$this->obj_tmpl->addVar('content', 'TEMPAT_LAHIR', $result['tempat_lahir']);

			$this->obj_tmpl->addVar('content', 'GENDER', ucwords($result['jenis_kelamin']));	

			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);	

			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);	

			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);	

			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);	

			$this->obj_tmpl->addVar('content', 'KODEPOS', $result['kodepos']);	

			$this->obj_tmpl->addVar('content', 'TELEPON', $result['telepon']);

			$this->obj_tmpl->addVar('content', 'NO_HP', $result['no_hp']);

			$this->obj_tmpl->addVar('content', 'TANGGAL_LAHIR', $this->obj_date->GetFullDate($result['tanggal_lahir']));

		}

	}

	

	private function DisplayAccountContent(){

		// load specific object

		$obj_account = $this->obj_ctrl->LoadBusiness('account', 'mysql', $this->arr_config['db']);

		$obj_account->SetUsesBusinessQuery(array('business'));

		// id person

		$id_person = $this->arr_routes['params'][1];

		$this->obj_tmpl->addVar('content', 'ID_PERSON', $id_person);	

		// parse data

		$result = $obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($id_person));

		if(!empty($result)){

			$this->obj_tmpl->addVar('content', 'EMAIL', $result['email']);

		}

	}

	

	private function DisplayAccessContent(){

		// cabang

		$rs_id = $this->obj_data->GetDataCabang();

		// selected cabang

		$rs_cabang = $this->obj_admin->GetListCabangByAdmin(array($this->arr_routes['params'][1]));

		while($rec_cabang = mysqli_fetch_assoc($rs_cabang)){

			$arr_cabang[] = $rec_cabang['id_cabang'];

		}

		// --

		$no = 0;

		$str_cabang = "";

		while($rec = mysqli_fetch_assoc($rs_id)){

			// selected cabang by admin

			if(in_array($rec['id_cabang'], $arr_cabang))

				$selected = "<b><u>".$rec['nama']."</u></b>";

			else

				$selected = $rec['nama'];

			// --

			if($no % 2 == 0){$str_cabang .= "<tr>";}else{$str_cabang .= "";}

			$str_cabang .= "<td><label>";

			$str_cabang .= $selected;

			$str_cabang .= "</label></td>";

			if($no % 2 == 1){$str_cabang .= "</tr>";}else{$str_cabang .= "";}

			$no++;

		}

		$this->obj_tmpl->addVar('content', 'CABANG', $str_cabang);

		// authority

		$rs_id = $this->obj_data->GetHakAksesByGroup(array($this->arr_config['app_group']['cpanel']));

		// selected access

		$rs_access = $this->obj_admin->GetListAuthorityByAdmin(array($this->arr_routes['params'][1], $this->arr_config['app_group']['cpanel']));

		while($rec_access = mysqli_fetch_assoc($rs_access)){

			$arr_access[] = $rec_access['id_auth'];

		}

		// --

		$no = 0;

		$str_akses = "";

		while($rec = mysqli_fetch_assoc($rs_id)){

			// selected cabang by admin

			if(in_array($rec['id_auth'], $arr_access))

				$selected = "<b><u>".$rec['auth_name']."</u></b>";

			else

				$selected = $rec['auth_name'];

			// --

			$str_akses .= "<tr>";

			$str_akses .= "<td><label>";

			$str_akses .= $selected . "<br><em>" . $rec['deskripsi'] . "</em>";

			$str_akses .= "</label></td>";

			$str_akses .= "</tr>";

			$no++;

		}

		$this->obj_tmpl->addVar('content', 'AUTHORITY', $str_akses);

	}

}



?>