<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	// object

	protected $obj_admin;

	protected $obj_support;

	protected $obj_paging;

	// variable

	protected $str_cabang;

	protected $str_keyword;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		/* Other object loaded below */

		// load object business

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);

		$this->obj_support = $this->obj_ctrl->LoadBusiness('supportdata', 'mysql', $this->arr_config['db']);	

		// load object pagination

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');	

		// load javascript

		$this->obj_ctrl->LoadJavascript('form_event');	

	}

	

	public function PageView(){

		// display variable

		self::DisplayVariable();		

		// display cabang

		self::DisplayCabangAuthority();

		// display data

		self::DisplayCalonAdministrator();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayVariable(){

		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));	

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));	

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'sistem'));	

		$this->obj_tmpl->addVar('content', 'URL_MEMBER', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'member'));

		// keyword

		if(isset($_SESSION['search']['keyword'])){

			$this->str_keyword = "%" . $_SESSION['search']['keyword'] . "%";

			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['keyword']);

		}else{

			$this->str_keyword = "%%";

		}

	}

	

	private function DisplayCabangAuthority(){

		// set parameter cabang

		if(isset($_SESSION['search']['cabang']) AND !empty($_SESSION['search']['cabang'])){ 

			$this->str_cabang =  "AND b.id_cabang =" . $_SESSION['search']['cabang'];

		}else{

			$_SESSION['search']['cabang'] = '';

		}

		// parsing data

		$rs_id = $this->obj_support->GetDataCabang();		

		while($rs = mysqli_fetch_assoc($rs_id)){

			if($rs['id_cabang'] == $_SESSION['search']['cabang']){

				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', 'selected="selected"');

			}else{

				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', '');

			}

			$this->obj_tmpl->addVar('list_cabang', 'VALUE', $rs['id_cabang']);

			$this->obj_tmpl->addVar('list_cabang', 'NAMA', $rs['nama']);

			$this->obj_tmpl->ParseTemplate('list_cabang', 'a');

		}

	}

	

	private function DisplayCalonAdministrator(){

		/* display paging template (bagian atas) */

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][0]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][0];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(10);

		// set total record

		$params = array($this->str_cabang, $this->str_keyword);

		$this->obj_paging->SetTotalRecord($this->obj_admin->GetTotalCalonAdministrator($params));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get data

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$params = array($this->str_cabang, $this->str_keyword, $start, $max);

		$rs_id = $this->obj_admin->GetDataCalonAdministrator($params);	

		if($rs_id){

			$no = $start + 1;

			while($rs = mysqli_fetch_assoc($rs_id)){				  

				//url detail

				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'register', array($rs['id_person']));

				// parse data

				$this->obj_tmpl->addVar('list_data', 'NO', $no);

				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama_lengkap']);

				$this->obj_tmpl->addVar('list_data', 'PREFIX', $rs['prefix']);

				$this->obj_tmpl->addVar('list_data', 'SUFFIX', $rs['suffix']);

				$this->obj_tmpl->addVar('list_data', 'CABANG', $rs['cabang']);

				$this->obj_tmpl->addVar('list_data', 'NO_ANGGOTA', $rs['no_anggota']);

				$this->obj_tmpl->addVar('list_data', 'KOTA', $rs['kota']);

				$this->obj_tmpl->addVar('list_data', 'TELEPON', $rs['telepon']);

				$this->obj_tmpl->addVar('list_data', 'URL_REGISTER', $url);

				$this->obj_tmpl->ParseTemplate('list_data', 'a');

				$no++;

			}

		}

	}

}



?>