<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object
	protected $obj_admin;
	protected $obj_cv;
	protected $obj_account;
	protected $obj_upload;
	protected $obj_crypt;
	protected $obj_notify;
	// post
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'sistem');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		$this->obj_account = $this->obj_ctrl->LoadBusiness('account', 'mysql', $this->arr_config['db']);
		$this->obj_account->SetUsesBusinessQuery(array('business'));
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		// plugins 
		$this->obj_ctrl->LoadFile('class.phpmailer.php', 'plugins/phpmailer');
		$this->obj_mail = new PHPMailer;
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'search_calon':
				self::SearchCalon();
				break;
                        case 'search':
				self::SearchData();
				break;	
			case 'insert':
				self::InsertData();
				break;
			case 'update':
				self::UpdateData();
				break;
			case 'delete':
				self::DeleteData();
				break;
			case 'identitas':
				self::UpdateIdentitasPribadi();
				break;			
			case 'email':
				self::UpdateEmail();
				break;
			case 'userid':
				self::UpdateUserId();
				break;
			case 'password':
				self::UpdatePassword();
				break;
			case 'cabang':
				self::UpdateCabang();
				break;
			case 'access':
				self::UpdateHakAkses();
				break;
			case 'hapus':
				self::HapusAdministrator();
				break;
			case 'register':
				self::RegistrasiAnggota();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// search calon admin dari anggota
	
	private function SearchCalon(){
		$_SESSION['search']['cabang'] = $this->arr_params['id_cabang'];
		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'member');	
	}
	

           private function SearchData(){
		$_SESSION['search']['prov_kom'] = $this->arr_params['prov_kom'];
		$_SESSION['search']['city'] = $this->arr_params['city'];
		$_SESSION['search']['cabang'] = $this->arr_params['cabang'];
		$_SESSION['search']['keyword'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_page'], $this->arr_params['id_person'], 'access'));
	}
	// add data
	
	private function InsertData(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		$tgl_lahir = $this->arr_params['tahun'].'-'.$this->arr_params['bulan'].'-'.$this->arr_params['hari'];
		if(empty($this->arr_params['nama'])){ $err[] = '<br /><b>Nama</b> harus diisi'; }
		if(empty($this->arr_params['tmp_lahir'])){ $err[] = '<br /><b>Tempat lahir</b> harus diisi'; }
		if(empty($this->arr_params['gender'])){ $err[] = '<br /><b>Jenis kelamin</b> harus diisi'; }
		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><b>Alamat</b> harus diisi'; }
		if(empty($this->arr_params['kota'])){ $err[] = '<br /><b>Kota tinggal</b> harus diisi'; }
		// id city
		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));
		if(empty($this->arr_params['cabang'])){ $err[] = '<br /><b>Administrator Komisariat</b> harus diisi'; }
		if(empty($this->arr_params['authority'])){ $err[] = '<br /><b>Hak akses</b> harus diisi'; }
		if(empty($this->arr_params['email'])){ $err[] = '<br /><b>Email</b> harus diisi'; }else{
			// eregi email
			$normal = "^[a-z0-9_\+-]+(\.[a-z0-9_\+-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*\.([a-z]{2,4})$";
			if(!eregi($normal, $this->arr_params['email'])){
			  $err[] = '<br /><b>Email</b> tidak sesuai dengan contoh format';
			}else{
				// validasi email
				if($this->arr_params['email'] !== $this->arr_params['confirm_email']){
					$err[] = '<br /><b>Confirm E-mail</b> yang dimasukkan tidak valid'; 
				}
			}
		}
		// kode validasi
		if($this->arr_params['valid_code'] != $_SESSION['captcha']){ 
			$err[] = '<br /><b>Kode validasi</b> yang dimasukkan tidak valid';
		}
		// processing --------------------------------------------------
		if(empty($err)){
			// get id person
			$this_day = date('Y').date('m').date('d');
			$id = $this->obj_admin->GetIdPerson(array($this_day . "%"));
			if(!empty($id)){
				$id = explode('-', $id);
				$id_person = $this_day . '-' . strval(intval($id[1]) + 1);
			}else{
				$id_person = $this_day . '-1';
			}
			// get userid
			$user_id = str_replace("-", "", $id_person);
			// get password
			$hask_key = $this->obj_crypt->CreateUserKey($user_id);
			$pass = substr($this->obj_crypt->CreateUserKey($hask_key), 0, 6);
			$pass_decrypt = $this->obj_crypt->StandardEncrypt($pass, $hask_key);
			// cabang
			$params_cabang = $this->arr_params['cabang'];			
			// authority
			$params_access = $this->arr_params['authority'];
			// person
			$params_person = array($id_person, $this->arr_params['nama'], $this->arr_params['tmp_lahir'], $tgl_lahir, $this->arr_params['gender'], $this->arr_params['prefix'], $this->arr_params['suffix'], $this->arr_params['alamat'], $this->arr_params['telepon'], $this->arr_params['no_hp'], $kota, $this->arr_params['kodepos'], $this->str_userid);
			// account
			$params_account = array($id_person,$user_id,$pass_decrypt,$hask_key,$this->arr_params['email'],$this->str_userid);
			if($this->obj_admin->InsertDataAdministrator($params_person, $params_account, $params_cabang, $params_access)){
				// try to send mail
				if(!self::SendEmailRegistrasi($params_person, $user_id, $pass, $this->arr_params['email'])){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add');	
			}	
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page ------------------------------------	
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add');	
		}
	}
	
	private function SendEmailRegistrasi($person, $userid, $pass, $email){
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Indonesia Nasional</h3>
						<h3>Control Panel</h3>
						<p><strong>".$person[5].' '.$person[1].' '.$person[6]."</strong>,<br>
						Email ini memberikan konfirmasi bahwa account anda sebagai administrator dalam web organisasi telah berhasil dibuat sebagai berikut:<br />User Id :<strong>".$userid."</strong>.<br />Password : <strong>".$pass."</strong><br /></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Administrator Control Panel";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($email, $person[1]);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	// identitas pribadi
	
	private function UpdateIdentitasPribadi(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['id_page'])){ $err[] = '<br /><strong>Id halaman</strong> tidak terpilih'; }
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id admin</strong> tidak terpilih'; }
		// data
		$tgl_lahir = $this->arr_params['tahun'].'-'.$this->arr_params['bulan'].'-'.$this->arr_params['hari'];
		if(empty($this->arr_params['nama_lengkap'])){ $err[] = '<br /><strong>Nama lengkap</strong> harus diisi'; }
		if(empty($this->arr_params['tempat_lahir'])){ $err[] = '<br /><strong>Tempat lahir</strong> harus diisi'; }
		if(empty($this->arr_params['alamat'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }
		// id city
		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));
		if(empty($kota)){ $err[] = '<br /><strong>Data kota</strong> tidak ditemukan'; }
		// processing -----------------------------------------------------
		if(empty($err)){
			$params = array($this->arr_params['nama_lengkap'], $this->arr_params['tempat_lahir'], $tgl_lahir, $this->arr_params['jenis_kelamin'], $this->arr_params['prefix'], $this->arr_params['suffix'], $this->arr_params['alamat'], $this->arr_params['telepon'], $this->arr_params['no_hp'], $kota, $this->arr_params['kodepos'], $this->arr_params['agama'], $this->str_userid, $this->arr_params['id_person']);
			// execute process
			if($this->obj_cv->UpdateIdentitasPribadi($params)){
				// uploadfile		
				$err[] = self::UploadFoto();
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, $this->arr_params['jenis_kelamin'] => 'selected="selected"', "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, $this->arr_params['jenis_kelamin'] => 'selected="selected"', "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_page'], $this->arr_params['id_person']));
	}	
	
	private function UploadFoto(){
		// allowed type
		$err = "";
		if(isset($_FILES['foto']['tmp_name']) AND !empty($_FILES['foto']['tmp_name'])){
			// name and path file
			$file_name = str_replace(' ', '_', $_FILES['foto']['name']);
			$file_path = "doc/person/".$this->arr_params['id_person']."/foto/";
			// delete last 
			if(is_dir($file_path))
				$this->obj_upload->RemoveDir($file_path);
			// processing
			if($this->obj_upload->ImageUpload($_FILES['foto'], $file_path, 120)){
				// insert to database
				$params = array($file_name, $this->arr_params['id_person']);
				$this->obj_cv->UpdateFotoPribadi($params);
				$err = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 
			}else{
				$err = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
			}
		}
		return $err;
	}
	
	/* account settings */
	
	// update email
	private function UpdateEmail(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['email'])){ 
			$err[] = '<br /><strong>Email baru</strong> harus diisi'; 
		}else{
			// eregi email
			$normal = "^[a-z0-9_\+-]+(\.[a-z0-9_\+-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*\.([a-z]{2,4})$";
			if(!eregi($normal, $this->arr_params['email'])){
			  $err[] = '<br /><b>Format Email</b> tidak diperkenankan';
			}else{
				// try to send mail
				if(!self::SendEmailUpdate()){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim, pastikan alamat email anda valid';
				}
			}
		}
		// processing -----------------------------------------------------
		if(empty($err)){
			$params = array($this->arr_params['email'], $this->arr_params['id_person']);
			// execute process
			if($this->obj_account->ProcessingData("UpdateEmail", $params)){
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("EMAIL_NOTIFIKASI" => $this->arr_params['email']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("EMAIL_NOTIFIKASI" => $this->arr_params['email']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_page'], $this->arr_params['id_person'], 'account'));
	}
	
	private function SendEmailUpdate(){
		// get detail member
		$params = array($this->arr_params['id_person']);
		$rs = $this->obj_admin->GetDetailAdministratorById($params);
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Indonesia Nasional</h3>
						<h3>Control Panel</h3>
						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>
						Kami melakukan konfirmasi bahwa alamat email anda telah diperbaharui. Untuk konfirmasi lain yang terkait dengan kegiatan anda dalam web organisasi akan ditujukan disini.<br></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Perubahan alamat email";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($this->arr_params['email'], $rs['nama_lengkap']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	// update userid
	
	private function UpdateUserId(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		$userid = trim($this->arr_params['userid']);
		if(empty($userid)){ 
			$err[] = '<br /><strong>User Id baru</strong> harus diisi'; 
		}else{
			if(strlen($userid) < 6 OR strlen($userid) > 30){
				$err[] = '<br /><strong>User Id baru</strong> melebihi atau kurang dari karakter yang diharuskan'; 
			}else{
				$rs = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->str_userid));
				if($rs['userid'] == $this->arr_params['userid']){
					$err[] = '<br /><strong>User Id baru</strong> tidak bisa digunakan (gunakan User Id yang lebih unik)'; 
				}
			}
		}
		// processing -----------------------------------------------------
		if(empty($err)){
			$params = array($this->arr_params['userid'], $this->arr_params['id_person']);
			// execute process
			if($this->obj_account->ProcessingData("UpdateUserId", $params)){
				// try to send mail
				if(!self::SendEmailUserid()){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("USERID_NEW" => $this->arr_params['userid']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("USERID_NEW" => $this->arr_params['userid']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_page'], $this->arr_params['id_person'], 'account'));
	}
	
	private function SendEmailUserid(){
		// get detail member
		$params = array($this->arr_params['id_person']);
		$rs = $this->obj_admin->GetDetailAdministratorById($params);
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Indonesia Nasional</h3>
						<h3>Control Panel</h3>
						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>
						Email ini memberikan konfirmasi kepada anda bahwa User Id dalam web organisasi telah berhasil diubah sebagai berikut : <strong>".$this->arr_params['userid']."</strong>.<br></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Perubahan User Id";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($rs['email'], $rs['nama_lengkap']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	// password
	
	private function UpdatePassword(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		$pass_old = trim($this->arr_params['pass_old']);
		$pass_new = trim($this->arr_params['pass_new']);
		$pass_confirm = trim($this->arr_params['pass_confirm']);
		if(empty($pass_old)){ $err[] = '<br /><strong>Kata kunci lama</strong> harus diisi'; }
		if(empty($pass_new)){ $err[] = '<br /><strong>Kata kunci baru</strong> harus diisi'; }
		if(strlen($pass_new) < 6 OR strlen($pass_new) > 30){
			$err[] = '<br /><strong>Kata kunci baru</strong> melebihi atau kurang dari karakter yang diharuskan'; 
		}
		if(strcmp($pass_new, $pass_confirm)){
			$err[] = '<br /><strong>Kata kunci baru</strong> tidak valid, pastikan kembali kata kunci anda'; 
		}
		// check old password
		$rs = $this->obj_account->GetDataAsSingleArray("GetUserAccountByIdPerson", array($this->arr_params['id_person']));
		$pass_valid = $this->obj_crypt->StandardDecrypt($rs['pass'], $rs['hash_key']);
		if($pass_valid != $pass_old){
			$err[] = '<br /><strong>Password lama</strong> tidak cocok (tidak dapat ditemukan)'; 
		}
		// processing -----------------------------------------------------
		if(empty($err)){
			// encrypt password
			$pass_new = $this->obj_crypt->StandardEncrypt($pass_new, $rs['hash_key']);
			$params = array($pass_new, $this->arr_params['id_person']);
			// execute process
			if($this->obj_account->ProcessingData("UpdatePassword", $params)){
				// try to send mail
				if(!self::SendEmailPassword($pass_confirm)){
					$err[] = '<br /><b>Email</b> tidak dapat terkirim';
				}
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array();
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array();
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}
		// redirect page --------------------------------------------------
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_page'], $this->arr_params['id_person'], 'account'));	
	}
	
	private function SendEmailPassword($pass_confirm){
		// get detail member
		$params = array($this->arr_params['id_person']);
		$rs = $this->obj_admin->GetDetailAdministratorById($params);
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Indonesia Nasional</h3>
						<h3>Control Panel</h3>
						<p><strong>".$rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix']."</strong>,<br>
						Email ini memberikan konfirmasi kepada anda bahwa Password dalam web organisasi telah berhasil diubah sebagai berikut : <strong>".$pass_confirm."</strong>.<br></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Perubahan kata kunci (password)";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($rs['email'], $rs['nama_lengkap']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	// cabang
	
	private function UpdateCabang(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['cabang'])){ $err[] = '<br /><strong>Komisariat</strong> harus diisi'; }
		// processing -----------------------------------------------------
		if(empty($err)){
			// delete related cabang
			$this->obj_admin->DeleteCabangByAdmin(array($this->arr_params['id_person']));
			// insert 
			foreach($this->arr_params['cabang'] as $id_cabang){
				$this->obj_admin->InsertDataCabangByAdmin(array($this->arr_params['id_person'], $id_cabang));
			}
			// sukses message				
			self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			// redirect to success page ------------------------------------
		}else{
			// filled last field
			$filled = array();
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_page'], $this->arr_params['id_person'], 'access'));
	}
	
	// akses
	
	private function UpdateHakAkses(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['authority'])){ $err[] = '<br /><strong>Authority</strong> harus diisi'; }
		// processing -----------------------------------------------------
		if(empty($err)){
			// delete related cabang
			$this->obj_admin->DeleteDataAksesByAdmin(array($this->arr_params['id_person'], $this->arr_config['app_group']['cpanel']));
			// insert 
			foreach($this->arr_params['authority'] as $id_auth){
				$this->obj_admin->InsertDataAksesByAdmin(array($this->arr_params['id_person'], $id_auth));
			}
			// sukses message				
			self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			// redirect to success page ------------------------------------
		}else{
			// filled last field
			$filled = array();
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_params['id_page'], $this->arr_params['id_person'], 'access'));
	}
	
	// hapus data
	
	private function HapusAdministrator(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id</strong> tidak terpilih'; }
		// get person data
		$arr_data = $this->obj_admin->GetDetailPersonById(array($this->arr_params['id_person']));
		// processing -----------------------------------------------------
		if(empty($err)){
			// check data member
			$params = array($this->arr_params['id_person']);
			if($this->obj_admin->CheckAdminMerangkapAnggota($params)){
				// hapus dari admin
				$this->obj_admin->HapusDataAdmin($params);
			}else{
				// hapus dari person
				$this->obj_admin->HapusDataPerson($params);
				// remove direktori
				$uploader = $this->obj_ctrl->LoadLibrary('Uploader');
				$path_folder = "doc/person/".$this->arr_params['id_person']."/";
				if(is_dir($path_folder)){
					$uploader->RemoveDir($path_folder);
				}
			}
			// send email notification
			// try to send mail
			if(!self::SendEmailDelete($arr_data)){
				$err[] = '<br /><b>Email</b> tidak dapat terkirim';
			}
			// redirect to success page ------------------------------------
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'sistem', array($this->arr_params['id_page']));	
		}else{
			// filled last field
			$filled = array();
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}
		// redirect page --------------------------------------------------
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'sistem', array($this->arr_params['id_page'], $this->arr_params['id_person']));
	}
	
	private function SendEmailDelete($arr_data){
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>Persatuan Perawat Indonesia Nasional</h3>
						<h3>Control Panel</h3>
						<p><strong>".$arr_data['prefix'].' '.$arr_data['nama_lengkap'].' '.$arr_data['suffix']."</strong>,<br>
						Email ini memberikan konfirmasi kepada anda bahwa data anda sebagai administrator pada web aplikasi PPNI telah dihapus<br></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Penghapusan data administrator";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($arr_data['email'], $arr_data['nama_lengkap']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	// register member
	
	private function RegistrasiAnggota(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// required -------------------------------------------
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Id</strong> tidak terpilih'; }
		if(empty($this->arr_params['cabang'])){ $err[] = '<br /><strong>PPNI cabang</strong> tidak terpilih'; }
		if(empty($this->arr_params['authority'])){ $err[] = '<br /><strong>Hak akses</strong> tidak terpilih'; }
		// processing -----------------------------------------------------
		if(empty($err)){
			// insert to admin 
			$params = array($this->arr_params['id_person'], $this->str_userid);
			if($this->obj_admin->InsertDataAdministratorByPerson($params)){
				// insert cabang
				foreach($this->arr_params['cabang'] as $id_cabang){
					$this->obj_admin->InsertDataCabangByAdmin(array($this->arr_params['id_person'], $id_cabang));
				}
				// insert hak akses
				foreach($this->arr_params['authority'] as $id_auth){
					$this->obj_admin->InsertDataAksesByAdmin(array($this->arr_params['id_person'], $id_auth));
				}
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
			// sukses message				
			self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			// redirect to success page ------------------------------------
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'member');
		}else{
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'register', array($this->arr_params['id_person']));
		}		
	}
	
}

?>