<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	protected $obj_admin;

	protected $obj_paging;

	protected $obj_notify;

	protected $obj_date;

	

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// load object business

		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);	

		// load object pagination

		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');

		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');

		

	}

	

	public function PageView(){

		// display test cookies

		self::DisplayNotification();

		// display variable

		self::DisplayVariable();

		// display list administrator

		self::DisplayListAdministrator();

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_notify->GetMessage();

		// display message	

		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');

		// clear session when finish

		$this->obj_notify->ClearSession();

	}

	

	private function DisplayVariable(){

		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));	

		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'sistem'));	

		$this->obj_tmpl->addVar('content', 'URL_MEMBER', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'member'));	

	}

	

	private function DisplayListAdministrator(){

		/* 

		-- display paging template (bagian atas)

		*/

		// set parameter pages on index [0]

		if(!isset($this->arr_routes['params'][0]))

			$page = 1;

		else

			$page = $this->arr_routes['params'][0];

		// set active page number

		$this->obj_paging->SetPagesNumber($page);

		// set max record

		$this->obj_paging->SetMaxRecord(10);

		// set total record

		$this->obj_paging->SetTotalRecord($this->obj_admin->GetTotalAdministrator(array()));

		// set url

		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));

		// set template

		$this->obj_paging->SetTempatePaging('pagination');

		// parse paging

		$this->obj_paging->ParsePaging();

		// get data

		// get start record

		$start = $this->obj_paging->int_start_record;

		$max = $this->obj_paging->int_max_record;

		// parsing data

		$rs_id = $this->obj_admin->GetListAdministrator(array($start, $max));	

		if($rs_id){

			$no = $start + 1;

			while($rs = mysqli_fetch_assoc($rs_id)){		

				// url		  

				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $rs['id_person']));

				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'hapus', array($page, $rs['id_person']));

				$url_anggota = $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'anggota', 'anggota', 'edit', array(1, $rs['id_person'], $rs['id_cabang']));

				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $url_edit);

				$this->obj_tmpl->addVar('list_data', 'URL_HAPUS', $url_hapus);	

				$this->obj_tmpl->addVar('list_data', 'URL_ANGGOTA', $url_anggota);				

				// --

				$this->obj_tmpl->addVar('list_data', 'NO', $no);

				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama_lengkap']);

				$this->obj_tmpl->addVar('list_data', 'PREFIX', $rs['prefix']);

				$this->obj_tmpl->addVar('list_data', 'SUFFIX', $rs['suffix']);

				$this->obj_tmpl->addVar('list_data', 'ALAMAT', $rs['alamat']);

				$this->obj_tmpl->addVar('list_data', 'KOTA', $rs['kota']);

				$this->obj_tmpl->addVar('list_data', 'TELEPON', $rs['telepon']);

				$this->obj_tmpl->addVar('list_data', 'NO_HP', $rs['no_hp']);

				// photo

				$file_photo = "doc/person/".$rs['id_person']."/foto/".$rs['photo'];

				if(is_file($file_photo))

					$this->obj_tmpl->addVar('list_data', 'PHOTOPATH', HTTPPATH.$file_photo);

				else

					$this->obj_tmpl->addVar('list_data', 'PHOTOPATH', HTTPPATH."doc/temp/blank.jpg");

				// cabang

				$this->obj_tmpl->addVar('list_data', 'CABANG', self::GetListCabangByAdmin($rs['id_person']));

				// keanggotaan				

				if(!empty($rs['no_anggota'])){

					$this->obj_tmpl->addVar('list_data', 'ANGGOTA', $rs['no_anggota']);

				}else{

					$this->obj_tmpl->addVar('list_data', 'ANGGOTA', '');

				}

				// hak akses

				$this->obj_tmpl->addVar('list_data', 'AKSES', self::GetListAkses($rs['id_person']));

				// last update

				$person = $this->obj_admin->GetDataAsSingleArray("GetPersonNameById", array($rs['mdb']));

				$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($rs['mdd']));

				$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);

				// parse

				$this->obj_tmpl->ParseTemplate('list_data', 'a');

				$no++;

			}

		}

	}

	

	private function GetListCabangByAdmin($admin){

		$str_result = "";

		$sp = "";

		// parsing data

		$rs_id = $this->obj_admin->GetListCabangByAdmin(array($admin));	

		while($rs = mysqli_fetch_assoc($rs_id)){

			$str_result .= $sp . $rs['nama'];

			$sp = ", ";

		}

		return $str_result;

	}

	

	private function GetListAkses($admin){

		$str_result = "";

		$sp = "";

		// parsing data

		$rs_id = $this->obj_admin->GetListAuthorityByAdmin(array($admin, $this->arr_config['app_group']['cpanel']));	

		while($rs = mysqli_fetch_assoc($rs_id)){

			$str_result .= $sp . $rs['auth_name'];

			$sp = ", ";

		}

		return $str_result;

	}

}



?>