<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_mDisplay;

	private $obj_mNtf;

	// Constructor    

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// -------------------------------------------------------------------		

		// load business class * ( can load other business class )

		$this->obj_mDisplay = $this->obj_ctrl->LoadBusiness('vendor', 'mysql', $this->arr_config['db']);

		// load notification class

		$this->obj_mNtf = $this->obj_ctrl->LoadLibrary('Notification');	

	}

	

    public function PageView()

    {    		

		// notification

		self::DisplayNotification();

		self::SetContentVar();

		

		// class function to display content

		self::DisplayDetailAuthority($this->arr_routes['params'][0], $this->arr_routes['params'][1]);

		self::DisplayListMenu($this->arr_routes['params'][0], $this->arr_routes['params'][1]);

		

    }



	protected function SetContentVar(){	

		// display content templates

		$url_process = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access_process');

		$url_add = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access_add');

		$url_view = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access');

		$url_map = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access_map');

		$this->obj_tmpl->addVar('content', 'ADD_URL', $url_add);

		$this->obj_tmpl->addVar('content', 'VIEW_URL', $url_view);

		$this->obj_tmpl->addVar('content', 'MAPING_URL', $url_map);

		$this->obj_tmpl->addVar('content', 'PROCESS_URL', $url_process);

		

		$this->obj_tmpl->addVar('content', 'GROUP', $this->arr_routes['params'][0]);

	}

	

	// Private function to display base content ----------------------------- // 	

	private function DisplayDetailAuthority($group, $id){

		$rs = $this->obj_mDisplay->GetDetailAuthority(array($group, $id));

		if(empty($rs)){

			$this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access', array($group));

		}else{

			foreach($rs as $rec){

				$this->obj_tmpl->addVar('content', 'ID', $rec['id_auth']);

				$this->obj_tmpl->addVar('content', 'GROUP', $rec['id_group']);

				$this->obj_tmpl->addVar('content', 'AUTH_NAME', $rec['auth_name']);

			}

		}

	}

	

	private function DisplayListMenu($group, $id_auth){

		$param = array($group, 0, 1);

		$rs = $this->obj_mDisplay->GetListMenu($param);

		if(!empty($rs)){					

			foreach($rs as $rec){

				$this->obj_tmpl->addVar('list_menu', 'ID_MENU', $rec['id_nav']);

				$this->obj_tmpl->addVar('list_menu', 'MENU_NAME', $rec['title']);

				// checked allowed menu

				if($this->obj_mDisplay->GetAllowedMenu($group, $id_auth, $rec['id_nav']))

					$this->obj_tmpl->addVar('list_menu', 'CHECKED', 'checked="checked"');

				else

					$this->obj_tmpl->addVar('list_menu', 'CHECKED', '');

				// display child

				$child = self::GetListChildMenu($group, $id_auth, $rec['id_nav']);

				$this->obj_tmpl->addVar('list_menu', 'CHILD_MENU', $child);

				$this->obj_tmpl->ParseTemplate('list_menu', 'a');

			}

		}

	}

	

	private function GetListChildMenu($group, $id_auth, $id_menu){

		$param = array($group, $id_menu, 1);

		$rs = $this->obj_mDisplay->GetListMenu($param);

		$str = "";

		if(!empty($rs)){

			$str .= "<ul>";

			foreach($rs as $rec){

				// checked allowed menu

				if($this->obj_mDisplay->GetAllowedMenu($group, $id_auth, $rec['id_nav']))

					$check = 'checked="checked"';

				else

					$check = '';

					

				$str .= "<li style=\"list-style: none;\">";

				$str .= "<label>";

				$str .= "<input type=\"checkbox\" name=\"check[]\" value=\"".$rec['id_nav']."\" ".$check."/>";

				$str .= "<font color=\"#286597\">";

				$str .= $rec["title"];

				$str .= "</font>";

				$str .= "</label>";

				$str .= self::GetListChildMenu($group, $id_auth, $rec['id_nav']);

				$str .= "</li>";				

			}

			$str .= "</ul>";

		}		

		return $str;

	}

	

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_mNtf->GetMessage();

		// display message	

		$this->obj_mNtf->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_mNtf->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_mNtf->ClearSession();

	}

	

} 

	

?>