<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_mDisplay;

	private $obj_mNtf;

	// Constructor    

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		//$this->obj_tmpl->displayParsedTemplate('document');		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access');

	}

	

	protected function PageLoad(){ 

	

		// load business class * ( can load other business class )

		$this->obj_mDisplay = $this->obj_ctrl->LoadBusiness('vendor', 'mysql', $this->arr_config['db']);

		$this->obj_mNtf = $this->obj_ctrl->LoadLibrary('Notification');		

  		//$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');



	}

	

    //function PageProcess($save)

	public function PageView(){



		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$proc = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$proc = FALSE;

		}

		// controller to manage process that page requested

		switch($proc[0]){

			case 'view':

				self::ViewAccessGroup();

				break;

			case 'add_access':

				self::AddAccess();

			case 'edit_access':

				self::UpdateAccess();

				break;

			case 'del_access':

				self::DeleteAccess();

				break;

			case 'map_access':

				self::MapingAccess();

				break;

			default:

				// default redirect to validation this page

				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access');

				break;

		}

	}

	

	// function to process

	private function ViewAccessGroup(){

		// set validation true

		$valid = TRUE;

		// clear / trim space

		//echo $this->arr_params['group'].":param group<br>";

		$param = $this->arr_params['group'];

		if(!empty($param))

			$group = $param;

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access', array($group));

	}

	

	private function AddAccess(){		

		// set validation true

		$err = array();	

		$valid = TRUE;

		// clear / trim space

		$param = $this->arr_params;

		// check empty input

		if(empty($param['nama'])){ $err[] = '<strong>Nama Hak Akses</strong> tidak boleh kosong'; }

		

		if(!empty($err))

			$valid = FALSE;		

		// process input

		if($valid){

			// Input Variable

			$arrData = array($param['group'], $param['nama']);

			// process logic

			if(!$this->obj_mDisplay->SaveAccess($arrData)){

				$valid = FALSE;

			}

		}



			if($valid){

				// notification message				

				self::SendNotification($err, array(), "Data has been saved.", "success");

        	}else{

				// error message

				self::SendNotification($err, $param, "Business process failure.", "error");

			}	

			

		

		// RETURN CONDITION

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access_add', array($param['group']));

	}

	

	private function UpdateAccess(){		

		// set validation true

		$err = array();	

		$valid = TRUE;

		// clear / trim space

		$param = $this->arr_params;

		// check empty input

		if(empty($param['nama'])){ $err[] = '<strong>Nama Hak Akses</strong> tidak boleh kosong'; }

		

		if(!empty($err))

			$valid = FALSE;		

		// process input

		if($valid){

			// Input Variable

			$arrData = array($param['nama'], $param['group'], $param['id_auth']);

			// process logic

			if(!$this->obj_mDisplay->UpdateAccess($arrData)){

				$valid = FALSE;

			}

		}

		

			if($valid){

				// notification message				

				self::SendNotification($err, array(), "Data has been saved.", "success");

        	}else{

				// error message

				self::SendNotification($err, $param, "Business process failure.", "error");

			}	

		

		// RETURN CONDITION

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access_edit', array($param['group'], $param['id_auth']));

	}

	

	private function Deleteaccess(){		

		// set validation true

		$err = array();	

		$valid = TRUE;

		// clear / trim space

		$param = $this->arr_params;

		// check empty input

		if(empty($param['group'])){ $err[] = '<strong>Group</strong> belum terpilih'; }

		if(empty($param['id_auth'])){ $err[] = '<strong>ID Authority</strong> belum terpilih'; }

		

		if(!empty($err))

			$valid = FALSE;		

		// process input

		if($valid){

			// process logic

			$this->obj_mDisplay->DeleteAccess($param['group'], $param['id_auth']);

		}

		

		// set notification

			if($valid){

				// notification message				

				self::SendNotification($err, array(), "Data has been deleted.", "success");

        	}else{

				// error message

				self::SendNotification($err, $param, "Business process failure.", "error");

			}	

		

		// RETURN CONDITION

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'company');

	}	

	

	private function MapingAccess(){		

		// set validation true

		$err = array();	

		$valid = TRUE;

		// clear / trim space

		$param = $this->arr_params;

		// check empty input

		if(empty($param['id_auth'])){ $err[] = '<strong>ID Authority</strong> tidak boleh kosong'; }

		

		if(!empty($err))

			$valid = FALSE;		

		// process input

		if($valid){

			// Input Variable

			$arrDel = array($param['id_auth']);

			// process logic

			$this->obj_mDisplay->DeleteMapingAccess($arrDel);

			if(!empty($param['check'])){

				foreach($param['check'] as $id){

					$this->obj_mDisplay->AddMapingAccess(array($id, $param['id_auth']));

				}

			}

		}

		

		// set notification

			if($valid){

				// notification message				

				self::SendNotification($err, array(), "Data has been saved.", "success");

        	}else{

				// error message

				self::SendNotification($err, $param, "Business process failure.", "error");

			}	

		

		

		// RETURN CONDITION

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'access_map', array($param['group'] , $param['id_auth']));

	}

	

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_mNtf->ClearSession();

		$this->obj_mNtf->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_mNtf->SetMessage($val);

		}		

		// field value history

		foreach($filled as $key=>$value){

			$this->obj_mNtf->SetField($key, $value);

		}

		$this->obj_mNtf->SentMessage();

	}

	

} 

	

?>