<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_mDisplay;

	private $obj_mNtf;

	protected $obj_crypt;

	// Constructor    

	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

		// set page templates

		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		

        $this->obj_tmpl->readTemplatesFromFile('template.html');

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_tmpl->displayParsedTemplate('document');		

	}

	

	protected function PageLoad(){ 

		// themes setting

		// --

		// call function to set page templates

		$this->SetPageTemplates();

		// -------------------------------------------------------------------		

		// load business class * ( can load other business class )

		$this->obj_mDisplay = $this->obj_ctrl->LoadBusiness('vendor', 'mysql', $this->arr_config['db']);

		// load notification class

		$this->obj_mNtf = $this->obj_ctrl->LoadLibrary('Notification');	

		

		$this->obj_system = $this->obj_ctrl->LoadBusiness('systemdata', 'mysql', $this->arr_config['db']);

		

			//obj_crypth

		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');	

	}

	

    public function PageView()

    {    		

		// notification

		self::DisplayNotification();

		self::SetContentVar();

		

		// class function to display content

		// self::DisplayListGroup($_GET['group']);



		self::DisplayDetailOperator($this->arr_routes['params'][0]);

		self::DisplayListAccess($this->arr_routes['params'][0]);

    }

	

	protected function SetContentVar(){	

		// display content templates

		$url_process = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'manager_process');

		$url_add = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'manager_add');

		$url_del = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'manager_delete');

		$url_view = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'manager');

		$this->obj_tmpl->addVar('content', 'VIEW_URL', $url_view);

		$this->obj_tmpl->addVar('content', 'ADD_URL', $url_add);

		$this->obj_tmpl->addVar('content', 'DELETE_URL', $url_del);

		$this->obj_tmpl->addVar('content', 'PROCESS_URL', $url_process);

	}

	

	// Private function to display base content ----------------------------- // 

	private function DisplayListGroup($group){

		$rs = $this->obj_mDisplay->GetListGroup();

		if(empty($rs)){

			$this->obj_tmpl->setAttribute('list_group', 'visibility', 'hidden');

		}else{

			foreach($rs as $rec){

				if($group == $rec['id_group']){

					$this->obj_tmpl->addVar('list_group', 'SELECTED', 'selected="selected"');

					$this->obj_tmpl->addVar('content', 'GROUP', $rec['id_group']);

				}else{

					$this->obj_tmpl->addVar('list_group', 'SELECTED', '');

				}	

				$this->obj_tmpl->addVar('list_group', 'ID_GROUP', $rec['id_group']);

				$this->obj_tmpl->addVar('list_group', 'NAME_GROUP', $rec['name_group']);

				$this->obj_tmpl->ParseTemplate('list_group', 'a');

			}

		}

	}

	

	private function DisplayDetailOperator($id){

		$rs = $this->obj_mDisplay->M_GetDetailManager(array($id));

		if(empty($rs)){

			$this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'manager');

		}else{

			foreach($rs as $rec){

				$this->obj_tmpl->addVar('content', 'ID_ADMIN', $rec['id_person']);

				$this->obj_tmpl->addVar('content', 'NAME_ADMIN', $rec['nama_lengkap']);

				$this->obj_tmpl->addVar('content', 'USERNAME', $rec['userid']);

				$this->obj_tmpl->addVar('content', 'COMPANY', $rec['name_distribution']);

				$this->obj_tmpl->addVar('content', 'PASS', $this->obj_crypt->StandardDecrypt($rec['pass'], $rec['hash_key']));

			}

		}

	}

	

	private function DisplayListAccess($id){

	

		$rs = $this->obj_mDisplay->M_GetUserVendorGroup(array($this->arr_routes['params'], $this->arr_config['app_group']['private']));

		

		// list data

		$table = array("tbl" => "sys_authority_m");

		$fields = array("id_auth" => "id_auth", "id_group" => "id_group", "auth_name" => "auth_name", "deskripsi" => "deskripsi");

		$params = array("id_group:AND" => "int:" . $this->arr_config['app_group']['vpanel']);

		$limits = array();

		$orders = array("auth_name" => "ASC");

		// ------------------------------------------------------------------

		$rs= $this->obj_system->GetTableAsResource($table, $fields, $params, $limits, $orders);

		while($rec = mysqli_fetch_assoc($rs)){

		

	

				if(!empty($rec['id_auth'])){

					$this->obj_tmpl->addVar('list_access', 'SELECTED', 'checked="checked"');

				}else{

					$this->obj_tmpl->addVar('list_access', 'SELECTED', '');

				}	

				$this->obj_tmpl->addVar('list_access', 'ID_AUTH', $rec['id_auth']);

				$this->obj_tmpl->addVar('list_access', 'ID_AUTHVAL', $rec['id_auth']);

				$this->obj_tmpl->addVar('list_access', 'NAME_AUTH', $rec['auth_name']);

				$this->obj_tmpl->ParseTemplate('list_access', 'a');

			}

		

	}

	

		

	private function DisplayNotification(){

		// get session for start notification

		$this->obj_mNtf->GetMessage();

		// display message	

		$this->obj_mNtf->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');

		// last field	

		$this->obj_mNtf->DisplayLastField($this->obj_tmpl, 'display');

		// clear session when finish

		$this->obj_mNtf->ClearSession();

	}

} 

	

?>