<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_event;

	private $obj_date;

	private $obj_notify;

	private $arr_params;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category');

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_event = $this->obj_ctrl->LoadBusiness('agenda', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		$err = array();	

		// check / validate parameter 

		if(empty($this->arr_params['cat'])){ $err[] = '<br /><strong>Kategori</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array("nama" => $this->arr_params['cat'], "deskripsi" => $this->arr_params['description'],

                     		"mdb" => $this->str_userid);

			if($this->obj_event->SetAgendaCategory($params, true)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

			}	

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			$this->obj_notify->SetField('CAT', $this->arr_params['cat']);

			$this->obj_notify->SetField('DESCRIPTION', $this->arr_params['description']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

		}

		// redirect to page error page ------------------------------------		

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category', array('add'));	

	}

	

	private function UpdateData(){

		$err = array();	

		// check / validate parameter 

		if(empty($this->arr_params['id_cat'])){ $err[] = '<br /><strong>Kategori</strong> tidak terpilih'; }

		if(empty($this->arr_params['cat'])){ $err[] = '<br /><strong>Kategori</strong> harus diisi'; }

		if(empty($this->arr_params['description'])){ $err[] = '<br /><strong>Deskripsi</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$params = array("nama" => $this->arr_params['cat'], "deskripsi" => $this->arr_params['description'],

							"mdb" => $this->str_userid, "id_cat" => $this->arr_params['id_cat']);

			if($this->obj_event->SetAgendaCategory($params, false)){

				// notification message				

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("success", "Data has been saved.");

				$this->obj_notify->SentMessage();

			}else{

				// error message

				$this->obj_notify->ClearSession();

				$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

				$this->obj_notify->SentMessage();

			}

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");

			foreach($err as $val){

				$this->obj_notify->SetMessage($val);

			}

			// filled field with last input

			$this->obj_notify->SetField('CAT', $this->arr_params['cat']);

			$this->obj_notify->SetField('DESCRIPTION', $this->arr_params['description']);

			// sent message to view page	

			$this->obj_notify->SentMessage();

		}

   		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category', array('edit', $this->arr_params['id_cat']));	

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_event->DeleteAgendaCategoryById(array($id))){

					// notification message				

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("success", "Data has been deleted.");

					$this->obj_notify->SentMessage();

				}else{

					// error message

					$this->obj_notify->ClearSession();

					$this->obj_notify->SetHeaderMessage("error", "Business process failure.");

					$this->obj_notify->SentMessage();

				}

			}				

		}else{

			// error message

			$this->obj_notify->ClearSession();

			$this->obj_notify->SetHeaderMessage("error", "See input requirement.");			

			$this->obj_notify->SentMessage();

		}

	}

}



?>