<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');



class ApplicationContent extends ApplicationBase

{	

	private $obj_event;

	private $obj_date;

	private $obj_notify;

	private $arr_params;

	private $obj_upload;



	function __construct(){ }

	

	function __destruct(){ }

	

	protected function SetPageTemplates(){

	}		

	

	protected function ParseDocumentOutput(){

		/** Out the result as template */

		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori']));

	}

	

	protected function PageLoad(){ 

		/*

		-- Other object loaded below 

		*/

		$this->obj_event = $this->obj_ctrl->LoadBusiness('agenda', 'mysql', $this->arr_config['db']);

		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		

  		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

	}

	

	public function PageView(){

		// important to encypte bug post form

		if(isset($_POST['save'])){ 

			$action = array_keys($_POST['save']); 

			$this->arr_params = $_POST;

			unset($_POST);

		}else{

			$action = FALSE;

		}

		// controller to manage process that page requested

		switch($action[0]){

			case 'insert':

				self::InsertData();

				break;

			case 'update':

				self::UpdateData();

				break;

			case 'delete':

				self::DeleteData();

				break;

			default:

				break;

		}

	}

	

	/* 

	| ------------------------------------------------------------------

	| private function to parse output from business class

	| ------------------------------------------------------------------

	*/

	

	private function InsertData(){

		$err = array();

		$filled = array();

		// check / validate parameter 

		//if(empty($this->arr_params['kategori'])){ $err[] = '<br /><strong>Kategori</strong> tidak diisi'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> harus diisi'; }

		if(empty($this->arr_params['pembicara'])){ $err[] = '<br /><strong>Pembicara</strong> harus diisi'; }

		if(empty($this->arr_params['penyelenggara'])){ $err[] = '<br /><strong>Penyelenggara</strong> harus diisi'; }

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Konten</strong> harus diisi'; }

		$id_agenda = $this->obj_event->GetLastIdAgenda(array());

		// processing --------------------------------------------------

		if(empty($err)){

			// --

			$filename = self::UploadImage($id_agenda);

			$file = self::UploadFile($id_agenda);

			// --

			$tgl_mulai = $this->arr_params['tahun_mulai']."-".$this->arr_params['bulan_mulai']."-".$this->arr_params['hari_mulai'];

			$tgl_akhir = $this->arr_params['tahun_akhir']."-".$this->arr_params['bulan_akhir']."-".$this->arr_params['hari_akhir'];

			$params = array("id_agenda" => $id_agenda, "id_cat" => $this->arr_params['cat'], 

							"judul" => $this->arr_params['judul'], "tempat" => $this->arr_params['tempat'], 

							"tgl_mulai" => $tgl_mulai, "tgl_selesai" => $tgl_akhir, "tingkat" => $this->arr_params['tingkat'],

							"pembicara" => $this->arr_params['pembicara'],"penyelenggara" => $this->arr_params['penyelenggara'],

							"sk_event" => $this->arr_params['sk'], "content" => $this->arr_params['content'],

							"sumber" => $this->arr_params['sumber'], "id_country" => $this->arr_params['country'],

							"img_name" => $filename, "img_note" => $this->arr_params['image_note'],

							"file_title" => $this->arr_params['file_note'], "file_name" => $file,

							"hits" => $this->arr_params['hit'], "mdb" => $this->str_userid);

			if($this->obj_event->SetAgenda($params, true)){

				// notification message				

				self::SendNotification($err, array(), "Data has been saved.", "success");

        	}else{

				// error message

				self::SendNotification($err, $params, "Business process failure.", "error");

			}	

		}else{

			$tgl_mulai = $this->arr_params['tahun_mulai']."-".$this->arr_params['bulan_mulai']."-".$this->arr_params['hari_mulai'];

			$tgl_akhir = $this->arr_params['tahun_akhir']."-".$this->arr_params['bulan_akhir']."-".$this->arr_params['hari_akhir'];

			$params = array("id_cat" => $this->arr_params['cat'], "judul" => $this->arr_params['judul'],

							"tempat" => $this->arr_params['tempat'], "tgl_mulai" => $tgl_mulai,

							"tgl_selesai" => $tgl_akhir, "tingkat" => $this->arr_params['tingkat'],

							"pembicara" => $this->arr_params['pembicara'],"penyelenggara" => $this->arr_params['penyelenggara'],

							"sk_event" => $this->arr_params['sk'], "content" => $this->arr_params['content'],

							"sumber" => $this->arr_params['sumber'], "id_country" => $this->arr_params['country'],

							"img_note" => $this->arr_params['image_note'], "file_title" => $this->arr_params['file_note'],

							"hits" => $this->arr_params['hit'], "mdb" => $this->str_userid);

			// error message

        	self::SendNotification($err, $params, "See input requirement.", "error");

			// redirect to page error page ------------------------------------		

			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array($this->arr_params['kategori'], 'add'));	

		}

	}

   

  	private function UploadImage($id_agenda){

		// allowed type

		if(isset($this->arr_params['image_hid']))

			$file_name = $this->arr_params['image_hid'];

		else

			$file_name = '';

		// --			

		if(isset($_FILES['image']['tmp_name']) AND !empty($_FILES['image']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['image']['name']);

			$file_path = "doc/event/images/".$id_agenda.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->ImageUpload($_FILES['image'], $file_path, 180);

		}

		return $file_name;

	}



  	private function UploadFile($id_agenda){

		// allowed type

		if(isset($this->arr_params['file_hid']))

			$file_name = $this->arr_params['file_hid'];

		else

			$file_name = '';

		// --

		if(isset($_FILES['file']['tmp_name']) AND !empty($_FILES['file']['tmp_name'])){

			// name and path file

			$file_name = str_replace(' ', '_', $_FILES['file']['name']);

			$file_path = "doc/event/file/".$id_agenda.'/';

			$this->obj_upload->RemoveDir($file_path);

			// processing

			$this->obj_upload->FileUpload($_FILES['file'], $file_path);

		}

		return $file_name;

	}

	

	private function UpdateData(){

		$err = array();	

		$filled = array();

		// check / validate parameter 

		//if(empty($this->arr_params['kategori'])){ $err[] = '<br /><strong>Kategori</strong> tidak diisi'; }

		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }

		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> harus diisi'; }

		if(empty($this->arr_params['pembicara'])){ $err[] = '<br /><strong>Pembicara</strong> harus diisi'; }

		if(empty($this->arr_params['penyelenggara'])){ $err[] = '<br /><strong>Penyelenggara</strong> harus diisi'; }

		if(empty($this->arr_params['content'])){ $err[] = '<br /><strong>Konten</strong> harus diisi'; }

		// processing --------------------------------------------------

		if(empty($err)){

			$filename = self::UploadImage($this->arr_params['id_agenda']);

			$file = self::UploadFile($this->arr_params['id_agenda']);

			

			$tgl_mulai = $this->arr_params['tahun_mulai']."-".$this->arr_params['bulan_mulai']."-".$this->arr_params['hari_mulai'];

			$tgl_akhir = $this->arr_params['tahun_akhir']."-".$this->arr_params['bulan_akhir']."-".$this->arr_params['hari_akhir'];

			$params = array("id_cat" => $this->arr_params['cat'], "judul" => $this->arr_params['judul'],

							"tempat" => $this->arr_params['tempat'], "tgl_mulai" => $tgl_mulai,

							"tgl_selesai" => $tgl_akhir, "tingkat" => $this->arr_params['tingkat'],

							"pembicara" => $this->arr_params['pembicara'],"penyelenggara" => $this->arr_params['penyelenggara'],

							"sk_event" => $this->arr_params['sk'], "content" => $this->arr_params['content'],

							"sumber" => $this->arr_params['sumber'], "id_country" => $this->arr_params['country'],

							"img_name" => $filename, "img_note" => $this->arr_params['image_note'],

							"file_title" => $this->arr_params['file_note'], "file_name" => $file,

							"hits" => $this->arr_params['hit'], "mdb" => $this->str_userid,

							"id_agenda" => $this->arr_params['id_agenda']);

			if($this->obj_event->SetAgenda($params, false)){

				// notification message	

            	self::SendNotification($err, array(), "Data has been saved.", "success");

			}else{

				// error message

            	self::SendNotification($err, $params, "Business process failure.", "error");

			}	

		}else{

			$tgl_mulai = $this->arr_params['tahun_mulai']."-".$this->arr_params['bulan_mulai']."-".$this->arr_params['hari_mulai'];

			$tgl_akhir = $this->arr_params['tahun_akhir']."-".$this->arr_params['bulan_akhir']."-".$this->arr_params['hari_akhir'];

			$params = array("id_cat" => $this->arr_params['cat'], "judul" => $this->arr_params['judul'],

							"tempat" => $this->arr_params['tempat'], "tgl_mulai" => $tgl_mulai,

							"tgl_selesai" => $tgl_akhir,  "tingkat" => $this->arr_params['tingkat'],

							"pembicara" => $this->arr_params['pembicara'],"penyelenggara" => $this->arr_params['penyelenggara'],

							"sk_event" => $this->arr_params['sk'],  "content" => $this->arr_params['content'],

							"sumber" => $this->arr_params['sumber'],  "id_country" => $this->arr_params['country'],

							"img_name" => "", "img_note" => $this->arr_params['image_note'],

							"file_title" => $this->arr_params['file_note'], "file_name" => "",

							"hits" => $this->arr_params['hit'], "mdb" => $this->str_userid,

							"id_agenda" => $this->arr_params['id_agenda']);

			// error message

        	self::SendNotification($err, $params, "See input requirement.", "error");

		}

   		// redirect page

   		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view', array('edit', $this->arr_params['id_agenda']));	

	}

	

	private function DeleteData(){

		// check / validate parameter 

		$err = array();	

		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID </strong>not selected'; }

		// processing --------------------------------------------------

		if(empty($err)){

			foreach($this->arr_params['downcheck'] as $id){

				if($this->obj_event->DeleteAgendaById(array($id))){

					$file_path = "doc/event/images/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					$file_path = "doc/event/file/".$id.'/';

					$this->obj_upload->RemoveDir($file_path);

					// notification message	

            		self::SendNotification($err, array(), "Data has been deleted.", "success");

				}else{

					// error message

            		self::SendNotification($err, array(), "Business process failure.", "error");

				}

			}				

		}else{

			// error message

        	self::SendNotification($err, array(), "See input requirement.", "error");

		}

	}

	

	private function SendNotification($err, $filled, $msg, $type){

		$this->obj_notify->ClearSession();

		$this->obj_notify->SetHeaderMessage($type, $msg);

		// error send

		foreach($err as $val){

			$this->obj_notify->SetMessage($val);

		}		

		// field value history

		foreach($filled as $key=>$value){

			$this->obj_notify->SetField($key, $value);

		}

		$this->obj_notify->SentMessage();

	}

}



?>