<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	private $obj_news;
	private $obj_person;
	private $obj_date;
	private $obj_paging;
	private $obj_notify;

	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/*
		-- Other object loaded below 
		*/
		$this->obj_news = $this->obj_ctrl->LoadBusiness('news', 'mysql', $this->arr_config['db']);
		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_ctrl->LoadJavascript('tiny_mce');
	}
	
	public function PageView(){
		/* 
		-- display view content
		*/
		self::DisplayNotification();
		self::DisplayPageLink();
		self::DisplayRedirect();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	private function DisplayPageLink(){
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0'], 'add')));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0'])));
      $this->obj_tmpl->addVar('content', 'URL_CATEGORY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category'));
		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process', array($this->arr_routes['params']['0'])));
		// parse kategori
		$this->obj_tmpl->addVar('display', 'KATEGORI', $this->arr_routes['params']['0']);
	}

   private function DisplayRedirect() {
      if (isset($this->arr_routes['params']['1']) && $this->arr_routes['params']['1'] == "add") {
         self::DisplayAddForm();
      } else if (isset($this->arr_routes['params']['1']) && $this->arr_routes['params']['1'] == "edit") {
         self::DisplayEditForm();
      } else {
         self::DisplayListArchive();
      }
   }
   
	private function DisplayListArchive(){
  		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');
		if(!isset($this->arr_routes['params']['1'])) {
			$page = 1;
		} else {
			$page = $this->arr_routes['params']['1'];
		}
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(10);
		// set total record
		$this->obj_paging->SetTotalRecord($this->obj_branch->CountPengurusById(array($this->arr_routes['params']['0'])));
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0']))."/");
		// set template
		$this->obj_paging->SetTempatePaging('pagination');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		$news = $this->obj_branch->GetPengurusByCabangId(array($this->arr_routes['params']['0'], $start, $max));
		$no = 0;
		$num = $start+1;
		foreach($news as $key=>$value) {
			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params']['0'], "edit", $value['id_berita']));
			// display last update
			$person = $this->obj_person->GetDataAsSingleArray("GetPersonNameById", array($value['mdb']));
			$this->obj_tmpl->addVar('list_data', 'MDD', $this->obj_date->GetFullDate($value['mdd']));
			$this->obj_tmpl->addVar('list_data', 'MDB', $person['nama']);
			// --
			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);
			$this->obj_tmpl->addVar('list_data', 'NO', $num);
			$this->obj_tmpl->addVar('list_data', 'ID', $value['id_pengurus']);	
			$this->obj_tmpl->addVar('list_data', 'CATEGORY', $value['nama']);
			$this->obj_tmpl->addVar('list_data', 'TITLE', $value['jabatan']);
			$this->obj_tmpl->addVar('list_data', 'URL_IMAGE', HTTPPATH . 'doc/logo/cabang/pengurus/' . $value['id_pengurus'] . '/' . $value['img_name']);
			$this->obj_tmpl->addVar('list_data', 'IMG_NAME', $value['img_name']);
			$this->obj_tmpl->addVar('list_data', 'HIT', $value['hit']);
			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);
			$this->obj_tmpl->ParseTemplate('list_data', 'a');
			$no++;
			$num++;
		}
	}	

	private function DisplayAddForm(){
		// activated template
		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');
		$this->obj_tmpl->addVar('display', 'view', 'add');
		if(isset($this->obj_notify->arr_message['field'])){
		$result = array($this->obj_notify->arr_message['field']);
		$this->obj_tmpl->addVar('display', 'TITLE', $result['0']['judul']);
		$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['deskripsi']);
		$this->obj_tmpl->addVar('display', 'CONTENT', $result['0']['content']);
		$this->obj_tmpl->addVar('display', 'URL_IMAGE', $result['0']['img_name']);
		$this->obj_tmpl->addVar('display', 'IMAGE_NOTE', $result['0']['img_note']);
      }
      $cat = $this->obj_news->GetCategory(array(0, 1000));
      foreach($cat as $key=>$value ) {
         $this->obj_tmpl->addVar('cat_add', 'CAT_VALUE', $value['id_cat']);
         $this->obj_tmpl->addVar('cat_add', 'CAT_NAME', $value['nama']);
         if (isset($result['0']['id_cat'])) {
            if ($value['id_cat'] == $result['0']['id_cat']) {
               $this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', 'selected');
            } else {
               $this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');
            }
         } else {
            $this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');
         }
         $this->obj_tmpl->ParseTemplate('cat_add', 'a');
      }
	}
	
	private function DisplayEditForm(){
		// activated template
		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');
		$this->obj_tmpl->addVar('display', 'view', 'edit');
		// parse data	
		$result = $this->obj_news->GetNewsById(array($this->arr_routes['params']['2']));
		if(isset($this->obj_notify->arr_message['field'])){
			$result = array($this->obj_notify->arr_message['field']);
		}
		$this->obj_tmpl->addVar('display', 'ID', $result['0']['id_berita']);	
		$this->obj_tmpl->addVar('display', 'TITLE', $result['0']['judul']);
		$this->obj_tmpl->addVar('display', 'DESCRIPTION', $result['0']['deskripsi']);
		$this->obj_tmpl->addVar('display', 'CONTENT', $result['0']['content']);
		$urlImg = "";
		if(!empty($result['0']['img_name'])) {
			$urlImg = HTTPPATH . "doc/news/public/" . $result['0']['id_berita'] . '/' . $result['0']['img_name'];
		}
		$this->obj_tmpl->addVar('display', 'URL_IMAGE', $urlImg);
		$this->obj_tmpl->addVar('display', 'IMAGE_NOTE', $result['0']['img_note']);
		$this->obj_tmpl->addVar('display', strtoupper($result['0']['headline']),'selected="selected"' );
		$this->obj_tmpl->addVar('display', 'SORT_HEAD', $result['0']['sort_head']);
		$this->obj_tmpl->addVar('display', 'HIT', $result['0']['hit']);
      
      	$cat = $this->obj_news->GetCategory(array(0, 1000));
		foreach($cat as $key=>$value ) {
			$this->obj_tmpl->addVar('cat_edit', 'CAT_VALUE', $value['id_cat']);
			$this->obj_tmpl->addVar('cat_edit', 'CAT_NAME', $value['nama']);
			if ($value['id_cat'] == $result['0']['id_cat']) {
				$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', 'selected');
			} else {
				$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', '');
			}
			$this->obj_tmpl->ParseTemplate('cat_edit', 'a');
		}
	}
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>