<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	protected $obj_cpd;
	protected $obj_paging;
	protected $obj_date;
	protected $obj_notify;
	// var

	protected $obj_admin;
	protected $str_keyword;
	protected $str_cabang;
	protected $arr_cabang = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		// load object business
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('wilayah');
		$this->obj_admin = $this->obj_ctrl->LoadBusiness('administrator', 'mysql', $this->arr_config['db']);
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		// load object pagination
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();			
		// display cabang
		self::DisplayCabangAuthority();	
		// display calon anggota
		self::DisplayListAnggota();
		// display test cookies
		self::DisplayNotification();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));	
		// keyword
		if(isset($_SESSION['search']['dokumen']['nama'])){
			$this->str_keyword = "%" . $_SESSION['search']['dokumen']['nama'] . "%";
			$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['dokumen']['nama']);
		}else{
			$this->str_keyword = "%%";
		}
	}
	
		
		private function DisplayCabangAuthority(){
		// cabang
		$cabang = "";
		if(isset($_SESSION['search']['dokumen']['cabang'])){ $this->str_cabang = $_SESSION['search']['dokumen']['cabang'];}
		//if(isset($_SESSION['search']['cabang'])){ $this->str_cabang = $_SESSION['search']['cabang'];}
		// parsing data
		$rs_id = $this->obj_admin->GetListCabangByAdmin(array($this->str_userid));		
		while($rs = mysql_fetch_assoc($rs_id)){	
			$this->arr_cabang[] = $rs['id_cabang'];
			if($rs['id_cabang'] == $this->str_cabang){
				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', 'selected="selected"');
			}else{
				$this->obj_tmpl->addVar('list_cabang', 'SELECTED', '');
			}
			$this->obj_tmpl->addVar('list_cabang', 'VALUE', $rs['id_cabang']);
			$this->obj_tmpl->addVar('list_cabang', 'NAMA', $rs['nama']);
			$this->obj_tmpl->ParseTemplate('list_cabang', 'a');
		}
		if(empty($this->str_cabang))
			$this->arr_cabang = implode(',', $this->arr_cabang);
		else
			$this->arr_cabang = $this->str_cabang;
	}
	
	
	
	private function DisplayListAnggota(){
		// set parameter pages on index [0]
		if(!isset($this->arr_routes['params'][0]))
			$page = 1;
		else
			$page = $this->arr_routes['params'][0];
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(20);
		// set total record
		//print_r($this->str_cabang);
		//$this->obj_cpd->DebugQuery("GetTotalAnggotaByCabang", array($this->str_cabang, $this->str_keyword));
		$int_total = $this->obj_cpd->GetDataAsSingleArray("GetTotalAnggotaByCabang", array($this->arr_cabang, $this->str_keyword));
		$this->obj_paging->SetTotalRecord($int_total['total']);
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// set template
		$this->obj_paging->SetTempatePaging('pagination');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get data
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListAnggotaByCabang", array($this->arr_cabang, $this->str_keyword, $start, $max));	
		if($rs_id){
			$no = $start + 1;
			while($rs = mysql_fetch_assoc($rs_id)){	
				// url detail
				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'dokumen-periode', array($rs['id_person']));
				// parse data
				$this->obj_tmpl->addVar('list_data', 'WAITING', 0);
				$waiting = $this->obj_cpd->GetDataAsSingleArray("GetTotalDokumenWaitingByPerson", array($rs['id_person']));
				if(!empty($waiting['total'])){
					$this->obj_tmpl->addVar('list_data', 'WAITING', '<b>'.$waiting['total'].'</b>');
				}else{
					$this->obj_tmpl->addVar('list_data', 'WAITING', '0');
				}
				$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url);
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'ID', $rs['id_person']);
				$this->obj_tmpl->addVar('list_data', 'CABANG', $rs['cabang']);
				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama_lengkap']);
				$this->obj_tmpl->addVar('list_data', 'PREFIX', $rs['prefix']);
				$this->obj_tmpl->addVar('list_data', 'SUFFIX', $rs['suffix']);
				$this->obj_tmpl->addVar('list_data', 'NO_ANGGOTA', $rs['no_anggota']);
				$this->obj_tmpl->addVar('list_data', 'ALAMAT', $rs['alamat']);				
				$this->obj_tmpl->addVar('list_data', 'KOTA', "<br />" . $rs['kota']);
				$this->obj_tmpl->ParseTemplate('list_data', 'a');
				$no++;
			}
		}
	}
}

?>