<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_date;
	protected $obj_paging;
	protected $obj_notify;
	// variable definition
	protected $int_periode;
	// variable definition
	protected $str_keyword;
	protected $str_wilayah;
	protected $arr_wilayah = array();
	protected $arr_kota = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('wilayah', 'evaluasi', 'kegiatan', 'dokumen');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');		
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){	
		// display notification
		self::DisplayNotification();
		// select periode aktif
		self::GetVariablePeriodeStr();
		// display periode buku log
		self::DisplayPeriodeStr();	
		// display List Kegiatan
		self::DisplayListDokumen();
		// Variable
		self::DisplayVariable();
		// display wilayah
		//self::DisplayWilayahAuthority();		
		// display wilayah
		//self::DisplayKotaAuthority();	
		// display detail user
		self::DisplayDetailPerson();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function GetVariablePeriodeStr(){
		$str_default_periode = date('Y') . '-' . date('m') . '-' . date('d');
		// default periode 
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDefaultPeriodeByPerson", array($this->str_userid, $str_default_periode));		
		// cari periodenya
		if(isset($this->arr_routes['params'][1]) AND !empty($this->arr_routes['params'][1])){
			// int periode
			$this->int_periode = $this->arr_routes['params'][1];
		}else{	
			// int periode
			$this->int_periode = $result['id_periode'];
		}
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'dokumen-anggota'));
		$this->obj_tmpl->addVar('content', 'URL_STR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'dokumen-periode', array($this->arr_routes['params'][0])));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// --		
		$this->obj_tmpl->addVar('content', 'ID_PERSON', $this->arr_routes['params'][0]);
		$this->obj_tmpl->addVar('content', 'PERIODE', $this->int_periode);
	}
	
	private function DisplayPeriodeStr(){
		// display detail periode
		$rs_str = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->arr_routes['params'][0], $this->int_periode));
		$this->obj_tmpl->addVar('content', 'TAHUN_STR', $rs_str['mulai'] . ' - ' . $rs_str['selesai']);
	}
	
	private function DisplayListDokumen(){
		$no = 1;
		$total = 0;
		// parameter
		$params = array($this->arr_routes['params'][0], $this->arr_routes['params'][1]);
		// get data
		$rs_id = $this->obj_cpd->GetResourceId("GetListDokumenByPerson", $params);
		if($rs_id){
			// parse data
			while($rec = mysql_fetch_assoc($rs_id)){
				//$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'dokumen', 'download-lampiran', array(sha1(md5($this->arr_routes['params'][0])), md5(sha1($rec['id']))));
				$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'dokumen', 'download-lampiran', array($this->arr_routes['params'][0], $rec['id']));	
				$this->obj_tmpl->addVar('list_dokumen', 'URL_DOWNLOAD', $url_download);	
				// --
				$this->obj_tmpl->addVar('list_dokumen', 'NO', $no . '.');
				$this->obj_tmpl->addVar('list_dokumen', 'TANGGAL', $this->obj_date->GetFullDate($rec['tgl_dokumen']));
				$this->obj_tmpl->addVar('list_dokumen', 'TGL_PERIKSA', $this->obj_date->GetFullDate($rec['tgl_verifikasi']));
				$this->obj_tmpl->addVar('list_dokumen', 'PEMERIKSA', self::GetDataPemeriksa($rec['verifikator']));
				$this->obj_tmpl->addVar('list_dokumen', 'CATATAN', $rec['catatan']);
				$this->obj_tmpl->addVar('list_dokumen', 'JUDUL', $rec['judul']);
				$this->obj_tmpl->addVar('list_dokumen', 'DESKRIPSI', $rec['deskripsi']);
				$this->obj_tmpl->addVar('list_dokumen', 'FILENAME', $rec['file_name']);
				$this->obj_tmpl->addVar('list_dokumen', 'ID', $rec['id']);
				switch($rec['evaluated']){
					case 'no':
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" title="Rejected" />';
						$this->obj_tmpl->addVar('list_dokumen', 'REJECT', 'selected="selected"');
						break;
					case 'yes':
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" title="Accepted" />';
						$this->obj_tmpl->addVar('list_dokumen', 'YES', 'selected="selected"');
						break;
					default :
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/orangin-ico.jpg".'" title="Waiting" />';
						$this->obj_tmpl->addVar('list_dokumen', 'WAIT', 'selected="selected"');
						break;
				}
				$this->obj_tmpl->addVar('list_dokumen', 'VERIFIKASI', $status_verifikasi);
				$this->obj_tmpl->ParseTemplate('list_dokumen', 'a');
				$no++;	
			}
		}	
		$this->obj_tmpl->addVar('content', 'JUMLAH_KEGIATAN', $no - 1);
	}
	
	private function GetDataPemeriksa($person){
		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDataPemeriksaByPerson", array($person));
		if(!empty($rs)){
			$label = $rs['prefix'].' '.$rs['nama_lengkap'].' '.$rs['suffix'].'<br>'.$rs['nama'];
		}else{
			$label = "-";
		}
		return $label;
	}
	
	// authority
	
	private function DisplayWilayahAuthority(){		
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListWilayahByTim", array($this->str_userid));
		if($rs_id){		
			while($rs = mysql_fetch_assoc($rs_id)){	
				$this->arr_wilayah[] = $rs['id_wilayah'];
			}
		}
		$this->arr_wilayah = implode(',', $this->arr_wilayah);
	}
	
	private function DisplayKotaAuthority(){
		// parsing data
		$rs_id = $this->obj_cpd->GetResourceId("GetListKotaByWilayah", array($this->arr_wilayah));
		if($rs_id){		
			while($rs = mysql_fetch_assoc($rs_id)){	
				$this->arr_kota[] = $rs['id_city'];
			}
		}
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDatasetAsArray("GetDetailAnggotaByIdPerson", array($this->arr_routes['params'][0]));
		if(!empty($result)){
			/*if(!in_array($result[0]['id_city'], $this->arr_kota)){
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	
			}else{*/
				$this->obj_tmpl->addVar('content', 'PREFIX', $result[0]['prefix']);
				$this->obj_tmpl->addVar('content', 'SUFFIX', $result[0]['suffix']);
				$this->obj_tmpl->addVar('content', 'NAMA_LENGKAP', $result[0]['nama_lengkap']);
				$this->obj_tmpl->addVar('content', 'ALAMAT', $result[0]['alamat']);
				$this->obj_tmpl->addVar('content', 'KOTA', $result[0]['kota']);
				$this->obj_tmpl->addVar('content', 'CABANG', $result[0]['cabang']);
				$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result[0]['no_anggota']);
				// display foto
				$path = "doc/person/".$result[0]['id_person']."/foto/".$result[0]['photo'];
				if(is_file($path))
					$this->obj_tmpl->addVar('content', 'FOTO', $path);
				else
					$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");
			}
	/*	}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	
		}*/
	}
}

?>