<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_date;
	// variable definition
	protected $arr_search;
	protected $int_periode;
	protected $int_tahun;
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('content');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kegiatan', 'dashboard');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// loaded javascript
		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
		
		// load plugins
		$this->obj_ctrl->LoadFile('tcpdf/tcpdf.php', 'plugins');
		$this->obj_tcpdf = $this->obj_ctrl->LoadClass('TCPDF');
		
		// load style :
		$this->obj_ctrl->LoadStyle('a-load-style', 'private/style');	
		
		// loaded style
		//$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');		
	}
	
	public function PageView(){	
		// Search Data
		self::GetSearchSession();
		// select periode aktif
		//self::GetVariableBukuLog();
		// display periode buku log
		//self::DisplayPeriodeBukuLog();
		// display List Kegiatan
		self::DisplayListKegiatan();
		// Variable
		self::DisplayVariable();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_STR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode'));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'borang', 'ajax-keyword'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// tahun periode str
		$this->obj_tmpl->addVar('content', 'URL_PERIODE', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log', array($this->int_periode, $this->int_tahun)));
		// --
		$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log'));
		$this->obj_tmpl->addVar('content', 'URL_BORANG', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'cpd', 'borang', 'isian'));
		$this->obj_tmpl->addVar('content', 'URL_DASHBOARD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'dashboard', 'pribadi', 'p2kb', array($this->int_periode)));
		// --
		$this->obj_tmpl->addVar('content', 'PERIODE', $this->int_periode);
		$this->obj_tmpl->addVar('content', 'TAHUN', $this->int_tahun);
	}
	
	private function GetSearchSession(){
		// search value
		$this->arr_search['keyword'] = "%";
		$this->arr_search['ranah'] = "";
		$this->arr_search['jenis'] = "";
		// ---
		if(isset($_SESSION['search']['bukulog'])){
			// keyword
			if(isset($_SESSION['search']['bukulog']['keyword']) AND !empty($_SESSION['search']['bukulog']['keyword'])){
				$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['bukulog']['keyword']);
				$this->arr_search['keyword'] .= $_SESSION['search']['bukulog']['keyword'];	
			}
			// ranah 
			if(isset($_SESSION['search']['bukulog']['ranah']) AND !empty($_SESSION['search']['bukulog']['ranah'])){
				switch($_SESSION['search']['bukulog']['ranah']){
					case 1:					
						$this->obj_tmpl->addVar('content', 'RANAH_A', 'selected="selected"');
						break;
					case 2:
						$this->obj_tmpl->addVar('content', 'RANAH_B', 'selected="selected"');
						break;
					case 3:
						$this->obj_tmpl->addVar('content', 'RANAH_C', 'selected="selected"');
						break;
					case 4:
						$this->obj_tmpl->addVar('content', 'RANAH_D', 'selected="selected"');
						break;
					case 5:
						$this->obj_tmpl->addVar('content', 'RANAH_E', 'selected="selected"');
						break;
					default:
						break;
				}
				// parse
				$this->arr_search['ranah'] = "AND b.id_ranah = " . $_SESSION['search']['bukulog']['ranah']; 
			}
			// jenis 
			if(isset($_SESSION['search']['bukulog']['jenis']) AND !empty($_SESSION['search']['bukulog']['jenis'])){
				switch($_SESSION['search']['bukulog']['jenis']){
					case 1:					
						$this->obj_tmpl->addVar('content', 'PRIBADI', 'checked="checked"');
						break;
					case 2:
						$this->obj_tmpl->addVar('content', 'INTERNAL', 'checked="checked"');
						break;
					case 3:
						$this->obj_tmpl->addVar('content', 'EKSTERNAL', 'checked="checked"');
						break;
					default:
						break;
				}
				// parse
				$this->arr_search['jenis'] = "AND b.id_jenis = " . $_SESSION['search']['bukulog']['jenis']; 
			}
		}	
		// search value
		$this->arr_search['keyword'] .= "%";
	}
	
	private function GetVariableBukuLog(){
		// cari periode
		if(!isset($this->arr_routes['params'][0])){
			$str_default_periode = date('Y') . '-' . date('m') . '-' . date('d');
			$result = $this->obj_cpd->GetDataAsSingleArray("GetDefaultPeriodeByPerson", array($this->arr_routes['params'][0], $str_default_periode));
			if(!empty($result)){
				// int periode
				$this->int_periode = $result['id_periode'];
				// int tahun
				$this->int_tahun = $result['id_tahun_periode'];
				$this->str_tgl_mulai = $result['tgl_mulai'];
				$this->str_tgl_selesai = $result['tgl_selesai'];
			}
		}else{
			// int periode
			$this->int_periode = $this->arr_routes['params'][1];
			// tahun
			if(isset($this->arr_routes['params'][2])){
				$this->int_tahun = $this->arr_routes['params'][2];
				$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeKegiatanBySelected", array($this->arr_routes['params'][0], $this->int_tahun));		
				// set batasan tanggal
				$this->str_tgl_mulai = $result['tgl_mulai'];
				$this->str_tgl_selesai = $result['tgl_selesai'];
			}else{
				// cari tahun pertama dulu
				$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeKegiatanByPeriode", array($this->arr_routes['params'][0], $this->int_periode));
				$this->int_tahun = $result['id_tahun_periode'];
				// set batasan tanggal
				$this->str_tgl_mulai = $result['tgl_mulai'];
				$this->str_tgl_selesai = $result['tgl_selesai'];
			}
		}		
		// validated parameter anda redirected
		if(empty($this->int_periode) OR empty($this->int_tahun) OR empty($this->str_tgl_mulai) OR empty($this->str_tgl_selesai)){
			// redirect to buku log
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');
		}
	}
	
	private function DisplayPeriodeBukuLog(){
		// display detail periode
		$rs_str = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));
		$this->obj_tmpl->addVar('content', 'TAHUN_STR', $rs_str['mulai'] . ' - ' . $rs_str['selesai']);
		switch($rs_str['status_evaluasi']){
			case 'rejected':
				$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" title="Rejected" />';
				break;
			case 'accepted':
				$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" title="Accepted" />';
				break;
			default :
				$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/orangin-ico.jpg".'" title="Waiting" />';
				break;
		}
		$this->obj_tmpl->addVar('content', 'VERIFIKASI_STR', $status_verifikasi);
		if($rs_str['status_pengajuan'] == 'yes')
			$this->obj_tmpl->addVar('content', 'PENGAJUAN_STR', '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" />');
		else
			$this->obj_tmpl->addVar('content', 'PENGAJUAN_STR', '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" />');
		// diaplay tahun kegiatan
		$rs_id =  $this->obj_cpd->GetResourceId("GetListTahunPeriodeById", array($this->str_userid, $this->int_periode));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_tahun', 'VALUE', $this->int_periode . '/' .$rec['id_tahun_periode'] . '/');
				// parse data
				$lbl= $this->obj_date->GetFullDate($rec['tgl_mulai']).' s/d '.$this->obj_date->GetFullDate($rec['tgl_selesai']);
				if($this->int_tahun == $rec['id_tahun_periode']){
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', 'selected="selected"');
					// selected tahun kegiatan
					$this->obj_tmpl->addVar('content', 'TAHUN_PERIODE', $lbl);
					switch($rec['status_evaluasi']){
						case 'rejected':
							$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" title="Rejected" />';
							break;
						case 'accepted':
							$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" title="Accepted" />';
							break;
						default :
							$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/orangin-ico.jpg".'" title="Waiting" />';
							break;
					}
					$this->obj_tmpl->addVar('content', 'VERIFIKASI_TAHUN', $status_verifikasi);
					if($rec['status_pengajuan'] == 'yes')
						$this->obj_tmpl->addVar('content', 'PENGAJUAN_TAHUN', '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" />');
					else
						$this->obj_tmpl->addVar('content', 'PENGAJUAN_TAHUN', '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" />');
					// end of selected
				}else{
					$this->obj_tmpl->addVar('list_tahun', 'SELECTED', '');
				}
				$this->obj_tmpl->addVar('list_tahun', 'TAHUN', $rec['tahun'] . '/' . ($rec['tahun'] + 1));
				$this->obj_tmpl->ParseTemplate('list_tahun', 'a');
			}
		}
	}
	
	private function DisplayListKegiatan(){
	$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));
		
		/*if(!empty($result)){
			$tgl_periode = $this->obj_date->GetFullDate($result['tgl_mulai']) . ' s/d ' .$this->obj_date->GetFullDate($result['tgl_selesai']);
			$this->obj_tmpl->AddVar('content', 'STR_PERIODE', $tgl_periode);
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'hasil', 'evaluasi');
		}*/
	$rs_str = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));
	$rs_id = $this->obj_cpd->GetResourceId("GetListRanahByIdPerson", array($this->str_userid,$this->str_tgl_mulai, $this->str_tgl_selesai));
		//$this->obj_cpd->DebugQuery("GetListRanahByIdPerson", array($this->str_userid,$this->str_tgl_mulai, $this->str_tgl_selesai));
		$person = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->str_userid));
		$path = "doc/temp/blank.jpg";
		if(!empty($person)){
			// display foto
			$path = "doc/person/".$person['id_person']."/foto/".$person['photo'];
			if(!is_file($path))
				$path = "doc/temp/blank.jpg";
		}

		$this->tablealign = '
							<table border="none" width="100%" cellpadding="2">
							  <tr>
								<td width="70" align="left"><img src="doc/temp/p2kb-logo.png" width="50" height="50" /></td>
								<td align="center" width="400"><b>KOMISI PENGEMBANGAN PENDIDIKAN KEPROFESIAN BERKELANJUTAN (P2KB)<br />
								  IAKTAN FISIOTERAPI INDONESIA (IFI)</b>
								 <font size="9">Sekretariat : Pengurus PusatIkatan Fisioterapi Indonesia<br /> ( PP IFI)
								 <br />
								   RSCM, Lt II G3<br />
								   Jl. Diponegoro 71 Jakarta 10430 <br />
								   Telp: 021-390 9431 Fax : 021-390 9431 <br />
								   E-mail: p2kb_IFI@yahoo.com</font></td>
									<td width="70" align="right"><img src="doc/temp/logo-ifi.jpg"  /></td>
							  </tr>
							  </table>
							<img src="doc/temp/hr.jpg" width="530" />
							<br>
							<table border="none" width="100%" cellpadding="2">
							
							<tr >
							<td width="60"  rowspan="5"><img src="'.HTTPPATH.$path.'" width="50" height="50" /></td>
							<td width="170">Nama</td>
							<td width="15">:</td>
							<td width="300">'.$person['prefix'].' '.$person['nama_lengkap'].' '.$person['suffix'].'</td>
						  </tr>
						 
										 
						  <tr>
							<td width="170">Nomor anggota IFI</td>
							<td width="15">:</td>
							<td>'.$person['no_anggota'].'</td>
						  </tr>
						  
						 <tr>
							<td width="170">Periode STR</td>
							<td width="15">:</td>
							<td width="300">'.$tgl_periode.'</td>
						  </tr>
						  
						  <tr>
							<td width="170">Alamat</td>
							<td width="15">:</td>
							<td width="300">'.$person['alamat'].'</td>
						  </tr>
						  
						  </table>
							<br />';
		// parameterasdf3
		
		$params = array($this->str_userid, $this->str_tgl_mulai, $this->str_tgl_selesai, $this->arr_search['keyword'], $this->arr_search['ranah'], $this->arr_search['jenis']);
		// get data
		$rs_id = $this->obj_cpd->GetResourceId("GetListKegiatanGroupByForm", $params);
		// parse data
		if($rs_id){
			$no = 0;
			$total = 0;
			$this->tablealign .= '<h4>Kegiatan P2KB periode '.$this->obj_date->GetFullDate($this->str_tgl_mulai).' s/d '.$this->obj_date->GetFullDate($this->str_tgl_selesai).'</h4>
								  <table class="table-view" align="center" width="530" border="0" cellpadding="0" cellspacing="0" bordercolor="efefef">
										<tr height="36px">
										  <td width="27" height="36" bgcolor="#000000" class="content-center" style="color:#FFFFFF; height:36px;">No.</td>
										  <td width="230" bgcolor="#000000" class="content-center" style="color:#FFFFFF; height:36px;">Nama Kegiatan</td>
										  <td width="65" bgcolor="#000000" class="content-center" style="color:#FFFFFF; height:36px;">Ranah</td>
										  <td width="65" bgcolor="#000000" class="content-center" style="color:#FFFFFF; height:36px;">Jumlah</td>
										  <td width="65" bgcolor="#000000" class="content-center" style="color:#FFFFFF; height:36px;">Disetujui</td>
										  <td width="65" bgcolor="#000000" class="content-center" style="color:#FFFFFF; height:36px;">Nilai SKP</td>
										 
										</tr>';
			while($rec = mysql_fetch_assoc($rs_id)){
				// url
				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->int_periode, $this->int_tahun, $rec['id_kegiatan']));
				// parse
				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no . '.');
				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA', $rec['kegiatan']);
				$this->obj_tmpl->addVar('list_kegiatan', 'RANAH', $rec['ranah']);
				$this->obj_tmpl->addVar('list_kegiatan', 'JENIS', ucwords($rec['kelompok']));
				$this->obj_tmpl->addVar('list_kegiatan', 'KEGIATAN', $rec['kegiatan']);
				$this->obj_tmpl->addVar('list_kegiatan', 'JUMLAH', $rec['jumlah']);
				$this->obj_tmpl->addVar('list_kegiatan', 'ACCEPTED', $rec['accepted']);
				if($rec['tipe'] == 'rutin')
					$nilai = self::GetNilaiSkpRutin($rec['id_form']);
				else
					$nilai = $rec['nilai'];
				$this->obj_tmpl->addVar('list_kegiatan', 'NILAI', $nilai);
				$this->obj_tmpl->addVar('list_kegiatan', 'URL_INPUT', $url);
				$this->obj_tmpl->ParseTemplate('list_kegiatan', 'a');
				$total = $total + $nilai;
				$no++;	
				$this->tablealign .= '<tr>
											  <td width="27">'.$no .'</td>
											  <td width="230" align="left">'.$rec['kegiatan'].'</td>
											  <td width="65" class="content-center"><strong>'.$rec['ranah'].'</strong></td>
											  <td width="65" class="content-center">'.$rec['jumlah'].'</td>
											  <td width="65" class="content-center"><strong>'.$rec['accepted'].'</strong></td>
											  <td width="65" class="content-center">'.$nilai.' skp</td>
											</tr>';
										
			}
			$this->tablealign .= '<tr>
								  <td width="452"  bgcolor="#999999" align="left" colspan="5"><strong>Total SKP</strong></td>
								  <td width="65" bgcolor="#999999" class="content-center"><strong>'.$total.'skp</strong></td>
									</tr>
								  </table>';
			$this->obj_tmpl->addVar('content', 'TOTAL_NILAI', $total);
		}	
		self::DisplayReport();	
		
	}

	private function GetNilaiSkpRutin($id_form){
		$nilai = 0;
		$jumlah = 0;
		// get parameter and indikator
		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));
		$id_parameter = $arr['parameter'];
		$id_engine = $arr['indikator'];
		// get nilai dalam range tahun kegiatannya
		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($this->str_userid, $id_form, $this->str_tgl_mulai, $this->str_tgl_selesai));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_field = "";
				$xml = simplexml_load_string($rec["data_kegiatan"]);
				// echo does the casting for you
				$count = count($xml->item);
				for($i=0;$i<$count;$i++){
					$id = intval($xml->item[$i]->idt);
					$value = strval($xml->item[$i]->value);
					if($id == $id_parameter){
						$jumlah = $jumlah + $value;
						break;
					}
				}
			}
		}
		// get list elemen
		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));
		if($rs_id_list){
			$group_list = "FIND_IN_SET(0, group_elemen_list)";
			while($rec = mysql_fetch_assoc($rs_id_list)){
				$range_value = explode('-', $rec['list_value'], 2);
				if(sizeof($range_value) >= 2){
					$batas_bawah = round($range_value[0], 2);
					$batas_atas = round($range_value[1], 2);
				}else{
					$batas_bawah = 0;
					$batas_atas = 0;
				}	
				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){
					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";
					break;
				}
			}
		}
		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	
		if(!empty($nilai))
			return $nilai['nilai_skp'];
		else
			return 0;
	}
	
	private function DisplayReport(){
		// print pdf
		$this->obj_tcpdf->setPrintHeader(false);
		$this->obj_tcpdf->setPrintFooter(false);
		$this->obj_tcpdf->SetDisplayMode('real');
		$this->obj_tcpdf->SetMargins(10, 10);		
		// add a page
		$this->obj_tcpdf->AddPage();	
		$this->obj_tcpdf->SetFont("arial", "BI", 10);	
		// create some HTML content
		//$this->tablealign = '';
   

		// output the HTML content
		$this->obj_tcpdf->writeHTML($this->tablealign, true, 0, true, 0);
		//Close and output PDF document
		$this->obj_tcpdf->Output("Buku Log P2KB.pdf", "D");
	}
}

?>
